<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

/**
 * @property mixed fecha_expedicion_documento
 * @property mixed grupo_sanguineo
 * @property mixed rh
 * @property mixed tipo_documento
 * @property integer numero_documento
 * @property mixed direccion_residencia
 * @property mixed ciudad_residencia
 * @property mixed email
 * @property mixed telefono_fijo
 * @property mixed telefono_celular
 * @property mixed sexo
 * @property mixed nombre
 * @property mixed id_organismo
 * @property mixed fecha_nacimiento
 */
class Ciudadano extends Model
{
    protected $connection = 'mysql2';
    protected $table = 'ciudadanos';
    protected $fillable = [
        'id_organismo',
        'nombre',
        'numero_documento',
        'tipo_documento',
        'ciudad_residencia',
        'direccion_residencia',
        'telefono_fijo',
        'telefono_celular'
    ];

    function organismo(){
        return $this->belongsTo('App\Organismo', 'id_organismo');
    }

    function ciudad(){
        return $this->belongsTo('App\Ciudad', 'ciudad_residencia');
    }

    function vehiculos(){
        return $this->hasMany('App\Vehiculo', 'id_ciudadano');
    }
}
