<?php

namespace App\Clases;

use App\Pqrs;
use App\Radicacion as ConsecutivoRadicacion;
use Carbon\Carbon;

class Radicacion
{

    private $radicacion;

    public function __construct($noRadicacion)
    {
        $this->radicacion = $noRadicacion;
    }

    public function validateAndGenerate()
    {
        if (!$this->isExist()) return $this->radicacion;

        $consecutivo = $this->getConsecutivo();

        return $this->generateNewRad($consecutivo);
    }

    public function isExist()
    {
        $pqr = Pqrs::where('no_radicacion', $this->radicacion)->get();

        if ($pqr->count() > 0) return true;

        return false;
    }

    private function getConsecutivo()
    {
        return ConsecutivoRadicacion::find(1);
    }

    public function generateNewRad($consecutivo)
    {
        $radicacion = $consecutivo->consecutivo_externo . Carbon::now()->format('Ymd');
        $consecutivo->consecutivo = $consecutivo->consecutivo + 1;
        $consecutivo->consecutivo_externo = str_pad($consecutivo->consecutivo_externo + 1, 4, "0", STR_PAD_LEFT);
        $consecutivo->save();

        return $radicacion;
    }
}
