<?php

namespace App\Console\Commands;

use App\Impuesto;
use App\Pago;
use Illuminate\Console\Command;

class ActualizarImpuestos extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'impuestos:actualizar';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Comando temporal para insertar registros desde pagos a impuestos';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $pagos = Pago::where('estado', 'pagado')->orderBy('id')->orderBy('ano')->get();

        foreach($pagos as $pago){
            echo("PAGO {$pago->id} - VEHICULO {$pago->id_vehiculo} - ANO: {$pago->ano}... ");

            if( Impuesto::where('ano', $pago->ano)->where('id_vehiculo', $pago->id_vehiculo)->where('estado', 'pagado')->exists() ){
                echo "IGNORADO\n";
            }else{
                Impuesto::create(['id_vehiculo' => $pago->id_vehiculo, 'ano' => $pago->ano, 'estado' => 'pagado']);
                echo "OK!\n";
            }
        }
    }
}
