<?php

namespace App\Console\Commands;

use App\Solicitud;
use App\Vehiculo;
use Illuminate\Console\Command;

class ActualizarSolicitudes extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'solicitudes:actualizar';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Actualiza el estado de las solicitudes';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $solicitudesCreacion = Solicitud::where('estado', 'pendiente')->where('etiqueta', 'crear-vehiculo')->get();

        foreach($solicitudesCreacion as $solicitud){
            echo "Consultando solicitud #{$solicitud->id}... ";

            if(Vehiculo::where('placa', $solicitud->placa)->exists()){
                $solicitud->estado = 'completada';
                $solicitud->save();
                echo "Actualizada!\n\r";
            }else{
                echo "No se cambió\n\r";
            }

        }
    }
}
