<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\AcuerdoPago as Acuerdo;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use App\Infraccion;
use App\InfraccionF;
use App\InfraccionSalario;
use App\ParamHonorario;
use App\ParamSistematizacion;
use App\Http\Controllers\CajaController;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class AcuerdoPago extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   */
  protected $signature = 'acuerdopago:start {medio} {id_comparendo} {id_acuerdo}';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Imprime una resolucion de acuerdo de pago';

  /**
  * variables de contenido de la tarea
  */
  protected $ultimaNumeracion = 1900;
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoEmpresaSecreteria = '';
  protected $organismoMunicipio= '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $idComparendo = $this->argument('id_comparendo');
    $idAcuerdo = $this->argument('id_acuerdo');
    $medio = $this->argument('medio');
    $this->rutaImagenTop = '';
    if($medio == "c"){
      $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      $this->rutaFirma = base_path() . '/public/images/firma2.png';
    } else if($medio == "w"){
      $this->rutaImagenTop = asset('images/membrete_2018.png');
      $this->rutaFirma = asset('images/firma2.png');
    }
    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');

    $this->line(base_path() );
    $this->line($this->rutaImagenTop);
    $this->line($this->rutaFirma);

    $organismo = \App\Organismo::first();
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretario_nombre;
    $this->organismoEmpresaSecreteria = $organismo->secretaria_nombre;
    $this->organismoMunicipio = $organismo->municipio;

    $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '16')->first();

    if($numeracion != null){
      $this->ultimaNumeracion = $numeracion->final;
    }
    $inicioNumeracion = $this->ultimaNumeracion + 1;

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                   'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

    $convertidorNumerosALetras = new \NumberToLetterConverter();

    $infraccion = Infraccion::all();
    $infraccion_f = InfraccionF::all();
    $tieneSancion = true;
    $tieneMandamiento = true;
    $acuerdo = Acuerdo::find($idAcuerdo);
    $comparendo = Comparendo::find($idComparendo);
    $sancion = ResolucionSimit::where('COL7', '=', $comparendo->numero)->where('COL5', '=', '1')->first();
    if($sancion == null){
      $tieneSancion = false;
    }
    $mandamiento = ResolucionSimit::where('COL7', '=', $comparendo->numero)->where('COL5', '=', '16')->first();
    if($mandamiento == null){
      $tieneMandamiento = false;
    }
    $this->ultimaNumeracion++;
    $archivo = '';
    /*CALCULANDO LA FECHA DE LA SANCION*/
    $fechaResolucion = '';
    $fechaGeneracionResolucion = '';
    $fechaResolucion = Carbon::now()->format('Y-m-d');
    $fechaNotificacion = Carbon::now()->format('d/m/Y');
    $fechaNotificacionBD = Carbon::now()->format('Y-m-d');
    $fechaResolucionCarbon = new Carbon($fechaResolucion);
    $fechaGeneracionResolucion = $fechaResolucionCarbon->day . ' de ' . $this->meses[$fechaResolucionCarbon->month - 1] . ' de ' . $fechaResolucionCarbon->year;

    $fechaComparendo = new Carbon($comparendo->infraccion_fecha);
    $fechaComparendo = $fechaComparendo->day . ' de ' . $this->meses[$fechaComparendo->month - 1] . ' de ' . $fechaComparendo->year;

    /*FIN DEL CALCULO*/
    $numeroResolucion = 'RAP-' . $this->ultimaNumeracion . '-' . $fechaResolucionCarbon->year;
    $archivo = $numeroResolucion . '.pdf';

    $folder = $rutaExpediente  .  $comparendo->numero_expediente;
    \File::makeDirectory($folder, 0777, true, true);

    $this->comparendopdf = view('acuerdo_pago.pdf.acuerdo_head_pdf',[
                            'organismoDireccion' => $this->organismoDireccion,
                            'rutaImagenTop' => $this->rutaImagenTop
                          ]);
    $infraccion_fecha = new Carbon($comparendo->infraccion_fecha);
    $infraccion_fecha = $infraccion_fecha->day . ' de ' . $this->meses[$infraccion_fecha->month - 1] . ' de ' . $infraccion_fecha->year;
    $descripcionInfraccion = '';
    $codigoLetraInfraccion = substr($comparendo->infracciones, 0, 1);
    $codigoCompletoInfraccion = $comparendo->infracciones;
    $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();

    if(!isset($if->salarios_dias)){
      foreach ($infraccion as $inf) {
        if($inf->codigo_old == $comparendo->infracciones){
          $codigoLetraInfraccion = substr($inf->codigo, 0, 1);
          $codigoCompletoInfraccion = $inf->codigo;
          $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();
          $infraccion_salario = $if->salarios_dias;
          break;
        }
      }
    } else{
      $infraccion_salario = $if->salarios_dias;
    }

    if($codigoLetraInfraccion == 'F'){

    }else {
      $descripcionInfraccion = Infraccion::where('codigo', '=', $codigoCompletoInfraccion)->first()->infraccion;
    }
    //intereses
    $intereses = CajaController::calcularIntereses($sancion->COL4, $sancion->COL23, 0);

    $honorario = ParamHonorario::orderby('id', 'desc')->first();
    $sistematizacion = ParamSistematizacion::orderby('id', 'desc')->first();
    //si es cobro coactivo cobrar honorario y sistematizacion
    if($tieneMandamiento){
      $valor_honorario = $honorario->valor * ($intereses * 1 + $sancion->COL23 * 1) / 100;
      $valor_sistematizacion = $sistematizacion->valor;
    }else{
      $valor_honorario = 0;
      $valor_sistematizacion = 0;
    }

    $sumaValoresAdicionales = $valor_honorario + $valor_sistematizacion;
    $sumaTotal = $acuerdo->valor;
    $pagoInicial = $acuerdo->cuota_inicial;
    $sumaComparendoInteres = $sumaTotal; // antes se restaban los valores adicionales - $sumaValoresAdicionales
    $cuotaPactada = ceil(($sumaTotal - $pagoInicial) / $acuerdo->plazo);

    //validando si viene por pago de embargos
    $esPorDesembargo = false;
    $embargo = ComparendoExpediente::where('id_comparendo', '=', $comparendo->id)
                                      ->where('id_tipo_evento', '=', '19')->first();
    if(isset($embargo->id)){
      $esPorDesembargo = true;
    }

    $sancionpdf =  view('acuerdo_pago.pdf.acuerdo_pdf', [
                            'comparendo' => $comparendo,
                            'numero_resolucion' => $numeroResolucion,
                            'fechaGeneracionResolucion' => $fechaGeneracionResolucion,
                            'fechaComparendo' => $fechaComparendo,
                            'tieneSancion' => $tieneSancion,
                            'sancion' => $sancion,
                            'descripcionInfraccion' => $descripcionInfraccion,
                            'infraccion_salario' => $infraccion_salario,
                            'valorLetras' => $convertidorNumerosALetras->to_word(round($acuerdo->valor)),
                            'valor' => $acuerdo->valor,
                            'tieneMandamiento' => $tieneMandamiento,
                            'mandamiento' => $mandamiento,
                            'plazo' => $acuerdo->plazo,
                            'intereses' => $intereses,
                            'valor_honorario' => $valor_honorario,
                            'valor_sistematizacion' => $valor_sistematizacion,
                            'sumaTotal' => $sumaTotal,
                            'pagoInicial' => $pagoInicial,
                            'cuotaPactada' => $cuotaPactada,
                            'fecha' => Carbon::now(),

                            'rutaFirma' => $this->rutaFirma,
                            'nombreSecretaria' => $this->organismoNombreSecreteria,
                            'nombreEmpresa' => $this->organismoEmpresaSecreteria,
                            'municipio' => $this->organismoMunicipio,
                            'fechaNotificacion' => $fechaNotificacion,
                            'activarNotificacion' => true,
                            'esPorDesembargo' => $esPorDesembargo
                          ]);

    $this->comparendopdf .= $sancionpdf . '</body></html>';

    $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');
    $pdf->save($folder . '/' . $archivo);
     $this->line("archivo: " . $folder . '/' . $archivo);

    //creando el registro en expediente
    $expediente = new \App\ComparendoExpediente();
    $expediente->id_comparendo = $comparendo->id;
    $expediente->fecha_generacion = $fechaResolucion;
    $expediente->nombre_documento = $archivo;
    $expediente->id_tipo_evento = 16;//res acuerdo pago
    $expediente->id_paquete = 0;
    $expediente->id_user = 4;
    $expediente->is_impreso = 0;
    $expediente->envio_simit = 0;
    $expediente->save();

    //creando el registro en resoluciones simit #6
    $fechaComparendo = new Carbon($comparendo->infraccion_fecha);
    $resolucion = new ResolucionSimit();
    $resolucion->COL2 = $numeroResolucion;
    if($tieneMandamiento){
      $resolucion->COL3 = $mandamiento->COL2;
    }else{
      $resolucion->COL3 = $sancion->COL2;
    }
    $resolucion->COL4 = $fechaNotificacion;
    $resolucion->COL5 = '6';
    $resolucion->COL7 = $comparendo->numero;
    $resolucion->COL8 = $fechaComparendo->format('d/m/Y');
    $resolucion->COL9 = $comparendo->infractor_documento;
    $resolucion->COL10 = '1';
    $resolucion->COL11 = mb_strtoupper($comparendo->infractor_nombre);
    $resolucion->COL12 = mb_strtoupper($comparendo->infractor_apellido);
    $resolucion->COL13 = mb_strtoupper($comparendo->infraccion_direccion);
    $resolucion->COL15 = $organismo->codigo;
    $resolucion->COL16 = ceil($sumaComparendoInteres);
    $resolucion->COL17 = ceil($sumaValoresAdicionales);

    if($comparendo->es_fotomulta == 0){
      $resolucion->COL18 = 'N';
    } elseif($comparendo->es_fotomulta == 1){
      $resolucion->COL18 = 'S';
    }
    $resolucion->COL19 = $organismo->codigo;

    if($comparendo->es_polca == 0){
      $resolucion->COL20 = 'N';
    } elseif($comparendo->es_polca == 1){
      $resolucion->COL20 = 'S';
    }

    $resolucion->COL21 = $comparendo->infracciones;
    $resolucion->COL22 = $comparendo->valor;
    $resolucion->COL23 = ceil($sumaComparendoInteres);

    if($comparendo->infracciones == 'F'){
      $resolucion->COL24 = $comparendo->grado_alcohol;
      $resolucion->COL25 = 'N';
    } else {
      $resolucion->COL24 = '';
      $resolucion->COL25 = '';
    }
    $resolucion->confirmado_simit = 0;
    $resolucion->es_pdf_impreso = 1;
    $resolucion->save();

    //creando el registro en resoluciones simit #8
    $resolucion = new ResolucionSimit();
    $resolucion->COL2 = $numeroResolucion;
    $resolucion->COL4 = $fechaNotificacion;
    $resolucion->COL5 = '8';
    $resolucion->COL7 = $comparendo->numero;
    $resolucion->COL8 = $fechaComparendo->format('d/m/Y');
    $resolucion->COL9 = $comparendo->infractor_documento;
    $resolucion->COL10 = '1';
    $resolucion->COL11 = mb_strtoupper($comparendo->infractor_nombre);
    $resolucion->COL12 = mb_strtoupper($comparendo->infractor_apellido);
    $resolucion->COL13 = mb_strtoupper($comparendo->infraccion_direccion);
    $resolucion->COL15 = $organismo->codigo;
    $resolucion->COL16 = ceil($sumaComparendoInteres);
    $resolucion->COL17 = ceil($sumaValoresAdicionales);

    if($comparendo->es_fotomulta == 0){
      $resolucion->COL18 = 'N';
    } elseif($comparendo->es_fotomulta == 1){
      $resolucion->COL18 = 'S';
    }
    $resolucion->COL19 = $organismo->codigo;

    if($comparendo->es_polca == 0){
      $resolucion->COL20 = 'N';
    } elseif($comparendo->es_polca == 1){
      $resolucion->COL20 = 'S';
    }

    $resolucion->COL21 = $acuerdo->plazo;
    $resolucion->COL22 = $comparendo->valor;
    $resolucion->COL23 = ceil($sumaComparendoInteres);

    if($comparendo->infracciones == 'F'){
      $resolucion->COL24 = $comparendo->grado_alcohol;
      $resolucion->COL25 = 'N';
    } else {
      $resolucion->COL24 = '';
      $resolucion->COL25 = '';
    }
    $resolucion->confirmado_simit = 0;
    $resolucion->es_pdf_impreso = 1;
    $resolucion->save();

    //actualizando
    $comparendoActualizar = Comparendo::find($comparendo->id);
    $comparendoActualizar->id_tipo_evento = 4;//sancion
    $comparendoActualizar->estado = 6;//acuerdo de pago
    $comparendoActualizar->fecha_notificacion = $fechaNotificacionBD;//fecha de notificado
    $comparendoActualizar->save();
    $this->line("acuerdo impreso: " . $comparendo->id);

    if($this->ultimaNumeracion >= $inicioNumeracion){
      $this->line("Actualizando Numeracion...");
      //actualizar la numeracion en un nuevo registro
      $numeracion = new Numeracion();
      $numeracion->prefijo = 'RAP';
      $numeracion->inicio = $inicioNumeracion;
      $numeracion->final = $this->ultimaNumeracion;
      $numeracion->id_tipo_evento = 16;//res acuerdo pago
      $numeracion->id_organismo = 1;
      $numeracion->id_paquete = 0;
      $numeracion->save();
      $this->line("Fin Numeracion");
    } else {
      $this->line("No se imprimo acuerdos.");
    }
  }
}
