<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;

class AvisoMandamientoEspecial extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'avisomandamientoespecial:start {total} {medio}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
    * variables de contenido de la tarea
    */
    protected $relacionContenido = '';
    protected $pdfMasivo = '';
    protected $comparendosImpresos = array();
    protected $ultimaNumeracion = 1900;
    protected $comparendopdf = '';
    protected $meses = [];
    protected $organismoNombreSecreteria = '';
    protected $organismoDireccion = '';
    protected $rutaImagenTop = '';
    protected $rutaFirma = '';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $totalAImprimir = $this->argument('total');
        $medio = $this->argument('medio');
        $this->rutaImagenTop = '';
        if($medio == "c"){
          $this->rutaImagenTop = base_path() . '/public/images/hoja membrete.jpg';
          $this->rutaFirma = base_path() . '/public/images/firma2.png';
        } else if($medio == "w"){
          $this->rutaImagenTop = base_path() . '/public/images/hoja membrete.jpg';
          $this->rutaFirma = base_path() . '/public/images/firma2.png';
        }
        $this->line("totalAImprimir: $totalAImprimir");
        $rutaExpediente = \Config::get('myconfig.ruta_avisos_mandamientos');

        $organismo = \App\Organismo::first();
        $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
        $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

        $this->pdfMasivo .= '<style>.page-break {page-break-after: always;}</style>';

        $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '14')->first();

        if($numeracion != null){
          $this->ultimaNumeracion = $numeracion->final;
        }
        $inicioNumeracion = $this->ultimaNumeracion + 1;

        /*$years = array(
                  array(
                    'year' => '2015',
                    'meses' => array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12)
                  ),
                  array(
                    'year' => '2016',
                    'meses' => array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12)
                  ),
                  array(
                    'year' => '2017',
                    'meses' => array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12)
                  ));*/
        $years = array(
                  array(
                    'year' => '2015',
                    'meses' => array(1, 2, 3, 4, 5, 6)
                  ));
        foreach ($years as $year) {
          $anio = $year['year'];
          $this->line($year['year']);
          foreach ($year['meses'] as $mes) {
            //consultar los mandamientos del año y meses
            $mandamientos = ComparendoExpediente::where('id_tipo_evento', '=', '5')
                                                ->whereYear('fecha_generacion', '=', $anio)
                                                ->whereMonth('fecha_generacion', '=', $mes)
                                                ->where('is_impreso', '=', '0')
                                                ->get();
            if(!$mandamientos->isEmpty()){
              $this->ultimaNumeracion++;
              $archivo = 'AVMP-' . $this->ultimaNumeracion . '-' . $mes . $anio . '.pdf';
              $folder = $rutaExpediente;
              \File::makeDirectory($folder, 0755, true, true);

              $fechaAvisoCarbon = new Carbon('01-' . $mes . '-' . $anio);
              $fechaAviso = $fechaAvisoCarbon->endOfMonth()->format('d/m/Y');

              //generamos por cada comparendo el registro de que se creo en el aviso y cambiamos el estado en aviso
              $mandamientosArray = [];
              $mandamientosCollection = null;
              foreach ($mandamientos as $mandamiento) {
                  array_push($mandamientosArray, (object) array(
                                                  'identificacion' => $mandamiento->comparendo->infractor_documento,
                                                  'comparendo' => $mandamiento->comparendo->numero,
                                                  'fecha_comparendo' => Carbon::parse($mandamiento->comparendo->infraccion_fecha)->format('d/m/Y'),
                                                  'numero_mandamiento' => preg_replace('/\\.[^.\\s]{3,4}$/', '', $mandamiento->nombre_documento),
                                                  'fecha_mandamiento' => Carbon::parse($mandamiento->fecha_generacion)->format('d/m/Y')
                                                ));
                  $mandamientosCollection = new Collection($mandamientosArray);
                  $mandamientosCollection = $mandamientosCollection->sortBy('identificacion');
                  //creando el registro en expediente
                  $expediente = new \App\ComparendoExpediente();
                  $expediente->id_comparendo = $mandamiento->comparendo->id;
                  $expediente->fecha_generacion = $fechaAviso;
                  $expediente->nombre_documento = $archivo;
                  $expediente->id_tipo_evento = 14;//aviso mandamiento de pago
                  $expediente->id_paquete = 0;
                  $expediente->id_user = 4;
                  $expediente->save();

                  $comparendoActualizar = Comparendo::find($mandamiento->comparendo->id)->where('id_tipo_evento', '=', '5')->first();
                  $comparendoActualizar->id_tipo_evento = 14;//aviso mandamiento de pago
                  $comparendoActualizar->save();
                  $this->line("aviso mandamiento impreso: " . $mandamiento->comparendo->id);

                  $mandamiento->is_impreso = 1;
                  $mandamiento->save();

                  $this->line("expediente actualizado: " . $mandamiento->nombre_documento);
              }
              $this->comparendopdf = view('comparendos.especial.aviso_mandamiento_head_pdf',[
                                      'organismoDireccion' => $this->organismoDireccion,
                                      'rutaImagenTop' => $this->rutaImagenTop,
                                      'rutaFirma' => $this->rutaFirma,
                                      'fechaAviso' => $fechaAviso
                                    ]);
              $this->comparendopdf .= '<div class="page-break"></div>';
              $avisopdf = view('comparendos.especial.aviso_mandamiento_pdf', [
                                      'mandamientos' => $mandamientosCollection
                                    ]);

              $this->comparendopdf .= $avisopdf . '</body></html>';

              $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('letter', 'portrait');
              $pdf->save($folder . '/' . $archivo);
            }
          }
        }

        if($this->ultimaNumeracion >= $inicioNumeracion){
          $this->line("Actualizando Numeracion...");
          //actualizar la numeracion en un nuevo registro
          $numeracion = new Numeracion();
          $numeracion->prefijo = 'AVMP';
          $numeracion->inicio = $inicioNumeracion;
          $numeracion->final = $this->ultimaNumeracion;
          $numeracion->id_tipo_evento = 14;//aviso mandamiento de pago
          $numeracion->id_organismo = 1;
          $numeracion->id_paquete = 0;
          $numeracion->save();
          $this->line("Fin Numeracion");
        } else {
          $this->line("No se imprimo avisos de mandamientos.");
        }
    }
}
