<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use App\ResolucionSimit;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;
use Maatwebsite\Excel\Facades\Excel;

class AvisoMandamientoEspecial1 extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'avisomandamientoespecial1:start';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
    * variables de contenido de la tarea
    */
    protected $relacionContenido = '';
    protected $pdfMasivo = '';
    protected $comparendosImpresos = array();
    protected $ultimaNumeracion = 1900;
    protected $comparendopdf = '';
    protected $meses = [];
    protected $organismoNombreSecreteria = '';
    protected $organismoDireccion = '';
    protected $rutaImagenTop = '';
    protected $rutaFirma = '';
    protected $avisos = null;

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {

      $this->rutaImagenTop = base_path() . '/public/images/hoja membrete.jpg';
      $this->rutaFirma = base_path() . '/public/images/firma2.png';

      $rutaExpediente = \Config::get('myconfig.ruta_avisos_mandamientos');

      $organismo = \App\Organismo::first();
      $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
      $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

      $this->pdfMasivo .= '<style>.page-break {page-break-after: always;}</style>';

      //consultando y guardando en un array las resoluciones_simit
      /*$resoluciones = ResolucionSimit::where('COL5', DB::raw("'16'"))
                                    ->where('para_revisiones', 0)
                                    ->whereBetween('fecha_format_comparendo', array('2013-06-30', '2016-06-30'))->get();*/
      $resoluciones = ResolucionSimit::where('id', 91699)->get();
      $mandamientosResol = [];
      foreach ($resoluciones as $resolucion) {
        $comparendo = Comparendo::where('numero', '=', $resolucion->COL7)->first();
        if(isset($comparendo->id)){
          if($comparendo->tieneSaldo($comparendo->id)){
            $avisomandamiento = ComparendoExpediente::where('id_tipo_evento', '=', '14')
                                                ->where('id_comparendo', '=', $comparendo->id)
                                                ->first();
            if(!isset($avisomandamiento->id)){
              try {
                $this->line("Res. " . $resolucion->COL2);
                array_push($mandamientosResol, (object) array(
                  'identificacion' => $comparendo->infractor_documento,
                  'comparendo' => $comparendo->numero,
                  'fecha_comparendo' => Carbon::parse($comparendo->infraccion_fecha)->format('d/m/Y'),
                  'numero_mandamiento' => preg_replace('/\\.[^.\\s]{3,4}$/', '', $resolucion->COL2),
                  'fecha_mandamiento' => Carbon::parse($resolucion->fecha_format_resol)->format('d/m/Y')
                ));
              } catch (\Exception $e) {
                $this->line("Res. " . $resolucion->COL2);
              }
            }else{
              $this->line("tiene aviso");
              $resolucion->para_revisiones = -1;
              $resolucion->save();
            }
          }else{
            $this->line("no tiene saldo");
            $resolucion->para_revisiones = -1;
            $resolucion->save();
          }
        }
      }

      $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '14')->first();

      if($numeracion != null){
        $this->ultimaNumeracion = $numeracion->final;
      }
      $inicioNumeracion = $this->ultimaNumeracion + 1;

      $archivo = '';
      $folder = $rutaExpediente;
      \File::makeDirectory($folder, 0777, true, true);

      $festivos = Festivos::all();

      $fechaAvisoCarbon = new Carbon('2019-05-01');
      $fechaAvisoCarbon = Comparendo::calcularFechaHabilLaboral($festivos, $fechaAvisoCarbon->endOfMonth());
      $fechaAvisoCarbon = new Carbon($fechaAvisoCarbon);
      $fechaAviso = $fechaAvisoCarbon->format('Y-m-d');

      //generamos por cada comparendo el registro de que se creo en el aviso y cambiamos el estado en aviso
      $mandamientosArray = [];
      $mandamientosCollection = null;
      foreach ($mandamientosResol as $resolucion) {
        $comparendo = Comparendo::where('numero', '=', $resolucion->comparendo)->first();
        array_push($mandamientosArray, (object) array(
                                        'identificacion' => $resolucion->identificacion,
                                        'comparendo' => $comparendo->numero,
                                        'fecha_comparendo' => $resolucion->fecha_comparendo,
                                        'numero_mandamiento' => $resolucion->numero_mandamiento,
                                        'fecha_mandamiento' => $resolucion->fecha_mandamiento,
                                        'comparendo_id' => $comparendo->id,
                                        'expediente' => $comparendo->numero_expediente
                                      ));
      }
      //armando paquetes de 500 por aviso en un array multidimencional
      $countAvisos = 1;
      $avisosMatriz = [];
      $avisosArrayUni = [];
      $countMan = 0;
      foreach ($mandamientosArray as $man) {
        $countMan++;
        if($countAvisos < 500){
          array_push($avisosArrayUni, (object) array(
                                          'identificacion' => $man->identificacion,
                                          'comparendo' => $man->comparendo,
                                          'fecha_comparendo' => $man->fecha_comparendo,
                                          'numero_mandamiento' => $man->numero_mandamiento,
                                          'fecha_mandamiento' => $man->fecha_mandamiento,
                                          'comparendo_id' => $man->comparendo_id,
                                          'expediente' => $man->expediente
                                        ));
          $countAvisos++;
          if($countMan == count($mandamientosArray)){
            array_push($avisosMatriz, (object) array(
                                          'aviso' => $avisosArrayUni,
                                        ));
          }
        }else {
          array_push($avisosMatriz, (object) array(
                                        'aviso' => $avisosArrayUni,
                                      ));
          $countAvisos = 1;
          $avisosArrayUni = [];
          array_push($avisosArrayUni, (object) array(
                                          'identificacion' => $man->identificacion,
                                          'comparendo' => $man->comparendo,
                                          'fecha_comparendo' => $man->fecha_comparendo,
                                          'numero_mandamiento' => $man->numero_mandamiento,
                                          'fecha_mandamiento' => $man->fecha_mandamiento,
                                          'comparendo_id' => $man->comparendo_id,
                                          'expediente' => $man->expediente
                                        ));
          $countAvisos++;
        }
      }
      //escribiendo los paquetes
      $mandamientosArrayExcel = [];
      foreach ($avisosMatriz as $av) {
        $this->ultimaNumeracion++;
        $archivo = 'AVMP-' . $this->ultimaNumeracion . '-' . $fechaAvisoCarbon->format('m-Y');
        $mandamientosArray = [];
        foreach ($av->aviso as $man) {
          array_push($mandamientosArray, (object) array(
                                          'identificacion' => $man->identificacion,
                                          'comparendo' => $man->comparendo,
                                          'fecha_comparendo' => $man->fecha_comparendo,
                                          'numero_mandamiento' => $man->numero_mandamiento,
                                          'fecha_mandamiento' => $man->fecha_mandamiento
                                        ));
          array_push($mandamientosArrayExcel, array(
                                          'identificacion' => $man->identificacion,
                                          'nombre' => $man->numero_mandamiento,
                                          'fecha' => $fechaAviso,
                                          'archivo' => $archivo,
                                          'expediente' => $man->expediente
                                        ));
          //creando el registro en expediente
          $expediente = new \App\ComparendoExpediente();
          $expediente->id_comparendo = $man->comparendo_id;
          $expediente->fecha_generacion = $fechaAviso;
          $expediente->nombre_documento = $archivo;
          $expediente->id_tipo_evento = 14;//aviso mandamiento de pago
          $expediente->id_paquete = 0;
          $expediente->id_user = 4;
          $expediente->save();
        }
        $mandamientosCollection = new Collection($mandamientosArray);//tiene un mandamiento array de 500
        $mandamientosCollection = $mandamientosCollection->sortBy('identificacion');
        $this->comparendopdf = view('comparendos.especial.aviso_mandamiento_head_pdf',[
                                'organismoDireccion' => $this->organismoDireccion,
                                'rutaImagenTop' => $this->rutaImagenTop,
                                'rutaFirma' => $this->rutaFirma,
                                'fechaAviso' => $fechaAvisoCarbon->format('d/m/Y'),
                                'nombreAviso' => $archivo,
                                'nombreSecretaria' => mb_strtoupper($organismo->secretaria_nombre),
                                'activarFirma' => true
                              ]);
        $this->comparendopdf .= '<div class="page-break"></div>';
        $avisopdf = view('comparendos.especial.aviso_mandamiento_pdf', [
                                'mandamientos' => $mandamientosCollection
                              ]);

        $this->comparendopdf .= $avisopdf . '</body></html>';

        $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('letter', 'portrait');
        $pdf->save($folder . '/' . $archivo. '.pdf');
      }

      $this->avisos = $mandamientosArrayExcel;
      Excel::create($archivo, function($excel) {
        $avisos = $this->avisos;
        $excel->sheet('Avisos', function ($sheet) use ($avisos) {
            $sheet->fromArray($avisos);
        });

      })->store('xls', storage_path('excel'));


      if($this->ultimaNumeracion >= $inicioNumeracion){
        $this->line("Actualizando Numeracion...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'AVMP';
        $numeracion->inicio = $inicioNumeracion;
        $numeracion->final = $this->ultimaNumeracion;
        $numeracion->id_tipo_evento = 14;//aviso mandamiento de pago
        $numeracion->id_organismo = 1;
        $numeracion->id_paquete = 0;
        $numeracion->save();
        $this->line("Fin Numeracion");
      } else {
        $this->line("No se imprimo avisos de mandamientos.");
      }
      $sale = 0;
      if(count($resoluciones) == 0){
        $sale = 0;
      }else{
        $sale = count($resoluciones);
      }
    }
}
