<?php

namespace App\Console\Commands\Avisos;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use App\AvisosCC;
use App\ResolucionSimit;
use App\ComparendoEntregaOficios as EntregaCitacion;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;
use Maatwebsite\Excel\Facades\Excel;

class AvisoEspecial extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'avisoespecial:start';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'avisos de fechas antiguas';

    /**
    * variables de contenido de la tarea
    */
    protected $relacionContenido = '';
    protected $pdfMasivo = '';
    protected $comparendosImpresos = array();
    protected $ultimaNumeracion = 1900;
    protected $comparendopdf = '';
    protected $meses = [];
    protected $organismoNombreSecreteria = '';
    protected $organismoNombreSecreterio = '';
    protected $organismoDireccion = '';
    protected $rutaImagenTop = '';
    protected $rutaFirma = '';
    protected $avisos = null;

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {

      $this->rutaImagenTop = base_path() . '/public/images/hoja membrete.jpg';
      //$this->rutaFirma = base_path() . '/public/images/firma2.png';


$organismo = \App\Organismo::first();

      if(env('TRANSITO')=="Curumani")
      {
      $this->rutaFirma = base_path() . '/public/images/firma_camilo.png';
      $this->organismoNombreSecreterio="CAMILO ANDRES MORALES HAECKERMANN";        
      }

      if(env('TRANSITO')=="Sabana De Torres")
      {
      //$this->rutaFirma = base_path() . '/public/images/firma_daniel.png';
      $this->rutaFirma = base_path() . '/public/images/firma.png';
      //$this->organismoNombreSecreterio="DANIEL AUGUSTO ARENAS ROJAS"; //2018
      //$this->organismoNombreSecreterio=$organismo->secretario_anterior; // 2019 Denis
      $this->organismoNombreSecreterio="Carlos Daniel Ditta Navarro"; //2020
      }

      if(env('TRANSITO')=="Guaduas")
      {
      //$this->rutaFirma = base_path() . '/public/images/firma_daniel.png';
      $this->rutaFirma = base_path() . '/public/images/firma.png';
      //$this->organismoNombreSecreterio="DANIEL AUGUSTO ARENAS ROJAS"; //2018
      //$this->organismoNombreSecreterio=$organismo->secretario_anterior; // 2019 Denis
      $this->organismoNombreSecreterio="ANDREA JULIANA PERALTA ACEVEDO"; //2020
      }

      $rutaExpediente = \Config::get('myconfig.ruta_avisos_mandamientos');

      
      $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
      $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

      $this->pdfMasivo .= '<style>.page-break {page-break-after: always;}</style>';
      //$this->pdfMasivo .= '<style></style>';

      $festivos = Festivos::all();

      $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '14')->first();

      if($numeracion != null){
        $this->ultimaNumeracion = $numeracion->final;
      }
      $inicioNumeracion = $this->ultimaNumeracion + 1;

      $aniosArray = ['2022'];
      $mesesArray = ['01','02','03','04','05','06', '07', '08', '09', '10', '11', '12'];//2018-12-01

      /*$aniosArray = ['2014', '2015'];
      $mesesArray = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'];//2016-12-01*/

      /*$aniosArray = ['2013'];
      $mesesArray = ['02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'];//2016-01-01*/

      /*$aniosArray = ['2013'];
      $mesesArray = ['01'];//2015-12-01*/

      /*$aniosArray = ['2012'];
      $mesesArray = ['07', '08', '09', '10', '11', '12'];//2015-06-01*/

      /*$aniosArray = ['2012'];
      $mesesArray = ['01', '02', '03', '04', '05', '06'];//2014-08-12*/
      $mandamientosArrayExcel = [];
      //$fechaAvisoCarbon = new Carbon('2014-08-12');//los de ofelia
      $fechaAvisoCarbon = new Carbon('2023-01-05');
      foreach ($aniosArray as $key) {
        foreach ($mesesArray as $keymes) {
          $archivo = '';
          $folder = $rutaExpediente;
          \File::makeDirectory($folder, 0777, true, true);

          //$fechaAvisoCarbon = Comparendo::calcularFechaHabilLaboralAnterior($festivos, $fechaAvisoCarbon->endOfMonth());
          //$fechaAvisoCarbon = new Carbon($fechaAvisoCarbon);
          $fechaAviso = $fechaAvisoCarbon->format('Y-m-d');

          $this->ultimaNumeracion++;
          $archivo = 'AVMP-' . $this->ultimaNumeracion . '-' . $fechaAvisoCarbon->format('m-Y');

          /*$resoluciones = ResolucionSimit::where('COL5', DB::raw("'16'"))
                                        ->whereBetween('fecha_format_comparendo', array(
                                                                                $key.'-'.$keymes.'-01',
                                                                                $key.'-'.$keymes.'-31')
                                                                                )->get();*/
          /*$resoluciones = ResolucionSimit::where('id', 38843)
                                          ->orWhere('id', 40544)->get();*/
          $mandamientosArray = [];
/*
->whereBetween('fecha_format_comparendo', array(
                                $key.'-'.$keymes.'-01',
                                $key.'-'.$keymes.'-31')*/

            ResolucionSimit::where('COL5', DB::raw("'16'"))
                            ->where('fecha_format_comparendo', '>=',
                                $key.'-'.$keymes.'-01')
                             ->where('fecha_format_comparendo', '<=',
                                $key.'-'.$keymes.'-31')
                                ->chunk(100, function($resoluciones) 
                                use (&$archivo,&$mandamientosArray,&$fechaAvisoCarbon,
                                  &$fechaAviso,&$folder,&$mandamientosArrayExcel,&$key,&$keymes){
            $comparendoid="";
          $comparendonumero="";  
          $festivos = Festivos::all();                            

          foreach ($resoluciones as $resolucion) {
            $this->line("NumCompa:".$resolucion->COL9);
            $cedu = AvisosCC::where('cc', $resolucion->COL9)->first();
            if(isset($cedu->id)){

            $comparendo = Comparendo::where('numero', '=', $resolucion->COL7)->first();
          $comparendoid=$comparendo->id;
          $comparendonumero=$comparendo->numero;            
            if(isset($comparendo->id)){
              if($comparendo->tieneSaldo($comparendo->id)){
                if(!$comparendo->tieneAcuerdoVigente($comparendo->id)){//que no tenga acuerdo vigente
                  /*$avisomandamiento = ComparendoExpediente::where('id_tipo_evento', '=', '14')
                                                      ->where('id_comparendo', '=', $comparendo->id)
                                                      ->first();
                  if(!isset($avisomandamiento->id)){*/
                    $notificacion = EntregaCitacion::where('estado', '1')
                                                        ->where('id_comparendo', '=', $comparendo->id)
                                                        ->first();
                    //if(!isset($notificacion->id)){
                      try {
                        $this->line("Res. " . $resolucion->COL2);
                        array_push($mandamientosArray, (object) array(
                          'identificacion' => $comparendo->infractor_documento,
                          'comparendo' => $comparendo->numero,
                          'fecha_comparendo' => Carbon::parse($comparendo->infraccion_fecha)->format('d/m/Y'),
                          'numero_mandamiento' => preg_replace('/\\.[^.\\s]{3,4}$/', '', $resolucion->COL2),
                          'fecha_mandamiento' => Carbon::parse($resolucion->fecha_format_resol)->format('d/m/Y')
                        ));

                       /* array_push($mandamientosArrayExcel, array(
                                                        'identificacion' => $comparendo->infractor_documento,
                                                        'nombre' => preg_replace('/\\.[^.\\s]{3,4}$/', '', $resolucion->COL2),
                                                        'fecha' => $fechaAviso,
                                                        'archivo' => $archivo,
                                                        'expediente' => $comparendo->numero_expediente
                                                      ));*/
                        //creando el registro en expediente
                        $expediente = new \App\ComparendoExpediente();
                        $expediente->id_comparendo = $comparendo->id;
                        $expediente->fecha_generacion = $fechaAviso;
                        $expediente->nombre_documento = $archivo;
                        $expediente->id_tipo_evento = 14;//aviso mandamiento de pago
                        $expediente->id_paquete = 0;
                        $expediente->id_user = 4;
                        $expediente->save();

                        $this->line("archivo. " . $archivo. ", IdCompa:". $comparendoid.", NumCompa:".$comparendonumero);

                      } catch (\Exception $e) {
                        $this->line("Excepcion Res. " . $resolucion->COL2. ' ' . $e);
                      }
                    /*}else{
                      $this->line("tiene notificacion entregada".$comparendonumero);
                      $resolucion->para_revisiones = -1;
                      $resolucion->save();
                    }*/

                  /*}else{
                    $this->line("tiene aviso".$comparendonumero);
                    $resolucion->para_revisiones = -1;
                    $resolucion->save();
                  }*/
                }
              }else{
                $this->line("no tiene saldo".$comparendonumero);
                $resolucion->para_revisiones = -1;
                $resolucion->save();
              }
            }
          }//fin cc
        }



          $mandamientosCollection = new Collection($mandamientosArray);
          $mandamientosCollection = $mandamientosCollection->sortBy('identificacion');
          $this->comparendopdf = view('comparendos.especial.aviso_mandamiento_head_pdf',[
                                  'organismoDireccion' => $this->organismoDireccion,
                                  'rutaImagenTop' => $this->rutaImagenTop,
                                  'rutaFirma' => $this->rutaFirma,
                                  'fechaAviso' => $fechaAvisoCarbon->format('d/m/Y'),
                                  'nombreAviso' => $archivo,
                    'nombreSecretaria' => $this->organismoNombreSecreterio, //'XILENA ANILLO RODRIGUEZ',//OFELIA MURILLO CASALINS
                                  'activarFirma' => true
                                ]);
          $this->comparendopdf .= '<div class="page-break"></div>';//
          $avisopdf = view('comparendos.especial.aviso_mandamiento_pdf', [
                                  'mandamientos' => $mandamientosCollection
                                ]);

          $this->comparendopdf .= $avisopdf . '</body></html>';

          $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('letter', 'portrait');
          $pdf->save($folder . '/' . $archivo. '.pdf');


          $this->line("anio. " . $key. ", IdCompa:". $comparendoid.", NumCompa:".$comparendonumero);
          //al terminar el mes se agrega otro a la fecha del avisos
          //$fechaAvisoCarbon = $fechaAvisoCarbon->addDays(15);
          });

        }
      }


      //$this->avisos = $mandamientosArrayExcel;
      /*Excel::create($archivo, function($excel) {
        $avisos = $this->avisos;
        $excel->sheet('Avisos', function ($sheet) use ($avisos) {
            $sheet->fromArray($avisos);
        });

      })->store('xls', storage_path('excel'));*/


      if($this->ultimaNumeracion >= $inicioNumeracion){
        $this->line("Actualizando Numeracion...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'AVMP';
        $numeracion->inicio = $inicioNumeracion;
        $numeracion->final = $this->ultimaNumeracion;
        $numeracion->id_tipo_evento = 14;//aviso mandamiento de pago
        $numeracion->id_organismo = 1;
        $numeracion->id_paquete = 0;
        $numeracion->save();
        $this->line("Fin Numeracion");
      } else {
        $this->line("No se imprimo avisos de mandamientos.");
      }
      /*
      $sale = 0;
      if(count($resoluciones) == 0){
        $sale = 0;
      }else{
        $sale = count($resoluciones);
      }
      */
    }
}
