<?php

namespace App\Console\Commands;

use App\RecaudoSimit;
use Illuminate\Console\Command;
use League\Csv\Reader;
use App\Ciudadano;
use App\Comparendo;
use App\Vehiculo;
use App\Transaccion;
use App\Recibo;
use App\ComparendoCurso;
use Carbon\Carbon;

class CargarCursos extends Command
{

  /**
   * The name and signature of the console command.
   *
   * @var string
   */
  //php artisan simit:cursos pagos20228000rec externo 0
  protected $signature = 'simit:cursos {filename} {origen} {ruta}';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Cargar Cursos';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    //$archivo = \Storage::path("resoluciones_simit.txt");
    //$csv = Reader::createFromPath($archivo, 'r');
    $filename = $this->argument('filename') . '.txt';
    $tipoArchivo = $this->argument('origen');

    $csv = [];
    if($this->argument('ruta') == '0'){
      $csv = Reader::createFromPath(public_path('uploads/' . $filename), 'r');
    }else{
      $csv = Reader::createFromPath($this->argument('ruta') . $filename, 'r');
    }

    $c = 1;
    foreach ($csv as $record) {
      if($c>1)
      {
      if (count($record) == 4) {
        $this->line("{$c}. PROCESANDO REGISTRO DE CONTROL CURSOS...");
      } else {
        $recaudo = new ComparendoCurso();
        $recaudo->COL2 = trim($record[4]);
        $recaudo->COL3 = trim($record[5]);
        $recaudo->COL4 = trim($record[7]);
        $recaudo->COL5 = trim($record[2]);
        $recaudo->COL6 = trim($record[9]);
        $recaudo->COL7 = trim($record[15]);

        $procesar=0;
        $items=Comparendo::where('numero',  $recaudo->COL4)->get();
            foreach ($items as $item) {
              $item->fecha_curso=substr($recaudo->COL7,6,4)."-"
              .substr($recaudo->COL7,3,2)."-".substr($recaudo->COL7,0,2);
              $codigoLetraInfraccion = substr($item->infracciones, 0, 1);
              $procesar=1;
              if($codigoLetraInfraccion=="H")
              {
                 $item->fecha_pago=$item->fecha_curso;
                 $procesar=2;
              }
              $item->save();

            }
        $recaudo->procesar = $procesar;
        //$recaudo->save();
      
        $recaudoBuscado = ComparendoCurso::where('COL2', '=', trim($recaudo->COL2))
                                      ->where('COL3', '=', trim($recaudo->COL3))
                                      ->where('COL4', '=', trim($recaudo->COL4))
                                      ->where('COL5', '=', trim($recaudo->COL5))
                                      ->where('COL6', '=', trim($recaudo->COL6))
                                      ->where('COL7', '=', trim($recaudo->COL7))
                                      ->get();
        if(count($recaudoBuscado) == 0){
          $this->line("{$c}. INSERTANDO CURSO {$record[0]}...".trim($recaudo->COL3).", ".trim($recaudo->COL4).", ".trim($recaudo->COL7));
          $recaudo->save();
        }else{
          $this->error("{$c}. CURSO YA REGISTRADO {$record[0]}...".trim($recaudo->COL3).", ".trim($recaudo->COL4).", ".trim($recaudo->COL7));
        }
      }
      }
      $c++;
    }
  }
}
