<?php

namespace App\Console\Commands;

use App\RecaudoSimit;
use Illuminate\Console\Command;
use League\Csv\Reader;
use App\Ciudadano;
use App\Comparendo;
use App\Vehiculo;
use App\Transaccion;
use App\Recibo;
use Carbon\Carbon;

class CargarRecaudo extends Command
{

  /**
   * The name and signature of the console command.
   *
   * @var string
   */
  //php artisan simit:recaudo pagos20228000rec externo 0
  protected $signature = 'simit:recaudo {filename} {origen} {ruta}';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Cargar recaudos';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    //$archivo = \Storage::path("resoluciones_simit.txt");
    //$csv = Reader::createFromPath($archivo, 'r');
    $filename = $this->argument('filename') . '.txt';
    $tipoArchivo = $this->argument('origen');

    $csv = [];
    if($this->argument('ruta') == '0'){
      $csv = Reader::createFromPath(public_path('uploads/' . $filename), 'r');
    }else{
      $csv = Reader::createFromPath($this->argument('ruta') . $filename, 'r');
    }

    $c = 1;
    foreach ($csv as $record) {
      if (count($record) == 4) {
        $this->line("{$c}. PROCESANDO REGISTRO DE CONTROL...");
      } else {
        $recaudo = new RecaudoSimit();
        $recaudo->C2 = $record[1];
        $recaudo->C3 = $record[2];
        $recaudo->C4 = $record[3];
        $recaudo->C5 = $record[4];
        $recaudo->C6 = $record[5];
        $recaudo->C7 = $record[6];
        $recaudo->C8 = $record[7];
        $recaudo->C9 = $record[8];
        /*si el recaudo viene del web service no me dice si es polca, debo correr una columna*/
        if($this->argument('ruta') == '0'){
          $recaudo->C10 = $record[9];
          $recaudo->C11 = '';
          $recaudo->C12 = $record[10];
          $recaudo->C13 = $record[11];
          $recaudo->C14 = $record[12];
          $recaudo->C15 = $record[13];
        }else{
          $recaudo->C10 = $record[9];
          $recaudo->C11 = '';
          $recaudo->C12 = $record[10];
          $recaudo->C13 = $record[11];
          $recaudo->C14 = $record[12];
          $recaudo->C15 = $record[13];
        }

        if($tipoArchivo == 'externo'){
          if(isset($record[15])){
            $recaudo->C16 = $record[15];//numero de comparendo
          }else{
            $recaudo->C16 = $record[14];//numero de comparendo
          }
        } else if($tipoArchivo == 'local'){
          $recaudo->C16 = $record[9];//numero de comparendo
        }
        $recaudo->fuente = $tipoArchivo;

        $recaudoBuscado = RecaudoSimit::where('C2', '=', $recaudo->C2)
                                      ->where('C3', '=', $recaudo->C3)
                                      ->where('C4', '=', $recaudo->C4)
                                      ->where('C5', '=', $recaudo->C5)
                                      ->where('C6', '=', $recaudo->C6)
                                      ->where('C7', '=', $recaudo->C7)
                                      ->where('C8', '=', $recaudo->C8)
                                      ->where('C9', '=', $recaudo->C9)
                                      ->where('C10', '=', $recaudo->C10)
                                      ->where('C11', '=', $recaudo->C11)
                                      ->where('C12', '=', $recaudo->C12)
                                      ->where('C13', '=', $recaudo->C13)
                                      ->where('C14', '=', $recaudo->C14)
                                      ->where('C15', '=', $recaudo->C15)
                                      ->where('C16', '=', $recaudo->C16)
                                      ->get();
        if(count($recaudoBuscado) == 0){
          $this->line("{$c}. INSERTANDO RECAUDO {$record[0]}...");
          $recaudo->save();
        }else{
          $this->error("{$c}. YA REGISTRADO {$record[0]}...");
        }
      }
      $c++;
    }
  }
}
