<?php

namespace App\Console\Commands;

use App\Ciudadano;
use App\Comparendo;
use App\ComparendoSimit;
use App\Http\Controllers\CargarVehiculosController;
use App\Http\Controllers\ControladorAgentes;
use App\Vehiculo;
use App\VehiculoCargar;
use App\VehiculoCilindraje;
use App\VehiculoColor;
use App\VehiculoMarca;
use App\VehiculoModelo;
use Illuminate\Console\Command;
use League\Csv\Reader;
use League\Csv\Statement;

class CargarVehiculos extends Command
{

    protected $signature = 'cargar:vehiculos';

    protected $description = 'Cargar Vehiculos';

    public function __construct()
    {
        parent::__construct();
    }

    public function handle()
    {
        $this->line("Cargando Datos..");
        ini_set('memory_limit', '-1');
        $archivo = \Storage::path("vehiculos.xlsx");

        $rows = \Excel::load($archivo)->get();

        foreach ($rows as $row) {
            $vehiculo = new VehiculoCargar();
            $ciudadano = new Ciudadano();
            $idPropietario = null;
            /*  tipo_documento
                documento_propietario
                propietario
                direccion
                ciudad_residencia_propietario
                ciudad_residencia_propietario_1
                telefono_propietario
                celular_propietario
                email
            */

            //Ciudadanos

            if (Ciudadano::where('numero_documento', $row->documento_propietario)->get() == '[]') {
                $tpcedula = $row->tipo_documento;

                if ($tpcedula == 'C') {
                    $tpcedula = "cc";
                } else if ($tpcedula == 'N') {
                    $tpcedula = "nit";
                }

                $ciudadano->nombre = $row->propietario;
                $ciudadano->tipo_documento = $tpcedula;
                $ciudadano->numero_documento = $row->documento_propietario;
                $ciudadano->ciudad_residencia = $row->ciudad_residencia_propietario;
                $ciudadano->direccion_residencia = $row->direccion;
                $ciudadano->telefono_fijo = $row->telefono_propietario;
                $ciudadano->telefono_celular = $row->celular_propietario;
                $ciudadano->email = $row->email;
                $ciudadano->id_organismo = '1';


                $ciudadano->save();
                $idPropietario = $ciudadano->id;

            } else {
                $queryCiudadan = Ciudadano::where('numero_documento', $row->documento_propietario)->first();
                $idPropietario = $queryCiudadan->id;
            }

            $placa = $row->placa;

            if (VehiculoCargar::where('placa', $placa)->get() != "[]") {

                $cv = VehiculoCargar::where('placa', $placa)->first();

                $tipo = null;
                $carroseria = null;
                $cilindraje = null;
                $vehiculoModel = new VehiculoModelo;
                $cilindrajeModel = new VehiculoCilindraje;
                $colorModel = new VehiculoColor;
                $idmodel = null;
                $idcilindraje = null;
                $carroseria = $row->carroceria;
                $color = $row->color;
                $idcolor = null;

                //Marca
                $marca = $row->marca;
                $marcaQuery = VehiculoMarca::where('nombre', $marca)->first();
                $idmarca = $marcaQuery->id;

                //Tipo
                $tipo = $row->clase;

                if ($tipo == 'MOTOCICLETA') {
                    $tipo = 7;
                } else if ($tipo == 'AUTOMOVIL') {
                    $tipo = 2;
                }

                //Get Model
                $modeloQuery = VehiculoModelo::where('id_marca', $idmarca)
                    ->where('id_tipo', $tipo)->get();
                if ($modeloQuery == '[]') {
                    $vehiculoModel->id_marca = $idmarca;
                    $vehiculoModel->id_tipo = $tipo;
                    $vehiculoModel->nombre = $row->linea;
                    $vehiculoModel->auto = '1';
                    $vehiculoModel->save();
                    $idmodel = $vehiculoModel->id;

                    $cilindrajeModel->id_modelo = $idmodel;
                    $cilindrajeModel->cilindraje = $row->cilindraje;
                    $idcilindraje = $cilindrajeModel->id;

                    $cv->id_cilindraje = $idcilindraje;
                    $cv->cilindraje = $row->cilindraje;
                } else {
                    $modeloQuery = VehiculoModelo::where('id_marca', $idmarca)
                        ->where('id_tipo', $tipo)->first();

                    $cilindrajeModel->id_modelo = $modeloQuery->id;
                    $cilindrajeModel->cilindraje = $row->cilindraje;
                    $idcilindraje = $cilindrajeModel->id;

                    $cv->id_cilindraje = $idcilindraje;
                    $cv->cilindraje = $row->cilindraje;
                    $idmodel = $modeloQuery->id;
                }

                $cv->id_organismo = '1';
                $cv->placa = $row->placa;
                $cv->id_clase = $tipo;
                $cv->id_tipo = $tipo;
                $cv->chasis = $row->chasis;

                if ($carroseria == "SPORT") {
                    $carroseria = 318;
                } else if ($carroseria == "TURISMO") {
                    $carroseria = 289;
                }
                if ($carroseria == "SIN CARROCERIA") {
                    $carroseria = 275;
                }

                $cv->id_carroceria = $carroseria;
                $cv->id_marca = $idmarca;
                $cv->ano = $row->modelo;
                $cv->id_modelo = $idmodel;
                $cv->linea = $row->linea;
                $cv->servicio = $row->servicio;

                if (VehiculoColor::where('nombre', $color)->get() == "[]") {
                    $colorModel->nombre = $color;
                    $colorModel->save();
                    $idcolor = $colorModel->id;
                } else {
                    $queryColor = VehiculoColor::where('nombre', $color)->first();
                    $idcolor = $queryColor->id;
                }
                $cv->id_color = $idcolor;
                $cv->numero_serie = $row->serie;
                $cv->numero_motor = $row->motor;
                $cv->prenda = $row->limitaciones;
                $cv->id_ciudadano = $idPropietario;

                //Para poder importar la lic de transito hay que quitar el punto de la lic y colocar guion bajo.
                $cv->licencia = $row->no_licencia_transito;
                $cv->auto_update = '1';
                $cv->save();
                $this->line("Vehiculo Actualizando  Con Placa " . $cv->placa);
                /*if ($cv->placa == 'XIN23C'){
                    $this->line("XIN23C FOUND");

                    $this->line("id_organismo " . $cv->id_organismo);
                    $this->line("placa " . $cv->placa);
                    $this->line("id_clase " . $cv->id_clase);
                    $this->line("id_tipo " . $cv->id_tipo);
                    $this->line("chasis " . $cv->chasis);

                    $this->line("id_carroceria " . $cv->id_carroceria);
                    $this->line("id_marca " . $cv->id_marca);
                    $this->line("ano " . $cv->ano);
                    $this->line("id_modelo " . $cv->id_modelo);
                    $this->line("linea " . $cv->linea);
                    $this->line("servicio " . $cv->servicio);

                    $this->line("id_color " . $cv->id_color);
                    $this->line("numero_serie " . $cv->numero_serie);
                    $this->line("numero_motor " . $cv->numero_motor);
                    $this->line("prenda " . $cv->prenda);
                    $this->line("id_ciudadano " . $cv->id_ciudadano);

                }*/
            } else {
                $tipo = null;
                $carroseria = null;
                $cilindraje = null;
                $vehiculoModel = new VehiculoModelo;
                $cilindrajeModel = new VehiculoCilindraje;
                $colorModel = new VehiculoColor;
                $idmodel = null;
                $idcilindraje = null;
                $carroseria = $row->carroceria;
                $color = $row->color;
                $idcolor = null;

                //Marca
                $marca = $row->marca;
                $marcaQuery = VehiculoMarca::where('nombre', $marca)->first();
                $idmarca = $marcaQuery->id;

                //Tipo
                $tipo = $row->clase;

                if ($tipo == 'MOTOCICLETA') {
                    $tipo = 7;
                } else if ($tipo == 'AUTOMOVIL') {
                    $tipo = 2;
                }

                //Get Model
                $modeloQuery = VehiculoModelo::where('id_marca', $idmarca)
                    ->where('id_tipo', $tipo)->get();
                if ($modeloQuery == '[]') {
                    $vehiculoModel->id_marca = $idmarca;
                    $vehiculoModel->id_tipo = $tipo;
                    $vehiculoModel->nombre = $row->linea;
                    $vehiculoModel->auto = '1';
                    $vehiculoModel->save();
                    $idmodel = $vehiculoModel->id;

                    $cilindrajeModel->id_modelo = $idmodel;
                    $cilindrajeModel->cilindraje = $row->cilindraje;
                    $idcilindraje = $cilindrajeModel->id;

                    $vehiculo->id_cilindraje = $idcilindraje;
                    $vehiculo->cilindraje = $row->cilindraje;
                } else {
                    $modeloQuery = VehiculoModelo::where('id_marca', $idmarca)
                        ->where('id_tipo', $tipo)->first();

                    $cilindrajeModel->id_modelo = $modeloQuery->id;
                    $cilindrajeModel->cilindraje = $row->cilindraje;
                    $idcilindraje = $cilindrajeModel->id;

                    $vehiculo->id_cilindraje = $idcilindraje;
                    $vehiculo->cilindraje = $row->cilindraje;
                    $idmodel = $modeloQuery->id;
                }

                $vehiculo->id_organismo = '1';
                $vehiculo->placa = $row->placa;
                $vehiculo->id_clase = $tipo;
                $vehiculo->id_tipo = $tipo;
                $vehiculo->chasis = $row->chasis;

                if ($carroseria == "SPORT") {
                    $carroseria = 318;
                } else if ($carroseria == "TURISMO") {
                    $carroseria = 289;
                }
                if ($carroseria == "SIN CARROCERIA") {
                    $carroseria = 275;
                }

                $vehiculo->id_carroceria = $carroseria;
                $vehiculo->id_marca = $idmarca;
                $vehiculo->ano = $row->modelo;
                $vehiculo->id_modelo = $idmodel;
                $vehiculo->linea = $row->linea;
                $vehiculo->servicio = $row->servicio;

                if (VehiculoColor::where('nombre', $color)->get() == "[]") {
                    $colorModel->nombre = $color;
                    $colorModel->save();
                    $idcolor = $colorModel->id;
                } else {
                    $queryColor = VehiculoColor::where('nombre', $color)->first();
                    $idcolor = $queryColor->id;
                }
                $vehiculo->id_color = $idcolor;
                $vehiculo->numero_serie = $row->serie;
                $vehiculo->numero_motor = $row->motor;
                $vehiculo->prenda = $row->limitaciones;
                $vehiculo->id_ciudadano = $idPropietario;
                //Para poder importar la lic de transito hay que quitar el punto de la lic y colocar guion bajo.
                $vehiculo->licencia = $row->no_licencia_transito;
                $vehiculo->auto = '1';

                $this->line("Guardando Vehiculo Con Placa " . $row->placa);
                $vehiculo->save();
            }

        }
        $this->info('Proceso Finalizado! ');

    }
}
