<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Comparendo;
use App\Cartera;
use App\ResolucionSimit;
use App\ComparendoSimit;
use App\ResolucionSimitError;
use App\ResolucionSimitErrorDetalle;
use App\RecaudoSimit;
use App\Transaccion;
use Carbon\Carbon;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\DB;

class CarteraConsolidada extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   */

  protected $signature = 'carteraconsolidada';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Este comando consolidad la cartera de comparendos.';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
 		\DB::table('cartera')->truncate();
		$honorario= \App\ParamHonorario::orderby('id', 'desc')->first();
		$sistematizacion= \App\ParamSistematizacion::orderby('id', 'desc')->first();
        $chunks = Comparendo::WhereNull('fecha_pago')->get()->chunk(100);
        $c = 0;
        foreach($chunks as $comparendos){
            foreach($comparendos as $comparendo){

                $c++;
                $this->line("{$c}. CONSULTANDO {$comparendo->numero}");
                $this->line("============================================================");


		$dif =0;
		$intereses_calculados2=0;
		$intereses_calculados=0;
		$campana_calculados =0;
		$valor_honorario=0;
		$valor_sistematizacion=0;
		$tipo_resol=0;
		$pagos=$comparendo->pendiente;
		$total=$comparendo->valor - $comparendo->pagos;
							//$date1 = new DateTime($comparendo->infraccion_fecha);
							//$date2 = new DateTime("now");
							//$dif = $date1->diff($date2);
				$ano=substr($comparendo->infraccion_fecha,0,4);

								$tipo_resol=0;
								$resol=0;
				foreach($comparendo->obtenerResolucion() as $resolucion){
								$tipo_resol=$resolucion->COL5;
								$resol=$resolucion->COL2;
								$total=($resolucion->COL23+$resolucion->COL17) - $comparendo->pagos;					
							   if($resolucion->COL5=="1" || $resolucion->COL5=="16"  || $resolucion->COL5=="17")
							   {
		$intereses_calculados2 = \App\Http\Controllers\CajaController::calcularIntereses($resolucion->COL4,$resolucion->COL23,1);
		$intereses_calculados = \App\Http\Controllers\CajaController::calcularIntereses($resolucion->COL4,$resolucion->COL23,0);
		$diff = \App\Http\Controllers\CajaController::calcularIntereses($resolucion->COL4,$resolucion->COL23,2);
		
		//$campana_calculados =($intereses_calculados * $campana/100);
		$comparendo->intereses=$intereses_calculados;		
		$valor_honorario2 = $honorario->valor * ($intereses_calculados*1 + $resolucion->COL23*1)/100;
   
                               if( $resolucion->COL5=="16"  || $resolucion->COL5=="17")
							   {
								   $valor_sistematizacion=$sistematizacion->valor;
								   $valor_honorario=$valor_honorario2;
							   }


							   }
					
				}
                $totalpagar=$total+$intereses_calculados+$valor_honorario+$valor_sistematizacion-$campana_calculados;
                 $cartera = new Cartera();
                 $cartera->valor = $total;
				 $cartera->intereses = $intereses_calculados;
				 $cartera->honorarios = $valor_honorario;
				 $cartera->sistematizacion = $valor_sistematizacion;
				 $cartera->total = $totalpagar;
				 $cartera->ano = $ano;
				 $cartera->tipo_resolucion = $tipo_resol;
				 $cartera->resolucion = $resol;
				 
							if($tipo_resol=='0')
							{
								$cartera->sin_sansion=$totalpagar;
							}
							
							
							if($tipo_resol=='16')
							{
								$cartera->mandamiento=$totalpagar;
							}

							if($tipo_resol=='6')
							{
								$cartera->acuerdopago=$totalpagar;
							}				 

							if($tipo_resol=='8')
							{
								$cartera->acuerdopago=$totalpagar;
							}	
   				$cartera->save();
			}
		}
					
  }//fin handle
  
  
  
}
