<?php

namespace App\Console\Commands;

use App\Ciudadano;
use App\Comparendo;
use App\ComparendoNumeracionImpresion as Numeracion;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\DB;

class CrearExpedienteMasivo extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'expedientes:start';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Crea masivamente los expedientes';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     */
    public function handle()
    {
      $ultimaNumeracion= 0;
      $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '11')->first();

      if($numeracion != null){
        $ultimaNumeracion = $numeracion->final;
      }
      $inicioNumeracion = $ultimaNumeracion + 1;

      do {
        $comparendos = Comparendo::where('numero_expediente', '=', '0')->limit(100)->get();

        foreach ($comparendos as $comparendo) {
          $ultimaNumeracion++;
          $comparendo->numero_expediente = $ultimaNumeracion;
          $comparendo->save();
          $this->line("Expediente: " . $ultimaNumeracion);
        }

        if($ultimaNumeracion >= $inicioNumeracion){
          $this->line("Actualizando Numeracion...");
          //actualizar la numeracion en un nuevo registro
          $numeracion = new Numeracion();
          $numeracion->prefijo = 'EXPEDIENTE';
          $numeracion->inicio = $inicioNumeracion;
          $numeracion->final = $ultimaNumeracion;
          $numeracion->id_tipo_evento = 11;//EXPEDIENTE
          $numeracion->id_organismo = 1;
          $numeracion->id_paquete = 0;
          $numeracion->save();
          $this->line("Fin Numeracion");
        } else {
          $this->line("No se imprimo mandamientos.");
          break;
        }
      } while (count($comparendos) > 0);
    }
}
