<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Comparendo;
use App\ResolucionSimit;
use App\ComparendoSimit;
use App\ResolucionSimitError;
use App\ResolucionSimitErrorDetalle;
use App\RecaudoSimit;
use App\Transaccion;
use Carbon\Carbon;
use Illuminate\Support\Collection;

class DepuracionResoluciones extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   */

  protected $signature = 'depuracion:resoluciones';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Este comando es es de auxilio. su contenido es modificable segun el tratamiento para las resoluciones. Revisar antes de ejecutar.';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {

    //revisa que comparendos ya tienen pago para no sancionarlos o generarle mandamiento
    do {
      $comparendos = Comparendo::where('es_recaudo_minimo', '=', '0')->where('revisado_auxiliar', '=', '0')->limit(200)->get();

      foreach ($comparendos as $comparendo) {
          $sumaRecaudo = 0;
          $resoluciones = Comparendo::getResolucionesByComparendo($comparendo->numero)->orderBy('COL4F', 'desc')->get();

          if(count($resoluciones) > 0){
            foreach ($resoluciones as $resolucion) {
              $recaudos = RecaudoSimit::where('C10', '=', $resolucion->COL2)
                                      ->orWhere('C10', '=', $resolucion->COL2)
                                      ->orWhere('C15', '=', $resolucion->COL2)
                                      ->orWhere('C16', '=', $resolucion->COL2)
                                      ->orWhere('C10', '=', $comparendo->numero)
                                      ->orWhere('C15', '=', $comparendo->numero)
                                      ->orWhere('C16', '=', $comparendo->numero)
                                      ->get();
              foreach ($recaudos as $recaudo) {
                $sumaRecaudo = $recaudo->C9 + $sumaRecaudo;
              }
            }
            //validar si de las resoluciones mas recientes se encuentra en incumplir AP
            foreach ($resoluciones as $resolucion) {
              if($resolucion->COL5 == '9'){
                $sumaRecaudo = 0;break;
              }
            }
          }else{
            $recaudos = RecaudoSimit::where('C10', '=',  $comparendo->numero)
                                    ->orWhere('C15', '=', $comparendo->numero)
                                    ->orWhere('C16', '=', $comparendo->numero)->get();
            foreach ($recaudos as $recaudo) {
              $sumaRecaudo = $recaudo->C9 + $sumaRecaudo;
            }

          }
          $comparendoActualizar = Comparendo::find($comparendo->id);
          if($sumaRecaudo > 0){
            $this->line("sumaRecaudo: " . $sumaRecaudo);
            $comparendoActualizar->es_recaudo_minimo = 1;
            $this->line("COMP: " . $comparendo->numero);
          }
          $comparendoActualizar->revisado_auxiliar = 1;
          $comparendoActualizar->save();
      }
    } while (count($comparendos) > 0);

    /*
    //pasa los pagos de transacciones a recaudos simit
    $organismo = \App\Organismo::first();
    $transacciones = Transaccion::whereNotNull('fecha_descarga')->where('etiqueta', '=', 'pago-comparendo')->get();
    $arrayComparendosRecorridos = [];
    foreach ($transacciones as $transaccion) {
      if($transaccion->esTransaccionAprobada()){
        $recaudo = new RecaudoSimit();
        $recaudo->C2 = Carbon::createFromFormat("Y-m-d H:i:s", $transaccion->created_at)->format('d/m/Y');
        $recaudo->C3 = Carbon::createFromFormat("Y-m-d H:i:s", $transaccion->created_at)->format('H:i');
        $recaudo->C4 = Carbon::createFromFormat("Y-m-d", $transaccion->getFechaTransaccion())->format('d/m/Y');
        $recaudo->C5 = '0';
        $recaudo->C6 = 'taquilla transito';
        $recaudo->C7 = $transaccion->valor;
        $recaudo->C8 = '0';
        $recaudo->C9 = $transaccion->valor;
        $resolucion = Comparendo::getResolucionesByComparendo($transaccion->obtenerPrimerComparendo()->numero)->orderBy('COL4F', 'desc')->first();
        //si han pagado es porque tienen o tenian resolucion 1, 6, 8, 16 o 17 activa, no hay que hacer filtro de tipo de resolucion.
        if(isset($resolucion->COL5)){
          if ($resolucion->COL5 == '16' || $resolucion->COL5 == '17' || $resolucion->COL5 == '6' || $resolucion->COL5 == '8') {
            $recaudo->C10 = $resolucion->COL2;
          } else {
            $recaudo->C10 = $transaccion->obtenerPrimerComparendo()->numero;
          }
        } else {
          $recaudo->C10 = $transaccion->obtenerPrimerComparendo()->numero;
        }

        $recaudo->C11 = 'N';
        if ($transaccion->obtenerPrimerComparendo()->es_polca) {
            $recaudo->C11 = 'S';
        }

        $recaudo->C12 = $transaccion->obtenerPrimerComparendo()->infractor_documento;

        if(isset($resolucion->COL5)){
          if ($resolucion->COL5 == '6' || $resolucion->COL5 == '8') {
            $recaudo->C13 = '4';
          } elseif ($resolucion->COL5 == '16' || $resolucion->COL5 == '17') {
            $recaudo->C13 = '6';
          } else {
            $recaudo->C13 = '1';
          }
        } else {
          $recaudo->C13 = '1';
        }

        $recaudo->C14 = $organismo->codigo;
        $recaudo->C15 = $transaccion->cns_factura;

        $recaudo->C16 = $recaudo->C10;//numero de cuota, pero no puedo calcularla hasta que descargue el pago.
        $recaudo->fuente = 'local';

        $recaudoBuscado = RecaudoSimit::where('C2', '=', $recaudo->C2)
                                      ->where('C3', '=', $recaudo->C3)
                                      ->where('C4', '=', $recaudo->C4)
                                      ->where('C5', '=', $recaudo->C5)
                                      ->where('C6', '=', $recaudo->C6)
                                      ->where('C7', '=', $recaudo->C7)
                                      ->where('C8', '=', $recaudo->C8)
                                      ->where('C9', '=', $recaudo->C9)
                                      ->where('C10', '=', $recaudo->C10)
                                      ->where('C11', '=', $recaudo->C11)
                                      ->where('C12', '=', $recaudo->C12)
                                      ->where('C13', '=', $recaudo->C13)
                                      ->where('C14', '=', $recaudo->C14)
                                      ->where('C15', '=', $recaudo->C15)
                                      ->where('C16', '=', $recaudo->C16)
                                      ->get();
        $this->line("COUNT " . count($recaudoBuscado));
        if(count($recaudoBuscado) == 0){
          $this->line("INSERTANDO RECAUDO " . $transaccion->id);
          $recaudo->save();
        }else{
          $this->error("YA REGISTRADO " . $transaccion->id);
        }
      }
    }*/

    /*
    $comparendos = Comparendo::where('infracciones', '=', 'F')->get();
    foreach ($comparendos as $comparendo) {
      $resoluciones = ResolucionSimit::where('COL7', '=', $comparendo->numero)->get();
      foreach ($resoluciones as $res) {
        $res->COL24 = $comparendo->grado_alcohol;
        if($res->COL25 == ''){
          $res->COL25 = 'N';
        }
        $res->save();
        $this->line("RES: " . $res->COL2);
      }
    }*/
    /*
    $comparendos = ComparendoSimit::where('COL56', '=', 'F')->get();
    foreach ($comparendos as $comparendosimit) {
      $comparendo = Comparendo::where('numero', '=', $comparendosimit->COL2)->first();
      if(isset($comparendo->id)){
        $comparendo->grado_alcohol = $comparendosimit->COL58;
        $comparendo->save();
        $this->line("COMP: " . $comparendo->numero);
      }
    }*/
    /*
    ResolucionSimitErrorDetalle::where('codigo_error', '=', '1')->chunk(200, function ($errores) {
      foreach ($errores as $error) {

        $resolucionError = ResolucionSimitError::where('COL1', '=', $error->item)->get();
        foreach ($resolucionError as $res) {
          $res->delete();
        }

      }
    });*/
    /*ComparendoSimit::where('COL54', '=', '11')->chunk(200, function ($comparendos) {
      foreach ($comparendos as $comparendo) {

        $resolucion = ResolucionSimit::where('COL7', '=', $comparendo->COL2)
                                      ->where('COL4', '>=', '2018-09-18')
                                      ->where('COL5', '=', '1')->first();
        if(isset($resolucion->COL7)){
          $this->line("COMP: " . $resolucion->COL7);
        }
      }
    });*/
  }
}
