<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoOficio;
use App\ComparendoEmbargos;
use App\Banco;
use App\ComparendoNumeracionImpresion as Numeracion;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class DesembargoMandamientoPDF extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:embargo
   */
  protected $signature = 'mandamiento:desembargo {id_resolucion} {banco} {id_embargo}';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Genera los oficios para desembargos a los diferentes bancos';

  /**
  * variables de contenido de la tarea
  */
  protected $relacionContenido = '';
  protected $pdfMasivo = '';
  protected $comparendosImpresos = array();
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $idResolucion = $this->argument('id_resolucion');
    $banco = $this->argument('banco');
    $idEmbargo = $this->argument('id_embargo');

    $resolucion = ResolucionSimit::where('id', '=', $idResolucion)->first();

     $bancos = Banco::all();  

    if(isset($resolucion->id)) {

      //buscar el comparendo y despues buscar el desembargo con el id comparendo y sera compatible con oficios anteriores a la numeracion
      $comparendo = Comparendo::where('numero', '=', DB::raw("'$resolucion->COL7'"))->first();

      $embargo = ComparendoEmbargos::find($idEmbargo);

      $idPaqueteOficioDesembargo = $embargo->id_paquete;

      $mostrar_expediente="Si";
      if($embargo->fecha_generacion < "2019-01-01"){
        $mostrar_expediente="No";
      }


      if($embargo->id_paquete_desembargo > 0){
        return $this->line("Este mandamiento Ya tiene un desembargo");
      }

      $this->rutaImagenTop = '';

      $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      $this->rutaFirma = base_path() . '/public/images/firmamecanica.png';
      $rutaPaquete = \Config::get('myconfig.ruta_paquetes_oficios_mandamientos');

      $organismo = \App\Organismo::first();
      $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
      $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

      $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                     'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

      $convertidorNumerosALetras = new \NumberToLetterConverter();

      $fecha = Carbon::now();
      //$fecha = Carbon::parse('2022-02-22');

      $bancos = null;
      if($banco == 0){
        $bancos = Banco::where('estado', 1)->get();
      } else {
        $bancos = Banco::where('id', '=', $banco)->where('estado', 1)->get();
      }

      //numeracion de los paquetes_oficios
      $ultimaNumeracionPaq = 0;
      $numeracionPaq = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '23')->first();

      if($numeracionPaq != null){
        $ultimaNumeracionPaq = $numeracionPaq->final;
      }
      $inicioNumeracionPaq = $ultimaNumeracionPaq + 1;

      //numeracion de los oficios en expedientes
      $ultimaNumeracion = 0;
      $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '21')->first();

      if($numeracion != null){
        $ultimaNumeracion = $numeracion->final;
      }
      $inicioNumeracion = $ultimaNumeracion + 1;

      //numeracion de las resoluciones de embargos que no son enviadas al simir, solo por crear resoluciones al oficio.(presencia)
      $numeracionDes = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '22')->first();
      $ultimaNumeracionDes = $numeracionDes->final;
      $inicioNumeracionDes = $ultimaNumeracionDes + 1;

      $ultimaNumeracionDes++;
      $numeroResDes = 'RDES-' . $ultimaNumeracionDes . '-' . $fecha->year;

      $resolucionDes = new ResolucionSimit();
      $resolucionDes->COL2 = $numeroResDes;
      $resolucionDes->COL4 = $fecha->format('d/m/Y');
      $resolucionDes->COL5 = '267';
      $resolucionDes->COL7 = $resolucion->COL7;
      $resolucionDes->COL8 = $resolucion->COL8;
      $resolucionDes->COL9 = $resolucion->COL9;
      $resolucionDes->COL10 = $resolucion->COL10;
      $resolucionDes->COL11 = $resolucion->COL11;
      $resolucionDes->COL12 = $resolucion->COL12;
      $resolucionDes->COL13 = $resolucion->COL13;
      $resolucionDes->COL15 = $resolucion->COL15;
      $resolucionDes->COL16 = $resolucion->COL16;
      $resolucionDes->COL17 = $resolucion->COL17;
      $resolucionDes->COL18 = $resolucion->COL18;
      $resolucionDes->COL19 = $resolucion->COL19;
      $resolucionDes->COL20 = $resolucion->COL20;
      $resolucionDes->COL21 = $resolucion->COL21;
      $resolucionDes->COL22 = '0';
      $resolucionDes->COL23 = '0';
      $resolucionDes->confirmado_simit = '-1';
      $resolucionDes->save();

      $this->line("Actualizando Numeracion resolucion desembargo...");
      //actualizar la numeracion en un nuevo registro
      $numeracion = new Numeracion();
      $numeracion->prefijo = 'RDES';
      $numeracion->inicio = $inicioNumeracionDes;
      $numeracion->final = $ultimaNumeracionDes;
      $numeracion->id_tipo_evento = 22;//RESOLUCION DE DESEMBARGO
      $numeracion->id_organismo = $organismo->id;
      $numeracion->id_paquete = 0;
      $numeracion->save();
      //fin de la resolucion de desembargo

      $headTabla = '<table class="encabezado">
                      <tr>
                        <td style="text-align: center;"><b>NOMBRE</b></td>
                        <td style="text-align: center;"><b>CEDULA/NIT</b></td>
                        <td style="text-align: center;"><b>RESOLUCION MANDTO DE PAGO</b></td>
                        <td style="text-align: center;"><b>FECHA DE RESOLUCION</b></td>
                        <td style="text-align: center;"><b>No DE OFICIO DE EMBARGO</b></td>
                      </tr>';

      $ultimaNumeracionPaq++;
      $paqueteOfDes = new \App\ComparendoPaquete();
      $paqueteOfDes->nombre = 'PAQ-DES-' . $ultimaNumeracionPaq . '-' . $fecha->year;
      $paqueteOfDes->fecha = $fecha;
      $paqueteOfDes->id_user = 4;
      $paqueteOfDes->id_tipo_evento = 21;
      $paqueteOfDes->es_impreso = 0;
      $paqueteOfDes->save();

      $countOficiosNuevos = ComparendoOficio::where('id_paquete', $idPaqueteOficioDesembargo)->count();

      $fechaResolucionDesembargo = $fecha->format('Y-m-d');
      $numeroExpediente = $comparendo->numero_expediente;
      if($comparendo->pago_total != 'No' || $comparendo->fecha_pago != '' || $comparendo->fecha_pago != null){
        //si es por pago total se toma la resolucion terminacion_pdf
        $terminacion = ComparendoExpediente::where('id_comparendo', '=', $comparendo->id)
                                          ->where('id_tipo_evento', '=', '26')->first();
        if(isset($terminacion->id)){
          $numeroResDes = $terminacion->nombre_documento;
          $fechaResDes = new Carbon($terminacion->fecha_generacion);
          $fechaResolucionDesembargo = $fechaResDes->format('Y-m-d');
        }
      }else{
        $resolucionParaTerminacion = ResolucionSimit::where('COL7', $comparendo->numero)
          ->where(function ($query) {
            $query->where('COL5', '=', '21')//revocatoria directa
                ->orWhere('COL5', '=', '2')//exoneracion fallo
                ->orWhere('COL5', '=', '3')//exoneracion prescripcion
                ->orWhere('COL5', '=', '4')//exoneracion caducidad
                ->orWhere('COL5', '=', '5')//cese procedimiento
                ->orWhere('COL5', '=', '10')//anulacion acuerdo pago
                ->orWhere('COL5', '=', '12')//anulacion resolucion
                ->orWhere('COL5', '=', '15')//deja comparendo pendiente fallo
                ->orWhere('COL5', '=', '18')//anulacion de cobro
                ->orWhere('COL5', '=', '22')//nulidad por fallo
                ->orWhere('COL5', '=', '23')//asistencia curso comparendo
                ->orWhere('COL5', '=', '25')//asistencia curso resolucion
                ->orWhere('COL5', '=', '27')//proceso en excepcion
                ->orWhere('COL5', '=', '29')//cumplimiento ap
                ->orWhere('COL5', '=', '31');//pendiente de pago de fallo
          })->first();
        if(isset($resolucionParaTerminacion->id)){
          $numeroResDes = $resolucionParaTerminacion->COL2;
          $fechaResDes = Carbon::createFromFormat('d/m/Y', $resolucionParaTerminacion->COL4);
          $fechaResolucionDesembargo = $fechaResDes->format('Y-m-d');
        }
      }

      if($countOficiosNuevos > 0){
        $embargo->nombre_desembargo = $paqueteOfDes->nombre;
        $embargo->id_paquete_desembargo = $paqueteOfDes->id;
        $embargo->save();
        $ofEmb = ComparendoOficio::where('id_paquete', $idPaqueteOficioDesembargo)->get();
        foreach ($ofEmb as $oe) {

          //$banco = Banco::where('nombre', 'like', DB::raw("'%".$oe->banco."%'"))->first();

        $nombrebancos="";
        foreach ($bancos as $banco) {
             $nombrebancos=$nombrebancos . " - " . $banco->nombre;
        }

          $contenidoTabla = '<tr>
                                <td style="text-align: center;">'. $resolucion->COL11 . ' ' . $resolucion->COL12 .'</td>
                                <td style="text-align: center;">'. $resolucion->COL9 .'</td>
                                <td style="text-align: center;">'. $resolucion->COL2 .'</td>
                                <td style="text-align: center;">'. $resolucion->COL4 .'</td>
                                <td style="text-align: center;">'. $oe->nombre_documento .'</td>
                              </tr>';
          //hash code
          $random = openssl_random_pseudo_bytes(6);
          $random_hash = bin2hex($random);

          $random_hash = mb_strtoupper($random_hash);

          $ultimaNumeracion++;
          $numeroOficio = 'OFDES-' . $ultimaNumeracion . '-' . $fecha->year;
          //creando el registro en expediente
          $expediente = new \App\ComparendoExpediente();
          $expediente->id_comparendo = $comparendo->id;
          $expediente->fecha_generacion = $fecha->format('Y-m-d');
          $expediente->nombre_documento = $numeroOficio;
          $expediente->id_tipo_evento = 21;//oficio de desembargo
          $expediente->id_paquete = $paqueteOfDes->id;
          $expediente->id_user = 4;
          $expediente->hash_code = $random_hash;
          $expediente->save();

          $this->line("PARA EXPEDIENTE " . $resolucion->COL2);

          //creando la carpeta paquete donde deben ir todos los oficios a los bancos
          $folder = $rutaPaquete  . $paqueteOfDes->nombre;
          \File::makeDirectory($folder, 0777, true, true);

          $fechaCarbonLetras = new Carbon($fecha);
          $fechaLetras = $fechaCarbonLetras->day . ' de ' . $this->meses[$fechaCarbonLetras->month - 1] . ' de ' . $fechaCarbonLetras->year;

          $this->pdfMasivo = view('comparendos.mandamiento.desembargo.head_pdf',[
                                  'rutaImagenTop' => $this->rutaImagenTop,
                                  'fechaLetras' => 'Ciudad, ' . $fechaLetras,
                                  'numero' => 'OFICIO No. ' . $numeroOficio,
                                  'nombreInfractor' => $resolucion->COL11 . ' ' . $resolucion->COL12,
                                  'cedulaNit' => $resolucion->COL9,
                                  'resolDesembargo' => $numeroResDes,
                                  'fechaResolDesembargo' => $fechaResolucionDesembargo,
                                  'nombreBanco' => $nombrebancos,
                                  'mandamientoNumero' => $resolucion->COL2,
                                  'mandamientoFecha' => $resolucion->COL4,
                                  'codigoVerificacion' => $random_hash,
                                  'expediente' => $numeroExpediente,
                                  'mostrar_expediente' => $mostrar_expediente
                                ]);
          $this->pdfMasivo .= $headTabla . $contenidoTabla . '</table>';
          $this->pdfMasivo .= view('comparendos.mandamiento.desembargo.footer_pdf',[
                                  'nombreSecretario' => $organismo->secretario_nombre,
                                  'rutaFirma' => $this->rutaFirma,
                                  'organismoDireccion' => $organismo->direccion,
                                  'organismoNombreSecreteria' => $organismo->secretaria_nombre
                                ]);
          $pdf = PDF::loadHTML($this->pdfMasivo)->setPaper('letter', 'portrait');
          $pdf->save($folder . '/' . $numeroOficio . '_' . $banco->prefijo . '.pdf');
          $this->line("Oficio Desembargo creado... " . $numeroOficio . '_' . $banco->prefijo);
        }
        //fin de los embargos nuevos por oficio por banco unicos
      } else {
        $embargo->nombre_desembargo = $paqueteOfDes->nombre;
        $embargo->id_paquete_desembargo = $paqueteOfDes->id;
        $embargo->save();
        $oficioPaq = \App\ComparendoPaquete::where('id', '=', $idPaqueteOficioDesembargo)->first();

        $nombrebancos="";
        foreach ($bancos as $banco) {
             $nombrebancos=$nombrebancos . " - " . $banco->nombre;
        }

        //foreach ($bancos as $banco) {
          $contenidoTabla = '<tr>
                                <td style="text-align: center;">'. $resolucion->COL11 . ' ' . $resolucion->COL12 .'</td>
                                <td style="text-align: center;">'. $resolucion->COL9 .'</td>
                                <td style="text-align: center;">'. $resolucion->COL2 .'</td>
                                <td style="text-align: center;">'. $resolucion->COL4 .'</td>
                                <td style="text-align: center;">'. $oficioPaq->nombre .'</td>
                              </tr>';
          //hash code
          $random = openssl_random_pseudo_bytes(6);
          $random_hash = bin2hex($random);

          $random_hash = mb_strtoupper($random_hash);

          $ultimaNumeracion++;
          $numeroOficio = 'OFDES-' . $ultimaNumeracion . '-' . $fecha->year;
          //creando el registro en expediente
          $expediente = new \App\ComparendoExpediente();
          $expediente->id_comparendo = $comparendo->id;
          $expediente->fecha_generacion = $fecha->format('Y-m-d');
          $expediente->nombre_documento = $numeroOficio;
          $expediente->id_tipo_evento = 21;//oficio de desembargo
          $expediente->id_paquete = $paqueteOfDes->id;
          $expediente->id_user = 4;
          $expediente->hash_code = $random_hash;
          $expediente->save();
          $this->line("PARA EXPEDIENTE " . $resolucion->COL2);

          //creando la carpeta paquete donde deben ir todos los oficios a los bancos
          $folder = $rutaPaquete . $paqueteOfDes->nombre;
          \File::makeDirectory($folder, 0777, true, true);

          $fechaCarbonLetras = new Carbon($fecha);
          $fechaLetras = $fechaCarbonLetras->day . ' de ' . $this->meses[$fechaCarbonLetras->month - 1] . ' de ' . $fechaCarbonLetras->year;

          $this->pdfMasivo = view('comparendos.mandamiento.desembargo.head_pdf',[
                                  'rutaImagenTop' => $this->rutaImagenTop,
                                  'fechaLetras' => 'Ciudad, ' . $fechaLetras,
                                  'numero' => 'OFICIO No. ' . $numeroOficio,
                                  'nombreInfractor' => $resolucion->COL11 . ' ' . $resolucion->COL12,
                                  'cedulaNit' => $resolucion->COL9,
                                  'resolDesembargo' => $numeroResDes,
                                  'fechaResolDesembargo' => $fechaResolucionDesembargo,
                                  'nombreBanco' => $nombrebancos,
                                  'mandamientoNumero' => $resolucion->COL2,
                                  'mandamientoFecha' => $resolucion->COL4,
                                  'codigoVerificacion' => $random_hash,
                                  'expediente' => $numeroExpediente,
                                  'mostrar_expediente' => $mostrar_expediente
                                ]);
          $this->pdfMasivo .= $headTabla . $contenidoTabla . '</table>';
          $this->pdfMasivo .= view('comparendos.mandamiento.desembargo.footer_pdf',[
                                  'nombreSecretario' => $organismo->secretario_nombre,
                                  'rutaFirma' => $this->rutaFirma,
                                  'organismoDireccion' => $organismo->direccion,
                                  'organismoNombreSecreteria' => $organismo->secretaria_nombre
                                ]);
          $pdf = PDF::loadHTML($this->pdfMasivo)->setPaper('letter', 'portrait');
          $pdf->save($folder . '/' . $numeroOficio . '_' . $banco->prefijo . '.pdf');
          $this->line("Oficio Desembargo creado... " . $numeroOficio . '_' . $banco->prefijo);
        //}
      }

      if($ultimaNumeracion >= $inicioNumeracion){
        $this->line("Actualizando Numeracion...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'OFDES';
        $numeracion->inicio = $inicioNumeracion;
        $numeracion->final = $ultimaNumeracion;
        $numeracion->id_tipo_evento = 21;//OFICIO DE DESEMBARGO
        $numeracion->id_organismo = $organismo->id;
        $numeracion->id_paquete = $paqueteOfDes->id;
        $numeracion->save();
        $this->line("Fin Numeracion Oficio Desembargo.");
      } else {
        $this->line("No se imprimo Oficio Desembargo.");
      }

      if($ultimaNumeracionPaq >= $inicioNumeracionPaq){
        //para la numeracion se usa el id 23 pero cuando se crea el paquete como expediente se usa el id 21 para compatibilidad con desembargos
        //anteriores
        $this->line("Actualizando Numeracion Paquete...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'PAQ-DES';
        $numeracion->inicio = $inicioNumeracionPaq;
        $numeracion->final = $ultimaNumeracionPaq;
        $numeracion->id_tipo_evento = 23;//PAQUETE OFICIO DE DESEMBARGO
        $numeracion->id_organismo = $organismo->id;
        $numeracion->id_paquete = 0;
        $numeracion->save();
        $this->line("Fin Numeracion Paquete Desembargo.");
      } else {
        $this->line("No se imprimo Paquete Desembargo.");
      }
    }
  }
}
