<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoVivo;
use App\Organismo;
use App\ComparendoExpediente;
use App\ComparendoEmbargos;
use App\ResolucionSimit;
use App\ArchivoEmbargos;
use App\Banco;
use App\Cuenta;
use App\ComparendoOficio;
use App\ComparendoNumeracionImpresion as Numeracion;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class EmbargoMandamientoPDF extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:embargo
   */
  protected $signature = 'mandamiento:embargo';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Genera los oficios para los diferentes bancos';

  /**
  * variables de contenido de la tarea
  */
  protected $relacionContenido = '';
  protected $pdfMasivo = '';
  protected $comparendosImpresos = array();
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $this->rutaImagenTop = '';

    $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
    $this->rutaFirma = base_path() . '/public/images/firma2.png';
    $rutaPaquete = \Config::get('myconfig.ruta_paquetes_oficios_mandamientos');
    $organismo = \App\Organismo::first();

    
          if($organismo->codigo=="20228000" )
          {
               $this->rutaFirma = base_path() . '/public/images/firma3.png';
          }



    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                   'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

    $convertidorNumerosALetras = new \NumberToLetterConverter();
    $resoluciones = null;
    $fecha = Carbon::now();
    $bancos = Banco::all();
    $bancoCuentaJudicial = Banco::where('id', '14')->first();
    $cuentaJudicial = Cuenta::where('id_banco', $bancoCuentaJudicial->id)->first();
    do {
      $ultimaNumeracion = 0;
      $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '19')->first();

      if($numeracion != null){
        $ultimaNumeracion = $numeracion->final;
      }
      $inicioNumeracion = $ultimaNumeracion + 1;

      $ultimaNumeracionEmb = 0;
      $numeracionEmb = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '27')->first();

      if($numeracionEmb != null){
        $ultimaNumeracionEmb = $numeracionEmb->final;
      }
      $inicioNumeracionEmb = $ultimaNumeracionEmb + 1;

//                                    ->where('fecha_resol', 'BETWEEN', DB::raw("'2021-08-01' AND '2021-08-30'"))
      //->where('confirmado_simit', '=', 1)
      $resoluciones = ResolucionSimit::getResolucionesByComparendo()
                                    ->where('embargo', '=', DB::raw("0"))
                                    ->where('procesado_embargo', '=', DB::raw("0"))
                                    ->limit(100)->get();

      $countMandamientos = 0;
      $paquete = null;

      $headTabla = '<table class="encabezado">
                      <tr>
                        <td style="text-align: center;"><b>No. PROCESO</b></td>
                        <td style="text-align: center;"><b>CEDULA/NIT</b></td>
                        <td style="text-align: center;"><b>DEMANDADO</b></td>
                        <td style="text-align: center;"><b>VALOR EMBARGO</b></td>
                      </tr>';
      $contenidoTabla = '';
      if(count($resoluciones) > 0){
        $paquete = new \App\ComparendoPaquete();
        $paquete->fecha = $fecha;
        $paquete->id_user = 4;
        $paquete->id_tipo_evento = 19;
        $paquete->es_impreso = 0;
        $paquete->save();
      }

      //escribiendo el csv para las guias
      $txt = "";
      $tmp['PROCESO'] = 'PROCESO';
      $tmp['CEDULA'] = 'CEDULA/NIT';
      $tmp['NOMBRE'] = 'DEMANDADO';
      $tmp['VALOR'] = 'VALOR EMBARGO';

      $txt .= implode(';', $tmp) . "\n";
      foreach ($resoluciones as $resolucion) {
        $countResoluciones = ResolucionSimit::where(function ($query) {
                                                  $query->where('COL5', '=', '21')
                                                      ->orWhere('COL5', '=', '3')
                                                      ->orWhere('COL5', '=', '6')
                                                      ->orWhere('COL5', '=', '8');
                                              })->where('COL7', '=', $resolucion->COL7)->count();
        $comparendo = Comparendo::where('numero', '=', $resolucion->COL7)->first();

        $comparendovivo = ComparendoVivo::where('numero', '=', $resolucion->COL7)->get();
        $swvivo=0;
        foreach ($comparendovivo as $vivo) {
          $swvivo=1;
        }
        
        if(isset($comparendo->recaudo_externo) && isset($comparendo->recaudo_externo) && ($swvivo==1)){
          $recaudoTotal = $comparendo->recaudo_externo + $comparendo->recaudo_local;
          if($countResoluciones == 0 && $recaudoTotal == 0){
            $countMandamientos++;
            $valorEmbargado = $resolucion->COL23 * 2.5;
            $contenidoTabla .= '<tr>
                                  <td style="text-align: center;">'. $comparendo->numero_expediente .'</td>
                                  <td style="text-align: center;">'. $resolucion->COL9 .'</td>
                                  <td style="text-align: justify;">'. $resolucion->COL11 . ' ' . $resolucion->COL12 .'</td>
                                  <td style="text-align: center;">$'. number_format($valorEmbargado, 0, ".", ".") .'</td>
                                </tr>';
            $tmp = [];
            $tmp['PROCESO'] = $comparendo->numero_expediente;
            $tmp['CEDULA'] = $resolucion->COL9;
            $tmp['NOMBRE'] = $resolucion->COL11 . ' ' . $resolucion->COL12;
            $tmp['VALOR'] = '$'. number_format($valorEmbargado, 0, ".", ".");

            $txt .= implode(';', $tmp) . "\n";

            //creando el registro en expediente
            $expediente = new ComparendoExpediente();
            $expediente->id_comparendo = $comparendo->id;
            $expediente->fecha_generacion = $fecha->format('Y-m-d');
            $expediente->nombre_documento = $resolucion->COL2;
            $expediente->id_tipo_evento = 19;//oficio de embargo
            $expediente->id_paquete = $paquete->id;
            $expediente->id_user = 4;
            $expediente->save();
            $this->line("PARA EXPEDIENTE " . $resolucion->COL2);

            $this->line("POR PRESCRIPCION " . $resolucion->COL2);
            $resolucionModificar = ResolucionSimit::where('id', '=', $resolucion->id)->first();
            $resolucionModificar->procesado_embargo = 1;
            $resolucionModificar->save();
          }else{
            //poner el mandamiento como no valido con -1
            $this->line("POR PRESCRIPCION " . $resolucion->COL2);
            $resolucionModificar = ResolucionSimit::where('id', '=', $resolucion->id)->first();
            $resolucionModificar->procesado_embargo = -1;
            $resolucionModificar->save();
          }
        }else{
          //poner el mandamiento como no valido con -2
          $this->line("POR NO ENCONTRAR COMPARENDO " . $resolucion->COL2);
          $resolucionModificar = ResolucionSimit::where('id', '=', $resolucion->id)->first();
          $resolucionModificar->procesado_embargo = -2;
          $resolucionModificar->save();
        }
      }
      if($countMandamientos > 0){

        $fe=Carbon::now()->format('Ymd');
        //$fechaHoy = Carbon::now();



        $ultimaNumeracion++;
        $numeroOficio = 'OF-' . $ultimaNumeracion . '-' . $fecha->year;
        //actualizando el paquete
        $paquete->nombre = $numeroOficio;
        $paquete->save();
        //creando la carpeta paquete donde deben ir todos los oficios a los bancos
        $folder = $rutaPaquete  . $numeroOficio;
        \File::makeDirectory($folder, 0777, true, true);
        //el archivo con todos los maandamientos
        \File::put($folder . '/PLANO_' . $numeroOficio . '.csv', $txt);
        $nombrebancos="";
        foreach ($bancos as $banco) {
             $nombrebancos=$nombrebancos . " - " . $banco->nombre;
        }
                        $emb = new ArchivoEmbargos();
                        $emb->nombre =  $folder;
                        $emb->csv =  $numeroOficio.'/PLANO_' . $numeroOficio. '.csv';
                        $emb->tipo_archivo = ".csv";

                               
          $ultimaNumeracionEmb++;
          $numeroOficioEmb = 'OF-EMB-' . $ultimaNumeracionEmb . '-' . $fecha->year;
          //creando el registro en expediente de oficios para cada banco
          $oficioE = new \App\ComparendoOficio();
          $oficioE->id_comparendo = $comparendo->id;
          $oficioE->fecha_generacion = $fecha->format('Y-m-d');
          $oficioE->nombre_documento = $numeroOficioEmb;
          $oficioE->id_tipo_evento = 27;//oficio de embargo
          $oficioE->id_paquete = $paquete->id;
          $oficioE->id_user = 4;
          $oficioE->save();

          $this->pdfMasivo = view('comparendos.mandamiento.embargo.head_pdf',[
                                  'rutaImagenTop' => $this->rutaImagenTop,
                                  'numero' => $numeroOficioEmb,
                                  'alcaldia' => mb_strtoupper($organismo->alcaldia_nombre),
                                  'nombreSecretaria' => mb_strtoupper($organismo->secretaria_nombre),
                                  'fechaLetra' => $fecha->day . ' de ' . $this->meses[$fecha->month - 1] . ' de ' . $fecha->year,
                                  'nombreBanco' => $nombrebancos,
                                  'direccionBanco' => $banco->direccion,
                                  'ciudadBanco' => " ", //$banco->ciudad
                                  'municipio' => $organismo->municipio,
                                  'nit' => $organismo->nit_alcaldia,
                                ]);
          $this->pdfMasivo .= $headTabla . $contenidoTabla . '</table>';
          $this->pdfMasivo .= view('comparendos.mandamiento.embargo.footer_pdf',[
                                  'municipio' => $organismo->municipio,
                                  'nombreSecretario' => $organismo->secretario_nombre,
                                  'rutaFirma' => $this->rutaFirma,
                                  'nit' => $organismo->nit_alcaldia,
                                  'email' => $organismo->email_cobro,
                                  'nombreBanco' => $bancoCuentaJudicial->nombre,
                                  'cuenta_deposito_judicial' => $cuentaJudicial->numero,
                                ]);
          $pdf = PDF::loadHTML($this->pdfMasivo)->setPaper('legal', 'portrait');
          $pdf->save($folder . '/' . $numeroOficioEmb  . '_.pdf');
                        $emb->pdf = $numeroOficio. '/' . $numeroOficioEmb  . '_.pdf';  
                        $emb->transito = $organismo->codigo;
                        $emb->estado = 0;
                        $emb->save();        
                        $this->line("ArchivoEmbargos creado... " . $emb->id);                 
          $this->line("Oficio creado... " . $numeroOficioEmb . '_' . $banco->prefijo);
        


      }else{
        if($paquete != null){
          $paquete->delete();
        }
      }

      if($ultimaNumeracion >= $inicioNumeracion){
        $this->line("Actualizando Numeracion...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'OF';
        $numeracion->inicio = $inicioNumeracion;
        $numeracion->final = $ultimaNumeracion;
        $numeracion->id_tipo_evento = 19;//OFICIO DE EMBARGO paquete
        $numeracion->id_organismo = $organismo->id;
        $numeracion->id_paquete = 0;
        $numeracion->save();
        $this->line("Fin Numeracion Oficio paquete.");
      } else {
        $this->line("No se imprimo Oficio paquete.");
      }

      if($ultimaNumeracionEmb >= $inicioNumeracionEmb){
        $this->line("Actualizando Numeracion...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'OF-EMB';
        $numeracion->inicio = $inicioNumeracionEmb;
        $numeracion->final = $ultimaNumeracionEmb;
        $numeracion->id_tipo_evento = 27;//OFICIO DE EMBARGO
        $numeracion->id_organismo = $organismo->id;
        $numeracion->id_paquete = 0;
        $numeracion->save();
        $this->line("Fin Numeracion Oficio.");
      } else {
        $this->line("No se imprimo Oficio.");
      }
    } while (count($resoluciones) > 0);

$embargos = ComparendoExpediente::where('is_impreso', 0)->where('id_tipo_evento', 19)->where('created_at', '>=', DB::raw("'2021-09-01'"))->get();
    foreach ($embargos as $embargo) {
      $cemb = new ComparendoEmbargos();
      $cemb->id_comparendo = $embargo->id_comparendo;
      $cemb->fecha_generacion = $embargo->fecha_generacion;
      $cemb->nombre_documento =  $embargo->nombre_documento;
      $cemb->id_paquete = $embargo->id_paquete;
      $cemb->id_user = 4;
      $cemb->id_comparendo_expediente = $embargo->id;
      $cemb->save();
      $embargo->is_impreso=1;
      $embargo->save();
            //$embargo->nombre_documento = $numeroOficioEmb;
            //$embargo->save();

      $this->line("insert..." . $numeroOficioEmb."-->".$embargo->nombre_documento);
    }

  }
}
