<?php
namespace App\Console\Commands;
use App\Ciudadano;
use App\Comparendo;
use App\Campana;
use App\Festivos;
use App\ResolucionSimit;
use App\ParamHonorario;
use App\ParamSistematizacion;
use App\Http\Controllers\CajaController;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\DB;
use App\ComparendoVivo;
use App\EmpresaPlaca;
use App\ComparendoExpediente;
use DateTime;
use Session;
use Illuminate\Support\Facades\Mail;

class EnvioMsjVencimiento extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'proceso:msjvencimiento {comparendo}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Proceso Envio Msj vencimiento';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     */
    public function handle()
    {
        $c = 0;

           $NumCompa = $this->argument('comparendo');
          $campara="like";
           if($NumCompa=="0")
           {
              $campara="<>";
           }

           $hoy = Carbon::now()->format('Y-m-d');

            //where('infraccion_fecha','like','2018%')->
            EmpresaPlaca::where('soat_vencimiento','<',$hoy)
            ->orwhere('tecno_vencimiento','<',$hoy)
            ->orwhere('poliza_vencimiento','<',$hoy)
            ->orchunk(100, function($comparendos) use (&$c,&$NumCompa)
            {
                foreach($comparendos as $comparendo)
                {
                    $c++;

                    $this->line("{$c}. - Soat:{$comparendo->soat_vencimiento} - tecno:{$comparendo->id} 
                      - poliza:{$comparendo->poliza_vencimiento}.. Id:{$comparendo->id}");
                    $hoy = Carbon::now()->format('Y-m-d');

                    if($comparendo->soat_vencimiento<$hoy )
                    {
                            \Session::put('email_e', $comparendo->msjemail);
                            $dta = array(
                                'id' => $comparendo->id,
                                'codigo_email' => $comparendo->numero,
                                'email' => $comparendo->msjemail,
                                'fecha' => $comparendo->infraccion_fecha,
                                'nombre' => $comparendo->infractor_nombre. " " . $comparendo->infractor_apellido
                            );
                     
                            Mail::send('emails.msj50', $dta, function ($message){
                                $noreply = env('MAIL_USERNAME');
                                $message->from($noreply, 'Transito '.env('TRANSITO'));
                                $message->to(\Session::get('email_e'))->subject('DESCUENTO DE LEY DEL 50% COMPARENDO SECRETARIA DE TRANSITO '.env('TRANSITO')) ;
                            });
                          /*sleep(2);
                            Mail::send('emails.msj50', $dta, function ($message){
                                $noreply = env('MAIL_USERNAME');
                                $message->from($noreply, 'Transito '.env('TRANSITO'));
                                $message->to(env('MAIL_COPIA'))->subject('DESCUENTO DE LEY DEL 50% COMPARENDO SECRETARIA DE TRANSITO '.\Session::get('email_e')) ;
                            });*/
                       
                         $this->line(" MSJ Enviados Satisfactoriamente! ".  $comparendo->msjemail);
                         sleep(2);         
                    }
                }
            });
 
   }

}
