<?php

namespace App\Console\Commands\EspecialSanciones;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\ComparendoAudiencias;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;
use App\Festivos;
use Maatwebsite\Excel\Facades\Excel;

class AudienciasPdfJairsino extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:start 0 c new no
   */
  protected $signature = 'audienciasjairsino:start';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'audiencias jairsino';

  /**
  * variables de contenido de la tarea
  */
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';
  protected $arrayExcel = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
    $this->rutaFirma =  base_path() . '/public/images/firma2.png';

    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
    $rutaEstados = \Config::get('myconfig.ruta_audiencia_estados');

    $organismo = \App\Organismo::first();
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                   'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

    $convertidorNumerosALetras = new \NumberToLetterConverter();
    $resoluciones = null;

    $countAudiencia = 0;
    $horaAudiencia = array(
                          '08:30 am',
                          '08:30 am',
                          '09:00 am',
                          '09:30 am',
                          '10:00 am',
                          '10:30 am',
                          '11:00 am',
                          '11:30 am',
                          '01:00 pm',
                          '01:30 pm',
                          '02:00 pm',
                          '02:30 pm',
                          '03:00 pm',
                          '03:30 pm',
                          '04:00 pm',
                          '04:30 pm'
                          );
    /*
    $fechaInicioAudiencias = Carbon::createFromFormat('d/m/Y', '06/09/2018');
    $fechaInicioEstados = Carbon::createFromFormat('d/m/Y', '03/09/2018');
    $fechaNotificacion = Carbon::createFromFormat('d/m/Y', '04/09/2018');*/

    $fechaInicioAudiencias = Carbon::createFromFormat('d/m/Y', '05/09/2018');
    $fechaInicioEstados = Carbon::createFromFormat('d/m/Y', '29/08/2018');
    $fechaNotificacion = Carbon::createFromFormat('d/m/Y', '30/09/2018');
    $festivos = Festivos::all();

    $arrayTratar = [];
    $sanciones = ResolucionSimit::where('COL5', '=', '1')
                                    ->where('fecha_format_resol', 'BETWEEN', DB::raw("'2014-08-15' AND '2015-06-22'"))
                                    ->where('id', 45415)
                                    ->get();

    //ingresando todas las sanciones que si deben ir a audiencia
    foreach ($sanciones as $sancion) {
      $comparendo = Comparendo::where('numero', '=', $sancion->COL7)->first();
      if(isset($comparendo->id)){
        $aaaaudiencia = ComparendoExpediente::where('id_comparendo', '=', $comparendo->id)
                                            ->where('id_tipo_evento', 29)->first();
        if(!isset($aaaaudiencia->id)){
          array_push($arrayTratar, (object) array(
            'resolucion' => $sancion->COL2,
            'fecha' => $sancion->COL4,
            'comparendo' => $sancion->COL7,
            'nombre' => $sancion->COL11 . ' ' . $sancion->COL12,
            'cedula' => $sancion->COL9,
            'valor' => $sancion->COL23
          ));
        }
      }
    }

    $mandamientos = ResolucionSimit::where('COL5', '=', '16')
                                    ->where('fecha_format_resol', 'BETWEEN', DB::raw("'2014-08-15' AND '2015-06-22'"))
                                    ->where('id', 54490)
                                    ->get();
    $arrayAux = $arrayTratar;
    //vamos a buscar todos los comparendos que faltan que estan en mandamientos y no estan en arrays a tratar
    foreach ($mandamientos as $mandamiento) {
      $ingresaComparendo = true;
      foreach ($arrayAux as $at) {
        if($mandamiento->COL7 == $at->comparendo){
          $ingresaComparendo = false;break;
        }
      }
      if($ingresaComparendo){
        $comparendo = Comparendo::where('numero', '=', $mandamiento->COL7)->first();
        if(isset($comparendo->id)){
          $aaaaudiencia = ComparendoExpediente::where('id_comparendo', '=', $comparendo->id)
                                              ->where('id_tipo_evento', 29)->first();
          if(!isset($aaaaudiencia->id)){
            array_push($arrayTratar, (object) array(
              'resolucion' => $mandamiento->COL2,
              'fecha' => $mandamiento->COL4,
              'comparendo' => $mandamiento->COL7,
              'nombre' => $mandamiento->COL11 . ' ' . $mandamiento->COL12,
              'cedula' => $mandamiento->COL9,
              'valor' => $mandamiento->COL23
            ));
          }
        }
      }
    }

    $countEstado = 0;
    $ultimaNumeracion = 0;
    $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '29')->first();

    if($numeracion != null){
      $ultimaNumeracion = $numeracion->final;
    }
    $inicioNumeracion = $ultimaNumeracion + 1;

    $arrayAudiencias = [];
    $arrayAudienciasAll = [];
    $arrayAudienciasAllObject = [];
    $numeroEstado = '';
    foreach ($arrayTratar as $resolucion) {
      $comparendo = Comparendo::where('numero', '=', $resolucion->comparendo)->first();
      if(isset($comparendo->id)){
        if($comparendo->tieneSaldo($comparendo->id)){
          if($countEstado == 0){
            $fechaInicioEstados = $fechaInicioEstados->addDays(1);
            $fechaInicioEstados = Comparendo::calcularFechaHabilLaboral($festivos, $fechaInicioEstados);
            $fechaInicioEstados = new Carbon($fechaInicioEstados);

            $ultimaNumeracionEst = 0;
            $numeracionEst = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '30')->first();

            if($numeracionEst != null){
              $ultimaNumeracionEst = $numeracionEst->final;
            }
            $inicioNumeracionEst = $ultimaNumeracionEst + 1;
            $ultimaNumeracionEst++;
            $numeroEstado = 'AUD_EST-' . $ultimaNumeracionEst . '-' . $fechaInicioEstados->year;
            //cada vez que reinicie se agrega 1 dia para notificacion del estado del dia siguiente
            $fechaNotificacion = $fechaNotificacion->addDays(1);
            $fechaNotificacion = Comparendo::calcularFechaHabilLaboral($festivos, $fechaNotificacion);
            $fechaNotificacion = new Carbon($fechaNotificacion);
            $fechaNotificacionTexto = $fechaNotificacion->format('d/m/Y');
          }
          $countEstado++;
          //if($countEstado <= 100){//mientras sean menos de 100 para el estado
            if($countAudiencia == 0){
              $fechaInicioAudiencias = Comparendo::calcularFechaHabilLaboral($festivos, $fechaInicioAudiencias);
              $fechaInicioAudiencias = new Carbon($fechaInicioAudiencias);
            }
            //mientras sean menos o igual a 15 para las audiencias por dia
            $ultimaNumeracion++;
            $numeroResolucion = 'AUD-' . $ultimaNumeracion . '-' . $fechaInicioAudiencias->year;
            $archivo = $numeroResolucion . '.pdf';
            $fechaTexto = $fechaInicioAudiencias->format('d/m/Y') . ' ' . $horaAudiencia[$countAudiencia];
            $fechaAudienciaTexto = $fechaInicioAudiencias->day . ' de ' . $this->meses[$fechaInicioAudiencias->month - 1] . ' de ' . $fechaInicioAudiencias->year;

            $fechaLetras = $fechaInicioEstados->day . ' de ' . $this->meses[$fechaInicioEstados->month - 1] . ' de ' . $fechaInicioEstados->year;

            //pdf de la audiencias
            $this->comparendopdf = view('comparendos.especial.jairsino.head_pdf',[
                                    'organismoDireccion' => $this->organismoDireccion,
                                    'rutaImagenTop' => $this->rutaImagenTop
                                  ]);
            $this->comparendopdf .=  view('comparendos.especial.jairsino.pdf', [
                                    'numero_resolucion' => $numeroResolucion,
                                    'fecha_actual' => $fechaLetras,
                                    'comparendo' => $comparendo,
                                    'demandado' => mb_strtoupper ($comparendo->infractor_nombre . ' ' . $comparendo->infractor_apellido),
                                    'rutaFirma' => $this->rutaFirma,
                                    'nombreSecretaria' => $organismo->secretario_nombre,
                                    'fechaNotificacion' => $fechaNotificacionTexto . ' a las 8:00 am',
                                    'nombreEstado' => $numeroEstado,
                                    'fechaAudiencia' => $fechaAudienciaTexto . ' a las ' . $horaAudiencia[$countAudiencia],
                                  ]);
            $this->comparendopdf = $this->comparendopdf . '</body></html>';

            $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');

            $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
            \File::makeDirectory($folder, 0777, true, true);
            try {
              $pdf->save($folder . '/' . $archivo);
            } catch (\Exception $e) {

            }

            array_push($arrayAudiencias, (object) array(
              'comparendo_id' => $comparendo->id,
              'resolucion' => $resolucion->resolucion,
              'fecha' => $resolucion->fecha,
              'comparendo' => $resolucion->comparendo,
              'nombre' => $resolucion->nombre,
              'cedula' => $resolucion->cedula,
              'valor' => $resolucion->valor,
              'res_audiencia' => $numeroResolucion,
              'fecha_audiencia' => $fechaInicioAudiencias->format('d/m/Y'),
              'nombre_estado' => $numeroEstado,
              'fecha_actual' => $fechaInicioEstados->format('d/m/Y'),
              'ruta' => $folder . '/' . $archivo
            ));
            array_push($arrayAudienciasAll, array(
              'comparendo_id' => $comparendo->id,
              'resolucion' => $resolucion->resolucion,
              'fecha' => $resolucion->fecha,
              'comparendo' => $resolucion->comparendo,
              'nombre' => $resolucion->nombre,
              'cedula' => $resolucion->cedula,
              'valor' => $resolucion->valor,
              'res_audiencia' => $numeroResolucion,
              'fecha_audiencia' => $fechaInicioAudiencias->format('d/m/Y'),
              'nombre_estado' => $numeroEstado,
              'fecha_actual' => $fechaInicioEstados->format('d/m/Y'),
              'ruta' => $folder . '/' . $archivo
            ));
            array_push($arrayAudienciasAllObject, (object) array(
              'comparendo_id' => $comparendo->id,
              'resolucion' => $resolucion->resolucion,
              'fecha' => $resolucion->fecha,
              'comparendo' => $resolucion->comparendo,
              'nombre' => $resolucion->nombre,
              'cedula' => $resolucion->cedula,
              'valor' => $resolucion->valor,
              'res_audiencia' => $numeroResolucion,
              'fecha_audiencia' => $fechaInicioAudiencias->format('d/m/Y'),
              'nombre_estado' => $numeroEstado,
              'fecha_actual' => $fechaInicioEstados->format('d/m/Y'),
              'ruta' => $folder . '/' . $archivo
            ));

            //creando el registro en expediente
            $expediente = new \App\ComparendoExpediente();
            $expediente->id_comparendo = $comparendo->id;
            $expediente->fecha_generacion = $fechaInicioEstados->format('Y-m-d');
            $expediente->nombre_documento = $numeroResolucion;
            $expediente->id_tipo_evento = 29;//res audiencia reconstruccion
            $expediente->id_paquete = 0;
            $expediente->id_user = 4;
            $expediente->save();


            $expediente = new \App\ComparendoAudiencias();
            $expediente->id_comparendo = $comparendo->id;
            $expediente->fecha_generacion = $fechaInicioEstados->format('Y-m-d');
            $expediente->fecha_audiencia = $fechaInicioAudiencias->format('Y-m-d');
            $expediente->fecha_info = $fechaInicioAudiencias->format('d/m/Y') . ' ' . $horaAudiencia[$countAudiencia];
            $expediente->nombre_documento = $numeroResolucion;
            $expediente->id_tipo_evento = 29;//res audiencia reconstruccion
            $expediente->id_user = 4;
            $expediente->save();

            $this->line("audiencia impreso: " . $archivo);

            $resolucion->es_pdf_impreso = 1;
            //$resolucion->save();

            $countAudiencia++;
            if($countAudiencia == 16){//reiniciando las horas del dia y sumando 1 dia
              $countAudiencia = 0;
              $fechaInicioAudiencias = $fechaInicioAudiencias->addDays(1);
              $fechaInicioAudiencias = Comparendo::calcularFechaHabilLaboral($festivos, $fechaInicioAudiencias);
              $fechaInicioAudiencias = new Carbon($fechaInicioAudiencias);
            }

          //}else{
            $fechaPublicacionLetras = $fechaInicioEstados->day . ' de ' . $this->meses[$fechaInicioEstados->month - 1] . ' de ' . $fechaInicioEstados->year;
            $countEstado = 0;
            //escribir en el estado
            foreach ($arrayAudiencias as $aud) {
              //creando el registro en expediente
              $expediente = new \App\ComparendoExpediente();
              $expediente->id_comparendo = $aud->comparendo_id;
              $expediente->fecha_generacion = $fechaInicioEstados->format('Y-m-d');
              $expediente->nombre_documento = $numeroEstado;
              $expediente->id_tipo_evento = 30;//estado de audiencias
              $expediente->id_paquete = 0;
              $expediente->id_user = 4;
              $expediente->save();
            }
            //pdf de los estados de las audiencias
            $estadoPdf = view('comparendos.especial.jairsino.estado.head_pdf',[
                                    'organismoDireccion' => $this->organismoDireccion,
                                    'rutaImagenTop' => $this->rutaImagenTop
                                  ]);
            $estadoPdf .=  view('comparendos.especial.jairsino.estado.pdf', [
                                    'arrayAudiencias' => $arrayAudiencias,
                                    'numeroEstado' => $numeroEstado,
                                    'fechaEstado' => $fechaInicioEstados->format('d/m/Y'),
                                    'fechaPublicacionLetras' => $fechaPublicacionLetras,
                                    'rutaFirma' => $this->rutaFirma,
                                    'nombreSecretaria' => $organismo->secretario_nombre,
                                  ]);
            $estadoPdf = $estadoPdf . '</body></html>';

            $pdf = PDF::loadHTML($estadoPdf)->setPaper('legal', 'landscape');
            \File::makeDirectory($rutaEstados, 0777, true, true);
            try {
              $pdf->save($rutaEstados . $numeroEstado . '.pdf');
            } catch (\Exception $e) {
              $this->line("No se hizo el pdf..." . $e);
            }
            if($ultimaNumeracionEst >= $inicioNumeracionEst){
              $this->line("Actualizando Numeracion...");
              //actualizar la numeracion en un nuevo registro
              $numeracion = new Numeracion();
              $numeracion->prefijo = 'AUD_EST';
              $numeracion->inicio = $inicioNumeracionEst;
              $numeracion->final = $ultimaNumeracionEst;
              $numeracion->id_tipo_evento = 30;//estado de audiencias
              $numeracion->id_organismo = 1;
              $numeracion->id_paquete = 0;
              $numeracion->save();
              $this->line("Fin Numeracion ESTADOS DE AUDIENCIA.");
            } else {
              $this->line("No se imprimo ESTADOS DE AUDIENCIA.");
            }
            //reiniciar las audiencias que van para el estado
            $arrayAudiencias = [];
          //}
        } else {
          $resolucion->es_pdf_impreso = -4;
          //$resolucion->save();
          $this->line("No tiene Saldo.");
        }
      } else {
        $resolucion->es_pdf_impreso = -2;
        //$resolucion->save();
        $this->line("RMP Sin comparendo");
      }
    }


    if($ultimaNumeracion >= $inicioNumeracion){
      $this->line("Actualizando Numeracion AUDIENCIAS...");
      //actualizar la numeracion en un nuevo registro
      $numeracion = new Numeracion();
      $numeracion->prefijo = 'AUD';
      $numeracion->inicio = $inicioNumeracion;
      $numeracion->final = $ultimaNumeracion;
      $numeracion->id_tipo_evento = 29;//audiciencias
      $numeracion->id_organismo = 1;
      $numeracion->id_paquete = 0;
      $numeracion->save();
      $this->line("Fin Numeracion AUDIENCIAS");
    } else {
      $this->line("No se imprimo AUDIENCIAS.");
    }


    $this->arrayExcel = $arrayAudienciasAll;
    Excel::create($archivo, function($excel) {
      $arrayExcel = $this->arrayExcel;
      $excel->sheet('Audiencias', function ($sheet) use ($arrayExcel) {
          $sheet->fromArray($arrayExcel);
      });

    })->store('xls', storage_path('excel'));

    $arrayCollection = new Collection($arrayAudienciasAllObject);
    $arrayCollection = $arrayCollection->sortBy('cedula');

    foreach ($arrayCollection as $resol) {
      $nuevoArchivo = \Config::get('myconfig.ruta_jairsino') . $resol->cedula . ' - ' . $resol->res_audiencia . '.pdf';
      \File::copy($resol->ruta, $nuevoArchivo);
    }

  }
}
