<?php

namespace App\Console\Commands\EspecialSanciones;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\ComparendoAudiencias;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;
use App\Festivos;
use App\RecaudoSimit;
use Maatwebsite\Excel\Facades\Excel;

class AuxiliarFix extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:start 0 c new no
   */
  protected $signature = 'auxfix:start';
  protected $avisos = null;
  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'para cuando falte algo por arreglar';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    //$comparendos = Comparendo::where('infraccion_fecha', '<=', DB::raw("'2014-12-31'"))->get();
    $comparendos = Comparendo::all();
    $count16 = 0;
    $count17 = 0;
    $count18 = 0;
    $count19 = 0;
    foreach ($comparendos as $comp) {
      if(!$comp->tieneSaldo($comp->id)){
        //buscar ultimo pago sacar fecha
        $pago = RecaudoSimit::where('id','>=',1);
        //buscar resoluciones de posibles pagos
        $resolucion = Comparendo::getResolucionesByComparendo($comp->numero)
        ->where(function ($query) {
            $query->where('COL5', '16')
                ->orWhere('COL5', '17')
                ->orWhere('COL5', '6')
                ->orWhere('COL5', '8');
        })
        ->orderBy('COL4F', 'desc')->first();
        //si han pagado es porque tienen o tenian resolucion 1, 6, 8, 16 o 17 activa, no hay que hacer filtro de tipo de resolucion.
        if(isset($resolucion->COL5)){
          if ($resolucion->COL5 == '16' || $resolucion->COL5 == '17' || $resolucion->COL5 == '6' || $resolucion->COL5 == '8') {
            //$this->line("POR RES: " . $comp->numero);
            $pago = $pago->where('C10', '=', $resolucion->COL2)
                          ->orWhere('C16', '=', $resolucion->COL2)
                          ->orWhere('C10', '=', $comp->numero)
                          ->orWhere('C16', '=', $comp->numero)->orderBy('fecha_pago', 'desc')->first();
          } else {
            //$this->line("POR comp: " . $comp->numero);
            $pago = $pago->Where('C10', '=', $comp->numero)
                          ->orWhere('C16', '=', $comp->numero)->orderBy('fecha_pago', 'desc')->first();
          }
        } else {
          //$this->line("POR comp sin res: ". $comp->numero);
          $pago = $pago->where('C10', '=', $comp->numero)
                        ->orWhere('C16', '=', $comp->numero)->orderBy('fecha_pago', 'desc')->first();
        }

        if(isset($pago->id)){
          $fechaC = new Carbon($pago->fecha_pago);
          //$this->line("fecha: " . $fechaC->year);
          if($fechaC->year == 2016){
            $count16++;
            $this->line("16: " . $count16);
          } else if($fechaC->year == 2017){
            $count17++;
            $this->line(" - 17: " . $count17);
          } else if($fechaC->year == 2018){
            $count18++;
            $this->line(" - 18: " . $count18);
          } else if($fechaC->year == 2019){
            $count19++;
            $this->line(" - 19: " . $count19);
          }
        }

      }
    }
    $this->line("16: " . $count16 . " - 17: " . $count17 . " - 18: " . $count18 . " - 19: " . $count19);
    /*$comparendos = Comparendo::where('infraccion_fecha', '<=', DB::raw("'2014-12-31'"))->get();
    $arrayAudiencias = [];
    foreach ($comparendos as $comp) {
      if($comp->tieneSaldo($comp->id)){
        array_push($arrayAudiencias, array(
          'identificacion' => $comp->infractor_documento,
          'numero' => $comp->numero,
          'fecha' => $comp->infraccion_fecha,
          'expediente' => $comp->numero_expediente
        ));
      }
    }
    $this->avisos = $arrayAudiencias;
    Excel::create('Prescribir', function($excel) {
      $avisos = $this->avisos;
      $excel->sheet('Prescribir', function ($sheet) use ($avisos) {
          $sheet->fromArray($avisos);
      });

    })->store('xls', storage_path('excel'));*/
    /*$audiencias = ComparendoAudiencias::all();
    foreach ($audiencias as $aud) {
      $comparendo = Comparendo::find($aud->id_comparendo);
      $this->line("comp: " . $comparendo->numero);
      $sancion = ResolucionSimit::where('COL5', '1')
                                  ->where('COL7', $comparendo->numero)
                                  ->whereBetween('fecha_format_resol', array('2014-08-15', '2015-06-22'))
                                  ->first();
      $sancionAportada = ResolucionSimit::where('COL5', '1')
                                  ->where('COL7', $comparendo->numero)
                                  ->first();
      $mandamiento = ResolucionSimit::where('COL5', '16')
                                  ->where('COL7', $comparendo->numero)
                                  ->whereBetween('fecha_format_resol', array('2014-08-15', '2015-06-22'))
                                  ->first();
      $mandamientoAportado = ResolucionSimit::where('COL5', '16')
                                  ->where('COL7', $comparendo->numero)
                                  ->first();
      if(isset($sancion->id) && isset($mandamiento->id)){//13
        $aud->sancion_rec = 1;
        $aud->mandamiento_rec = 1;
      }else if(isset($sancion->id)){//1 solo reconstruyo la sancion
        $aud->sancion_rec = 1;
      }else if(isset($mandamiento->id)){//3 solo reconstruyo el mandamiento
        $aud->mandamiento_rec = 1;
      }
      $aud->save();
    }*/
    /*$rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
    $arrayAudiencias = [];
    $audiencias = ComparendoExpediente::where('id_tipo_evento', 31)->get();
    foreach ($audiencias as $aud) {
      $comparendo = Comparendo::find($aud->id_comparendo);
      $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
      $archivo = $aud->nombre_documento . '.pdf';
      array_push($arrayAudiencias, (object) array(
        'cedula' => $comparendo->infractor_documento,
        'res_audiencia' => $aud->nombre_documento,
        'ruta' => $folder . '/' . $archivo
      ));
      $this->line("aud..." . $archivo);
    }


    $arrayCollection = new Collection($arrayAudiencias);
    $arrayCollection = $arrayCollection->sortBy('cedula');

    foreach ($arrayCollection as $resol) {
      $nuevoArchivo = \Config::get('myconfig.ruta_jairsino') . 'rec_audiencia/' . $resol->cedula . ' - ' . $resol->res_audiencia . '.pdf';
      \File::copy($resol->ruta, $nuevoArchivo);
      $this->line("copy..." . $nuevoArchivo);
    }*/
    /*$avisos = ComparendoExpediente::where('id_tipo_evento', 14)
                                  ->get();
    $arrayAudiencias = [];
    foreach ($avisos as $av) {
      $comparendo = $av->comparendo;
      $borrar = true;
      if($av->nombre_documento == 'AVMP-1920-01-2016' && $comparendo->infractor_documento == '1122405401'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1915-01-2016' && $comparendo->infractor_documento == '12630234'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1922-01-2016' && $comparendo->infractor_documento == '1118659'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1914-01-2016' && $comparendo->infractor_documento == '5016877'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1929-30-2016' && $comparendo->infractor_documento == '1064719883'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1932-11-2015' && $comparendo->infractor_documento == '17593890'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1904-01-2015' && $comparendo->infractor_documento == '6759439'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1904-01-2015' && $comparendo->infractor_documento == '6759439'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1911-01-2016' && $comparendo->infractor_documento == '79419783'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1907-01-2016' && $comparendo->infractor_documento == '8723896'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1912-01-2016' && $comparendo->infractor_documento == '8854598'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1919-01-2016' && $comparendo->infractor_documento == '77189094'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1911-01-2016' && $comparendo->infractor_documento == '71241221'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1908-01-2016' && $comparendo->infractor_documento == '18971950'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1908-01-2016' && $comparendo->infractor_documento == '3751708'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1936-11-2015' && $comparendo->infractor_documento == '51916300'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1920-01-2016' && $comparendo->infractor_documento == '1122405401'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1902-01-2016' && $comparendo->infractor_documento == '1122405401'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1915-01-2016' && $comparendo->infractor_documento == '1064708626'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1922-01-2016' && $comparendo->infractor_documento == '9692990'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1915-01-2016' && $comparendo->infractor_documento == '9692990'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1920-01-2016' && $comparendo->infractor_documento == '18973287'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1918-01-2016' && $comparendo->infractor_documento == '18973287'){
        $borrar = false;
      } elseif($av->nombre_documento == 'AVMP-1916-01-2016' && $comparendo->infractor_documento == '18973287'){
        $borrar = false;
      }
      if(!$borrar){
        $mandamiento = ResolucionSimit::where('COL5', DB::raw("'16'"))
                                      ->where('COL7', $comparendo->numero)->first();
        $fechaAvisoCarbon = new Carbon($av->fecha_generacion);
        $fechaAviso = $fechaAvisoCarbon->format('Y-m-d');
        array_push($arrayAudiencias, array(
          'identificacion' => $comparendo->infractor_documento,
          'nombre' => preg_replace('/\\.[^.\\s]{3,4}$/', '', $mandamiento->COL2),
          'fecha' => $fechaAviso,
          'archivo' => $av->nombre_documento,
          'expediente' => $comparendo->numero_expediente
        ));
      }
    }
    $this->avisos = $arrayAudiencias;
    Excel::create('Avisos Salvar', function($excel) {
      $avisos = $this->avisos;
      $excel->sheet('Avisos', function ($sheet) use ($avisos) {
          $sheet->fromArray($avisos);
      });

    })->store('xls', storage_path('excel'));*/

    /*
    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
    $arrayAudiencias = [];
    $audiencias = ComparendoExpediente::where('id_tipo_evento', 31)->get();
    foreach ($audiencias as $aud) {
      $comparendo = Comparendo::find($aud->id_comparendo);
      $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
      $archivo = $aud->nombre_documento . '.pdf';
      array_push($arrayAudiencias, (object) array(
        'cedula' => $comparendo->infractor_documento,
        'res_audiencia' => $aud->nombre_documento,
        'ruta' => $folder . '/' . $archivo
      ));
      $this->line("aud..." . $archivo);
    }


    $arrayCollection = new Collection($arrayAudiencias);
    $arrayCollection = $arrayCollection->sortBy('cedula');

    foreach ($arrayCollection as $resol) {
      $nuevoArchivo = \Config::get('myconfig.ruta_jairsino') . 'rec_audiencia/' . $resol->cedula . ' - ' . $resol->res_audiencia . '.pdf';
      \File::copy($resol->ruta, $nuevoArchivo);
      $this->line("copy..." . $nuevoArchivo);
    }
    */
  }
}
