<?php

namespace App\Console\Commands\EspecialSanciones;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use App\ResolucionSimit;
use App\ComparendoEntregaOficios as EntregaCitacion;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;
use Maatwebsite\Excel\Facades\Excel;

class AvisoResReconstruccion extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'avisoresrec:start';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'avisos de resoluciones de reconstruccion';

    /**
    * variables de contenido de la tarea
    */
    protected $relacionContenido = '';
    protected $pdfMasivo = '';
    protected $comparendosImpresos = array();
    protected $ultimaNumeracion = 1900;
    protected $comparendopdf = '';
    protected $meses = [];
    protected $organismoNombreSecreteria = '';
    protected $organismoDireccion = '';
    protected $rutaImagenTop = '';
    protected $rutaFirma = '';
    protected $avisos = null;

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle(){

      $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      $this->rutaFirma = base_path() . '/public/images/firma2.png';

      $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');

      $organismo = \App\Organismo::first();
      $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
      $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

      $this->pdfMasivo .= '<style>.page-break {page-break-after: always;}</style>';

      $festivos = Festivos::all();

      $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '34')->first();

      if($numeracion != null){
        $this->ultimaNumeracion = $numeracion->final;
      }
      $inicioNumeracion = $this->ultimaNumeracion + 1;

      $resreconstruccion = ComparendoExpediente::where('id_tipo_evento', 33)->get();

      foreach ($resreconstruccion as $rec) {
        $avRec = ComparendoExpediente::where('id_tipo_evento', 34)->where('id_comparendo', $rec->id_comparendo)->first();
        if(!isset($avRec->id)){
          $comparendo = $rec->comparendo;
          $expedienteNumero = 'EXP-' . $comparendo->numero_expediente;

          $archivo = '';
          $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
          \File::makeDirectory($folder, 0777, true, true);

          $fechaAvisoCarbon = new Carbon($rec->fecha_generacion);
          $fechaAviso = $fechaAvisoCarbon->format('Y-m-d');

          $fechaRetiroCarbon = new Carbon($rec->fecha_generacion);
          $fechaRetiroCarbon = Comparendo::calcularFechaHabilLaboral($festivos, $fechaRetiroCarbon->addDays(5));
          $fechaRetiroCarbon = new Carbon($fechaRetiroCarbon);
          $fechaRetiro = $fechaRetiroCarbon->format('Y-m-d');

          $this->ultimaNumeracion++;
          $archivo = 'AVREC-' . $this->ultimaNumeracion . '-' . $fechaAvisoCarbon->format('Y');

          //creando el registro en expediente
          $expediente = new \App\ComparendoExpediente();
          $expediente->id_comparendo = $comparendo->id;
          $expediente->fecha_generacion = $fechaAviso;
          $expediente->nombre_documento = $archivo;
          $expediente->id_tipo_evento = 34;//aviso rec
          $expediente->id_paquete = 0;
          $expediente->id_user = 4;
          $expediente->save();

          $this->comparendopdf = view('comparendos.especial.jairsino.aviso.head',[
                                  'rutaImagenTop' => $this->rutaImagenTop,
                                ]);
          $avisopdf = view('comparendos.especial.jairsino.aviso.pdf', [
                                  'nombreAviso' => $archivo,
                                  'resRec' => $rec->nombre_documento,
                                  'fechaRec' => $fechaAvisoCarbon->format('d/m/Y'),
                                  'expedienteNumero' => $expedienteNumero,
                                  'fechaAviso' => $fechaAvisoCarbon->format('d/m/Y'),
                                  'fechaRetiro' => $fechaRetiro,
                                  'rutaFirma' => $this->rutaFirma,
                                  'nombreSecretaria' => $organismo->secretario_nombre,
                                  'numero_comparendo' => $comparendo->numero,
                                ]);

          $this->comparendopdf .= $avisopdf . '</body></html>';

          $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('letter', 'portrait');
          $pdf->save($folder . '/' . $archivo. '.pdf');


          $this->line("aviso. " . $archivo);
        }
      }

      if($this->ultimaNumeracion >= $inicioNumeracion){
        $this->line("Actualizando Numeracion...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'AVREC';
        $numeracion->inicio = $inicioNumeracion;
        $numeracion->final = $this->ultimaNumeracion;
        $numeracion->id_tipo_evento = 34;//aviso mandamiento de pago
        $numeracion->id_organismo = 1;
        $numeracion->id_paquete = 0;
        $numeracion->save();
        $this->line("Fin Numeracion");
      } else {
        $this->line("No se imprimo avisos.");
      }
    }
}
