<?php

namespace App\Console\Commands\EspecialSanciones;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\ComparendoAudiencias;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;
use App\Festivos;
use Maatwebsite\Excel\Facades\Excel;

class EstadosAudienciasJairsino extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:start 0 c new no
   */
  protected $signature = 'estadoarecjairsino:start';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'estados audiencias jairsino';

  /**
  * variables de contenido de la tarea
  */
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';
  protected $arrayExcel = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
    $this->rutaFirma =  base_path() . '/public/images/firma2.png';

    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
    $rutaEstados = \Config::get('myconfig.ruta_rec_estados');

    $organismo = \App\Organismo::first();
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                   'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

    $convertidorNumerosALetras = new \NumberToLetterConverter();
    $resoluciones = null;

    $countAudiencia = 0;

    /*$anio = '2018';
    $mesesArray = ['09', '10', '11', '12'];*/

    $anio = '2019';
    $mesesArray = ['01', '02', '03', '04'];

    $ultimaNumeracionEst = 0;
    $numeracionEst = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '32')->first();

    if($numeracionEst != null){
      $ultimaNumeracionEst = $numeracionEst->final;
    }
    $inicioNumeracionEst = $ultimaNumeracionEst + 1;
    $ultimaNumeracionEst++;//aqui es donde se aumenta el numero del estado
    $arrayEstado = [];
    foreach ($mesesArray as $keymes) {
      for ($i = 1; $i <= 31; $i++) {
        $audiencias = ComparendoAudiencias::where('fecha_audiencia', '=', DB::raw("'".$anio."-".$keymes."-".$i."'"))
                                        ->get();

        $fechaInicioEstados = new Carbon($anio."-".$keymes."-".$i);
        $fechaPublicacionLetras = $fechaInicioEstados->day . ' de ' . $this->meses[$fechaInicioEstados->month - 1] . ' de ' . $fechaInicioEstados->year;
        $numeroEstado = 'REC_EST-' . $ultimaNumeracionEst . '-' . $fechaInicioEstados->year;

        foreach ($audiencias as $aud) {
          $estado = ComparendoExpediente::where('id_comparendo', '=', $aud->id_comparendo)
                                        ->where('id_tipo_evento', 32)->first();
          $fechaInicioAudiencias = new Carbon($aud->fecha_audiencia);
          if(!isset($estado->id)){//hacer el estado si no tiene
            $comparendo = Comparendo::find($aud->id_comparendo);
            $infractor = mb_strtoupper ($comparendo->infractor_nombre . ' ' . $comparendo->infractor_apellido);

            $rec = ComparendoExpediente::where('id_comparendo', '=', $aud->id_comparendo)
                                          ->where('id_tipo_evento', 33)->first();

            $this->line("REC ..." . $rec->nombre_documento);
            array_push($arrayEstado, (object) array(
              'nombre' => $infractor,
              'res_audiencia' => $rec->nombre_documento,
              'fecha_audiencia' => $fechaInicioAudiencias->format('d/m/Y'),
              'expediente' => 'EXP-' . $comparendo->numero_expediente,
            ));

            //creando el registro en expediente
            $expediente = new \App\ComparendoExpediente();
            $expediente->id_comparendo = $aud->id_comparendo;
            $expediente->fecha_generacion = $fechaInicioAudiencias->format('Y-m-d');
            $expediente->nombre_documento = $numeroEstado;
            $expediente->id_tipo_evento = 32;//audiencia reconstruccion
            $expediente->id_paquete = 0;
            $expediente->id_user = 4;
            $expediente->save();
          }
        }

        if(count($arrayEstado) > 0){
          //aqui escribir el archivo
          $ultimaNumeracionEst++;//aqui es donde se aumenta el numero del estado
          $estadoPdf = view('comparendos.especial.jairsino.estado.head_pdf',[
                                  'organismoDireccion' => $this->organismoDireccion,
                                  'rutaImagenTop' => $this->rutaImagenTop
                                ]);
          $estadoPdf .= view('comparendos.especial.jairsino.estado.pdf_rec', [
                                  'arrayAudiencias' => $arrayEstado,
                                  'numeroEstado' => $numeroEstado,
                                  'fechaEstado' => $fechaInicioEstados->format('d/m/Y'),
                                  'fechaPublicacionLetras' => $fechaPublicacionLetras,
                                  'rutaFirma' => $this->rutaFirma,
                                  'nombreSecretaria' => $organismo->secretario_nombre,
                                ]);
          $estadoPdf = $estadoPdf . '</body></html>';

          $pdf = PDF::loadHTML($estadoPdf)->setPaper('legal', 'landscape');
          \File::makeDirectory($rutaEstados, 0777, true, true);
          try {
            $arrayEstado = [];
            $pdf->save($rutaEstados . $numeroEstado . '.pdf');
          } catch (\Exception $e) {
            $this->line("No se hizo el pdf..." . $e);
          }
        }
      }
    }

    if($ultimaNumeracionEst >= $inicioNumeracionEst){
      $this->line("Actualizando Numeracion...");
      //actualizar la numeracion en un nuevo registro
      $numeracion = new Numeracion();
      $numeracion->prefijo = 'REC_EST';
      $numeracion->inicio = $inicioNumeracionEst;
      $numeracion->final = $ultimaNumeracionEst;
      $numeracion->id_tipo_evento = 32;//estado de reconstruccion
      $numeracion->id_organismo = 1;
      $numeracion->id_paquete = 0;
      $numeracion->save();
      $this->line("Fin Numeracion ESTADOS DE AUDIENCIA.");
    } else {
      $this->line("No se imprimo ESTADOS DE AUDIENCIA.");
    }
  }
}
