<?php

namespace App\Console\Commands\EspecialSanciones;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\ComparendoAudiencias;
use App\Infraccion;
use App\InfraccionF;
use App\InfraccionSalario;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;
use App\Festivos;
use Maatwebsite\Excel\Facades\Excel;

class FormatoAudienciasJairsino extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:start 0 c new no
   */
  protected $signature = 'formatoaudienciasjairsino:start';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'emite la ausencia en la audiencia para reconstruir documentos faltantes jairsino';

  /**
  * variables de contenido de la tarea
  */
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';
  protected $arrayExcel = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $infraccion = Infraccion::all();
    $infraccion_f = InfraccionF::all();
    $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
    $this->rutaFirma =  base_path() . '/public/images/firma2.png';

    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
    $rutaEstados = \Config::get('myconfig.ruta_audiencia_estados');

    $organismo = \App\Organismo::first();
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                  'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');
    $diasLetras = array('uno', 'dos', 'tres', 'cuatro', 'cinco', 'seis', 'siete',
                  'ocho', 'nueve', 'diez', 'once', 'doce', 'trece', 'catorce', 'quince', 'dieciseis', 'diecisiete', 'dieciocho', 'diecinueve',
                  'veinte', 'veintiun', 'veintidos', 'veintitres', 'veinticuatro', 'veinticinco', 'veintiseis', 'veintisiete', 'veintiocho', 'veintinueve',
                  'treinta', 'treintiun');

    $convertidorNumerosALetras = new \NumberToLetterConverter();
    $resoluciones = null;

    $fechaAudiencia = null;

    $fechaEstado = Carbon::createFromFormat('d/m/Y', '03/09/2018');
    $fechaAviso = Carbon::createFromFormat('d/m/Y', '04/09/2018');
    $festivos = Festivos::all();

    $ultimaNumeracion = 0;
    $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '31')->first();

    if($numeracion != null){
      $ultimaNumeracion = $numeracion->final;
    }
    $inicioNumeracion = $ultimaNumeracion + 1;

    /*$audiencias = ComparendoAudiencias::where('id_comparendo', 31959)
                                      ->orWhere('id_comparendo', 26616)
                                      ->orWhere('id_comparendo', 25016)
                                      ->orWhere('id_comparendo', 24453)->get();*/
    $audiencias = ComparendoAudiencias::all();
    $arrayAudienciasAll = [];
    foreach ($audiencias as $aud) {
      $comparendo = Comparendo::find($aud->id_comparendo);
      $ar = ComparendoExpediente::where('id_tipo_evento', 31)->where('id_comparendo', $comparendo->id)->first();
      if(!isset($ar->id)){
        $this->line("comp: " . $comparendo->numero);
        $sancion = ResolucionSimit::where('COL5', '1')
                                    ->where('COL7', $comparendo->numero)
                                    ->whereBetween('fecha_format_resol', array('2014-08-15', '2015-06-22'))
                                    ->first();
        $sancionAportada = ResolucionSimit::where('COL5', '1')
                                    ->where('COL7', $comparendo->numero)
                                    ->first();
        $mandamiento = ResolucionSimit::where('COL5', '16')
                                    ->where('COL7', $comparendo->numero)
                                    ->whereBetween('fecha_format_resol', array('2014-08-15', '2015-06-22'))
                                    ->first();
        $mandamientoAportado = ResolucionSimit::where('COL5', '16')
                                    ->where('COL7', $comparendo->numero)
                                    ->first();

        $textoCaso = '';
        $textoResuelve = '';
        $infractor = mb_strtoupper ($comparendo->infractor_nombre . ' ' . $comparendo->infractor_apellido);
        $cedulaInfractor = $comparendo->infractor_documento;
        if(isset($sancion->id) && isset($mandamiento->id)){//13
          $textoCaso = 'hace falta el folio 1 correspondiente a la resolucion sancion N&#176; <b>'.$sancion->COL2.'</b>, aportada como base de la presente ejecución. Asi mismo, se tiene que no se observa el folio 3 que corresponde a la resolucion de madamiento de pago  N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b>, que da inicio al proceso administrativo de cobro coactivo';

          $textoResuelve = '<b>PRIMERO:</b> Declarar reconstruido el folio 1  de cuaderno principal del
          expediente administrativo de cobro coactivo y que corresponde a la resolucion Sancion N&#176; <b>'.$sancion->COL2.'</b> de fecha <b>'.$sancion->COL4.'</b> en la que se declaro contraventor y deudor al señor <b>'.$infractor.'</b>,
          identificado con CC <b>'.$cedulaInfractor.'</b>, a favor del municipio de Curumaní – Cesar, por valor de <b>$'.number_format($sancion->COL23, 0, ",", ".").'</b> que configura  como titulo ejecutivo. SEGUNDO: Declarar reconstruido el folio 3 del cuaderno
          principal del expediente administrativo de cobro coactivo y que corresponde a la resolucion de mandamiento de pago N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b> por valor de <b>$'.number_format($mandamiento->COL23, 0, ",", ".").'</b>, que dio inicio al
          presente proceso en contra del señor <b>'.$infractor.'</b>, identificado con CC <b>'.$cedulaInfractor.'</b> y que le ordenaba el pago por valor de <b>$'.number_format($mandamiento->COL23, 0, ",", ".").'</b> mas los intereses de mora, las costas y gastos, que
          se generen hasta que se realice el pago total de la obligacion.';

          $aud->sancion_rec = 1;
          $aud->mandamiento_rec = 1;
        }else if(isset($sancion->id)){//1 solo reconstruyo la sancion
          $textoCaso = 'hace falta el folio 1 correspondiente a la resolucion sancion N&#176; <b>'.$sancion->COL2.'</b>, aportada como base de la presente ejecución';

          $textoResuelve = '<b>PRIMERO:</b> Declarar reconstruido el folio 1  de cuaderno principal del
          expediente administrativo de cobro coactivo y que corresponde a la resolucion Sancion N&#176; <b>'.$sancion->COL2.'</b> de fecha <b>'.$sancion->COL4.'</b> en la que se declaro contraventor y deudor al señor <b>'.$infractor.'</b>,
          identificado con CC <b>'.$cedulaInfractor.'</b>, a favor del municipio de Curumaní – Cesar, por valor de <b>$'.number_format($sancion->COL23, 0, ",", ".").'</b> que configura  como titulo ejecutivo.';

          $aud->sancion_rec = 1;
        }else if(isset($mandamiento->id)){//3 solo reconstruyo el mandamiento
          $textoCaso = 'hace falta el folio 3 que corresponde a la resolucion de madamiento de pago  N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b>, que da inicio al proceso administrativo de cobro coactivo';

          $textoResuelve = '<b>PRIMERO:</b> Declarar reconstruido el folio 3 del cuaderno
          principal del expediente administrativo de cobro coactivo y que corresponde a la resolucion de mandamiento de pago N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b> por valor de <b>$'.number_format($mandamiento->COL23, 0, ",", ".").'</b>, que dio inicio al
          presente proceso en contra del señor <b>'.$infractor.'</b>, identificado con CC <b>'.$cedulaInfractor.'</b> y que le ordenaba el pago por valor de <b>$'.number_format($mandamiento->COL23, 0, ",", ".").'</b> mas los intereses de mora, las costas y gastos, que
          se generen hasta que se realice el pago total de la obligacion.';

          $aud->mandamiento_rec = 1;
        }
        //codigo de la infraccion
        $codigoLetraInfraccion = substr($comparendo->infracciones, 0, 1);
        $codigoCompletoInfraccion = $comparendo->infracciones;
        $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();

        if(!isset($if->salarios_dias)){
          foreach ($infraccion as $inf) {
            if($inf->codigo_old == $comparendo->infracciones){
              $codigoLetraInfraccion = substr($inf->codigo, 0, 1);
              $codigoCompletoInfraccion = $inf->codigo;
              $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();
              $infraccion_salario = $if->salarios_dias;
              break;
            }
          }
        } else{
          $infraccion_salario = $if->salarios_dias;
        }

        //generando la audiencia
        $ultimaNumeracion++;
        $fechaAudiencia = new Carbon($aud->fecha_audiencia);
        $numeroResolucion = 'AR-' . $ultimaNumeracion . '-' . $fechaAudiencia->year;
        $archivo = $numeroResolucion . '.pdf';
        //pdf de la audiencias
        $this->comparendopdf = view('comparendos.especial.jairsino.audiencia.head_pdf',[
                                'organismoDireccion' => $this->organismoDireccion,
                                'rutaImagenTop' => $this->rutaImagenTop
                              ]);
        $fechaGeneracionAudiencia = new Carbon($aud->fecha_generacion);
        $this->comparendopdf .=  view('comparendos.especial.jairsino.audiencia.pdf', [
                                'numero_expediente' => 'EXP-'.$comparendo->numero_expediente,
                                'numero_audiencia' => $aud->nombre_documento,
                                'numero_audiencia_r' => $numeroResolucion,
                                'numero_comparendo' => $comparendo->numero,
                                'infraccion' => $codigoCompletoInfraccion,
                                'infractor' => $infractor,
                                'cedula' => $cedulaInfractor,
                                'placa' => $comparendo->vehiculo_placa,
                                'nombreSecretaria' => $organismo->secretario_nombre,
                                'nombreCoordinadora' => 'MARIA ALEJANDRA CASTRO',
                                'diasLetras' => $diasLetras[$fechaAudiencia->day - 1],
                                'dias' => $fechaAudiencia->day,
                                'mes' => $this->meses[$fechaAudiencia->month - 1],
                                'anio' => $fechaAudiencia->year,
                                'fechaGeneracionAudiencia' => $fechaGeneracionAudiencia->format('d/m/Y'),
                                'cedulaCoordinadora' => '1.143.399.209 de Cartagena',
                                'textoCaso' => $textoCaso,
                                'sancionAportada' => $sancionAportada,
                                'mandamientoAportado' => $mandamientoAportado,
                                'textoResuelve' => $textoResuelve,
                              ]);
        $this->comparendopdf = $this->comparendopdf . '</body></html>';

        $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');

        $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
        \File::makeDirectory($folder, 0777, true, true);
        try {
          $pdf->save($folder . '/' . $archivo);
        } catch (\Exception $e) {

        }
        array_push($arrayAudienciasAll, (object) array(
          'cedula' => $cedulaInfractor,
          'res_audiencia' => $aud->nombre_documento,
          'ruta' => $folder . '/' . $archivo
        ));
        //creando el registro en expediente
        $expediente = new \App\ComparendoExpediente();
        $expediente->id_comparendo = $aud->id_comparendo;
        $expediente->fecha_generacion = $fechaAudiencia->format('Y-m-d');
        $expediente->nombre_documento = $numeroResolucion;
        $expediente->id_tipo_evento = 31;//audiencia reconstruccion
        $expediente->id_paquete = 0;
        $expediente->id_user = 4;
        $expediente->save();

        $aud->save();
      }

    }

    if($ultimaNumeracion >= $inicioNumeracion){
      $this->line("Actualizando Numeracion AUDIENCIAS...");
      //actualizar la numeracion en un nuevo registro
      $numeracion = new Numeracion();
      $numeracion->prefijo = 'AR';
      $numeracion->inicio = $inicioNumeracion;
      $numeracion->final = $ultimaNumeracion;
      $numeracion->id_tipo_evento = 31;//audiciencias
      $numeracion->id_organismo = 1;
      $numeracion->id_paquete = 0;
      $numeracion->save();
      $this->line("Fin Numeracion AUDIENCIAS");
    } else {
      $this->line("No se imprimo AUDIENCIAS.");
    }


    $arrayCollection = new Collection($arrayAudienciasAll);
    $arrayCollection = $arrayCollection->sortBy('cedula');

    foreach ($arrayCollection as $resol) {
      $nuevoArchivo = \Config::get('myconfig.ruta_jairsino') . 'rec_audiencia/' . $resol->cedula . ' - ' . $resol->res_audiencia . '.pdf';
      \File::copy($resol->ruta, $nuevoArchivo);
    }

  }
}
