<?php

namespace App\Console\Commands\EspecialSanciones;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\ComparendoAudiencias;
use App\Infraccion;
use App\InfraccionF;
use App\InfraccionSalario;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;
use App\Festivos;
use Maatwebsite\Excel\Facades\Excel;

class ResolucionAudienciasJairsino extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:start 0 c new no
   */
  protected $signature = 'resolucionaudienciasjairsino:start';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'emite la resolucion de la audiencia realizada para jairsino';

  /**
  * variables de contenido de la tarea
  */
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';
  protected $arrayExcel = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $infraccion = Infraccion::all();
    $infraccion_f = InfraccionF::all();
    $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
    $this->rutaFirma =  base_path() . '/public/images/firma2.png';

    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
    $rutaEstados = \Config::get('myconfig.ruta_audiencia_estados');

    $organismo = \App\Organismo::first();
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                  'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');
    $diasLetras = array('uno', 'dos', 'tres', 'cuatro', 'cinco', 'seis', 'siete',
                  'ocho', 'nueve', 'diez', 'once', 'doce', 'trece', 'catorce', 'quince', 'dieciseis', 'diecisiete', 'dieciocho', 'diecinueve',
                  'veinte', 'veintiun', 'veintidos', 'veintitres', 'veinticuatro', 'veinticinco', 'veintiseis', 'veintisiete', 'veintiocho', 'veintinueve',
                  'treinta', 'treintiun');

    $convertidorNumerosALetras = new \NumberToLetterConverter();
    $resoluciones = null;

    $fechaAudiencia = null;

    $ultimaNumeracion = 0;
    $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '33')->first();

    if($numeracion != null){
      $ultimaNumeracion = $numeracion->final;
    }
    $inicioNumeracion = $ultimaNumeracion + 1;

    /*$audiencias = ComparendoAudiencias::where('id_comparendo', 31959)
                                      ->orWhere('id_comparendo', 26616)
                                      ->orWhere('id_comparendo', 25016)
                                      ->orWhere('id_comparendo', 24453)->get();*/
    $audiencias = ComparendoExpediente::where('id_tipo_evento', 31)
                                ->get();
    /*$audiencias = ComparendoExpediente::where('id_tipo_evento', 31)
                                      ->where(function ($query) {
                                          $query->where('id_comparendo', 21754)
                                          ->orWhere('id_comparendo', 28732)
                                          ->orWhere('id_comparendo', 19117)
                                          ->orWhere('id_comparendo', 26616)
                                          ->orWhere('id_comparendo', 25016)
                                          ->orWhere('id_comparendo', 27182)
                                          ->orWhere('id_comparendo', 20392)
                                          ->orWhere('id_comparendo', 20339)
                                          ->orWhere('id_comparendo', 20338)
                                          ->orWhere('id_comparendo', 19899)
                                          ->orWhere('id_comparendo', 22665)
                                          ->orWhere('id_comparendo', 21069)
                                          ->orWhere('id_comparendo', 27192)
                                          ->orWhere('id_comparendo', 29085)
                                          ->orWhere('id_comparendo', 21670);
                                      })
                                      ->get();*/
    /*$audiencias = ComparendoExpediente::where('id_tipo_evento', 31)
                                      ->where(function ($query) {
                                          $query
                                          ->orWhere('id_comparendo', 20357);
                                      })
                                      ->get();*/
    $arrayAudienciasAll = [];
    foreach ($audiencias as $aud) {
      $resAudienciaEncontrada = ComparendoExpediente::where('id_tipo_evento', 33)
                                                    ->where('id_comparendo', $aud->id_comparendo)
                                                    ->first();
      if(!isset($resAudienciaEncontrada->id)){
        $comparendo = Comparendo::find($aud->id_comparendo);
        $sancion = ResolucionSimit::where('COL5', '1')
                                    ->where('COL7', $comparendo->numero)
                                    ->whereBetween('fecha_format_resol', array('2014-08-15', '2015-06-22'))
                                    ->first();
        $sancionAportada = ResolucionSimit::where('COL5', '1')
                                    ->where('COL7', $comparendo->numero)
                                    ->first();
        $mandamiento = ResolucionSimit::where('COL5', '16')
                                    ->where('COL7', $comparendo->numero)
                                    ->whereBetween('fecha_format_resol', array('2014-08-15', '2015-06-22'))
                                    ->first();
        $mandamientoAportado = ResolucionSimit::where('COL5', '16')
                                    ->where('COL7', $comparendo->numero)
                                    ->first();
        $reconstruccionAudiencia = ComparendoExpediente::where('id_comparendo', $comparendo->id)
                                    ->where('id_tipo_evento', 31)
                                    ->first();

          //codigo de la infraccion
          $codigoLetraInfraccion = substr($comparendo->infracciones, 0, 1);
          $codigoCompletoInfraccion = $comparendo->infracciones;
          $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();

          if(!isset($if->salarios_dias)){
            foreach ($infraccion as $inf) {
              if($inf->codigo_old == $comparendo->infracciones){
                $codigoLetraInfraccion = substr($inf->codigo, 0, 1);
                $codigoCompletoInfraccion = $inf->codigo;
                $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();
                $infraccion_salario = $if->salarios_dias;
                break;
              }
            }
          } else{
            $infraccion_salario = $if->salarios_dias;
          }

          $textoCaso = '';
          $textoResuelve = '';
          $infractor = mb_strtoupper ($comparendo->infractor_nombre . ' ' . $comparendo->infractor_apellido);
          $cedulaInfractor = $comparendo->infractor_documento;
          $resolucionReconstruir = '';
          $foliosFaltantes = '';
          if(isset($sancion->id) && isset($mandamiento->id)){//13
            $textoCaso = 'uno(1) correspondiente a la resolución sanción N&#176; <b>'.$sancion->COL2.'</b> de fecha <b>'.$sancion->COL4.'</b>, aportada como base de la presente ejecución y el folio tres(3) que corresponde a la resolucion de madamiento de pago  N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b>, que da inicio al proceso administrativo de cobro coactivo.';
            $resolucionReconstruir = 'sanción N&#176; <b>'.$sancion->COL2.'</b> de fecha <b>'.$sancion->COL4.'</b>  y la resolución madamiento de pago N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b>';

            $textoResuelve = '<ul>';
            $textoResuelve .= '<li>Resolución Sanción N&#176; <b>'.$sancion->COL2.'</b> de fecha <b>'.$sancion->COL4.'</b>, que declara contraventor(a) a <b>'.$infractor.'</b>, identificado(a) <b>'.$cedulaInfractor.'</b>, de la infracción de transito '.$codigoCompletoInfraccion.' y lo declaro deudor a favor del municipio de Curumaní, por la suma de <b>$'.number_format($sancion->COL23, 0, ",", ".").'</b>.</li>';
            $textoResuelve .= '<li>Resolución de Mandamiento de pago N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b>, que ordena al (la) señor(a) <b>'.$infractor.'</b>, identificado(a) <b>'.$cedulaInfractor.'</b>, a pagar la suma de <b>$'.number_format($mandamiento->COL23, 0, ",", ".").'</b> en un plazo de quince (15) días a partir de la fecha de su expedición a favor del municipio de Curumani - Secretaria de Transito y Transporte.</li>';
            $textoResuelve .= '</ul>';

            $foliosFaltantes = 'uno(1) y tres(3)';
          }else if(isset($sancion->id)){//1 solo reconstruyo la sancion
            $textoCaso = 'uno(1) correspondiente a la resolucion sancion N&#176; <b>'.$sancion->COL2.'</b> de fecha <b>'.$sancion->COL4.'</b>, aportada como base de la presente ejecución.';
            $resolucionReconstruir = 'sanción N&#176; <b>'.$sancion->COL2.'</b> de fecha <b>'.$sancion->COL4.'</b>';

            $textoResuelve = '<ul>';
            $textoResuelve .= '<li>Resolución Sanción N&#176; <b>'.$sancion->COL2.'</b> de fecha <b>'.$sancion->COL4.'</b>, que declara contraventor(a) a <b>'.$infractor.'</b>, identificado(a) <b>'.$cedulaInfractor.'</b>, de la infracción de transito '.$codigoCompletoInfraccion.' y lo declaro deudor a favor del municipio de Curumaní, por la suma de <b>$'.number_format($sancion->COL23, 0, ",", ".").'</b>.</li>';
            $textoResuelve .= '</ul>';

            $foliosFaltantes = 'uno(1)';
          }else if(isset($mandamiento->id)){//3 solo reconstruyo el mandamiento
            $textoCaso = 'tres(3) que corresponde a la resolucion de madamiento de pago  N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b>, que da inicio al proceso administrativo de cobro coactivo.';
            $resolucionReconstruir = 'madamiento de pago N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b>';

            $textoResuelve = '<ul>';
            $textoResuelve .= '<li>Resolución de Mandamiento de pago N&#176; <b>'.$mandamiento->COL2.'</b> de fecha <b>'.$mandamiento->COL4.'</b>, que ordena al (la) señor(a) <b>'.$infractor.'</b>, identificado(a) <b>'.$cedulaInfractor.'</b>, a pagar la suma de <b>$'.number_format($mandamiento->COL23, 0, ",", ".").'</b> en un plazo de quince (15) días a partir de la fecha de su expedición a favor del municipio de Curumani - Secretaria de Transito y Transporte.</li>';
            $textoResuelve .= '</ul>';

            $foliosFaltantes = 'tres(3)';
          }


          //generando la audiencia
          $ultimaNumeracion++;
          $fechaAudiencia = new Carbon($aud->fecha_generacion);
          $numeroResolucion = 'REC-' . $ultimaNumeracion . '-' . $fechaAudiencia->year;
          $fechaResLetra = $fechaAudiencia->day . ' de ' . $this->meses[$fechaAudiencia->month - 1] . ' de ' . $fechaAudiencia->year;
          $archivo = $numeroResolucion . '.pdf';
          //pdf de la audiencias
          $this->comparendopdf = view('comparendos.especial.jairsino.resolucion.head_pdf',[
                                  'organismoDireccion' => $this->organismoDireccion,
                                  'rutaImagenTop' => $this->rutaImagenTop
                                ]);
          $this->comparendopdf .=  view('comparendos.especial.jairsino.resolucion.pdf', [
                                  'numero_audiencia_r' => $numeroResolucion,
                                  'fechaResLetra' => $fechaResLetra,
                                  'foliosFaltantes' => $foliosFaltantes,
                                  'reconstruccionAudiencia' => $reconstruccionAudiencia,
                                  'numero_expediente' => 'EXP-'.$comparendo->numero_expediente,
                                  'numero_comparendo' => $comparendo->numero,
                                  'infractor' => $infractor,
                                  'cedula' => $cedulaInfractor,
                                  'fechaAudiencia' => $fechaAudiencia->format('d/m/Y'),
                                  'rec_audiencia' => $aud->nombre_documento,
                                  'nombreCoordinadora' => 'MARIA ALEJANDRA CASTRO',
                                  'cedulaCoordinadora' => '1.143.399.209 de Cartagena',
                                  'textoCaso' => $textoCaso,
                                  'resolucionReconstruir' => $resolucionReconstruir,
                                  'textoResuelve' => $textoResuelve,
                                  'rutaFirma' => $this->rutaFirma,
                                  'nombreSecretaria' => $organismo->secretario_nombre,
                                  'diasLetras' => $diasLetras[$fechaAudiencia->day - 1],
                                  'dias' => $fechaAudiencia->day,
                                  'mes' => $this->meses[$fechaAudiencia->month - 1],
                                  'anio' => $fechaAudiencia->year,
                                  'sancionAportada' => $sancionAportada,
                                  'mandamientoAportado' => $mandamientoAportado,
                                ]);
          $this->comparendopdf = $this->comparendopdf . '</body></html>';

          $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');

          $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
          \File::makeDirectory($folder, 0777, true, true);
          try {
            $pdf->save($folder . '/' . $archivo);
          } catch (\Exception $e) {

          }
          array_push($arrayAudienciasAll, (object) array(
            'cedula' => $cedulaInfractor,
            'res_audiencia' => $numeroResolucion,
            'ruta' => $folder . '/' . $archivo
          ));
          //creando el registro en expediente
          $expediente = new \App\ComparendoExpediente();
          $expediente->id_comparendo = $aud->id_comparendo;
          $expediente->fecha_generacion = $fechaAudiencia->format('Y-m-d');
          $expediente->nombre_documento = $numeroResolucion;
          $expediente->id_tipo_evento = 33;//resolucion audiencia reconstruccion
          $expediente->id_paquete = 0;
          $expediente->id_user = 4;
          $expediente->save();
          $this->line("Res: " . $numeroResolucion);
      }
    }

    if($ultimaNumeracion >= $inicioNumeracion){
      $this->line("Actualizando Numeracion AUDIENCIAS...");
      //actualizar la numeracion en un nuevo registro
      $numeracion = new Numeracion();
      $numeracion->prefijo = 'REC';
      $numeracion->inicio = $inicioNumeracion;
      $numeracion->final = $ultimaNumeracion;
      $numeracion->id_tipo_evento = 33;//RES audiencia reconstruccion
      $numeracion->id_organismo = 1;
      $numeracion->id_paquete = 0;
      $numeracion->save();
      $this->line("Fin Numeracion AUDIENCIAS");
    } else {
      $this->line("No se imprimo AUDIENCIAS.");
    }


    $arrayCollection = new Collection($arrayAudienciasAll);
    $arrayCollection = $arrayCollection->sortBy('cedula');

    foreach ($arrayCollection as $resol) {
      $nuevoArchivo = \Config::get('myconfig.ruta_jairsino') . 'res_audiencia/' . $resol->cedula . ' - ' . $resol->res_audiencia . '.pdf';
      \File::copy($resol->ruta, $nuevoArchivo);
    }

  }
}
