<?php

namespace App\Console\Commands\EspecialSanciones;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;

class ResolucionMandamientoPdfOfelia extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:start 0 c new no
   */
  protected $signature = 'mandamientoofelia:start';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'mandamientos ofelia';

  /**
  * variables de contenido de la tarea
  */
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $this->rutaImagenTop = base_path() . '/public/images/logo_sancion_ofelia.png';
    $this->rutaFirma = '';

    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');

    $organismo = \App\Organismo::first();
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                   'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

    $convertidorNumerosALetras = new \NumberToLetterConverter();
    $resoluciones = null;

    $arrayTratar = [];
    do {
      /*$resoluciones = ResolucionSimit::where('es_pdf_impreso', '=', '0')
                                      ->where('COL5', '=', '16')
                                      ->whereBetween('fecha_format_resol', array('2011-04-11', '2014-08-14'))
                                      ->limit(50)->get();*/
      $resoluciones = ResolucionSimit::where('id', 52816)->get();

      foreach ($resoluciones as $resolucion) {
        $comparendo = Comparendo::where('numero', '=', $resolucion->COL7)->first();
        if(isset($comparendo->id)){
          //if($comparendo->tieneSaldo($comparendo->id)){
            $sancion = ResolucionSimit::where('COL2', '=', $resolucion->COL3)->where('COL5', '=', '1')->first();

            $fechaMandamientoCarbon = Carbon::createFromFormat('d/m/Y', $resolucion->COL4);
            $fechaGeneracionMandamiento = $fechaMandamientoCarbon->day . ' de ' . $this->meses[$fechaMandamientoCarbon->month - 1] . ' de ' . $fechaMandamientoCarbon->year;

            $fechaSancion = Carbon::createFromFormat('d/m/Y', $sancion->COL4);
            $fechaGeneracionSancion = $fechaSancion->day . ' de ' . $this->meses[$fechaSancion->month - 1] . ' de ' . $fechaSancion->year;

            $archivo = $resolucion->COL2 . '.pdf';

            $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
            \File::makeDirectory($folder, 0777, true, true);

            $this->comparendopdf = view('comparendos.especial.ofelia.mandamiento_head_pdf',[
                                    'organismoDireccion' => $this->organismoDireccion,
                                    'rutaImagenTop' => $this->rutaImagenTop
                                  ]);

            $infraccion_fecha = new Carbon($comparendo->infraccion_fecha);
            $infraccion_fecha = $infraccion_fecha->format('d/m/Y');

            $mandamientopdf =  view('comparendos.especial.ofelia.mandamiento_pdf', [
                                    'numeroResolucion' => $resolucion->COL2,
                                    'comparendo' => $comparendo,
                                    'valorLetras' => $convertidorNumerosALetras->to_word(round($comparendo->valor)),
                                    'infraccion_fecha' => $infraccion_fecha,
                                    'infraccion_hora' => $comparendo->infraccion_hora,
                                    'fechaMandamiento' => $fechaGeneracionMandamiento,
                                    'resol_sancion' => $sancion->COL2,
                                    'resol_fecha' => $sancion->COL4
                                  ]);

            $this->comparendopdf .= $mandamientopdf . '</body></html>';

            $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');
            try {
              $pdf->save($folder . '/' . $archivo);
            } catch (\Exception $e) {

            }
            array_push($arrayTratar, (object) array(
              'resolucion' => $resolucion->COL2,
              'cedula' => $comparendo->infractor_documento,
              'ruta' => $folder . '/' . $archivo
            ));
            $this->line("mandamiento impreso: " . $archivo);

            $resolucion->es_pdf_impreso = 1;
            $resolucion->save();
          /*} else {
            $resolucion->es_pdf_impreso = -4;
            $resolucion->save();
            $this->line("No tiene Saldo.");
          }*/
        } else {
          $resolucion->es_pdf_impreso = -2;
          $resolucion->save();
          $this->line("RMP Sin comparendo");
        }
      }

    } while (count($resoluciones) > 0);

    $arrayCollection = new Collection($arrayTratar);
    $arrayCollection = $arrayCollection->sortBy('cedula');

    foreach ($arrayCollection as $resol) {
      $nuevoArchivo = \Config::get('myconfig.ruta_ofelia') . 'mandamiento/' . $resol->cedula . ' - ' . $resol->resolucion . '.pdf';
      \File::copy($resol->ruta, $nuevoArchivo);
    }

  }
}
