<?php

namespace App\Console\Commands\EspecialSanciones;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ResolucionSimit;
use App\Infraccion;
use App\InfraccionSalario;
use App\ComparendoNumeracionImpresion as Numeracion;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;
use Illuminate\Support\Collection;
use \Milon\Barcode\DNS1D;

class ResolucionSancionPdfOfelia extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'sancionpdfofelia:start';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Solo ofelia';

    /**
    * variables de contenido de la tarea
    */
    protected $comparendopdf = '';
    protected $meses = [];
    protected $organismoNombreSecreteria = '';
    protected $organismoDireccion = '';
    protected $rutaImagenTop = '';
    protected $rutaFirma = '';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
      $this->rutaImagenTop = base_path() . '/public/images/logo_sancion_ofelia.png';
      $this->rutaFirma = '';

      $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
      $rutaPaquete = \Config::get('myconfig.ruta_paquetes_mensajeria');

      $organismo = \App\Organismo::first();
      $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
      $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

      $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                     'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');
      $convertidorNumerosALetras = new \NumberToLetterConverter();
      $resoluciones = null;

      $infraccion = Infraccion::all();
      $infraccionSalario = InfraccionSalario::all();
      $fecha = Carbon::now();
      $arrayTratar = [];
      $barcode = new DNS1D();
      do {
        /*$resoluciones = ResolucionSimit::where('es_pdf_impreso', '=', '0')
                                        ->where('COL5', '=', '1')
                                        ->whereBetween('fecha_format_resol', array('2011-04-11', '2014-08-14'))
                                        ->limit(50)->get();*/

        $resoluciones = ResolucionSimit::where('id', 10184)->get();
        foreach ($resoluciones as $resolucion) {
          $comparendo = Comparendo::where('numero', '=', $resolucion->COL7)->first();
          if(isset($comparendo->id)){
            //if($comparendo->tieneSaldo($comparendo->id)){
              $fechaSancionCarbon = Carbon::createFromFormat('d/m/Y', $resolucion->COL4);
              $fechaGeneracionSancion = $fechaSancionCarbon->day . ' de ' . $this->meses[$fechaSancionCarbon->month - 1] . ' de ' . $fechaSancionCarbon->year;

              $archivo = $resolucion->COL2 . '.pdf';
              $numeroResolucion = $resolucion->COL2;

              $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
              \File::makeDirectory($folder, 0777, true, true);

              $this->comparendopdf = view('comparendos.especial.ofelia.sancion_head_pdf',[
                                      'organismoDireccion' => $this->organismoDireccion,
                                      'rutaImagenTop' => $this->rutaImagenTop
                                    ]);

              $descripcionSalario = '';
              $descripcionInfraccion = '';
              $codigoLetraInfraccion = substr($comparendo->infracciones, 0, 1);
              $codigoCompletoInfraccion = $comparendo->infracciones;
              $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();

              $puedeSeguir = true;
              if(!isset($if->salarios_dias)){
                foreach ($infraccion as $inf) {
                  $this->line("Codigo Infraccion: " . $comparendo->infracciones);
                  try {
                    if($inf->codigo_old == $comparendo->infracciones){
                      $codigoLetraInfraccion = substr($inf->codigo, 0, 1);
                      $codigoCompletoInfraccion = $inf->codigo;
                      $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();
                      $infraccion_salario = $if->salarios_dias;
                      $descripcionSalario = $if->descripcion;
                      $descripcionInfraccion = $inf->infraccion;
                      break;
                    }
                  } catch (\Exception $e) {
                    $this->line("Falla codigo: " . $comparendo->infracciones);
                    $puedeSeguir = false;
                  }
                }
              } else{
                $infraccion_salario = $if->salarios_dias;
                $descripcionSalario = $if->descripcion;
                $infraccion = Infraccion::where('codigo', '=', $codigoCompletoInfraccion)->first();
                $descripcionInfraccion = $infraccion->infraccion;
              }

              if($puedeSeguir){
                array_push($arrayTratar, (object) array(
                  'resolucion' => $numeroResolucion,
                  'cedula' => $comparendo->infractor_documento,
                  'ruta' => $folder . '/' . $archivo
                ));

                $barcode->setStorPath(__DIR__."/cache/");
                $infraccion_fecha = new Carbon($comparendo->infraccion_fecha);
                $infraccion_fecha = $infraccion_fecha->day . ' de ' . $this->meses[$infraccion_fecha->month - 1] . ' de ' . $infraccion_fecha->year;
                $sancionpdf =  view('comparendos.especial.ofelia.sancion_pdf', [
                                        'numeroResolucion' => $numeroResolucion,
                                        'fechaResolucion' => $fechaGeneracionSancion,
                                        'nombreInfractor' => strtoupper($comparendo->infractor_nombre . ' ' . $comparendo->infractor_apellido),
                                        'ccInfractor' => $comparendo->infractor_documento,
                                        'fechaComparendo' => Carbon::now()->day . '/' . Carbon::now()->month . '/' . Carbon::now()->year,
                                        'codigoCompletoInfraccion' => $codigoCompletoInfraccion,
                                        'valorLetras' => $convertidorNumerosALetras->to_word(round($comparendo->valor)),
                                        'comparendo' => $comparendo,
                                        'infraccion_fecha' => $infraccion_fecha,
                                        'fecha_actual' => Carbon::now()->day . ' de ' . $this->meses[Carbon::now()->month - 1] . ' de ' . Carbon::now()->year,
                                        'codebar' => $barcode->getBarcodeHTML("4", "EAN13")
                                      ]);

                $this->comparendopdf .= $sancionpdf . '</body></html>';

                $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('letter', 'portrait');
                $pdf->save($folder . '/' . $archivo);

                $resolucion->es_pdf_impreso = 1;
                $resolucion->save();
                $this->line("RS impresa: " . $archivo);
              }else{
                $resolucion->es_pdf_impreso = -3;
                $resolucion->save();
                $this->line("RS Sin pdf por falla codigo");
              }
            /*}else{
              $resolucion->es_pdf_impreso = -4;
              $resolucion->save();
              $this->line("No tiene Saldo.");
            }*/

          } else {
            $resolucion->es_pdf_impreso = -2;
            $resolucion->save();
            $this->line("RS Sin comparendo");
          }
        }
        break;
      } while (count($resoluciones) > 0);

      $arrayCollection = new Collection($arrayTratar);
      $arrayCollection = $arrayCollection->sortBy('cedula');

      foreach ($arrayCollection as $resol) {
        $nuevoArchivo = \Config::get('myconfig.ruta_ofelia') . 'sancion/' . $resol->cedula . ' - ' . $resol->resolucion . '.pdf';
        \File::copy($resol->ruta, $nuevoArchivo);
      }
    }
}
