<?php

namespace App\Console\Commands;

use App\Cilindraje;
use App\VehiculoMarca;
use App\VehiculoModelo;
use DB;
use Illuminate\Console\Command;

class ExtraerCilindrajes extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'bases:extraerCilindrajes {id_tipo}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Extrae los cilindrajes de la tabla tmp_bases';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $id_tipo = $this->argument('id_tipo');
        echo "PROCESANDO TIPO {$id_tipo}\n\r";

        $marcas = VehiculoMarca::where('id_tipo', $id_tipo)->get();

        foreach ($marcas as $marca) {

            echo "\n\r";
            echo "\n\r";
            echo "=========================================================\n\r";
            echo "CONSULTADO {$marca->nombre}\n\r";
            echo "=========================================================\n\r";

            $lineas = VehiculoModelo::where('id_marca', $marca->id)->get();

            $c = 1;
            foreach ($lineas as $linea) {
                Cilindraje::where('id_modelo', $linea->id)->delete();

                $encontrados = DB::table('tmp_bases')->where('id_linea', $linea->id)->get();

                foreach ($encontrados as $encontrado) {
                    echo "INSERTANDO {$linea->nombre} - {$encontrado->cilindraje}...";

                    try {
                        Cilindraje::create(['id_modelo' => $linea->id, 'cilindraje' => $encontrado->cilindraje]);
                        $this->info("OK!");
                    } catch (\Illuminate\Database\QueryException $e) {
                        $this->error("REGISTRO IGNORADO");
                    }
                }
            }
        }

        DB::update("UPDATE vehiculos a
                JOIN tmp_bases b
                  ON a.id_modelo = b.id_linea
                    SET a.cilindraje = b.cilindraje
                AND a.id_tipo = {$id_tipo}");
    }
}
