<?php

namespace App\Console\Commands;

use App\VehiculoMarca;
use App\VehiculoModelo;
use DB;
use Illuminate\Console\Command;
use Illuminate\Database\QueryException;

class ExtraerLineas extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'bases:extraerLineas {id_tipo}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Extrae las líneas de la tabla tmp_bases';

    /**
     * Create a new command instance.
     *
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $id_tipo = $this->argument('id_tipo');
        echo "PROCESANDO TIPO {$id_tipo}\n\r";


        $marcas = VehiculoMarca::where('id_tipo', $id_tipo)->get();

        $c = 1;
        foreach ($marcas as $marca) {
            VehiculoModelo::where('id_marca', $marca->id)->delete();

            echo "\n\r";
            echo "\n\r";
            echo "=========================================================\n\r";
            echo "CONSULTADO {$marca->nombre}\n\r";
            echo "=========================================================\n\r";

            $lineas = DB::table('tmp_bases')
                ->where('marca', $marca->nombre)
                ->where('id_tipo', $id_tipo)
                ->get();

            foreach ($lineas as $fila) {
                if (!empty($fila->linea)) {
                    echo "{$c}. INSERTANDO {$marca->nombre} ({$marca->id}) - Cilindraje: {$fila->cilindraje} - Tipo {$id_tipo} - {$fila->linea}... ";

                    try {
                        VehiculoModelo::create(['id_marca' => $marca->id, 'id_tipo' => $id_tipo, 'nombre' => $fila->linea]);
                        $this->info("OK");
                    } catch (QueryException $e) {
                        $this->error("REGISTRO IGNORADO");
                    }

                    $c++;
                }
            }
        }

        DB::table('tmp_bases')
            ->join('vehiculos_modelos', function($join) {
                $join->on('tmp_bases.linea', '=', 'vehiculos_modelos.nombre');
                $join->on('tmp_bases.id_marca', '=', 'vehiculos_modelos.id_marca');
            })
            ->where('tmp_bases.id_tipo', '=', $id_tipo)
            ->where('vehiculos_modelos.id_tipo', '=', $id_tipo)
            ->update(['tmp_bases.id_linea' => DB::raw('vehiculos_modelos.id')]);
    }
}
