<?php

namespace App\Console\Commands;

use DB;
use Illuminate\Console\Command;

class ExtraerMarcas extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'bases:extraerMarcas {id_tipo}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Extrae las marcas de la tabla tmp_bases';

    /**
     * Create a new command instance.
     *
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $id_tipo = $this->argument('id_tipo');
        $this->line("PROCESANDO TIPO {$id_tipo}");


        $this->line('');
        $this->line('');

        echo "INSERTANDO MARCAS... ";
        DB::insert("INSERT IGNORE INTO vehiculos_marcas (nombre, id_tipo)
              SELECT DISTINCT marca, '{$id_tipo}'
              FROM tmp_bases
            WHERE id_tipo = {$id_tipo}
            ORDER BY marca");
        $this->info('OK!');

        echo "ACTUALIZANDO IDS... ";
        DB::update("UPDATE tmp_bases a
            JOIN vehiculos_marcas b
            ON a.marca = b.nombre
            SET a.id_marca = b.id
            WHERE a.id_tipo = {$id_tipo}
            AND b.id_tipo = {$id_tipo}");
        $this->info('OK!');
    }
}
