<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class NotificacionValidaciones extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:start 0 c new no
   */
  protected $signature = 'notificacion:validacion';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Valida que para notificar el comparendo cumpla los requisitos';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
      $resoluciones = ResolucionSimit::where('es_pdf_notificado', '=', '0')
                                      ->where('COL5', '=', '1')
                                      ->where('estado_notificacion', '=', '0')
                                      ->get();
      $count=0;
      foreach ($resoluciones as $resolucion) {
        $comparendo = Comparendo::where('numero', '=', $resolucion->COL7)->first();
        if(isset($comparendo->id)){
          $notificacion = ComparendoExpediente::where('id_comparendo', '=', $comparendo->id)
                                        ->where('id_tipo_evento', '=', '24')->first();
          if(isset($notificacion->id)){
            $resolucion->es_pdf_notificado = 1;
            $resolucion->estado_notificacion = 2;
            $resolucion->save();
            $count++;
            $this->line("Sancion: " . $resolucion->COL2. ", count: " . $count);
          }
        }

      }
    /*
    do {
      $resoluciones = ResolucionSimit::where('es_pdf_notificado', '=', '0')
                                      ->where('COL5', '=', '1')
                                      ->where('es_direccion_valida', '=', '1')
                                      ->limit(100)->get();
      foreach ($resoluciones as $resolucion) {
        $mandamiento = ResolucionSimit::where('COL7', '=', $resolucion->COL7)
                                      ->where('COL3', '=', $resolucion->COL2)
                                      ->where('COL5', '=', '16')
                                      ->orderByDesc('id')->first();
        $acuerdo = ResolucionSimit::where('COL7', '=', $resolucion->COL7)
                                      ->where('COL5', '=', '6')
                                      ->orderByDesc('id')->first();
        $countProgResol++;
      }

    } while (count($resoluciones) > 0);*/
  }
}
