<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Comparendo;
use App\ResolucionSimit;
use App\ComparendoSimit;
use App\ResolucionSimitError;
use App\ResolucionSimitErrorDetalle;
use App\RecaudoSimit;
use App\Transaccion;
use Carbon\Carbon;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\DB;

class RecaudosSimitComparendos extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   */

  protected $signature = 'comparendos:validarrecaudo';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Este comando revisa si tiene pagos minimos y marca el comparendo.';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    DB::table('comparendos')->where('revisado_auxiliar', '=', 1)->where('es_recaudo_minimo', '=', 0)->update(array('revisado_auxiliar' => 0));
    //revisa que comparendos ya tienen pago para no sancionarlos o generarle mandamiento
    do {
      $comparendos = Comparendo::where('es_recaudo_minimo', '=', '0')
                                ->where('revisado_auxiliar', '=', '0')
                                ->where('infraccion_fecha', '>=', DB::raw("'2012-01-01'"))
                                ->limit(200)->get();

      foreach ($comparendos as $comparendo) {
          $sumaRecaudo = 0;
          $resoluciones = Comparendo::getResolucionesByComparendo($comparendo->numero)->orderBy('COL4F', 'desc')->get();

          if(count($resoluciones) > 0){
            foreach ($resoluciones as $resolucion) {
              $recaudos = RecaudoSimit::where('C10', '=', $resolucion->COL2)
                                      ->orWhere('C10', '=', $resolucion->COL2)
                                      ->orWhere('C15', '=', $resolucion->COL2)
                                      ->orWhere('C16', '=', $resolucion->COL2)
                                      ->orWhere('C10', '=', $comparendo->numero)
                                      ->orWhere('C15', '=', $comparendo->numero)
                                      ->orWhere('C16', '=', $comparendo->numero)
                                      ->get();
              foreach ($recaudos as $recaudo) {
                $sumaRecaudo = $recaudo->C9 + $sumaRecaudo;
              }
            }
            //validar si de las resoluciones mas recientes se encuentra en incumplir AP
            foreach ($resoluciones as $resolucion) {
              if($resolucion->COL5 == '9'){
                $sumaRecaudo = 0;break;
              }
            }
          }else{
            $recaudos = RecaudoSimit::where('C10', '=',  $comparendo->numero)
                                    ->orWhere('C15', '=', $comparendo->numero)
                                    ->orWhere('C16', '=', $comparendo->numero)->get();
            foreach ($recaudos as $recaudo) {
              $sumaRecaudo = $recaudo->C9 + $sumaRecaudo;
            }

          }
          $comparendoActualizar = Comparendo::find($comparendo->id);
          if($sumaRecaudo > 0){
            $this->line("sumaRecaudo: " . $sumaRecaudo);
            $comparendoActualizar->es_recaudo_minimo = 1;
            $this->line("COMP: " . $comparendo->numero);
          }
          $comparendoActualizar->revisado_auxiliar = 1;
          $comparendoActualizar->save();
      }
    } while (count($comparendos) > 0);
  }
}
