<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Artisan;
use App\Organismo;
use App\ParamHonorario;
use App\ParamImpuesto;
use App\ParamInteres;
use App\ParamSistematizacion;

class ResolucionMandamiento extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'resolucion:mandamiento {id_comparendo} {fecha}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Genera un mandamiento para acuerdo validando la fecha';

    /**
    * variables de contenido de la tarea
    */

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
      $organismo = Organismo::first();
      $phono=ParamHonorario::orderby('id', 'desc')->first();
      $psiste=ParamSistematizacion::orderby('id', 'desc')->first();
      $festivos = Festivos::all();
      $idComparendo = $this->argument('id_comparendo');
      //comentariar
      $fechaActual = new Carbon($this->argument('fecha'));
      $ultimaNumeracion= 0;
      $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '5')->first();

      if($numeracion != null){
        $ultimaNumeracion = $numeracion->final;
      }
      $inicioNumeracion = $ultimaNumeracion + 1;

      $comparendo = Comparendo::find($idComparendo);

      if($comparendo != null) {
        $sancion = ResolucionSimit::where('COL5', '=', '1')->where('COL7', '=', $comparendo->numero)->first();
        if(isset($sancion->COL5)){
          //comparar las fechas
          //descoemtariar
          //$fechaActual = Carbon::now();
          $fechaSancion = Carbon::createFromFormat('d/m/Y', $sancion->COL4);
          $fechaMandamiento = $fechaSancion->addDays(33);//31 dias despues de la sancion es mandamiento
          $fechaMandamiento = Comparendo::calcularFechaHabilLaboral($festivos, $fechaMandamiento);
          $fechaMandamiento = new Carbon($fechaMandamiento);//fecha de mandamiento habil
          if($fechaMandamiento->lt($fechaActual)){
            $ultimaNumeracion++;
            $numeroResolucion = 'RMP-' . $ultimaNumeracion . '-' . $fechaActual->year;
            //creando el registro en resoluciones simit
            $mandamiento = new ResolucionSimit();
            $mandamiento->COL2 = $numeroResolucion;
            $mandamiento->COL3 = $sancion->COL2;
            $mandamiento->COL4 = $fechaActual->format('d/m/Y');
            $mandamiento->COL5 = '16';
            $mandamiento->COL7 = $sancion->COL7;
            $mandamiento->COL8 = $sancion->COL8;
            $mandamiento->COL9 = $sancion->COL9;
            $mandamiento->COL10 = $sancion->COL10;
            $mandamiento->COL11 = $sancion->COL11;
            $mandamiento->COL12 = $sancion->COL12;
            $mandamiento->COL13 = $sancion->COL13;
            $mandamiento->COL15 = $sancion->COL15;
            $mandamiento->COL16 = $sancion->COL16;

          if($organismo->codigo=="68655000" || $organismo->codigo=="13673000")
          {
           // $hono2=$hono2+22076;
             $mandamiento->COL17 = round(($sancion->COL16 * $phono->valor) / 100)+$psiste->valor;
          }else
          {
             $mandamiento->COL17 = round(($sancion->COL16 * $phono->valor) / 100);
          }
           
            $mandamiento->COL18 = $sancion->COL18;
            $mandamiento->COL19 = $sancion->COL19;
            $mandamiento->COL20 = $sancion->COL20;
            $mandamiento->COL21 = $sancion->COL21;
            $mandamiento->COL22 = $sancion->COL22;
            $mandamiento->COL23 = $sancion->COL23;
            $mandamiento->COL24 = $sancion->COL24;
            $mandamiento->COL25 = $sancion->COL25;
            $mandamiento->fecha_format_resol = $fechaMandamiento->format('Y-m-d');
            $mandamiento->confirmado_simit = 0;
            $mandamiento->es_pdf_impreso = 0;
            $mandamiento->save();
            $this->line($numeroResolucion);

      //ojo comentariar
          Artisan::call('mandamiento:start', [
              'id_resolucion' => $mandamiento->id,
              'medio' => 'c',
              'banner' => 'new',
              'carta_persuasivo' => ''
          ]);
          $this->info("Generando RPM:".$mandamiento->id."-".Artisan::output());

          
            
          }
        }
      }

      if($ultimaNumeracion >= $inicioNumeracion){
        $this->line("Actualizando Numeracion...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'RMP';
        $numeracion->inicio = $inicioNumeracion;
        $numeracion->final = $ultimaNumeracion;
        $numeracion->id_tipo_evento = 5;//mandamiento
        $numeracion->id_organismo = 1;
        $numeracion->id_paquete = 0;
        $numeracion->save();
        $this->line("Fin Numeracion");
      } else {
        $this->line("No se imprimo mandamientos.");
      }
    }
}
