<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use App\Tipo;
use App\Infraccion;
use App\InfraccionF;
use App\InfraccionSalario;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Artisan;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class ResolucionSancion extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   */
  protected $signature = 'resolucion:sancion {id_comparendo} {fecha}';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Genera una sancion al comparendo elegido';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $idComparendo = $this->argument('id_comparendo');

   //comentariar
    $fechaActual = new Carbon($this->argument('fecha'));

    $organismo = \App\Organismo::first();
    $ultimaNumeracion = 0;
    $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '4')->first();

    if($numeracion != null){
      $ultimaNumeracion = $numeracion->final;
    }
    $inicioNumeracion = $ultimaNumeracion + 1;

    $comparendo = Comparendo::find($idComparendo);

    $this->line($idComparendo);
    $this->line($fechaActual);

    if ($comparendo != null) {
      //comparar las fechas
      //$fechaActual = Carbon::now();
      $ultimaNumeracion++;
      $numeroResolucion = 'RS-' . $ultimaNumeracion . '-' . $fechaActual->year;
      //creando el registro en resoluciones simit
      $fechaComparendo = new Carbon($comparendo->infraccion_fecha);
      $resolucion = new ResolucionSimit();
      $resolucion->COL2 = $numeroResolucion;
      $resolucion->COL4 = $fechaActual->format('d/m/Y');
      $resolucion->COL5 = '1';
      $resolucion->COL7 = $comparendo->numero;
      $resolucion->COL8 = $fechaComparendo->format('d/m/Y');
      $resolucion->COL9 = $comparendo->infractor_documento;
      $resolucion->COL10 = '1';

            $infractor_tipo_doc = Tipo::where('id', $comparendo->infractor_tipo_documento)->get();
            foreach ($infractor_tipo_doc as $tp) {
                $resolucion->COL10 = $tp->codigo;              
            }

      $resolucion->COL11 = mb_strtoupper($comparendo->infractor_nombre);
      $resolucion->COL12 = mb_strtoupper($comparendo->infractor_apellido);
      $resolucion->COL13 = mb_strtoupper($comparendo->infraccion_direccion);
      $resolucion->COL15 = $organismo->codigo;
      $resolucion->COL16 = $comparendo->valor-$comparendo->pagos;
      $resolucion->COL17 = 0;

      if($comparendo->es_fotomulta == 0){
        $resolucion->COL18 = 'N';
      } elseif($comparendo->es_fotomulta == 1){
        $resolucion->COL18 = 'S';
      }
      $resolucion->COL19 = $organismo->codigo;

      if($comparendo->es_polca == 0){
        $resolucion->COL20 = 'N';
      } else{
        $resolucion->COL20 = 'S';
      }

      $resolucion->COL21 = $comparendo->infracciones;
      $resolucion->COL22 = $comparendo->valor;
      $resolucion->COL23 = $comparendo->valor;

      if($comparendo->infracciones == 'F'){
        $resolucion->COL24 = $comparendo->grado_alcohol;
        $resolucion->COL25 = 'N';
      }else{
        $resolucion->COL24 = '';
        $resolucion->COL25 = '';
      }
      $resolucion->confirmado_simit = 0;
      $resolucion->es_pdf_impreso = 0;
      $resolucion->save();

      $this->line("Num RES... " . $numeroResolucion);
      $comparendoActualizar = Comparendo::find($comparendo->id);
      $comparendoActualizar->id_tipo_evento = 4;//sancion
      $comparendoActualizar->pagos= 0;
      $comparendoActualizar->save();


      //ojo comentariar
          Artisan::call('sancionpdf:start', [
              'id_resolucion' => $resolucion->id,
              'medio' => 'c',
              'banner' => 'new'
          ]);
          $this->info(Artisan::output());


    }

    if($ultimaNumeracion >= $inicioNumeracion){
      $this->line("Actualizando Numeracion...");
      //actualizar la numeracion en un nuevo registro
      $numeracion = new Numeracion();
      $numeracion->prefijo = 'RS';
      $numeracion->inicio = $inicioNumeracion;
      $numeracion->final = $ultimaNumeracion;
      $numeracion->id_tipo_evento = 4;//sancion
      $numeracion->id_organismo = $organismo->id;
      $numeracion->id_paquete = 0;
      $numeracion->save();
      $this->line("Fin Numeracion");
    } else {
      $this->line("No se imprimo sancion.");
    }
  }
}
