<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ResolucionSimit;
use App\Infraccion;
use App\InfraccionSalario;
use App\ComparendoNumeracionImpresion as Numeracion;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class ResolucionSancionPdf extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'sancionpdf:start {id_resolucion} {medio} {banner}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
    * variables de contenido de la tarea
    */
    protected $comparendopdf = '';
    protected $meses = [];
    protected $organismoNombreSecreteria = '';
    protected $organismoNombreSecreterio = '';
    protected $organismoDireccion = '';
    protected $rutaImagenTop = '';
    protected $rutaFirma = '';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
      $idResolucion = $this->argument('id_resolucion');
      $medio = $this->argument('medio');
      $banner = $this->argument('banner');
      $this->rutaImagenTop = '';

      $organismo = \App\Organismo::first();

      if($medio == "c"){

        if($banner == "old"){
          $this->rutaImagenTop = base_path() . '/public/images/hoja membrete.jpg';
          $this->rutaFirma = base_path() . '/public/images/firma2anterior.png';
          $this->organismoNombreSecreterio = "DANIEL ARENAS ROJAS";
        } else {
          $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
          $this->rutaFirma = base_path() . '/public/images/firma2.png';
          $this->organismoNombreSecreterio = $organismo->secretario_nombre;
        }
        //$this->rutaFirma = base_path() . '/public/images/firma2.png';
      } else if($medio == "w"){
        if($banner == "old"){
          $this->rutaImagenTop = base_path() . '/public/images/hoja membrete.jpg';
        } else {
          $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
        }

        $this->rutaFirma = base_path() . '/public/images/firma2.png';
      }

      $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
      $rutaPaquete = \Config::get('myconfig.ruta_paquetes_mensajeria');


      $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
      $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

      $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                     'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');
      $convertidorNumerosALetras = new \NumberToLetterConverter();
      $resoluciones = null;
      $countAudiencia = 0;
      $horaAudiencia = new Carbon(Carbon::createFromTime(8, 0, 0));

      $infraccion = Infraccion::all();
      $infraccionSalario = InfraccionSalario::all();
      $fecha = Carbon::now();
      $ano = $fecha ->format('Y');
      do {
        if($idResolucion > 0){
          $resoluciones = ResolucionSimit::where('COL5', '=', '1')->where('id', '=', $idResolucion)->get();
        }else{
          if($organismo->codigo=="20228000")
          {
            //->where('id', '>=', 128965)
          $resoluciones = ResolucionSimit::where('es_pdf_impreso', '=', '0')
          ->where('COL2', 'like', "%". $ano."%")->where('COL5', '=', '1')->limit(50)->get();
          }else
          {
          $resoluciones = ResolucionSimit::where('es_pdf_impreso', '=', '0')
          ->where('COL2', 'like', "%". $ano."%")->where('COL5', '=', '1')->limit(50)->get();            
          }

        }

        //crear el paquete para que las que se impriman queden con este paquete
        $paquete = null;
        if(count($resoluciones) > 0){
          $paquete = new \App\ComparendoPaquete();
          $paquete->nombre = 'RS-'.$fecha->format('d/m/Y');
          $paquete->fecha = $fecha;
          $paquete->id_user = 4;
          $paquete->id_tipo_evento = 4;
          $paquete->es_impreso = 0;
          $paquete->save();
        }

        foreach ($resoluciones as $resolucion) {
          $comparendo = Comparendo::where('numero', '=', $resolucion->COL7)->first();
          if(isset($comparendo->id)){
            $firmaNueva = true;
            $fechaIngresoXilena = Carbon::createFromFormat('d/m/Y', '01/07/2015');


            $fechaSancionCarbon = Carbon::createFromFormat('d/m/Y', $resolucion->COL4);
            $fechaSancionCarbon2 = "".$fechaSancionCarbon;
//$fechaSancionCarbon2 = substr($fechaSancionCarbon2,6,4)."-".substr($fechaSancionCarbon2,3,2)."-".substr($fechaSancionCarbon2,0,2);


            $fechaGeneracionSancion = $fechaSancionCarbon->day . ' de ' . $this->meses[$fechaSancionCarbon->month - 1] . ' de ' . $fechaSancionCarbon->year;

            if($fechaSancionCarbon->lt($fechaIngresoXilena)){
              $firmaNueva = false;
            }

            $archivo = $resolucion->COL2 . '.pdf';
            $numeroResolucion = $resolucion->COL2;

            $folder = $rutaExpediente . $comparendo->numero_expediente;
            \File::makeDirectory($folder, 0775, true, true);

            /*INICIANDO EL CALCULO PARA EL TIEMPO DE AUDIENCIA*/
            if ($countAudiencia == 32) {
              $countAudiencia = 0;
              $horaAudiencia = new Carbon(Carbon::createFromTime(8, 0, 0));
            }
            $horaInicio = $horaAudiencia->format('H:i A');
            $horaAudiencia->addMinutes(15);
            $horaFinal = $horaAudiencia->format('H:i A');
            $countAudiencia++;
            /*FIN DEL CALCULO*/

            $this->comparendopdf = view('comparendos.comparendo_sancionado_head_pdf',[
                                    'organismoDireccion' => $this->organismoDireccion,
                                    'rutaImagenTop' => $this->rutaImagenTop
                                  ]);

            $descripcionSalario = '';
            $descripcionInfraccion = '';
            $codigoLetraInfraccion = substr($comparendo->infracciones, 0, 1);
            $codigoCompletoInfraccion = $comparendo->infracciones;
            $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();

            $puedeSeguir = true;
            if(!isset($if->salarios_dias)){
              foreach ($infraccion as $inf) {
                $this->line("Codigo Infraccion: " . $comparendo->infracciones);
                try {
                  if($inf->codigo_old == $comparendo->infracciones){
                    $codigoLetraInfraccion = substr($inf->codigo, 0, 1);
                    $codigoCompletoInfraccion = $inf->codigo;
                    $if = InfraccionSalario::where('codigo', '=', $codigoLetraInfraccion)->first();
                    $infraccion_salario = $if->salarios_dias;
                    $descripcionSalario = $if->descripcion;
                    $descripcionInfraccion = $inf->infraccion;
                    break;
                  }
                } catch (\Exception $e) {
                  $this->line("Falla codigo: " . $comparendo->infracciones);
                  $puedeSeguir = false;
                }
              }
            } else{
              $infraccion_salario = $if->salarios_dias;
              $descripcionSalario = $if->descripcion;
              $infraccion = Infraccion::where('codigo', '=', $codigoCompletoInfraccion)->first();
              $descripcionInfraccion = $infraccion->infraccion;
            }

            if($puedeSeguir){
              $infraccion_fecha = new Carbon($comparendo->infraccion_fecha);
              $infraccion_fecha = $infraccion_fecha->day . ' de ' . $this->meses[$infraccion_fecha->month - 1] . ' de ' . $infraccion_fecha->year;

          if($organismo->codigo=="20228000" && $fechaSancionCarbon2<"2022-01-24")
          {
               $this->rutaFirma = base_path() . '/public/images/firma_camilo.png';
               $this->organismoNombreSecreterio="CAMILO ANDRES MORALES HAECKERMANN";
          }

              $sancionpdf =  view('comparendos.comparendo_sancionado_pdf', [
                                      'comparendo' => $comparendo,
                                      'infraccion_fecha' => $infraccion_fecha,
                                      'fecha_actual' => Carbon::now()->day . ' de ' . $this->meses[Carbon::now()->month - 1] . ' de ' . Carbon::now()->year,
                                      'valorLetras' => $convertidorNumerosALetras->to_word(round($comparendo->valor)),
                                      'horaInicio' => $horaInicio,
                                      'horaFinal' => $horaFinal,
                                      'rutaFirma' => $this->rutaFirma,
                                      'organismoNombreSecreteria' => $this->organismoNombreSecreteria,
                                      'secretarioNombre' => $this->organismoNombreSecreterio,
                                      'descripcionInfraccion' => $descripcionInfraccion,
                                      'descripcionSalario' => $descripcionSalario,
                                      'codigoLetraInfraccion' => $codigoLetraInfraccion,
                                      'codigoCompletoInfraccion' => $codigoCompletoInfraccion,
                                      'numeroResolucion' => $numeroResolucion,
                                      'fechaResolucion' => $fechaGeneracionSancion
                                    ]);

              $this->comparendopdf .= $sancionpdf . '</body></html>';

              $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('letter', 'portrait');
              $pdf->save($folder . '/' . $archivo);
              $pdf->save('/var/www/html/comparendos2/temp/' . $archivo);
              //creando el registro en expediente
              $expediente = new \App\ComparendoExpediente();
              $expediente->id_comparendo = $comparendo->id;
              $expediente->fecha_generacion = Carbon::now();
              $expediente->nombre_documento = $archivo;
              $expediente->id_tipo_evento = 4;//sancion
              $expediente->id_paquete = $paquete->id;
              $expediente->id_user = 4;
              $expediente->save();

              $comparendoActualizar = Comparendo::find($comparendo->id);
              $comparendoActualizar->id_tipo_evento = 4;
              $comparendoActualizar->save();
              $resolucion->es_pdf_impreso = 1;
              $resolucion->fecha_format_resol = $fechaSancionCarbon2;
              $resolucion->save();
              $this->line("RS impresa: " . $archivo . $fechaSancionCarbon2 . $this->rutaFirma. $fechaSancionCarbon);
            }else{
              $resolucion->es_pdf_impreso = -3;
              $resolucion->fecha_format_resol = $fechaSancionCarbon2;
              $resolucion->save();
              $this->line("RS Sin pdf por falla codigo");
            }
          }else{
            $resolucion->es_pdf_impreso = -2;
            $resolucion->fecha_format_resol = $fechaSancionCarbon2;
            $resolucion->save();
            $this->line("RS Sin comparendo");
          }
        }

        $sale = 0;
        if($idResolucion > 0){
          $sale = 0;
        }else{
          $sale = count($resoluciones);
        }
      } while ($sale > 0);
    }
}
