<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Organismo;
use App\Comparendo;
use App\ParamSistematizacion;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Artisan;

class ResolucionesSimitMandamiento extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'resolucionessimit:mandamiento';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Genera mandamientos en la tabla resoluciones simit a las sanciones de mas de 30 dias';

    /**
    * variables de contenido de la tarea
    */

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
      $festivos = Festivos::all();
      $organismo = Organismo::first();
      $sistema = ParamSistematizacion::orderby('id', 'desc')->first();
      do {
        $ultimaNumeracion= 0;
        $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '5')->first();

        if($numeracion != null){
          $ultimaNumeracion = $numeracion->final;
        }
        $inicioNumeracion = $ultimaNumeracion + 1;

        $comparendos = Comparendo::where('infracciones', 'not like', DB::raw("'%I%'"))
                                ->where('infracciones', 'not like', DB::raw("'%J%'"))
                                ->where('infracciones', 'not like', DB::raw("'%G%'"))
                                ->where('infraccion_fecha', '>=', DB::raw("'2015-06-30'"))
                                ->whereNull('fecha_pago')
                                ->orderBy('infraccion_fecha', 'desc')
                                ->get();

        foreach ($comparendos as $comparendo) {
          $mandamiento = ResolucionSimit::where('COL5', '16')->where('COL7', $comparendo->numero)->first();
          $acuerdo = ResolucionSimit::where('COL5', '6')->where('COL7', $comparendo->numero)->first();
          if($comparendo->tieneSaldo($comparendo->id) && !isset($mandamiento->id) && !isset($acuerdo->id) ){
            $sancion = ResolucionSimit::where('COL5', '=', '1')->where('COL7', '=', $comparendo->numero)->first();
            if(isset($sancion->COL5)){
              //comparar las fechas
              $fechaActual = Carbon::now();
              $fechaSancion = Carbon::createFromFormat('d/m/Y', $sancion->COL4);
              $fechaMandamiento = $fechaSancion->addDays(33);//31 dias despues de la sancion es mandamiento
              $fechaMandamiento = Comparendo::calcularFechaHabilLaboral($festivos, $fechaMandamiento);
              $fechaMandamiento = new Carbon($fechaMandamiento);//fecha de mandamiento habil
              if($fechaMandamiento->lt($fechaActual)){
                $ultimaNumeracion++;
                $numeroResolucion = 'RMP-' . $ultimaNumeracion . '-' . $fechaMandamiento->year;
                //creando el registro en resoluciones simit
                $mandamiento = new ResolucionSimit();
                $mandamiento->COL2 = $numeroResolucion;
                $mandamiento->COL3 = $sancion->COL2;
                $mandamiento->COL4 = $fechaMandamiento->format('d/m/Y');
                $mandamiento->COL5 = '16';
                $mandamiento->COL7 = $sancion->COL7;
                $mandamiento->COL8 = $sancion->COL8;
                $mandamiento->COL9 = $sancion->COL9;
                $mandamiento->COL10 = $sancion->COL10;
                $mandamiento->COL11 = $sancion->COL11;
                $mandamiento->COL12 = $sancion->COL12;
                $mandamiento->COL13 = $sancion->COL13;
                $mandamiento->COL15 = $sancion->COL15;
                $mandamiento->COL16 = $sancion->COL16;

          $hono2=ceil(($sancion->COL16 * 15) / 100);      

          if($organismo->codigo=="68655000")
          {
            $hono2=$hono2+22076;
          }
          if($organismo->codigo=="13673000" or $organismo->codigo=="25320000")
          {
            $hono2=$hono2+$sistema->valor;
          }
                $mandamiento->COL17 = $hono2;
                $mandamiento->COL18 = $sancion->COL18;
                $mandamiento->COL19 = $sancion->COL19;
                $mandamiento->COL20 = $sancion->COL20;
                $mandamiento->COL21 = $sancion->COL21;
                $mandamiento->COL22 = $sancion->COL22;
                $mandamiento->COL23 = $sancion->COL23;
                $mandamiento->COL24 = $sancion->COL24;
                $mandamiento->COL25 = $sancion->COL25;
                $mandamiento->fecha_format_resol = $fechaMandamiento->format('Y-m-d');
                $mandamiento->confirmado_simit = 0;
                $mandamiento->es_pdf_impreso = 0;
                $mandamiento->save();
                $this->line($numeroResolucion);

                Artisan::call('mandamiento:start', [
                  'id_resolucion' => $mandamiento->id,
                  'medio' => 'c',
                  'banner' => 'new',
                  'carta_persuasivo' => 'no'
                ]);
              }
            }
          } else {
            $this->line("no tiene saldo...");
            $comparendo->tiene_saldo = 0;
            $comparendo->save();
          }
        }

        if($ultimaNumeracion >= $inicioNumeracion){
          $this->line("Actualizando Numeracion...");
          //actualizar la numeracion en un nuevo registro
          $numeracion = new Numeracion();
          $numeracion->prefijo = 'RMP';
          $numeracion->inicio = $inicioNumeracion;
          $numeracion->final = $ultimaNumeracion;
          $numeracion->id_tipo_evento = 5;//mandamiento
          $numeracion->id_organismo = 1;
          $numeracion->id_paquete = 0;
          $numeracion->save();
          $this->line("Fin Numeracion");
        } else {
          $this->line("No se imprimo mandamientos.");
          break;
        }
      } while (count($comparendos) > 0);
    }
}
