<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class ResolucionesSimitMandamientoPDF extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:start 0 c new no
   */
  protected $signature = 'mandamiento:start {id_resolucion} {medio} {banner} {carta_persuasivo}';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Command description';

  /**
  * variables de contenido de la tarea
  */
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoNombreSecreterio = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';
  protected $cuadro = '';
  protected $pie = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $idResolucion = $this->argument('id_resolucion');
    $medio = $this->argument('medio');
    $banner = $this->argument('banner');
    $cartaPersuasivo = $this->argument('carta_persuasivo');
    $this->rutaImagenTop = '';
    $organismo = \App\Organismo::first();



    if($medio == "c"){
      if($banner == "old"){
        $this->rutaImagenTop = base_path() . '/public/images/hoja membrete.jpg';
        $this->organismoNombreSecreterio = "DANIEL ARENAS ROJAS";
        $this->rutaFirma = base_path() . '/public/images/firma2anterior.png';
      } else {
        $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
        $this->organismoNombreSecreterio = $organismo->secretario_nombre;
        $this->rutaFirma = base_path() . '/public/images/firma2.png';
      }

      $this->cuadro = base_path() . '/public/images/cuadro.png';
      $this->pie = base_path() . '/public/images/piemembretesabana.jpg';
      
    } else if($medio == "w"){
      if($banner == "old"){
        $this->rutaImagenTop = base_path() . '/public/images/hoja membrete.jpg';
      } else {
        $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      }
      $this->rutaFirma = base_path() . '/public/images/firma2.png';
    }


          if($organismo->codigo=="20228000" )
          {
               $this->rutaFirma = base_path() . '/public/images/firma3.png';
          }

    if($cartaPersuasivo == "yes"){
      $cartaPersuasivo = true;
    } else {
      $cartaPersuasivo = false;
    }

    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
    $rutaPaquete = \Config::get('myconfig.ruta_paquetes_mensajeria');

    
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

    $this->pdfMasivo = view('comparendos.mandamiento.mandamiento_head_pdf',[
                            'organismoDireccion' => $this->organismoDireccion,
                            'rutaImagenTop' => $this->rutaImagenTop
                          ]);
    $this->pdfMasivo .= '<style>.page-break {page-break-after: always;}</style>';

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                   'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

    $convertidorNumerosALetras = new \NumberToLetterConverter();
    $resoluciones = null;
    $secretarioAntesXilena = 'OFELIA MURILLO CASALIG';
    $cargoAntesXilena = 'Director Tránsito y Transporte Municipal.';

      $fecha = Carbon::now();
      $ano = $fecha ->format('Y');

    do {
      if($cartaPersuasivo){
        //esta numeracion es para las cartas persuasivas adjuntas
        $ultimaNumeracion = 0;
        $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '10')->first();

        if($numeracion != null){
          $ultimaNumeracion = $numeracion->final;
        }
        $inicioNumeracion = $ultimaNumeracion + 1;
      }



      if($idResolucion > 0){
        $resoluciones = ResolucionSimit::where('COL5', '=', '16')->where('id', '=', $idResolucion)->get();
      }else{
        $resoluciones = ResolucionSimit::where('es_pdf_impreso', '=', '0')
        ->where('COL2', 'like', '%'.$ano)->where('COL5', '=', '16')->limit(50)->get();
      }

      //crear el paquete para que las que se impriman queden con este paquete
      $paquete = null;
      if(count($resoluciones) > 0){
        $paquete = new \App\ComparendoPaquete();
        $paquete->nombre = 'RMP-'.Carbon::now()->format('d/m/Y');
        $paquete->fecha = Carbon::now()->format('d/m/Y');
        $paquete->id_user = 4;
        $paquete->id_tipo_evento = 5;
        $paquete->es_impreso = 0;
        $paquete->save();
      }

      foreach ($resoluciones as $resolucion) {
        $comparendo = Comparendo::where('numero', '=', $resolucion->COL7)->first();
        if(isset($comparendo->id)){
          $sancion = ResolucionSimit::where('COL2', '=', $resolucion->COL3)->where('COL5', '=', '1')->first();

          $firmaNueva = true;
          $fechaIngresoXilena = Carbon::createFromFormat('d/m/Y', '23/06/2015');

          $fechaMandamientoCarbon = Carbon::createFromFormat('d/m/Y', $resolucion->COL4);
          $fechaMandamientoCarbon2 = "".$fechaMandamientoCarbon;
          $fechaGeneracionMandamiento = $fechaMandamientoCarbon->day . ' de ' . $this->meses[$fechaMandamientoCarbon->month - 1] . ' de ' . $fechaMandamientoCarbon->year;


          if($organismo->codigo=="20228000" && $fechaMandamientoCarbon2<"2022-01-24")
          {
               $this->rutaFirma = base_path() . '/public/images/firma_camilo.png';
               $this->organismoNombreSecreterio="CAMILO ANDRES MORALES HAECKERMANN";
          }

$this->line("RMP impresa: "  . $this->rutaFirma. $fechaMandamientoCarbon2);

          if($fechaMandamientoCarbon->lt($fechaIngresoXilena)){
            $firmaNueva = false;
          }

          $fechaSancion = Carbon::createFromFormat('d/m/Y', $sancion->COL4);
          $fechaGeneracionSancion = $fechaSancion->day . ' de ' . $this->meses[$fechaSancion->month - 1] . ' de ' . $fechaSancion->year;

          $archivo = $resolucion->COL2 . '.pdf';

          $this->comparendosImpresos[] = array('final_numero' => $comparendo->numero);
          $folder = $rutaExpediente  . $comparendo->numero_expediente;
          \File::makeDirectory($folder, 0775, true, true);
          $cartaPersuasivoContenido = '';
          if($cartaPersuasivo)
          {
            $ultimaNumeracion++;

            $hoyMas20Dias = Carbon::now()->addDays(20);
            $hoyMas20Dias = $hoyMas20Dias->day . ' de ' . $this->meses[$hoyMas20Dias->month - 1] . ' de ' . $hoyMas20Dias->year;



            if($comparendo->es_fotomulta == 1){
              //carta para fotomulta
              $cartaPersuasivoContenido = view('comparendos.persuasivo.persuadir_fotomulta_pdf', [
                                        'comparendo' => $comparendo,
                                        'ultimaNumeracion' => 'CP-' . $ultimaNumeracion . '-' . Carbon::now()->year,
                                        'hoyMas20Dias' => $hoyMas20Dias,
                                        'organismoNombreSecreteria' => $this->organismoNombreSecreteria,
                                        'organismoDireccion' => $this->organismoDireccion,
                                        'infraccion_fecha' => Carbon::createFromFormat('Y-m-d', $comparendo->infraccion_fecha)->format('d/m/Y'),
                                        'fecha_actual' => Carbon::now()->day . ' de ' . $this->meses[Carbon::now()->month - 1] . ' de ' . Carbon::now()->year,
                                        'rutaFirma' => $this->rutaFirma,
                                        'secretarioNombre' => $organismo->secretario_nombre
                                      ]);
            } else if($comparendo->es_fotomulta == 0){
              //carta para comparendo fisico
              $cartaPersuasivoContenido = view('comparendos.persuasivo.persuadir_multa_pdf', [
                                        'comparendo' => $comparendo,
                                        'descripcionInfraccion' => $comparendo->descripcion_infraccion,
                                        'ultimaNumeracion' => 'CP-' . $ultimaNumeracion . '-' . Carbon::now()->year,
                                        'hoyMas20Dias' => $hoyMas20Dias,
                                        'organismoNombreSecreteria' => $this->organismoNombreSecreteria,
                                        'organismoDireccion' => $this->organismoDireccion,
                                        'infraccion_fecha' => Carbon::createFromFormat('Y-m-d', $comparendo->infraccion_fecha)->format('d/m/Y'),
                                        'fecha_actual' => Carbon::now()->day . ' de ' . $this->meses[Carbon::now()->month - 1] . ' de ' . Carbon::now()->year,
                                        'rutaFirma' => $this->rutaFirma,
                                        'secretarioNombre' => $this->organismoNombreSecreterio
                                      ]);
            }
            $this->comparendopdf .= $cartaPersuasivoContenido;
            //saltamos la pagina para iniciar el mandamiento
            $this->comparendopdf .= '<div class="page-break"></div>';
          }
          else
          {
            if($fechaMandamientoCarbon->lt($fechaIngresoXilena)){
              //mandamiento viejo antes de el 1 de julio de 2015
              $this->comparendopdf = view('comparendos.mandamiento.mandamiento_antiguo_head_pdf',[
                                      'organismoDireccion' => $this->organismoDireccion,
                                      'rutaImagenTop' => $this->rutaImagenTop
                                    ]);
            } else {
              $this->comparendopdf = view('comparendos.mandamiento.mandamiento_head_pdf',[
                                      'organismoDireccion' => $this->organismoDireccion,
                                      'rutaImagenTop' => $this->rutaImagenTop
                                    ]);
            }

            $this->comparendopdf .= '<style>.page-break {page-break-after: always;}</style>';
          }

          $infraccion_fecha = new Carbon($comparendo->infraccion_fecha);
          $infraccion_fecha = $infraccion_fecha->format('d/m/Y');
          $articuloInfringido = 'Artículo 131, Literal ' . $comparendo->infracciones;

          if($fechaMandamientoCarbon->lt($fechaIngresoXilena)){
            //mandamiento viejo antes de el 1 de julio de 2015
            $mandamientopdf =  view('comparendos.mandamiento.mandamiento_antiguo_pdf', [
                                    'numeroResolucion' => $resolucion->COL2,
                                    'comparendo' => $comparendo,
                              'valorLetras' => $convertidorNumerosALetras->to_word(round($comparendo->valor)),
                                    'infraccion_fecha' => $infraccion_fecha,
                                    'infraccion_hora' => $comparendo->infraccion_hora,
                                    'fechaMandamiento' => $fechaGeneracionMandamiento,
                                    'secretarioAntesXilena' => $secretarioAntesXilena,
                                    'cargoAntesXilena' => $cargoAntesXilena,
                                    'resol_sancion' => $sancion->COL2,
                                    'resol_fecha' => $sancion->COL4
                                  ]);
          }else{
            //mandamiento nuevo desde el 1 de julio de 2015
            $mandamientopdf =  view('comparendos.mandamiento.mandamiento_pdf', [
                                    'comparendo' => $comparendo,
                                    'infraccion_fecha' => $infraccion_fecha,
                                    'fecha_actual' => $fechaGeneracionMandamiento,
                              'valorLetras' => $convertidorNumerosALetras->to_word(round($comparendo->valor)),
                                    'numeroResolucion' => $resolucion->COL2,
                                    'articuloInfringido' => $articuloInfringido,
                                    'rutaFirma' => $this->rutaFirma,
                                    'nit' => $organismo->nit_alcaldia,
                                    'sancion' => $sancion->COL2,
                                    'fecha_sancion' => $fechaGeneracionSancion,
                                    'organismoNombreSecreteria' => $this->organismoNombreSecreteria,
                                    'secretarioNombre' => $this->organismoNombreSecreterio,
                                    'firmaNueva' => $this->rutaFirma,
                                    'secretarioAntesXilena' => $secretarioAntesXilena,
                                    'cargoAntesXilena' => $cargoAntesXilena,
                                    'cuadro' => $this->cuadro,
                                    'pie' => $this->pie
                                  ]);
          }



          $this->comparendopdf .= $mandamientopdf . '</body></html>';

          $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');
          try {
            $this->line("mandamiento impreso: " . $folder . '/' . $archivo);
            $pdf->save($folder . '/' . $archivo);
            $pdf->save('/var/www/html/comparendos2/temp/' . $archivo);
          } catch (\Exception $e) {

          }

          //creando el registro en expediente
          $expediente = new \App\ComparendoExpediente();
          $expediente->id_comparendo = $comparendo->id;
          $expediente->fecha_generacion = $fechaMandamientoCarbon->format('Y-m-d');
          $expediente->nombre_documento = $archivo;
          $expediente->id_tipo_evento = 5;//mandamiento de pago
          $expediente->id_paquete = $paquete->id;
          $expediente->id_user = 4;
          $expediente->save();

          $comparendoActualizar = Comparendo::find($comparendo->id);
          $comparendoActualizar->id_tipo_evento = 5;//mandamiento de pago
          $comparendoActualizar->save();
          $this->line("mandamiento impreso: " . $archivo);

          $resolucion->es_pdf_impreso = 1;
          $resolucion->save();
        } else {
          $resolucion->es_pdf_impreso = -2;
          $resolucion->save();
          $this->line("RMP Sin comparendo");
        }
      }

      if($cartaPersuasivo){
        if($ultimaNumeracion >= $inicioNumeracion){
          $this->line("Actualizando Numeracion...");
          //actualizar la numeracion en un nuevo registro
          $numeracion = new Numeracion();
          $numeracion->prefijo = 'CP';
          $numeracion->inicio = $inicioNumeracion;
          $numeracion->final = $ultimaNumeracion;
          $numeracion->id_tipo_evento = 10;//CARTA PERSUASIVA
          $numeracion->id_organismo = $organismo->id;
          $numeracion->id_paquete = $paquete->id;
          $numeracion->save();
          $this->line("Fin Numeracion carta persuasiva.");
        } else {
          $this->line("No se imprimo carta persuasiva.");
        }
      }
      $sale = 0;
      if($idResolucion > 0){
        $sale = 0;
      }else{
        $sale = count($resoluciones);
      }
    } while ($sale > 0);
  }
}
