<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Ciudadano;
use App\CiudadanoUbicacion;
use App\RuntVehiculo;
use League\Csv\Reader;

class RuntCargarCiudadanos extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'runt:cargar_ciudadanos';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $this->line("leyendo");
        $archivo = \Storage::path("runt/runt_ciudadanos.txt");

        $content = Reader::createFromPath($archivo, 'r');
        foreach($content as $row) {
            $vehiculo = RuntVehiculo::where('placa', '=', $row[0])->first();
            if ($vehiculo === null) {// no existe
                $vehiculo = new RuntVehiculo();
                $vehiculo->placa = $row[0];
                $vehiculo->nombre = $row[1];
                $vehiculo->documento = $row[2];
                $vehiculo->direccion = $row[3];
                $vehiculo->ciudad_residencia = $row[4];
                $vehiculo->telefono = $row[5];
                $vehiculo->celular = $row[6];
                $vehiculo->correo = $row[7];
                $vehiculo->save();
            }
            // buscar por el documento el ciudadano
            $ciudadano = Ciudadano::where('numero_documento', '=', $row[2])->first();
            if ($ciudadano === null) {
                $ciudadano = new Ciudadano();
                $ciudadano->nombre = $row[1];
                $ciudadano->numero_documento = $row[2];
                $ciudadano->direccion_residencia = $row[3];
                $ciudadano->ciudad_residencia = $row[4];
                $ciudadano->telefono_fijo = $row[5];
                $ciudadano->telefono_celular = $row[6];
                $ciudadano->email = $row[7];
                $ciudadano->save();
            }
            $ubicacion = CiudadanoUbicacion::where('id_ciudadano', '=', $ciudadano->id)
                                            ->where('fecha_actualizacion', '>', date('Y-m-d'))
                                            ->orderBy('fecha_actualizacion', 'desc')
                                            ->limit(1)
                                            ->first();
            if ($ubicacion === null) {
                // guardamos la direccion en ciudadanos_ubicacion
                $ubicacion = new CiudadanoUbicacion();
                $ubicacion->id_ciudadano = $ciudadano->id;
                $ubicacion->direccion = $row[3];
                $ubicacion->ciudad = $row[4];
                $ubicacion->telefono = $row[6];
                $ubicacion->email = $row[7];
                $ubicacion->fecha_actualizacion = Carbon::now();
                $ubicacion->save();
            }
        }
    }
}
