<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use App\Infraccion;
use App\InfraccionF;
use App\InfraccionSalario;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class Sancion extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   */
  protected $signature = 'sancion:start {medio} {id_comparendo} {activar_notificacion} {id_usuario}';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Imprime una sola sancion a un comparendo, hace uso de un formato para cuando la persona se hace responsable del comparendo.';

  /**
  * variables de contenido de la tarea
  */
  protected $ultimaNumeracion = 1900;
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $idUsuario = $this->argument('id_usuario');
    $idComparendo = $this->argument('id_comparendo');
    $medio = $this->argument('medio');
    $activarNotificacion = $this->argument('activar_notificacion');
    if($activarNotificacion != 'true'){
      $activarNotificacion = false;
    } else {
      $activarNotificacion = true;
    }
    $this->rutaImagenTop = '';
    if($medio == "c"){
      $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      $this->rutaFirma = base_path() . '/public/images/firma2.png';
    } else if($medio == "w"){
      $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      $this->rutaFirma = base_path() . '/public/images/firma2.png';
    }
    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');

    $organismo = \App\Organismo::first();
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretario_nombre;

    $festivos = Festivos::all();
    $infraccion = Infraccion::all();
    $infraccion_f = InfraccionF::all();

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                   'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

    $convertidorNumerosALetras = new \NumberToLetterConverter();

    $comparendo = Comparendo::find($idComparendo);
    //validar si hay que iniciar el proceso de numeraciones
    $activarProceso = false;
    $sancion = ResolucionSimit::where('COL7', '=', $comparendo->numero)->where('COL5', '=', '1')->first();
    if(!isset($sancion->id)){
      $activarProceso = true;
    }

    if($activarProceso){
      $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '4')->first();

      if($numeracion != null){
        $this->ultimaNumeracion = $numeracion->final;
      }
      $inicioNumeracion = $this->ultimaNumeracion + 1;

      $countAudiencia = 0;
      $horaAudiencia = new Carbon(Carbon::createFromTime(8, 0, 0));
    }

    $sancion = ResolucionSimit::where('COL7', '=', $comparendo->numero)->where('COL5', '=', '1')->first();
    if(!isset($sancion->id)){
      $this->line('Llamando Sancion...');
      $this->ultimaNumeracion++;
      $archivo = '';
      ///INICIANDO EL CALCULO PARA EL TIEMPO DE AUDIENCIA
      if ($countAudiencia == 32) {
        $countAudiencia = 0;
        $horaAudiencia = new Carbon(Carbon::createFromTime(8, 0, 0));
      }
      $horaInicio = $horaAudiencia->format('H:i A');
      $horaAudiencia->addMinutes(15);
      $horaFinal = $horaAudiencia->format('H:i A');
      $countAudiencia++;
      //FIN DEL CALCULO
      //CALCULANDO LA FECHA DE LA SANCION

      $fechaSancion = Carbon::now()->format('Y-m-d');
      $fechaSancionResolucion = Carbon::now()->format('d/m/Y');

      $fechaNotificacion = Carbon::now()->format('d/m/Y');
      $fechaNotificacionBD = Carbon::now()->format('Y-m-d');
      $fechaSancionCarbon = new Carbon($fechaSancion);
      $fechaGeneracionSancion = $fechaSancionCarbon->day . ' de ' . $this->meses[$fechaSancionCarbon->month - 1] . ' de ' . $fechaSancionCarbon->year;

      //FIN DEL CALCULO
      $numeroResolucion = 'RS-' . $this->ultimaNumeracion . '-' . $fechaSancionCarbon->year;
      $archivo = $numeroResolucion . '.pdf';

      $this->comparendosImpresos[] = array('final_numero' => $comparendo->numero);
      $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
      \File::makeDirectory($folder, 0777, true, true);

      $this->comparendopdf = view('comparendos.sancion.sancion_head_pdf',[
                              'organismoDireccion' => $this->organismoDireccion,
                              'rutaImagenTop' => $this->rutaImagenTop
                            ]);
      $infraccion_fecha = new Carbon($comparendo->infraccion_fecha);
      $infraccion_fecha = $infraccion_fecha->day . ' de ' . $this->meses[$infraccion_fecha->month - 1] . ' de ' . $infraccion_fecha->year;
      $descripcionInfraccion = '';
      $infraccion_salario = InfraccionSalario::where('codigo', '=', substr($comparendo->infracciones, 0, 1))->first()->descripcion;
      if($comparendo->infracciones == 'F'){

      }else {
        $descripcionInfraccion = Infraccion::where('codigo', '=', $comparendo->infracciones)->first()->infraccion;
      }
      $sancionpdf =  view('comparendos.sancion.sancion_comparencia_pdf', [
                              'comparendo' => $comparendo,
                              'descripcionInfraccion' => $descripcionInfraccion,
                              'infraccion_salario' => $infraccion_salario,
                              'infraccion_fecha' => $infraccion_fecha,
                              'fecha_actual' => $fechaGeneracionSancion,
                              'valorLetras' => $convertidorNumerosALetras->to_word(round($comparendo->valor)),
                              'horaInicio' => $horaInicio,
                              'horaFinal' => $horaFinal,
                              'infraccion' => $infraccion,
                              'infraccion_f' => $infraccion_f,
                              'numero_resolucion' => $numeroResolucion,
                              'rutaFirma' => $this->rutaFirma,
                              'nombreSecretaria' => $this->organismoNombreSecreteria,
                              'fechaNotificacion' => $fechaNotificacion,
                              'activarNotificacion' => $activarNotificacion
                            ]);

      $this->comparendopdf .= $sancionpdf . '</body></html>';

      $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');
      $pdf->save($folder . '/' . $archivo);

      //creando el registro en expediente
      $expediente = new \App\ComparendoExpediente();
      $expediente->id_comparendo = $comparendo->id;
      $expediente->fecha_generacion = $fechaSancion;
      $expediente->nombre_documento = $archivo;
      $expediente->id_tipo_evento = 4;//sancion
      $expediente->id_paquete = 0;
      $expediente->id_user = $idUsuario;
      $expediente->is_impreso = 0;
      $expediente->envio_simit = 0;
      $expediente->save();

      //creando el registro en resoluciones simit
      $fechaComparendo = new Carbon($comparendo->infraccion_fecha);
      $resolucion = new ResolucionSimit();
      $resolucion->COL2 = $numeroResolucion;
      $resolucion->COL4 = $fechaSancionResolucion;
      $resolucion->COL5 = '1';
      $resolucion->COL7 = $comparendo->numero;
      $resolucion->COL8 = $fechaComparendo->format('d/m/Y');
      $resolucion->COL9 = $comparendo->infractor_documento;
      $resolucion->COL10 = '1';
      $resolucion->COL11 = mb_strtoupper($comparendo->infractor_nombre);
      $resolucion->COL12 = mb_strtoupper($comparendo->infractor_apellido);
      $resolucion->COL13 = mb_strtoupper($comparendo->infraccion_direccion);
      $resolucion->COL15 = $organismo->codigo;
      $resolucion->COL16 = $comparendo->valor;

      if($comparendo->es_fotomulta == 0){
        $resolucion->COL18 = 'N';
      } elseif($comparendo->es_fotomulta == 1){
        $resolucion->COL18 = 'S';
      }
      $resolucion->COL19 = $organismo->codigo;

      if($comparendo->es_polca == 0){
        $resolucion->COL20 = 'N';
      } elseif($comparendo->es_polca == 1){
        $resolucion->COL20 = 'S';
      }

      $resolucion->COL21 = $comparendo->infracciones;
      $resolucion->COL22 = $comparendo->valor;
      $resolucion->COL23 = $comparendo->valor;

      if($comparendo->infracciones == 'F'){
        $resolucion->COL24 = $comparendo->grado_alcohol;
        $resolucion->COL25 = '';
      }
      $resolucion->confirmado_simit = 0;
      $resolucion->save();

      $comparendoActualizar = Comparendo::find($comparendo->id);
      $comparendoActualizar->id_tipo_evento = 4;//sancion
      $comparendoActualizar->estado = 4;//con resolucion
      if($activarNotificacion){
        $comparendoActualizar->fecha_notificacion = $fechaNotificacionBD;//fecha de notificado
      }
      $comparendoActualizar->save();
      $this->line("sancion impresa: " . $comparendo->id);
    }else{
      $comparendo->id_tipo_evento = 4;
      $comparendo->save();
    }

    if($activarProceso){
      if($this->ultimaNumeracion >= $inicioNumeracion){
        $this->line("Actualizando Numeracion...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'RS';
        $numeracion->inicio = $inicioNumeracion;
        $numeracion->final = $this->ultimaNumeracion;
        $numeracion->id_tipo_evento = 4;//sancion
        $numeracion->id_organismo = 1;
        $numeracion->id_paquete = 0;
        $numeracion->save();
        $this->line("Fin Numeracion");
      } else {
        $this->line("No se imprimo sanciones.");
      }
    }
  }
}
