<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use App\Infraccion;
use App\InfraccionF;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class SancionEspecial extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'sancionespecial:start {medio} {id_usuario}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
    * variables de contenido de la tarea
    */
    protected $relacionContenido = '';
    protected $pdfMasivo = '';
    protected $comparendosImpresos = array();
    protected $ultimaNumeracion = 1900;
    protected $comparendopdf = '';
    protected $meses = [];
    protected $organismoNombreSecreteria = '';
    protected $organismoDireccion = '';
    protected $rutaImagenTop = '';
    protected $rutaFirma = '';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
      $idUsuario = $this->argument('id_usuario');
      $medio = $this->argument('medio');
      $this->rutaImagenTop = '';
      if($medio == "c"){
        $this->rutaImagenTop = asset(config('myconfig.proyect_route') . '/images/hoja membrete.jpg');
        $this->rutaFirma = asset(config('myconfig.proyect_route') . '/images/firma2.png');
      } else if($medio == "w"){
        $this->rutaImagenTop = asset('images/hoja membrete.jpg');
        $this->rutaFirma = asset('images/firma2.png');
      }
      $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
      $rutaPaquete = \Config::get('myconfig.ruta_paquetes_mensajeria');

      $listaMaxima = Comparendo::habilitadosParaSancionEspecial('antiguo')
                                ->where('validacion', '=', '1')//excluyendo las infracciones que no esten revisadas
                                ->where('estado', '!=', '2')
                                ->where('count_resolucion_sancion', '=', '0')
                                ->where('countap', '=', '0')
                                ->where('countexfallo', '=', '0')
                                ->where('countanulacion', '=', '0')
                                ->where('infracciones', 'not like', "'%H%'")
                                ->get();
      $maxId = $listaMaxima->max('id');
      if($maxId > 0){

        $organismo = \App\Organismo::first();
        $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
        $this->organismoNombreSecreteria = $organismo->secretaria_nombre;

        $this->pdfMasivo = view('comparendos.especial.sancion.comparendo_sancionado_head_pdf', [
                                'organismoDireccion' => $this->organismoDireccion,
                                'rutaImagenTop' => $this->rutaImagenTop
                              ]);
        $this->pdfMasivo .= '<style>.page-break {page-break-after: always;}</style>';

        //creando el paquete
        $paquete = new \App\ComparendoPaquete();
        $paquete->nombre = Carbon::now();
        $paquete->fecha = Carbon::now();
        $paquete->id_user = $idUsuario;
        $paquete->id_tipo_evento = 12;
        $paquete->es_impreso = 0;
        $paquete->save();

        $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '12')->first();

        if($numeracion != null){
          $this->ultimaNumeracion = $numeracion->final;
        }
        $inicioNumeracion = $this->ultimaNumeracion + 1;

        $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                       'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

        $convertidorNumerosALetras = new \NumberToLetterConverter();

        $countAudiencia = 0;
        $horaAudiencia = new Carbon(Carbon::createFromTime(8, 0, 0));

        $festivos = Festivos::all();
        $infraccion = Infraccion::all();
        $infraccion_f = InfraccionF::all();

        $comparendos = Comparendo::habilitadosParaSancionEspecial('antiguo')
                    ->where('validacion', '=', DB::raw('1'))//excluyendo las infracciones que no esten revisadas
                    ->where('estado', '!=', DB::raw('2'))
                    ->where('count_resolucion_sancion', '=', DB::raw('0'))
                    ->where('countap', '=', DB::raw('0'))
                    ->where('countexfallo', '=', DB::raw('0'))
                    ->where('countanulacion', '=', DB::raw('0'))
                    ->where('infracciones', 'not like', DB::raw("'%H%'"))
                    ->get();
        foreach ($comparendos as $comparendo) {
            $this->ultimaNumeracion++;
            $archivo = '';
            $resolucion = null;
            $numeroResolucion = '';
            if($comparendo->count_resolucion_sancion >= 1){ //tiene resolucion
              $resolucion = ResolucionSimit::where('COL7', '=', $comparendo->final_numero)
                                            ->where('COL5', '=', '1')->orderBy('COL2', 'desc')->first();
              $numeroResolucion = 'RS-' . $resolucion->COL2;
              $archivo = $numeroResolucion . '.pdf';
            }
            /*INICIANDO EL CALCULO PARA EL TIEMPO DE AUDIENCIA*/
            if ($countAudiencia == 32) {
              $countAudiencia = 0;
              $horaAudiencia = new Carbon(Carbon::createFromTime(8, 0, 0));
            }
            $horaInicio = $horaAudiencia->format('H:i A');
            $horaAudiencia->addMinutes(15);
            $horaFinal = $horaAudiencia->format('H:i A');
            $countAudiencia++;
            /*FIN DEL CALCULO*/
            /*CALCULANDO LA FECHA DE LA SANCION*/
            $fechaSancion = '';
            $fechaGeneracionSancion = '';
            if($comparendo->count_resolucion_sancion == 0){ //no tiene resolucion
              $fecha5Dias = new Carbon($comparendo->infraccion_fecha);
              $fecha5Dias->addDays(7);//7 dias
              $fecha5Dias = Comparendo::calcularFechaHabilLaboral($festivos, $fecha5Dias);
              $fechaSancionCarbon = new Carbon($fecha5Dias);
              $fechaSancion = $fechaSancionCarbon->year . '-' . $fechaSancionCarbon->month . '-' .  $fechaSancionCarbon->day;
              $fechaGeneracionSancion = $fechaSancionCarbon->day . ' de ' . $this->meses[$fechaSancionCarbon->month - 1] . ' de ' . $fechaSancionCarbon->year;
            } else {
              $fechaSancion = Carbon::createFromFormat('d/m/Y', $resolucion->COL4)->format('Y-m-d');
              $fechaSancionCarbon = new Carbon($fechaSancion);
              $fechaGeneracionSancion = $fechaSancionCarbon->day . ' de ' . $this->meses[$fechaSancionCarbon->month - 1] . ' de ' . $fechaSancionCarbon->year;
            }
            /*FIN DEL CALCULO*/
            if($comparendo->count_resolucion_sancion == 0){ //no tiene resolucion
              $numeroResolucion = 'RS-' . $this->ultimaNumeracion . '-' . $fechaSancionCarbon->year;
              $archivo = $numeroResolucion . '.pdf';
            }


            $this->comparendosImpresos[] = array('final_numero' => $comparendo->final_numero);
            $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
            \File::makeDirectory($folder, 0755, true, true);

            $this->comparendopdf = view('comparendos.especial.sancion.comparendo_sancionado_head_pdf',[
                                    'organismoDireccion' => 'Calle 7 # 15-104 Esquina, Curumaní - Cesar', //$this->organismoDireccion, por ser especial direccion antigua
                                    'rutaImagenTop' => $this->rutaImagenTop
                                  ]);
            $infraccion_fecha = new Carbon($comparendo->infraccion_fecha);
            $infraccion_fecha = $infraccion_fecha->day . ' de ' . $this->meses[$infraccion_fecha->month - 1] . ' de ' . $infraccion_fecha->year;
            $sancionpdf =  view('comparendos.especial.sancion.comparendo_sancionado_pdf', [
                                    'comparendo' => $comparendo,
                                    'descripcionInfraccion' => $comparendo->descripcion_infraccion,
                                    'infraccion_fecha' => $infraccion_fecha,
                                    'fecha_actual' => $fechaGeneracionSancion,
                                    'valorLetras' => $convertidorNumerosALetras->to_word(round($comparendo->valor)),
                                    'horaInicio' => $horaInicio,
                                    'horaFinal' => $horaFinal,
                                    'infraccion' => $infraccion,
                                    'infraccion_f' => $infraccion_f,
                                    'numero_resolucion' => $numeroResolucion,
                                    'rutaFirma' => $this->rutaFirma
                                  ]);

            $this->comparendopdf .= $sancionpdf . '</body></html>';

            $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');
            $pdf->save($folder . '/' . $archivo);

            //creando el registro en expediente
            $expediente = new \App\ComparendoExpediente();
            $expediente->id_comparendo = $comparendo->id;
            $expediente->fecha_generacion = $fechaSancion;
            $expediente->nombre_documento = $archivo;
            $expediente->id_tipo_evento = 12;//sancion especial
            $expediente->id_paquete = $paquete->id;
            $expediente->id_user = $idUsuario;
            $expediente->save();

            //creando el registro en resoluciones simit
            $fechaComparendo = new Carbon($comparendo->infraccion_fecha);
            $resolucion = new ResolucionSimit();
            $resolucion->COL2 = $numeroResolucion;
            $resolucion->COL4 = $fechaSancionCarbon->format('d/m/Y');
            $resolucion->COL5 = '1';
            $resolucion->COL7 = $comparendo->numero;
            $resolucion->COL8 = $fechaComparendo->format('d/m/Y');
            $resolucion->COL9 = $comparendo->infractor_documento;
            $resolucion->COL10 = '1';
            $resolucion->COL11 = mb_strtoupper($comparendo->infractor_nombre);
            $resolucion->COL12 = mb_strtoupper($comparendo->infractor_apellido);
            $resolucion->COL13 = mb_strtoupper($comparendo->infraccion_direccion);
            $resolucion->COL15 = $organismo->codigo;
            $resolucion->COL16 = $comparendo->valor;

            if($comparendo->es_fotomulta == 0){
              $resolucion->COL18 = 'N';
            } elseif($comparendo->es_fotomulta == 1){
              $resolucion->COL18 = 'S';
            }
            $resolucion->COL19 = $organismo->codigo;

            if($comparendo->es_polca == 0){
              $resolucion->COL20 = 'N';
            } elseif($comparendo->es_polca == 1){
              $resolucion->COL20 = 'S';
            }

            $resolucion->COL21 = $comparendo->infracciones;
            $resolucion->COL22 = $comparendo->valor;
            $resolucion->COL23 = $comparendo->valor;

            if($comparendo->infracciones == 'F'){
              $resolucion->COL24 = $comparendo->grado_alcohol;
              $resolucion->COL25 = '';
            }
            $resolucion->confirmado_simit = 0;
            $resolucion->save();

            $this->pdfMasivo .=  $sancionpdf;
            $this->pdfMasivo .= '<div class="page-break"></div>';
            $this->relacionContenido .= $comparendo->final_numero . "\r\n";

            $comparendoActualizar = Comparendo::find($comparendo->id);
            $comparendoActualizar->id_tipo_evento = 12;//sancion especial
            $comparendoActualizar->estado = 4;//con resolucion
            $comparendoActualizar->save();
            $this->line("suspension impresa: " . $comparendo->id);
        }

        if($this->ultimaNumeracion >= $inicioNumeracion){
          $this->line("Actualizando Numeracion...");
          //actualizar la numeracion en un nuevo registro
          $numeracion = new Numeracion();
          $numeracion->prefijo = 'RS';
          $numeracion->inicio = $inicioNumeracion;
          $numeracion->final = $this->ultimaNumeracion;
          $numeracion->id_tipo_evento = 12;//sancion especial
          $numeracion->id_organismo = 1;
          $numeracion->id_paquete = $paquete->id;
          $numeracion->save();
          $this->line("Fin Numeracion");

          //$pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');
          //return $pdf->stream('pdf.pdf');
          $this->line("Creando el PDF Masivo...");
          $this->pdfMasivo .= '</body></html>';
          $folder = $rutaPaquete . '/' . $paquete->id;
          \File::makeDirectory($folder, 0755, true, true);

          $pdf = PDF::loadHTML($this->pdfMasivo)->setPaper('legal', 'portrait');
          $archivo = 'paquete_' . $paquete->id;
          $pdf->save($folder . '/' . $archivo . '.pdf');
          $paquete->archivo_pdf = $archivo . '.pdf';

          //el archivo de remision
          \File::put($folder . '/' . $archivo . '.txt', $this->relacionContenido);

          //remision en pdf
          $pdf = PDF::loadView('comparendos.relacion_paquete',
                                  [ 'comparendos' => $this->comparendosImpresos ]
                              )->setPaper('legal', 'portrait');
          $pdf->save($folder . '/remision.pdf');
          $paquete->archivo_remision = 'remision.pdf';

          $paquete->save();
          $this->line("Fin Pdf masivo y actualizacion del Paquete.");
        } else {
          $this->line("No se imprimo sanciones.");
        }
      }else{
        $this->line("No se encontraron comparendos a suspencion especial.");
      }
    }
}
