<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use App\Festivos;
use App\Infraccion;
use App\InfraccionF;
use App\InfraccionSalario;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Artisan;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class SancionMasiva extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   */
  //php artisan sancion_masiva:start c old false 4
  protected $signature = 'sancion_masiva:start {medio} {what_fecha} {activar_notificacion} {id_usuario}';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Busca los comparendos a sancionar validando el tiempo transcurrido.';

  /**
  * variables de contenido de la tarea
  */
  protected $relacionContenido = '';
  protected $pdfMasivo = '';
  protected $comparendosImpresos = array();
  protected $ultimaNumeracion = 1900;
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';

  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
/*
    do {
      $comparendos = Comparendo::select(
                              DB::raw("(select count(1) from resoluciones_simit as rs where rs.COL7 = numero and rs.COL5 = '1') as count_resolucion_sancion"),
                              DB::raw("c.*")
                              )
                              ->from(DB::raw('comparendos c'))
                              ->where('infraccion_fecha', 'BETWEEN', DB::raw("'2018-01-01' AND '2018-08-25'"))
                              ->where('estado', '!=', DB::raw('1'))
                              ->whereNull('fecha_pago')
                              ->where('validacion', '=', DB::raw('1'))//excluyendo las infracciones que no esten revisadas
                              ->where('infracciones', 'not like', DB::raw("'%H%'"))
                              ->where(function ($query) {
                                  $query->where('id_tipo_evento', '=', DB::raw('0'))
                                        ->orWhereNull('id_tipo_evento');
                              });
      $consulta = $comparendos;
      $querySql = $consulta->toSql();

      $queryFinal = DB::table(DB::raw("($querySql) as tabla"))->where('count_resolucion_sancion','>',DB::raw('0'))->get();
      foreach ($queryFinal as $comparendo) {
        $this->info('Actualizado... ' . $comparendo->id);
        $comparendoActualizar = Comparendo::find($comparendo->id);
        $comparendoActualizar->id_tipo_evento = 4;
        $comparendoActualizar->save();
      }
    } while (count($queryFinal) > 0);*/

    $idUsuario = $this->argument('id_usuario');
    $medio = $this->argument('medio');
    $whatFecha = $this->argument('what_fecha');
    $activarNotificacion = $this->argument('activar_notificacion');
    if($activarNotificacion != 'true'){
      $activarNotificacion = false;
    } else {
      $activarNotificacion = true;
    }
    $this->rutaImagenTop = '';
    if($medio == "c"){
      $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      $this->rutaFirma = base_path() . '/public/images/firma2.png';
    } else if($medio == "w"){
      $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      $this->rutaFirma = base_path() . '/public/images/firma2.png';
    }
    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');
    $rutaPaquete = \Config::get('myconfig.ruta_paquetes_mensajeria');

    $organismo = \App\Organismo::first();
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretario_nombre;

    $festivos = Festivos::all();
    $infraccion = Infraccion::all();
    $infraccion_f = InfraccionF::all();

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                   'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

    $convertidorNumerosALetras = new \NumberToLetterConverter();

    do {
      //->where('estado', '!=', DB::raw('1'))
      $comparendos = Comparendo::where('infraccion_fecha', 'BETWEEN', DB::raw("'2020-10-01' AND '2020-12-31'"))
                              ->whereNull('fecha_pago')
                              ->where('validacion', '=', DB::raw('1'))//excluyendo las infracciones que no esten revisadas
                              ->where('infracciones', 'not like', DB::raw("'%H%'"))
                              ->where(function ($query) {
                                  $query->where('id_tipo_evento', '=', DB::raw('0'))
                                        ->orWhereNull('id_tipo_evento');
                              })->limit(10)->get();
      //validar si hay que iniciar el proceso de paquete y numeraciones
      $activarProceso = false;
      foreach ($comparendos as $comparendo) {
        $sancion = ResolucionSimit::where('COL7', '=', $comparendo->numero)->where('COL5', '=', '1')->first();
        $this->line('Compa...'.$comparendo->numero);
        if(!isset($sancion->id)){
          $activarProceso = true;
          break;
        }
      }
      

      if($activarProceso){
        $this->pdfMasivo = view('comparendos.sancion.sancion_head_pdf',[
                                'organismoDireccion' => $this->organismoDireccion,
                                'rutaImagenTop' => $this->rutaImagenTop
                              ]);

        //creando el paquete
        $paquete = new \App\ComparendoPaquete();
        $paquete->nombre = Carbon::now();
        $paquete->fecha = Carbon::now();
        $paquete->id_user = $idUsuario;
        $paquete->id_tipo_evento = 4;
        $paquete->es_impreso = 0;
        $paquete->save();

        $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '4')->first();

        if($numeracion != null){
          $this->ultimaNumeracion = $numeracion->final;
        }
        $inicioNumeracion = $this->ultimaNumeracion + 1;

        $countAudiencia = 0;
        $horaAudiencia = new Carbon(Carbon::createFromTime(8, 0, 0));
      }

      foreach ($comparendos as $comparendo) {
        $sancion = ResolucionSimit::where('COL7', '=', $comparendo->numero)->where('COL5', '=', '1')->first();
        if(!isset($sancion->id)){
          $this->line('Llamando Sancion...');
          $this->ultimaNumeracion++;
          $archivo = '';
          ///INICIANDO EL CALCULO PARA EL TIEMPO DE AUDIENCIA
          if ($countAudiencia == 32) {
            $countAudiencia = 0;
            $horaAudiencia = new Carbon(Carbon::createFromTime(8, 0, 0));
          }
          $horaInicio = $horaAudiencia->format('H:i A');
          $horaAudiencia->addMinutes(15);
          $horaFinal = $horaAudiencia->format('H:i A');
          $countAudiencia++;
          //FIN DEL CALCULO
          //CALCULANDO LA FECHA DE LA SANCION
          $fechaSancion = '';
          $fechaGeneracionSancion = '';

          if($whatFecha == 'now'){
            $fechaSancion = Carbon::now()->format('Y-m-d');
          }elseif($whatFecha == 'old'){
            $fechaSancion = new Carbon($comparendo->infraccion_fecha);
            //$fechaSancion = new Carbon("2020-10-30");
            $fechaSancion = $fechaSancion->addDays(31);//31 dias despues de la infraccion es sancion
            $fechaSancion = Comparendo::calcularFechaHabilLaboral($festivos, $fechaSancion);
            $fechaSancionCarbon = new Carbon($fechaSancion);
            $fechaSancion = $fechaSancionCarbon->format('Y-m-d');
            $fechaSancionResolucion = $fechaSancionCarbon->format('d/m/Y');
          }

          $fechaNotificacion = Carbon::now()->format('d/m/Y');
          $fechaNotificacionBD = Carbon::now()->format('Y-m-d');
          $fechaSancionCarbon = new Carbon($fechaSancion);
          $fechaGeneracionSancion = $fechaSancionCarbon->day . ' de ' . $this->meses[$fechaSancionCarbon->month - 1] . ' de ' . $fechaSancionCarbon->year;
          //FIN DEL CALCULO
          $numeroResolucion = 'RS-' . $this->ultimaNumeracion . '-' . $fechaSancionCarbon->year;
          $archivo = $numeroResolucion . '.pdf';

          $this->comparendosImpresos[] = array('final_numero' => $comparendo->numero);
          $folder = $rutaExpediente  . $comparendo->numero_expediente;
          \File::makeDirectory($folder, 0777, true, true);

          $this->comparendopdf = view('comparendos.sancion.sancion_head_pdf',[
                                  'organismoDireccion' => $this->organismoDireccion,
                                  'rutaImagenTop' => $this->rutaImagenTop
                                ]);
          $infraccion_fecha = new Carbon($comparendo->infraccion_fecha);
          $infraccion_fecha = $infraccion_fecha->day . ' de ' . $this->meses[$infraccion_fecha->month - 1] . ' de ' . $infraccion_fecha->year;
          $descripcionInfraccion = '';
          $infraccion_salario = InfraccionSalario::where('codigo', '=', substr($comparendo->infracciones, 0, 1))->first()->descripcion;
          if($comparendo->infracciones == 'F'){

          }else {
            $descripcionInfraccion = Infraccion::where('codigo', '=', $comparendo->infracciones)->first()->infraccion;
          }
          $sancionpdf =  view('comparendos.sancion.sancion_pdf', [
                                  'comparendo' => $comparendo,
                                  'descripcionInfraccion' => $descripcionInfraccion,
                                  'infraccion_salario' => $infraccion_salario,
                                  'infraccion_fecha' => $infraccion_fecha,
                                  'fecha_actual' => $fechaGeneracionSancion,
                                  'valorLetras' => $convertidorNumerosALetras->to_word(round($comparendo->valor)),
                                  'horaInicio' => $horaInicio,
                                  'horaFinal' => $horaFinal,
                                  'infraccion' => $infraccion,
                                  'infraccion_f' => $infraccion_f,
                                  'numero_resolucion' => $numeroResolucion,
                                  'rutaFirma' => $this->rutaFirma,
                                  'nombreSecretaria' => $this->organismoNombreSecreteria,
                                  'fechaNotificacion' => $fechaNotificacion,
                                  'activarNotificacion' => $activarNotificacion
                                ]);

          $this->comparendopdf .= $sancionpdf . '</body></html>';

          $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');
          $pdf->save($folder . '/' . $archivo);

          //creando el registro en expediente
          $expediente = new \App\ComparendoExpediente();
          $expediente->id_comparendo = $comparendo->id;
          $expediente->fecha_generacion = $fechaSancion;
          $expediente->nombre_documento = $archivo;
          $expediente->id_tipo_evento = 4;//sancion
          $expediente->id_paquete = $paquete->id;
          $expediente->id_user = $idUsuario;
          $expediente->is_impreso = 0;
          $expediente->envio_simit = 0;
          $expediente->save();

          //creando el registro en resoluciones simit
          $fechaComparendo = new Carbon($comparendo->infraccion_fecha);
          $resolucion = new ResolucionSimit();
          $resolucion->COL2 = $numeroResolucion;
          $resolucion->COL4 = $fechaSancionResolucion;
          $resolucion->COL5 = '1';
          $resolucion->COL7 = $comparendo->numero;
          $resolucion->COL8 = $fechaComparendo->format('d/m/Y');
          $resolucion->COL9 = $comparendo->infractor_documento;
          $resolucion->COL10 = '1';
          $resolucion->COL11 = mb_strtoupper($comparendo->infractor_nombre);
          $resolucion->COL12 = mb_strtoupper($comparendo->infractor_apellido);
          $resolucion->COL13 = mb_strtoupper($comparendo->infraccion_direccion);
          $resolucion->COL15 = $organismo->codigo;
          $resolucion->COL16 = $comparendo->valor;

          if($comparendo->es_fotomulta == 0){
            $resolucion->COL18 = 'N';
          } elseif($comparendo->es_fotomulta == 1){
            $resolucion->COL18 = 'S';
          }
          $resolucion->COL19 = $organismo->codigo;

          if($comparendo->es_polca == 0){
            $resolucion->COL20 = 'N';
          } elseif($comparendo->es_polca == 1){
            $resolucion->COL20 = 'S';
          }

          $resolucion->COL21 = $comparendo->infracciones;
          $resolucion->COL22 = $comparendo->valor;
          $resolucion->COL23 = $comparendo->valor;

          if($comparendo->infracciones == 'F'){
            $resolucion->COL24 = $comparendo->grado_alcohol;
            $resolucion->COL25 = '';
          }
          $resolucion->confirmado_simit = 0;
          $resolucion->save();

          $this->pdfMasivo .=  $sancionpdf;
          $this->pdfMasivo .= '<div class="page-break"></div>';
          $this->relacionContenido .= $comparendo->numero . "\r\n";

          $comparendoActualizar = Comparendo::find($comparendo->id);
          $comparendoActualizar->id_tipo_evento = 4;//sancion
          $comparendoActualizar->estado = 4;//con resolucion
          if($activarNotificacion){
            $comparendoActualizar->fecha_notificacion = $fechaNotificacionBD;//fecha de notificado
          }
          $comparendoActualizar->save();
          $this->line("sancion impresa: " . $comparendo->id);
        }else{
          $comparendo->id_tipo_evento = 4;
          $comparendo->save();
        }
      }

      if($activarProceso){
        if($this->ultimaNumeracion >= $inicioNumeracion){
          $this->line("Actualizando Numeracion...");
          //actualizar la numeracion en un nuevo registro
          $numeracion = new Numeracion();
          $numeracion->prefijo = 'RS';
          $numeracion->inicio = $inicioNumeracion;
          $numeracion->final = $this->ultimaNumeracion;
          $numeracion->id_tipo_evento = 4;//sancion
          $numeracion->id_organismo = 1;
          $numeracion->id_paquete = $paquete->id;
          $numeracion->save();
          $this->line("Fin Numeracion");

          $this->line("Creando el PDF Masivo...");
          $this->pdfMasivo .= '</body></html>';
          $folder = $rutaPaquete . '/' . $paquete->id;
          \File::makeDirectory($folder, 0777, true, true);

          $pdf = PDF::loadHTML($this->pdfMasivo)->setPaper('legal', 'portrait');
          $archivo = 'paquete_' . $paquete->id;
          $pdf->save($folder . '/' . $archivo . '.pdf');
          $paquete->archivo_pdf = $archivo . '.pdf';

          //el archivo de remision
          \File::put($folder . '/' . $archivo . '.txt', $this->relacionContenido);

          //remision en pdf
          $pdf = PDF::loadView('comparendos.relacion_paquete',
                                  [ 'comparendos' => $this->comparendosImpresos ]
                              )->setPaper('legal', 'portrait');
          $pdf->save($folder . '/remision.pdf');
          $paquete->archivo_remision = 'remision.pdf';

          $paquete->save();
          $this->line("Fin Pdf masivo y actualizacion del Paquete.");
        } else {
          $this->line("No se imprimo sanciones.");
        }
      }
    } while (count($comparendos) > 0);
  }
}
