<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\ResolucionSimit;
use App\Organismo;
use App\Comparendo;
use App\Agente;
use App\Tipo;
use SimpleXMLElement;

use App\NumeracionOficio;
use App\Http\Controllers\HomeController;
use Illuminate\Support\Facades\DB;
use App\RecaudoSimit;


class SimitWsCargaComparendo extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'simitws:registrocomparendo {comparendo}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Carga las resoluciones al simit de a 1';

    /**
     * @var SoapWrapper
     */
    protected $soapWrapper;

    /**
     * SoapController constructor.
     *
     * @param SoapWrapper $soapWrapper
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
		
		
    $no_compa = $this->argument('comparendo');    //$rutaArchivo = $basePath = storage_path().'/app/simittxt/resoluciones/';

    $organismo = \App\Organismo::first();
    $organismoCodigo = $organismo->codigo;


    $compa = Comparendo::where('numero', $no_compa);
    //$resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'RS-%'"));
    $compa = $compa->first();

     $tmp['iNconsecutivoComparendo']=1;
	   $tmp['clave'] = $organismo->clave;
	   $tmp['secretaria'] = $organismo->codigo;
	   $tmp['usuario'] = $organismo->usuario_simit; //'20228001';

//2020/12/31
     $tmp['iNfecha'] = substr($compa->infraccion_fecha,8,2) ."/" . substr($compa->infraccion_fecha,5,2) ."/" . substr($compa->infraccion_fecha,0,4) ;
$this->info("fecha ...".$tmp['iNfecha'] );

     $tmp['iNcomparendoElectronico'] = 'N';
    // $tmp['iNfecha'] = "31/12/2020";//$compa->infraccion_fecha;
     $tmp['iNhora'] = $compa->infraccion_hora;
     $tmp['iNdireccion'] = $compa->infraccion_direccion;
     $tmp['iNdivipoMunicipio'] = $compa->infraccion_ciudad;
     $tmp['iNplaca'] = $compa->vehiculo_placa;
     $tmp['iNdivipoMatricula'] = $compa->infraccion_ciudad;

$cod_clase = Tipo::where('id', $compa->vehiculo_tipo_vehiculo)->first();
$cod_servi = Tipo::where('id', $compa->vehiculo_tipo_servicio)->first();
//$tipo_infractor = Tipo::where('id', $compa->infractor_tipo)->first();
$infractor_tipo_doc = Tipo::where('id', $compa->infractor_tipo_documento)->first();

$this->info("compa ...".$compa->numero);
//$this->info("clase ...".$compa->vehiculo_tipo_vehiculo);

     
$tmp['iNtipoC'] = "1";
if($cod_clase!=null)
{
  $tmp['iNtipoC'] = $cod_clase->codigo;
}


$tmp['iNtipoS'] = "3";
if($cod_servi!=null)
{
  $tmp['iNtipoS'] = $cod_servi->codigo;
}

$tmp['iNtipoInfractor'] = $compa->infractor_tipo;
$tmp['iNtipoD']= "1";
if($infractor_tipo_doc!=null)
{
  $tmp['iNtipoD'] = $infractor_tipo_doc->codigo;
}
     

     $tmp['iNcodigoRa'] = $compa->vehiculo_radio_accion;

     $tmp['iNidInfractor'] =  $compa->infractor_documento;

$age = Agente::where('id', $compa->id_agente)->first();

     $tmp['iNplacaAgente'] =  $age->codigo_simit;

     //$tmp['iNfuga'] = $compa->es_fuga; 
            $tmp['iNfuga'] = "N";
            if ($compa->es_fuga) {
                $tmp['iNfuga'] = "S";
            }     
     $tmp['iNaccidente'] = "N";// $compa->es_fuga; 
     $tmp['iNinmovilizacion'] = "N";// $compa->es_fuga; 


     $tmp['iNvalorComp'] =  $compa->valor;
     $tmp['iNvalorAdi'] = $compa->valor_adicional;
     $tmp['iNorganismoTransito'] =   $organismo->codigo;
     $tmp['iNplacaAgente'] =  $age->codigo_simit;

     $tmp['iNestado'] = "1" ;

    if ($compa->es_polca) {     
     $tmp['iNestadoComparendoPolca'] =  "S";
     }else
     {
      $tmp['iNestadoComparendoPolca'] =  "N";
     }

     $tmp['iNplacaAgente'] = $age->codigo_simit;

     $tmp['iNvalorInf1'] =  $compa->valor;

     $tmp['iNcodigoInfraccion1'] =  $compa->infracciones;

     $tmp['iNnumeroComparendo'] =  $compa->numero;
     $tmp['iNnombreInfractor'] =  $compa->infractor_nombre;
     $tmp['iNapellidoInfractor'] =   $compa->infractor_apellido;
     
     $tmp['iNidTipoDocP'] =  $compa->propietario_tipo_documento;
     $tmp['iNnombreProp'] =  $compa->propietario_nombre;
     $tmp['iNidentificacion'] =  $compa->propietario_documento;
     $tmp['iNgradoAlcohol'] =  $compa->grado_alcohol;

/*

            <xsd:iNapellidoInfractor></xsd:iNapellidoInfractor>
            <xsd:iNciudadInfractor></xsd:iNciudadInfractor>
            <xsd:iNcodigoInfraccion1></xsd:iNcodigoInfraccion1>
            <xsd:iNcodigoMo></xsd:iNcodigoMo>
            <xsd:iNcodigoPa></xsd:iNcodigoPa>

            <xsd:iNconsecutivoIn></xsd:iNconsecutivoIn>
            <xsd:iNdirPatioInmovi></xsd:iNdirPatioInmovi>
            <xsd:iNdirecTesti></xsd:iNdirecTesti>

            <xsd:iNdireccionInfractor></xsd:iNdireccionInfractor>
            <xsd:iNdivipoLicencia></xsd:iNdivipoLicencia>
            <xsd:iNdivipoMatricula></xsd:iNdivipoMatricula>

            <xsd:iNedadIn></xsd:iNedadIn>
            <xsd:iNemail></xsd:iNemail>

            <xsd:iNfechaNotificacion></xsd:iNfechaNotificacion>
            <xsd:iNfechaVence></xsd:iNfechaVence> 

            <xsd:iNgradoAlcohol></xsd:iNgradoAlcohol>
            <xsd:iNgruaNumero></xsd:iNgruaNumero>
            <xsd:iNidSecretariaExpide></xsd:iNidSecretariaExpide>

            <xsd:iNidentificacion></xsd:iNidentificacion>'.
            <xsd:iNidentificacionTestigo></xsd:iNidentificacionTestigo>'.
            <xsd:iNlicenciaConduccion></xsd:iNlicenciaConduccion>'.
            <xsd:iNlicenciaTransito></xsd:iNlicenciaTransito>'.
            <xsd:iNlocalidadComuna></xsd:iNlocalidadComuna>'.
            <xsd:iNnitEmpresa></xsd:iNnitEmpresa>'.
            <xsd:iNnombreEmpresa></xsd:iNnombreEmpresa>'.

            <xsd:iNnombreProp></xsd:iNnombreProp>'.
            <xsd:iNnombreTestigo></xsd:iNnombreTestigo>'.
            <xsd:iNobservaciones></xsd:iNobservaciones>'.
            <xsd:iNpatioInmoviliza></xsd:iNpatioInmoviliza>'.

            <xsd:iNplacaGrua></xsd:iNplacaGrua>'.
            <xsd:iNtarjetaOperacion></xsd:iNtarjetaOperacion>'.
            <xsd:iNteleTestigo></xsd:iNteleTestigo>'.
            <xsd:iNtelefonoInfractor></xsd:iNtelefonoInfractor>'.

            <xsd:iNtipoD></xsd:iNtipoD>'.
            <xsd:iNtipoV></xsd:iNtipoV>'.

            <xsd:iNnombreInfractor></xsd:iNnombreInfractor>



              <web:cargaArchivoComparendos>
              <web:comparendo>
              <xsd:clave></xsd:clave>
              <xsd:secretaria></xsd:secretaria>
              <xsd:usuario></xsd:usuario>
              <xsd:iNaccidente></xsd:iNaccidente>

              <xsd:iNcodigoRa></xsd:iNcodigoRa>
              <xsd:iNcomparendoElectronico></xsd:iNcomparendoElectronico>
              <xsd:iNconsecutivoComparendo></xsd:iNconsecutivoComparendo>
              <xsd:iNdireccion></xsd:iNdireccion>
              <xsd:iNdivipoMunicipio></xsd:iNdivipoMunicipio>
              <xsd:iNestado></xsd:iNestado>
              <xsd:iNestadoComparendoPolca></xsd:iNestadoComparendoPolca>
              <xsd:iNfecha></xsd:iNfecha> 
              <xsd:iNfuga></xsd:iNfuga>
              <xsd:iNhora></xsd:iNhora>
              <xsd:iNidInfractor></xsd:iNidInfractor>
              <xsd:iNidTipoDocP></xsd:iNidTipoDocP>
              <xsd:iNinmovilizacion></xsd:iNinmovilizacion>
              <xsd:iNnumeroComparendo></xsd:iNnumeroComparendo>
              <xsd:iNorganismoTransito></xsd:iNorganismoTransito>
              <xsd:iNplaca></xsd:iNplaca>
              <xsd:iNplacaAgente></xsd:iNplacaAgente>
              <xsd:iNtipoC></xsd:iNtipoC>
              <xsd:iNtipoS></xsd:iNtipoS>
              <xsd:iNtipoInfractor></xsd:iNtipoInfractor>

              <xsd:iNvalorAdi></xsd:iNvalorAdi>
              <xsd:iNvalorComp></xsd:iNvalorComp>
              <xsd:iNvalorInf1></xsd:iNvalorInf1>
              </web:comparendo>
              </web:cargaArchivoComparendos> 
*/

	   
            $soapUrl = "http://172.18.164.200:8181/WSSimit/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint/";
			//      $soapUrl = "https://www3.simit.org.co/simit-pruebas/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint/";
            $xml_post_string = '<soapenv:Envelope '.
                                 'xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" '.
                                 'xmlns:web="http://webservices.qxmultas.quipux.com.co" '.
                                 'xmlns:xsd="http://webservices.qxmultas.quipux.com.co/xsd">'.
                                   '<soapenv:Header/>'.
                                   '<soapenv:Body>'.
                                   '<web:cargaArchivoComparendos>' .
                                     '<web:comparendo>' .
                                '<xsd:iNconsecutivoComparendo>' . $tmp['iNconsecutivoComparendo'] . '</xsd:iNconsecutivoComparendo>' .
                                '<xsd:iNcomparendoElectronico>' . $tmp['iNcomparendoElectronico'] . '</xsd:iNcomparendoElectronico>' .
                                '<xsd:iNfecha>' . $tmp['iNfecha'] . '</xsd:iNfecha>' .
                                '<xsd:iNhora>' . $tmp['iNhora'] . '</xsd:iNhora>' .
                                '<xsd:iNdireccion>' . $tmp['iNdireccion'] . '</xsd:iNdireccion>' .
                                '<xsd:iNdivipoMunicipio>' . $tmp['iNdivipoMunicipio'] . '</xsd:iNdivipoMunicipio>' .		
                                '<xsd:iNplaca>' . $tmp['iNplaca'] . '</xsd:iNplaca>' .
                                '<xsd:iNdivipoMatricula>' . $tmp['iNdivipoMatricula'] . '</xsd:iNdivipoMatricula>' .	

                                '<xsd:iNcodigoRa>' .  $tmp['iNcodigoRa'] . '</xsd:iNcodigoRa>' .			
                                '<xsd:iNtipoInfractor>' . $tmp['iNtipoInfractor'] . '</xsd:iNtipoInfractor>' .	
                                '<xsd:iNtipoC>' . $tmp['iNtipoC'] . '</xsd:iNtipoC>' .
                                '<xsd:iNtipoS>' . $tmp['iNtipoS'] . '</xsd:iNtipoS>' .
                                '<xsd:iNidInfractor>' . $tmp['iNidInfractor'] . '</xsd:iNidInfractor>' .
                                '<xsd:iNtipoD>' . $tmp['iNtipoD'] . '</xsd:iNtipoD>' .	
                                '<xsd:iNplacaAgente>' . $tmp['iNplacaAgente'] . '</xsd:iNplacaAgente>' .
                                '<xsd:iNfuga>' . $tmp['iNfuga'] . '</xsd:iNfuga>' .
                                '<xsd:iNaccidente>' . $tmp['iNaccidente'] . '</xsd:iNaccidente>' .
                                '<xsd:iNinmovilizacion>' . $tmp['iNinmovilizacion'] . '</xsd:iNinmovilizacion>' .		
                                '<xsd:iNvalorComp>' . $tmp['iNvalorComp'] . '</xsd:iNvalorComp>' .
                                '<xsd:iNvalorAdi>' . $tmp['iNvalorAdi'] . '</xsd:iNvalorAdi>' .
                                '<xsd:iNestado>' . $tmp['iNestado'] . '</xsd:iNestado>' .								
                                '<xsd:iNestadoComparendoPolca>' . $tmp['iNestadoComparendoPolca'] . '</xsd:iNestadoComparendoPolca>' .			
                                '<xsd:iNvalorInf1>' . $tmp['iNvalorInf1'] . '</xsd:iNvalorInf1>' .
                                '<xsd:iNgradoAlcohol>' . $tmp['iNgradoAlcohol'] . '</xsd:iNgradoAlcohol>' .  				
                                '<xsd:iNcodigoInfraccion1>' . $tmp['iNcodigoInfraccion1'] . '</xsd:iNcodigoInfraccion1>' .
                                '<xsd:iNnumeroComparendo>' . $tmp['iNnumeroComparendo'] . '</xsd:iNnumeroComparendo>' .	
                                '<xsd:iNnombreInfractor>' . $tmp['iNnombreInfractor'] . '</xsd:iNnombreInfractor>' . 
                                 '<xsd:iNapellidoInfractor>' . $tmp['iNapellidoInfractor'] . '</xsd:iNapellidoInfractor>' . 								
                                '<xsd:iNorganismoTransito>' . $tmp['iNorganismoTransito'] . '</xsd:iNorganismoTransito>' .    
                                '<xsd:iNidTipoDocP>' . $tmp['iNidTipoDocP'] . '</xsd:iNidTipoDocP>' .   
                                '<xsd:iNnombreProp>' . $tmp['iNnombreProp'] . '</xsd:iNnombreProp>' .   
                                '<xsd:iNidentificacion>' . $tmp['iNidentificacion'] . '</xsd:iNidentificacion>' .   
								                '<xsd:clave>' . $tmp['clave'] . '</xsd:clave>' .  
                                '<xsd:secretaria>' . $tmp['secretaria'] . '</xsd:secretaria>' .
                                '<xsd:usuario>' . $tmp['usuario'] . '</xsd:usuario>' .
                                '</web:comparendo>' .
                                '</web:cargaArchivoComparendos>'.
                                '</soapenv:Body>'.
                                '</soapenv:Envelope>';
            $headers = array(
                              "Content-type: text/xml;charset=\"utf-8\"",
                              "Accept: text/xml",
                              "Cache-Control: no-cache",
                              "Pragma: no-cache",
                              "SOAPAction: http://172.18.164.200:8181/WSSimit/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint",
                              "Content-length: ".strlen($xml_post_string),
                          ); //SOAPAction: your op URL
// "SOAPAction: http://172.18.164.200:8181/WSSimit/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint"
// "SOAPAction: https://www3.simit.org.co/simit-pruebas/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint",
            $this->info("URL ...".$soapUrl);
$this->info("Cargando ...".$xml_post_string);

            $url = $soapUrl;
//$this->line($xml_post_string);
            // PHP cURL  for https connection with auth
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_post_string); // the SOAP request
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

            // converting
            $response = curl_exec($ch);
            curl_close($ch);
            $response = html_entity_decode($response);


            // converting
            $response1 = str_replace('<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Body><ns:cargaArchivoComparendosResponse xmlns:ns="http://webservices.qxmultas.quipux.com.co"><ns:return><ArchivosTransito>','<body>',$response);
            $response2 = str_replace('</ArchivosTransito>',"",$response1);
            $response3 = str_replace("<?xml version='1.0' encoding='utf-8'?>","",$response2);
      $response2 = str_replace('</ns:return></ns:cargaArchivoComparendosResponse></soapenv:Body></soapenv:Envelope>','</body>',$response3);
			$this->info("nueva linea-->".$response);
			$this->info("Recibiendo  ...");
      $this->info("nueva linea-->".$response2);

            $xml = new SimpleXMLElement($response2);
            $json = json_encode($xml);
            $json = json_decode($json, true);
            if(isset($json['detalle']['idTipoError'])){
              $this->error($json['detalle']['descripcion']);
			       $compa->error_simit = $json['detalle']['descripcion']; 
              $compa->save();			  
			  
            }else{
              //dd($json);
              //$recaudo->fecha_descarga = Carbon::now();
			  $compa->error_simit = $json['detalle']['mensaje']. ' id: '.$json['encabezado']['consecutivoCarga'] ; 
			//  $resolucion->confirmado_simit = 1; 
              $compa->save();
              $this->info($json['detalle']['mensaje']);
            }	   

   //   } // if $puedeIrASimit
	  
	  
	  
	  
  //  }//for

    
	
    }
}
