<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Transaccion;
use App\TransaccionPorAprobar;
use App\Organismo;
use App\Comparendo;
use App\Tipo;
use App\RecaudoSimit;
use App\ReporteWebService;
use SimpleXMLElement;

use App\ParamHonorario;
use App\ParamImpuesto;
use App\ParamInteres;
use App\ParamSistematizacion;

use Illuminate\Support\Collection;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Storage;

class SimitWsCargaRegistroRecaudo extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'simitws:registrorecaudo {cantidad} {id_transaccion} {cuota} {adicional}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Carga los pagos locales al simit de a 1';

    /**
     * @var SoapWrapper
     */
    protected $soapWrapper;

    /**
     * SoapController constructor.
     *
     * @param SoapWrapper $soapWrapper
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
      $cantidadEnviarSimit = $this->argument('cantidad');
      $cantidadAdicional = $this->argument('adicional');

if($cantidadAdicional=="999")
{
  $cantidadAdicional = -1;
}

if($cantidadAdicional=="9999")
{
  $cantidadAdicional = -2;
}

      $idTransaccionRealizada = $this->argument('id_transaccion');
      $idcuota = $this->argument('cuota');
      $recaudos = [];
      if($cantidadEnviarSimit == 'all'){
        $recaudos = Transaccion::where('etiqueta', 'pago-comparendo')
                                ->where('valor', '>', 0)
                                ->where('fecha_descarga', null)
                                ->get();
      }else {
        $recaudos = Transaccion::where('id', $idTransaccionRealizada)
                                ->where('fecha_descarga', null)
                                ->get();
      }
      $organismo = Organismo::first();

$phono=ParamHonorario::orderby('id', 'desc')->first();
$psiste=ParamSistematizacion::orderby('id', 'desc')->first();

$this->info("id_transaccion:".$idTransaccionRealizada);

      foreach ($recaudos as $recaudo){


        $flag2 = true;
        if($recaudo->tipo_pago == 'Contado'){
           $this->info("flag1" );  
          $flag2 = true;
        }else if($recaudo->tipo_pago == 'Redeban' || $recaudo->tipo_pago == 'Consignacion' || $recaudo->tipo_pago == 'Apropiacion'){
          $this->info("flag2" );  
          $porAprobar = TransaccionPorAprobar::where('id_transaccion', '=', $recaudo->id)->first();
          if($porAprobar->estado != 'Aplicado'){
            $this->info("flag3" );  
            $flag2 = false;
          }
        }

 $infractor_tipo_doc = "1";
 $this->info("flag:". $flag2 );  
 $numcompare="";

        if($flag2){
          $jsonFactura = json_decode($recaudo->factura, true);
          if(count($jsonFactura['comparendos']) > 0){
            $comparendo = Comparendo::where('id', '=', $jsonFactura['comparendos'][0])->first();
            $numcompare=$comparendo->numero;
            $es_polca = 'N';
            if($comparendo->infractor_tipo_documento!="")
            {
              $infractor_tipo_doc = Tipo::where('id', $comparendo->infractor_tipo_documento)->first(); 
              $infractor_tipo_doc = $infractor_tipo_doc->codigo; 
            }
            

            if($comparendo->es_polca){
                $es_polca = 'S';
            }
	         $resolucion = Comparendo::getResolucionesByComparendo($recaudo->obtenerPrimerComparendo()->numero)
            ->where(function ($query) {
                $query->where('COL5', '16')
                    ->orWhere('COL5', '17')
                    ->orWhere('COL5', '270')
                    ->orWhere('COL5', '6')
                    ->orWhere('COL5', '8');
            })
            ->orderBy('COL4F', 'desc')->first();
			
			$docu=$recaudo->id_resolucion_pago;
      $val_compa=0;
			if(isset($resolucion->COL5)){
              if ($resolucion->COL5 == '16' || $resolucion->COL5 == '17' || $resolucion->COL5 == '6' 
			  || $resolucion->COL5 == '8' || $resolucion->COL5 == '270') {
                //$docu = $resolucion->COL2;
                $val_compa = $resolucion->COL16;
                 if ($resolucion->COL5 == '16' || $resolucion->COL5 == '17')
                 {
                      $val_compa = $resolucion->COL22;
                 }
              } else {
               //$docu = $recaudo->obtenerPrimerComparendo()->numero;
                $val_compa = $resolucion->COL16;
              }
            } else {
              //$docu = $recaudo->obtenerPrimerComparendo()->numero;
              $val_compa = 0;
            }			
	
                $count = RecaudoSimit::where('C10', '=', $numcompare)->count();
 		            $cuota=$count;
			
			$arrayComparendosRecorridos = [];
			
            if(isset($resolucion->COL5)){
              if ($resolucion->COL5 == '16' || $resolucion->COL5 == '17' || $resolucion->COL5 == '6' 
			  || $resolucion->COL5 == '8' || $resolucion->COL5 == '270') {
                //resolver el numero de la siguiente cuota
                $count = RecaudoSimit::where('C10', '=', $resolucion->COL7)->orWhere('C10', '=', $resolucion->COL2)->count();
                array_push($arrayComparendosRecorridos, (object)array(
                    'numero' => $resolucion->COL7
                ));

                $collectionRecorridos = new Collection($arrayComparendosRecorridos);
                $countRecorridos = $collectionRecorridos->where('numero', '=', $resolucion->COL7)->count();
                //minimo sera = 1 por entrar aqui, si vuelve a entrar sumara 2. esto para el caso de que al generar el archivo tenga mas de una cuota al generar recaudo.
                $cuota = $count; // + $countRecorridos;


              } else {
                //$cuota = '1';
              }
            } else {
              //$cuota = '1';
            }	
			//$cuota =  1;
            if($idcuota!="0")
            {
                 $cuota =  $idcuota;  
            }
					
      $inte=$jsonFactura['intereses']-$jsonFactura['campana_calculados'];
      $hono=$jsonFactura['honorarios'];
      $siste=$jsonFactura['sistematizacion'];
      $valor_pagado=$recaudo->valor-$jsonFactura['honorarios']-$siste;

      //$valor_recaudo=$recaudo->valor-$siste;
      $valor_recaudo=$recaudo->valor-$siste;

      $valor_d=$valor_recaudo;
      $this->info("Hono".$hono. ", Orga:".$organismo->codigo);
      if($hono>0) 
      {
        $this->info("Entro".$hono. "Compa:".$val_compa);
        $hono2=round($val_compa*$phono->valor/100) + $cantidadAdicional;
        
        /*if($hono2!=intval($hono2))
        {
            $hono2=intval($hono2)+1;
        }*/

        
        //$hono2 =  40519;  //para cargar manual                    13673000
          if($organismo->codigo=="68655000" || $organismo->codigo=="13673000")
          {
            $hono2=$hono2+$psiste->valor-1;
            $this->info("Mas siste:".$hono2);
          }

                  //if($valor_recaudo >= $hono2)
                  //{ 
                    $honor=$hono2; 
                  // $this->info(">".$valor_recaudo);
                  //}else
                  //{
                    //$honor=$valor_recaudo;
                    //$this->info("<".$valor_recaudo);
                  //}
                  //$valor_d=$valor_d-$honor;
                  $hono=$honor;
                  //$this->info("asi".$honor."-".$hono);

      }

      if($recaudo->tipo_pago=="Apropiacion")
      {
          $valor_recaudo=$valor_pagado+$jsonFactura['honorarios'];
      }else
      {
          $valor_recaudo=$valor_pagado+$hono;
      }
      



			$tiporec='';
 			if(isset($resolucion->COL5)){
              if ($resolucion->COL5 == '6' || $resolucion->COL5 == '8') {
                $tiporec = '4';
      $inte=0;
      $hono=0;
      $valor_recaudo=$recaudo->valor;

              } elseif ($resolucion->COL5 == '16' || $resolucion->COL5 == '17') {
                $tiporec = '6';
              } else {
                $tiporec = '1';
              }
            } else {
              $tiporec = '1';
            }
			
			$TranApro = TransaccionPorAprobar::where('id_transaccion', '=', $recaudo->id)->first();
			$FechaCon =$TranApro->fecha_descarga;

      if($TranApro->pago_total=="Si")
      {
        //$cuota =  0;
      }

      //$hono =  51585;



        $ws = new ReporteWebService();
        $ws->valor = $valor_recaudo;
        $ws->honorarios = round($hono,0);
        $ws->intereses = round($inte,0);
        $ws->descuentos = 0;
        $ws->fecha= Carbon::createFromFormat("Y-m-d", $FechaCon)->format('d/m/Y');
        $ws->ciudadano = $jsonFactura['ciudadano'];
        $ws->id_organismo = $organismo->codigo;
        $ws->no_operacion = $recaudo->cns_factura;
        $ws->cuota = $cuota;
        $ws->tipo_pago = $tiporec;
        $ws->save();



      /*if($recaudo->valor < 10000)
      {
        $valor_recaudo=10000;
      }*/
			
//$this->line($FechaCon);

            $data = [
             'clave' => $organismo->clave,
             'cuenta' => '0',
             'iNIdTipoDocumento' => $infractor_tipo_doc ,
             'iNNumeroCuota' => $cuota,
             'iNcodigoCO' => '0',
             'iNconsecutivoRecaudo' => '1',
             'iNdescripcionOrigen' => 'taquilla transito',
             'iNestadoRecaudoPolca' => $es_polca,
        'iNfechaContable' => Carbon::createFromFormat("Y-m-d H:i:s", $recaudo->created_at)->format('d/m/Y'),
             'iNfechaTransaccion' => Carbon::createFromFormat("Y-m-d", $FechaCon)->format('d/m/Y'),
             'iNhora' => Carbon::createFromFormat("Y-m-d H:i:s", $recaudo->created_at)->format('Hi'),
             'iNidentificacion' => $jsonFactura['ciudadano'],
             'iNnumeroConsignacion' => $recaudo->cns_factura,
             'iNnumeroReferencia' => $docu,
             'iNsecretaria' => $organismo->codigo,
             'iNtipoRecaudoReferencia' => $tiporec,
             'iNvalorCheque' => '0',
             'iNvalorEfectivo' => round($valor_recaudo),
             'iNvalorTotal' => round($valor_recaudo),
             'interesMoroso' => round($inte,0) ,
             'secretaria' => $organismo->codigo,
             'usuario' => $organismo->usuario_simit,
             'valorAdicional' => round($hono,0), //$jsonFactura['honorarios']
             'valorDescuento' => '0'
            ];
            //$soapUrl = "https://www3.simit.org.co/simit-pruebas/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint/";
            $soapUrl = "http://172.18.164.200:8181/WSSimit/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint/";
            $xml_post_string = '<soapenv:Envelope '.
                                 'xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" '.
                                 'xmlns:web="http://webservices.qxmultas.quipux.com.co" '.
                                 'xmlns:xsd="http://webservices.qxmultas.quipux.com.co/xsd">'.
                                   '<soapenv:Header/>'.
                                   '<soapenv:Body>'.
       '<web:cargaRecaudo>' .
         '<web:recaudo>' .
           '<xsd:clave>' . $data['clave'] . '</xsd:clave>' .
           '<xsd:cuenta>' . $data['cuenta'] . '</xsd:cuenta>' .
           '<xsd:iNIdTipoDocumento>' . $data['iNIdTipoDocumento'] . '</xsd:iNIdTipoDocumento>' .
           '<xsd:iNNumeroCuota>' . $data['iNNumeroCuota'] . '</xsd:iNNumeroCuota>' .
           '<xsd:iNcodigoCO>' . $data['iNcodigoCO'] . '</xsd:iNcodigoCO>' .
           '<xsd:iNconsecutivoRecaudo>' . $data['iNconsecutivoRecaudo'] . '</xsd:iNconsecutivoRecaudo>' .
           '<xsd:iNdescripcionOrigen>' . $data['iNdescripcionOrigen'] . '</xsd:iNdescripcionOrigen>' .
           '<xsd:iNestadoRecaudoPolca>' . $data['iNestadoRecaudoPolca'] . '</xsd:iNestadoRecaudoPolca>' .
           '<xsd:iNfechaContable>' . $data['iNfechaContable'] . '</xsd:iNfechaContable>' .
           '<xsd:iNfechaTransaccion>' . $data['iNfechaTransaccion'] . '</xsd:iNfechaTransaccion>' .
           '<xsd:iNhora>' . $data['iNhora'] . '</xsd:iNhora>' .
           '<xsd:iNidentificacion>' . $data['iNidentificacion'] . '</xsd:iNidentificacion>' .
           '<xsd:iNnumeroConsignacion>' . $data['iNnumeroConsignacion'] . '</xsd:iNnumeroConsignacion>' .
           '<xsd:iNnumeroReferencia>' . $data['iNnumeroReferencia'] . '</xsd:iNnumeroReferencia>' .
           '<xsd:iNsecretaria>' . $data['iNsecretaria'] . '</xsd:iNsecretaria>' .
           '<xsd:iNtipoRecaudoReferencia>' . $data['iNtipoRecaudoReferencia'] . '</xsd:iNtipoRecaudoReferencia>' .
           '<xsd:iNvalorCheque>' . $data['iNvalorCheque'] . '</xsd:iNvalorCheque>' .
           '<xsd:iNvalorEfectivo>' . $data['iNvalorEfectivo'] . '</xsd:iNvalorEfectivo>' .
           '<xsd:iNvalorTotal>' . $data['iNvalorTotal'] . '</xsd:iNvalorTotal>' .
           '<xsd:interesMoroso>' . $data['interesMoroso'] . '</xsd:interesMoroso>' .
           '<xsd:secretaria>' . $data['secretaria'] . '</xsd:secretaria>' .
           '<xsd:usuario>' . $data['usuario'] . '</xsd:usuario>' .
           '<xsd:valorAdicional>' . $data['valorAdicional'] . '</xsd:valorAdicional>' .
           '<xsd:valorDescuento>' . $data['valorDescuento'] . '</xsd:valorDescuento>' .
         '</web:recaudo>' .
                                   '</web:cargaRecaudo>'.
                                 '</soapenv:Body>'.
                                '</soapenv:Envelope>';
            $headers = array(
                              "Content-type: text/xml;charset=\"utf-8\"",
                              "Accept: text/xml",
                              "Cache-Control: no-cache",
                              "Pragma: no-cache",
                              "SOAPAction: http://172.18.164.200:8181/WSSimit/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint",
                              "Content-length: ".strlen($xml_post_string),
                          ); //SOAPAction: your op URL

            $url = $soapUrl;

            $ws->xml = $xml_post_string;
            $ws->save();

                    $this->info($xml_post_string);
            // PHP cURL  for https connection with auth
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_post_string); // the SOAP request
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

            // converting
            $response = curl_exec($ch);
            curl_close($ch);
            $response = html_entity_decode($response);
$this->info("--1--".$response);
            // converting
            $response1 = str_replace('<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Body><ns:cargaRecaudoResponse xmlns:ns="http://webservices.qxmultas.quipux.com.co"><ns:return><ArchivosTransito>','<body>',$response);
            $response2 = str_replace('</ArchivosTransito>',"",$response1);
            $response2 = str_replace('</ns:return></ns:cargaRecaudoResponse></soapenv:Body></soapenv:Envelope>','</body>',$response2);
            $this->info("--2--".$response2);

            $xml = new SimpleXMLElement($response2);
            $json = json_encode($xml);
            $json = json_decode($json, true);

              $recaudo->error= "Sin Respuesta del WebService";
              $recaudo->save();

            if(isset($json['detalle']['idTipoError'])){
              $this->error($json['detalle']['descripcion']);
			        $recaudo->error=$json['detalle']['descripcion'];
              $ws->msj = $recaudo->error;
              $ws->save();

            }else{
              //dd($json);
              $recaudo->fecha_descarga = Carbon::now();
              $this->info($json['detalle']['mensaje']. ' id: '.$json['encabezado']['consecutivoCarga']);
			        $recaudo->error=$json['detalle']['mensaje']. ' id: '.$json['encabezado']['consecutivoCarga'];
              $ws->msj = $recaudo->error;
              $ws->save();
            }
	      		$recaudo->save();
          }
        }
      }
    }
}
