<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\ResolucionSimit;
use App\Organismo;
use App\Comparendo;
use SimpleXMLElement;

use App\NumeracionOficio;
use App\Http\Controllers\HomeController;
use Illuminate\Support\Facades\DB;
use App\RecaudoSimit;


class SimitWsCargaResolucion extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'simitws:registroresolucion {tipo_resolucion}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Carga las resoluciones al simit de a 1';

    /**
     * @var SoapWrapper
     */
    protected $soapWrapper;

    /**
     * SoapController constructor.
     *
     * @param SoapWrapper $soapWrapper
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
		
		
    $tipoResolucion = $this->argument('tipo_resolucion');
    //$rutaArchivo = $basePath = storage_path().'/app/simittxt/resoluciones/';

    $organismo = \App\Organismo::first();
    $organismoCodigo = $organismo->codigo;
    //$folder = $rutaArchivo . Carbon::now()->format('Y-m-d'). '/';
    //$archivo = $organismoCodigo . 'resol.txt';
    //\File::makeDirectory($folder, 0777, true, true);

    $resoluciones = ResolucionSimit::where('confirmado_simit', '=', '0');
    if($tipoResolucion == 'rs'){
      $resoluciones = $resoluciones->where('COL5', 'like', DB::raw("'1'"));
    } else if($tipoResolucion == 'rsi'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'RSI-%'"));
    }else if($tipoResolucion == 'riap'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'RIAP-%'"));
    } else if($tipoResolucion == 'rmp'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'RMP-%'"));
    }else if($tipoResolucion == 'rp'){//prescripcion
      $resoluciones = $resoluciones->where('COL5', 'like', DB::raw("'3'"));
    } else if($tipoResolucion == 'irap'){//incumplimiento acuerdo de pago
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'IRAP-%'"));
    } else if($tipoResolucion == 'arap'){//anulacion acuerdo de pago
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'ARAP-%'"));
    } else if($tipoResolucion == 'rd'){//revocatoria directa
      $resoluciones = $resoluciones->where('COL5', 'like', DB::raw("'21'"));
    } else if($tipoResolucion == 'ard'){//revocatoria directa
      $resoluciones = $resoluciones->where('COL5', 'like', DB::raw("'40'"));      
    } else if($tipoResolucion == 'rap'){//acuerdo de pago
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'RAP-%'"));
    } else if($tipoResolucion == 'ars'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'ARS-%'"));
    } else if($tipoResolucion == 'a'){
      $resoluciones = $resoluciones->where('COL5', 'like', DB::raw("'12'"));
    } else if($tipoResolucion == 'rc'){
      $resoluciones = $resoluciones->where('COL5', 'like', DB::raw("'4'"));      
    } else if($tipoResolucion == 'armp'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'ARMP-%'"));
    } else if($tipoResolucion == 'ec'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'EC-%'"));
    } else if($tipoResolucion == 'ef'){
      $resoluciones = $resoluciones->where('COL5', 'like', DB::raw("'2'"));     
    } else if($tipoResolucion == 'RS-A'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'RS-A%'"));      
    } else if($tipoResolucion == 'RFA'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'RFA%'"));
    } else if($tipoResolucion == 'RSE'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'RSE%'"));
    } else if($tipoResolucion == 'RSM'){
      $resoluciones = $resoluciones->where('COL2', 'like', DB::raw("'RSM%'"));      
    } else{
      $this->line("CODIGO NO VALIDO");
      die;
    }
    //$resoluciones = $resoluciones->limit(1)->get();
    $resoluciones = $resoluciones->get();

    $txt = "";
    $total = 0;
    $consecutivo = 0;
    $totalAcuerdo = 0;
    $puedeIrASimit = false;
    foreach ($resoluciones as $resolucion) {
		
      if($resolucion->COL5 == '6' || $resolucion->COL5 == '8'){
        //buscando el recaudo
        $recaudoCount = RecaudoSimit::where('C10', '=', $resolucion->COL2)
                                      ->orWhere('C10', '=', $resolucion->COL7)
                                      ->orWhere('C15', '=', $resolucion->COL2)
                                      ->orWhere('C15', '=', $resolucion->COL7)
                                      ->orWhere('C16', '=', $resolucion->COL2)
                                      ->orWhere('C16', '=', $resolucion->COL7)
                                      ->count();
        if($recaudoCount > 0){
          $puedeIrASimit = true;
          $this->line("Recaudo: " . $recaudoCount. " Col2(". $resolucion->COL2 . ")Col7:(". $resolucion->COL7. ")cc:". $resolucion->COL9);
        } else {
          $puedeIrASimit = false;
           $this->line("Recaudo: " . $recaudoCount. " Col2(". $resolucion->COL2 . ")Col7:(". $resolucion->COL7. ")cc:". $resolucion->COL9);
        }
      } else {
        $puedeIrASimit = true;
      }
	  
      if($puedeIrASimit){
        $tmp = [];
        $consecutivo++;
        $total += $resolucion->COL16;

        $this->line("resolucion: " . $resolucion->COL2);
        $tmp['RESCONSECUTIVO'] = $consecutivo;
        $tmp['RESNUMERO'] = str_replace(',', '', $resolucion->COL2);		
        $tmp['RESNUMANT'] = str_replace(',', '', $resolucion->COL3);		
        $tmp['RESFECHA'] = str_replace(',', '', $resolucion->COL4);


        if($tipoResolucion=='rsi')
        {
         $tmp['RESTIPORES'] = 1; 
        }else
        {
        $tmp['RESTIPORES'] = str_replace(',', '', $resolucion->COL5);
        }

        $tmp['RESFHASTA'] = str_replace(',', '', $resolucion->COL6);		
        $tmp['RESCOMP'] = str_replace(',', '', $resolucion->COL7);
        $tmp['RESCOMPF'] = str_replace(',', '', $resolucion->COL8);		
        $tmp['RESNIPINFRAC'] = str_replace(',', '', $resolucion->COL9);		
        $tmp['RESTIPODOC'] = str_replace(',', '', $resolucion->COL10);		
        $tmp['RESNOMBE'] = str_replace(',', '', $resolucion->COL11);
        $tmp['RESAPELLIDO'] = str_replace(',', '', $resolucion->COL12);
        $tmp['RESDIRINFRACTOR'] = str_replace(',', '', $resolucion->COL13);
        $tmp['RESTELEINFRACTOR'] = str_replace(',', '', $resolucion->COL14);
        $tmp['RESIDCIUDAD'] = str_replace(',', '', $resolucion->COL15);		
        $tmp['RESVALOR'] = str_replace(',', '', $resolucion->COL16);
        if($resolucion->COL17 >= '0'){
          $tmp['RESVALAD'] = str_replace(',', '', $resolucion->COL17);
        }else{
          $tmp['RESVALAD'] = '0';
        }
        $tmp['FOTOMULTA'] = str_replace(',', '', $resolucion->COL18);
        $tmp['RESORGANISMO'] = str_replace(',', '', $resolucion->COL19);
        $tmp['RESCOMPOLCA'] = str_replace(',', '', $resolucion->COL20);
        $tmp['RESINFRACCION'] = str_replace(',', '', $resolucion->COL21);
        $tmp['RESVALINF'] = str_replace(',', '', $resolucion->COL22);
        $tmp['RESVALPAG'] = str_replace(',', '', $resolucion->COL16);
		
        if($resolucion->COL21 == 'F'){
          $tmp['GRADOALCOHOL'] = str_replace(',', '', $resolucion->COL24);
          $tmp['HORASCOMUNITARIAS'] = str_replace(',', '', $resolucion->COL25);
        }else{
          $tmp['GRADOALCOHOL'] = '';
          $tmp['HORASCOMUNITARIAS'] = '';
        }
       // $txt .= implode(',', $tmp) . "\n";
	   $tmp['clave'] = $organismo->clave;
	   $tmp['secretaria'] = $organismo->codigo;
	   //$tmp['usuario'] = '20228005';
	   $tmp['usuario'] = $organismo->usuario_simit; //'20228001';
	   
            $soapUrl = "http://172.18.164.200:8282/WSSimit/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint/";
			//$soapUrl = "https://www3.simit.org.co/simit-pruebas/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint/";
            $xml_post_string = '<soapenv:Envelope '.
                                 'xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" '.
                                 'xmlns:web="http://webservices.qxmultas.quipux.com.co" '.
                                 'xmlns:xsd="http://webservices.qxmultas.quipux.com.co/xsd">'.
                                   '<soapenv:Header/>'.
                                   '<soapenv:Body>'.
                                   '<web:cargaArchivoResolucion>' .
                                     '<web:resolucion>' .
                                '<xsd:consecutivoR>' . $tmp['RESCONSECUTIVO'] . '</xsd:consecutivoR>' .
                                '<xsd:numeroResolucion>' . $tmp['RESNUMERO'] . '</xsd:numeroResolucion>' .
                                '<xsd:numeroResolucionAnterior>' . $tmp['RESNUMANT'] . '</xsd:numeroResolucionAnterior>' .
                                '<xsd:fechaResolucion>' . $tmp['RESFECHA'] . '</xsd:fechaResolucion>' .
                                '<xsd:tipoR>' . $tmp['RESTIPORES'] . '</xsd:tipoR>' .
                                '<xsd:fechaHasta>' . $tmp['RESFHASTA'] . '</xsd:fechaHasta>' .					
                                '<xsd:numeroComparendo>' . $tmp['RESCOMP'] . '</xsd:numeroComparendo>' .
                                '<xsd:fechaComparendo>' . $tmp['RESCOMPF'] . '</xsd:fechaComparendo>' .	
                                '<xsd:idContraventor>' .  $tmp['RESNIPINFRAC'] . '</xsd:idContraventor>' .								
                                '<xsd:tipoD>' . $tmp['RESTIPODOC'] . '</xsd:tipoD>' .								
                                '<xsd:nombre>' . $tmp['RESNOMBE'] . '</xsd:nombre>' .
                                '<xsd:apellido>' . $tmp['RESAPELLIDO'] . '</xsd:apellido>' .
                                '<xsd:direccion>' . $tmp['RESDIRINFRACTOR'] . '</xsd:direccion>' .
                                '<xsd:telefono>' . $tmp['RESTELEINFRACTOR'] . '</xsd:telefono>' .								
                                '<xsd:idCiudad>' . $tmp['RESIDCIUDAD'] . '</xsd:idCiudad>' .								
                                '<xsd:valorTotalResolucion>' . $tmp['RESVALOR'] . '</xsd:valorTotalResolucion>' .
                                '<xsd:valorAdicionalResolucion>' . $tmp['RESVALAD'] . '</xsd:valorAdicionalResolucion>' .
                                '<xsd:fotoMulta>' . $tmp['FOTOMULTA'] . '</xsd:fotoMulta>' .								
                                '<xsd:codigoOrganismo>' . $tmp['RESORGANISMO'] . '</xsd:codigoOrganismo>' .
                                '<xsd:estadoResolucionPolca>' . $tmp['RESCOMPOLCA'] . '</xsd:estadoResolucionPolca>' .
                                '<xsd:codigoI1>' . $tmp['RESINFRACCION'] . '</xsd:codigoI1>' .								
                                '<xsd:valorInfraccionResolucion1>' . $tmp['RESVALINF'] . '</xsd:valorInfraccionResolucion1>' .								
                  '<xsd:valorPagarInfraccionResolucion1>' . $tmp['RESVALPAG'] . '</xsd:valorPagarInfraccionResolucion1>' .								
                                '<xsd:gradoAlcohol>' . $tmp['GRADOALCOHOL'] . '</xsd:gradoAlcohol>' .
                                '<xsd:horasComunitarias>' . $tmp['HORASCOMUNITARIAS'] . '</xsd:horasComunitarias>' .	
								
								'<xsd:clave>' . $tmp['clave'] . '</xsd:clave>' .  
                                '<xsd:secretaria>' . $tmp['secretaria'] . '</xsd:secretaria>' .
                                '<xsd:usuario>' . $tmp['usuario'] . '</xsd:usuario>' .
                                '</web:resolucion>' .
                                '</web:cargaArchivoResolucion>'.
                                '</soapenv:Body>'.
                                '</soapenv:Envelope>';
            $headers = array(
                              "Content-type: text/xml;charset=\"utf-8\"",
                              "Accept: text/xml",
                              "Cache-Control: no-cache",
                              "Pragma: no-cache",
            "SOAPAction: http://172.18.164.200:8181/WSSimit/services/WsCargaArchivos.WsCargaArchivosHttpsSoap11Endpoint",
                              "Content-length: ".strlen($xml_post_string),
                          ); //SOAPAction: your op URL

$this->info("Cargando ...".$xml_post_string);

            $url = $soapUrl;
//$this->line($xml_post_string);
            // PHP cURL  for https connection with auth
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_post_string); // the SOAP request
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

            // converting
            $response = curl_exec($ch);
            curl_close($ch);
            $response = html_entity_decode($response);

            // converting
            $response1 = str_replace('<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Body><ns:cargaArchivoResolucionResponse xmlns:ns="http://webservices.qxmultas.quipux.com.co"><ns:return><ArchivosTransito>','<body>',$response);
            $response2 = str_replace('</ArchivosTransito>',"",$response1);
            $response2 = str_replace('</ns:return></ns:cargaArchivoResolucionResponse></soapenv:Body></soapenv:Envelope>','</body>',$response2);
			$this->info("nueva linea-->".$response);
			$this->info("Recibiendo  ...");


if (!is_string($response2) || !strlen($response2)) {
    $this->error("Sin Respuesta Simit:"  ) ;
    $resolucion->error_simit = "Sin Respuesta Simit:"  ; 
    $resolucion->save();   
}else
{

            $xml = new SimpleXMLElement($response2);
            $json = json_encode($xml);
            $json = json_decode($json, true);
            if(isset($json['detalle']['idTipoError'])){
              $this->error($json['detalle']['descripcion']);
			  $resolucion->error_simit = $json['detalle']['descripcion']; 
              $resolucion->save();			  
			  
            }else{
              //dd($json);
              //$recaudo->fecha_descarga = Carbon::now();
			  $resolucion->error_simit = $json['detalle']['mensaje']. ' id: '.$json['encabezado']['consecutivoCarga'] ; 
			  $resolucion->confirmado_simit = 1; 
              $resolucion->save();
              $this->info($json['detalle']['mensaje']);
            }	   

}


      } // if $puedeIrASimit
	  
	  
	  
	  
    }//for

    
	
    }
}
