<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Illuminate\Support\Facades\Artisan;
use Carbon\Carbon;
use SimpleXMLElement;
use ZipArchive;
use App\Organismo;

class SimitWsCursos extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'simitws:cursos';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Cursos en base64 y se pasa a .zip';

    /**
     * @var SoapWrapper
     */
    protected $soapWrapper;

    /**
     * SoapController constructor.
     *
     * @param SoapWrapper $soapWrapper
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
		//'01/06/2016' $hoy
		//20228001

       //'fechaDesde' => '27/09/2019', 
       //'fechaHasta' => '01/10/2019',
	   		
	  $organismo = Organismo::first();
      $hoy = Carbon::now()->format('d/m/Y');
      $ante = Carbon::now()->subDay(25)->format('d/m/Y');
      $data = [
       'clave' => $organismo->clave,
       //'fechaDesde' => '01/03/2022', 
       //'fechaHasta' => '30/03/2022',
       'fechaDesde' => $ante, 
       'fechaHasta' => $hoy,       
       'secretariaRecaudo' => $organismo->codigo,
       'secretariaUsuario' => $organismo->codigo,
       'usuario' => $organismo->usuario_simit 
      ];
      $soapUrl = "https://www3.simit.org.co/Simit/services/WsConsultaCursoCia.WsConsultaCursoCiaHttpSoap11Endpoint/";
      $this->info($soapUrl);
      $xml_post_string = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:web="http://webservices.qxmultas.quipux.com.co" xmlns:xsd="http://webservices.qxmultas.quipux.com.co/xsd">'.
                             '<soapenv:Header/>'.
                             '<soapenv:Body>'.
                                '<web:consultaCia>'.                             
                                '<web:cursoCiaWs>'.
                                      '<xsd:clave>' . $data['clave'] . '</xsd:clave>'.
                                      '<xsd:fechaInicio>' . $data['fechaDesde'] . '</xsd:fechaInicio>'.
                                      '<xsd:fechaFin>' . $data['fechaHasta'] . '</xsd:fechaFin>'.
                                      '<xsd:secretaria>' . $data['secretariaRecaudo'] . '</xsd:secretaria>'.
                                      '<xsd:usuario>' . $data['usuario'] . '</xsd:usuario>'.
                                '</web:cursoCiaWs>'.
                                '</web:consultaCia>'.
                             '</soapenv:Body>'.
                          '</soapenv:Envelope>';
      $headers = array(
                        "Content-type: text/xml;charset=\"utf-8\"",
                        "Accept: text/xml",
                        "Cache-Control: no-cache",
                        "Pragma: no-cache",
                        "SOAPAction: $soapUrl",
                        "Content-length: ".strlen($xml_post_string),
                    ); //SOAPAction: your op URL

$this->info("Fecha:".$hoy."->".$ante);
$this->info($xml_post_string);

      // PHP cURL  for https connection with auth
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $soapUrl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
      curl_setopt($ch, CURLOPT_TIMEOUT, 30);
      curl_setopt($ch, CURLOPT_POST, true);
      curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_post_string); // the SOAP request
      curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

      // converting
      //$this->info("Consultando...".$soapUrl);
	  $this->info("Consultando...");
      $response = curl_exec($ch);
      curl_close($ch);
      $response = html_entity_decode($response);
     
//$this->info($response);




 // converting
$response2 = str_replace("<?xml version='1.0' encoding='utf-8'?>", "", $response);
  $response2 = str_replace('<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Body>', "", $response2);
  $response2 = str_replace('<ns:consultaCiaResponse xmlns:ns="http://webservices.qxmultas.quipux.com.co">', "", $response2);
  $response2 = str_replace('<ns:return xmlns:ax27="http://io.java/xsd" xmlns:ax212="http://webservices.qxmultas.quipux.com.co/xsd" xmlns:ax210="http://model.utilidades.qxmultas.quipux.com.co/xsd" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="ax212:ConsultaCiaService">','',$response2);
      /*$response2 = str_replace('<ns:return xmlns:ax224="http://webservices.qxmultas.quipux.com.co/xsd" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="ax224:RespuestaWsArchivo">', '', $response2);*/

      /*cuando viene con el archivo*/
      $response2 = str_replace('<ax212:codigoEstado>', '<body><codigoEstado>', $response2);
      $response2 = str_replace('<ax212:data>', '<archivo>', $response2);
      $response2 = str_replace('</ax212:data>', '</archivo>', $response2);
      $response2 = str_replace('<ax212:codigoEstado>', '<codigoEstado>', $response2);
      $response2 = str_replace('</ax212:codigoEstado>', '</codigoEstado>', $response2);
      $response2 = str_replace('<ax212:descripcion>', '<descripcion>', $response2);
      $response2 = str_replace('</ax212:descripcion>', '</descripcion>', $response2);
      $response2 = str_replace('<ax212:data xsi:nil="true" />', '', $response2);

      /*cuando viene sin el archivo*/
      /*$response2 = str_replace('<ax224:archivo xsi:nil="true" />', '<body>', $response2);
      $response2 = str_replace('<ax224:estadoRespuesta>', '<estadoRespuesta>', $response2);
      $response2 = str_replace('</ax224:estadoRespuesta>', '</estadoRespuesta>', $response2);
	  
      $response2 = str_replace('<ax224:respuesta>', '<respuesta>', $response2);
      $response2 = str_replace('</ax224:respuesta>', '</respuesta>', $response2);*/
	  
      $response2 = str_replace('</ns:return>', "", $response2);
      $response2 = str_replace('</ns:consultaCiaResponse></soapenv:Body></soapenv:Envelope>', '</body>', $response2);

//$this->info("nueva linea-->".$response2);

      $xml = new SimpleXMLElement($response2);
      $json = json_encode($xml);
      $json = json_decode($json, true);
      if(isset($json['codigoEstado'])){
        if($json['codigoEstado'] != 1){
          $this->info("Error:".$json['codigoEstado']);
        }else{
          $this->info("Convirtiendo a .zip...");
          $basePath = storage_path().'/app/simitws/'. Carbon::now()->format('Y-m-d'). '/';
          \File::makeDirectory($basePath, 0777, true, true);
          $file = $basePath.'rec_ext.zip';
          \File::put($basePath.'rec_ext.zip', base64_decode($json['archivo']));

          $this->info("Descomprimiendo...");
          $zip = new ZipArchive();
          $zip->open($file);
          $zip->extractTo($basePath);
          $zip->close();

          $this->info("Subiendo...");
          $organismo = \App\Organismo::first();
          Artisan::call('simit:cursos', [
              'filename' => 'cursoCia',
              'origen' => 'cursos',
              'ruta' => $basePath
          ]);
          $this->info(Artisan::output());
        }
      }else{
        $this->error("No se encontro una respuesta en el archivo.");
      }
    }
}
