<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Illuminate\Support\Facades\Artisan;
use Carbon\Carbon;
use SimpleXMLElement;
use ZipArchive;
use App\Organismo;

class SimitWsRecaudoExterno extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'simitws:recaudoexterno';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Recaudo externo en base64 y se pasa a .zip';

    /**
     * @var SoapWrapper
     */
    protected $soapWrapper;

    /**
     * SoapController constructor.
     *
     * @param SoapWrapper $soapWrapper
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
		//'01/06/2016' $hoy
		//20228001

       //'fechaDesde' => '27/09/2019', 
       //'fechaHasta' => '01/10/2019',
	   		
	  $organismo = Organismo::first();
      $hoy = Carbon::now()->format('d/m/Y');
      $ante = Carbon::now()->subDay(15)->format('d/m/Y');
      $data = [
       'clave' => $organismo->clave2,
       //'fechaDesde' => '01/02/2023', 
       //'fechaHasta' => '20/04/2023',
       'fechaDesde' => $ante, 
       'fechaHasta' => $hoy,       
       'secretariaRecaudo' => $organismo->codigo,
       'secretariaUsuario' => $organismo->codigo,
       'usuario' => $organismo->usuario_simit2 
      ];
      $soapUrl = config('myconfig.url_simit_generar_recaudo_externo');
      $xml_post_string = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:web="http://webservices.qxmultas.quipux.com.co" xmlns:xsd="http://webservices.qxmultas.quipux.com.co/xsd">'.
                             '<soapenv:Header/>'.
                             '<soapenv:Body>'.
                                '<web:generarRecaudoExterno>'.
                                   '<web:datosGenerarRecaudoExterno>'.
                                      '<xsd:clave>' . $data['clave'] . '</xsd:clave>'.
                                      '<xsd:fechaDesde>' . $data['fechaDesde'] . '</xsd:fechaDesde>'.
                                      '<xsd:fechaHasta>' . $data['fechaHasta'] . '</xsd:fechaHasta>'.
                                      '<xsd:secretariaRecaudo>' . $data['secretariaRecaudo'] . '</xsd:secretariaRecaudo>'.
                                      '<xsd:secretariaUsuario>' . $data['secretariaUsuario'] . '</xsd:secretariaUsuario>'.
                                      '<xsd:usuario>' . $data['usuario'] . '</xsd:usuario>'.
                                   '</web:datosGenerarRecaudoExterno>'.
                                '</web:generarRecaudoExterno>'.
                             '</soapenv:Body>'.
                          '</soapenv:Envelope>';
      $headers = array(
                        "Content-type: text/xml;charset=\"utf-8\"",
                        "Accept: text/xml",
                        "Cache-Control: no-cache",
                        "Pragma: no-cache",
                        "SOAPAction: $soapUrl",
                        "Content-length: ".strlen($xml_post_string),
                    ); //SOAPAction: your op URL

$this->info($soapUrl);
$this->info($xml_post_string);
$this->info("Fecha:".$hoy."->".$ante);

      // PHP cURL  for https connection with auth
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $soapUrl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
      curl_setopt($ch, CURLOPT_TIMEOUT, 30);
      curl_setopt($ch, CURLOPT_POST, true);
      //curl_setopt($ch, CURLOPT_SSLVERSION, 5);
      //curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
      curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
      curl_setopt($ch, CURLINFO_HEADER_OUT, true);

      curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_post_string); // the SOAP request
      curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

      // converting
      //$this->info("Consultando...".$soapUrl);
	  $this->info("Consultando...");
      $response = curl_exec($ch);
      //curl_close($ch);
      $response = html_entity_decode($response);

$info = curl_getinfo($ch);
//$cade='Took '. $info['total_time']. ' seconds to send a request to '. $info['url']. "\n";
$cade='header: '. $info['request_header'];

///   $this->info($cade) ;



/*
if (!curl_errno($ch)) {
  $info = curl_getinfo($ch);
  $cade= 'Took ', $info['total_time'], ' seconds to send a request to ', $info['url'], "\n";
  $this->info($error_msg);
}*/


if (curl_errno($ch)) {
    $error_msg = curl_error($ch);
    $this->info($error_msg);
}
curl_close($ch);

if (isset($error_msg)) {
    // TODO - Handle cURL error accordingly
}
     

//$this->info($response);
 // converting
      $response2 = str_replace('<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/"><soapenv:Body>', "", $response);
      $response2 = str_replace('<ns:generarRecaudoExternoResponse xmlns:ns="http://webservices.qxmultas.quipux.com.co">', "", $response2);
      $response2 = str_replace('<ns:return xsi:type="ax224:RespuestaWsArchivo" xmlns:ax224="http://webservices.qxmultas.quipux.com.co/xsd" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">','',$response2);
      $response2 = str_replace('<ns:return xmlns:ax224="http://webservices.qxmultas.quipux.com.co/xsd" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:type="ax224:RespuestaWsArchivo">', '', $response2);

      /*cuando viene con el archivo*/
      $response2 = str_replace('<ax224:archivo>', '<body><archivo>', $response2);
      $response2 = str_replace('</ax224:archivo>', '</archivo>', $response2);
      $response2 = str_replace('<ax224:estadoRespuesta>', '<estadoRespuesta>', $response2);
      $response2 = str_replace('</ax224:estadoRespuesta>', '</estadoRespuesta>', $response2);
      $response2 = str_replace('<ax224:respuesta xsi:nil="true" />', '', $response2);

      /*cuando viene sin el archivo*/
      $response2 = str_replace('<ax224:archivo xsi:nil="true" />', '<body>', $response2);
      $response2 = str_replace('<ax224:estadoRespuesta>', '<estadoRespuesta>', $response2);
      $response2 = str_replace('</ax224:estadoRespuesta>', '</estadoRespuesta>', $response2);
	  
      $response2 = str_replace('<ax224:respuesta>', '<respuesta>', $response2);
      $response2 = str_replace('</ax224:respuesta>', '</respuesta>', $response2);
	  
      $response2 = str_replace('</ns:return>', "", $response2);
      $response2 = str_replace('</ns:generarRecaudoExternoResponse></soapenv:Body></soapenv:Envelope>', '</body>', $response2);

//$this->info("nueva linea-->".$response2);

      $xml = new SimpleXMLElement($response2);
      $json = json_encode($xml);
      $json = json_decode($json, true);
      if(isset($json['estadoRespuesta'])){
        if($json['estadoRespuesta'] != 0){
          $this->info("Error:".$json['estadoRespuesta']);
        }else{
          $this->info("Convirtiendo a .zip...");
          $basePath = storage_path().'/app/simitws/'. Carbon::now()->format('Y-m-d'). '/';
          \File::makeDirectory($basePath, 0777, true, true);
          $file = $basePath.'rec_ext.zip';
          \File::put($basePath.'rec_ext.zip', base64_decode($json['archivo']));

          $this->info("Descomprimiendo...");
          $zip = new ZipArchive();
          $zip->open($file);
          $zip->extractTo($basePath);
          $zip->close();

          $this->info("Subiendo...");
          $organismo = \App\Organismo::first();
          Artisan::call('simit:recaudo', [
              'filename' => 'pagos'. $organismo->codigo .'rec',
              'origen' => 'externo',
              'ruta' => $basePath
          ]);
          $this->info(Artisan::output());
        }
      }else{
        $this->error("No se encontro una respuesta en el archivo.");
      }
    }
}
