<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Comparendo;
use App\ComparendoExpediente;
use App\ResolucionSimit;
use App\ComparendoNumeracionImpresion as Numeracion;
use Illuminate\Support\Facades\DB;
use Barryvdh\DomPDF\Facade as PDF;
use LynX39\LaraPdfMerger\PdfManage;

class TerminacionCobroPDF extends Command
{
  /**
   * The name and signature of the console command.
   *
   * @var string
   * php artisan mandamiento:start 0 c new no
   */
  protected $signature = 'cobro:terminacion {id_comparendo} {medio}';

  /**
   * The console command description.
   *
   * @var string
   */
  protected $description = 'Termina el proceso de cobro por desembargo';

  /**
  * variables de contenido de la tarea
  */
  protected $relacionContenido = '';
  protected $comparendopdf = '';
  protected $meses = [];
  protected $organismoNombreSecreteria = '';
  protected $organismoDireccion = '';
  protected $rutaImagenTop = '';
  protected $rutaFirma = '';
  protected $organismoNombreSecreterio = '';
 protected  $organismoMunicipio = '';
  /**
   * Create a new command instance.
   *
   * @return void
   */
  public function __construct()
  {
      parent::__construct();
  }

  /**
   * Execute the console command.
   *
   * @return mixed
   */
  public function handle()
  {
    $idComparendo = $this->argument('id_comparendo');
    $medio = $this->argument('medio');

    if($medio == "c"){
      $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      $this->rutaFirma = base_path() . '/public/images/firmamecanica.png';
    } else if($medio == "w"){
      $this->rutaImagenTop = base_path() . '/public/images/membrete_2018.png';
      $this->rutaFirma = base_path() . '/public/images/firmamecanica.png';
    }

    $rutaExpediente = \Config::get('myconfig.ruta_comparendo_expediente');

    $organismo = \App\Organismo::first();
    $this->organismoDireccion = $organismo->direccion . ' ' . $organismo->ciudad->nombre . ' - ' . $organismo->ciudad->departamento->nombre;
    $this->organismoNombreSecreteria = $organismo->secretaria_nombre;
    $this->organismoNombreSecreterio = $organismo->secretario_nombre;
    $this->organismoMunicipio = $organismo->municipio;

    $this->meses = array('Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio',
                   'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre');

    $convertidorNumerosALetras = new \NumberToLetterConverter();
    $resoluciones = null;

    $comparendo = Comparendo::where('id', '=', $idComparendo)->first();

    if(isset($comparendo->id)){
      $fecha = Carbon::now();
      //$fecha = Carbon::parse('2022-02-22');
      $sancion = ResolucionSimit::where('COL5', '=', '1')
                                ->where('COL7', '=', $comparendo->numero)
                                ->first();
      $mandamiento = ResolucionSimit::where('COL5', '=', '16')
                                    ->where('COL7', '=', $comparendo->numero)
                                    ->first();
      if(isset($mandamiento->id)){
        //numeracion de las resoluciones
        $numeracion = Numeracion::select(DB::raw("max(final) as final"))->where('id_tipo_evento', '26')->first();
        $ultimaNumeracion = $numeracion->final;
        $inicioNumeracion = $ultimaNumeracion + 1;

        $ultimaNumeracion++;
        $numeroReS = 'RTC-' . $ultimaNumeracion . '-' . $fecha->year;

        $resolucionDes = new ResolucionSimit();
        $resolucionDes->COL2 = $numeroReS;
        $resolucionDes->COL4 = $fecha->format('d/m/Y');
        $resolucionDes->COL5 = '266';
        $resolucionDes->COL7 = $sancion->COL7;
        $resolucionDes->COL8 = $sancion->COL8;
        $resolucionDes->COL9 = $sancion->COL9;
        $resolucionDes->COL10 = $sancion->COL10;
        $resolucionDes->COL11 = $sancion->COL11;
        $resolucionDes->COL12 = $sancion->COL12;
        $resolucionDes->COL13 = $sancion->COL13;
        $resolucionDes->COL15 = $sancion->COL15;
        $resolucionDes->COL16 = $sancion->COL16;
        $resolucionDes->COL17 = $sancion->COL17;
        $resolucionDes->COL18 = $sancion->COL18;
        $resolucionDes->COL19 = $sancion->COL19;
        $resolucionDes->COL20 = $sancion->COL20;
        $resolucionDes->COL21 = $sancion->COL21;
        $resolucionDes->COL22 = '0';
        $resolucionDes->COL23 = '0';
        $resolucionDes->confirmado_simit = '-1';
        $resolucionDes->save();

        $this->line("Actualizando Numeracion resolucion TERMINACION...");
        //actualizar la numeracion en un nuevo registro
        $numeracion = new Numeracion();
        $numeracion->prefijo = 'RTC';
        $numeracion->inicio = $inicioNumeracion;
        $numeracion->final = $ultimaNumeracion;
        $numeracion->id_tipo_evento = 26;//RESOLUCION DE terminacion cobro
        $numeracion->id_organismo = $organismo->id;
        $numeracion->id_paquete = 0;
        $numeracion->save();

        $fechaTerminacion = $fecha->day . ' de ' . $this->meses[$fecha->month - 1] . ' de ' . $fecha->year;

        $archivo = $numeroReS . '.pdf';

        $folder = $rutaExpediente . '/' . $comparendo->numero_expediente;
        \File::makeDirectory($folder, 0775, true, true);

        $prescripcion = $resolucionAcuerdo = ResolucionSimit::where('COL7', '=', $comparendo->numero)
                                            ->where('COL5', '=', '3')
                                            ->first();
        $writeTextoPrescripcion = false;
        if(isset($prescripcion->id)){
          $writeTextoPrescripcion = true;
        }

        $this->comparendopdf = view('coactivos.desembargo.terminacion_head_pdf',[
                                'organismoDireccion' => $this->organismoDireccion,
                                'organismoNombreSecreterio' => $this->organismoNombreSecreterio,
                                'organismoMunicipio' => $this->organismoMunicipio,
                                'rutaImagenTop' => $this->rutaImagenTop
                              ]);
        $mandamientopdf =  view('coactivos.desembargo.terminacion_pdf', [
                                'comparendo' => $comparendo,
                                'numero_resolucion' => $numeroReS,
                                'fechaGeneracionResolucion' => $fechaTerminacion,
                                'fechaResolucion' => $fecha->format('d/m/Y'),
                                'mandamiento' => $mandamiento,
                                'sancion' => $sancion,
                                'dias' => $fecha->day,
                                'mes' => $this->meses[$fecha->month - 1],
                                'anio' => $fecha->year,
                                'rutaFirma' => $this->rutaFirma,
                                'writeTextoPrescripcion' => $writeTextoPrescripcion,
                                'organismoNombreSecreteria' => $this->organismoNombreSecreteria,
                                'organismoNombreSecreterio' => $this->organismoNombreSecreterio,
                                'organismoMunicipio' => $this->organismoMunicipio
                              ]);

        $this->comparendopdf .= $mandamientopdf . '</body></html>';

        $pdf = PDF::loadHTML($this->comparendopdf)->setPaper('legal', 'portrait');
        $pdf->save($folder . '/' . $archivo);

        //creando el registro en expediente
        $expediente = new \App\ComparendoExpediente();
        $expediente->id_comparendo = $comparendo->id;
        $expediente->fecha_generacion = $fecha->format('Y-m-d');
        $expediente->nombre_documento = $numeroReS;
        $expediente->id_tipo_evento = 26;//terminacion de cobro
        $expediente->id_paquete = 0;
        $expediente->id_user = 4;
        $expediente->save();

        $comparendoActualizar = Comparendo::find($comparendo->id);
        $comparendoActualizar->id_tipo_evento = 5;//mandamiento de pago
        $comparendoActualizar->save();
        $this->line("terminacion impresa: " . $archivo);
      }
    }
  }
}
