<?php

namespace App\Console\Commands;

use App\Coactivo;
use Excel;
use Illuminate\Console\Command;

class morosos_crear_excel extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'coactivos:excel {ano}';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Genera un excel por cada año de morosos';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $headers = ['Placa', 'Año', 'Nombre', 'Documento', 'Direccion', 'Ciudad', 'Departamento', 'Fijo', 'Celular', 'Impuestos', 'Intereses', 'Honorarios', 'Sistematización', 'Total'];
        $data = [];
        $ano = $this->argument('ano');

        if($ano == 0){
            $filename = "cartera-morosa";
            if (file_exists(public_path("xls/cartera/" . $filename . ".xlsx"))) {
                unlink(public_path("xls/cartera/" . $filename . ".xlsx"));
            }
            Excel::create($filename, function ($excel) use ($headers, $ano) {
                $excel->sheet('Hoja 1', function ($sheet) use ($headers, $ano) {
                    $sheet->appendRow($headers);

                    Coactivo::orderBy('placa')->orderBy('documento')->orderBy('ano')->chunk(100, function ($items) use ($sheet) {
                        foreach ($items as $item) {
                            $this->line("AGREGANDO {$item->placa} - {$item->ano}...");
                            $tmp = [];
                            $tmp['placa'] = $item->placa;
                            $tmp['ano'] = $item->ano;
                            $tmp['nombre'] = $item->nombre;
                            $tmp['documento'] = $item->documento;
                            $tmp['direccion'] = $item->direccion;
                            $tmp['ciudad'] = $item->ciudad;
                            $tmp['departamento'] = $item->departamento;
                            $tmp['fijo'] = $item->fijo;
                            $tmp['celular'] = $item->celular;
                            $tmp['impuestos'] = $item->impuestos;
                            $tmp['intereses'] = $item->intereses;
                            $tmp['honorarios'] = $item->honorarios;
                            $tmp['sistematizacion'] = $item->sistematizacion;
                            $tmp['total'] = $item->total;

                            $sheet->appendRow($tmp);
                        }
                    });
                });
            })->save('xlsx', public_path("xls/cartera/"));
        }else{
            $filename = "cartera-morosa-{$ano}";

            $this->line("PROCESANDO AÑO {$ano}");
            $this->line("=========================================");

            if (file_exists(public_path("xls/cartera/" . $filename . ".xlsx"))) {
                unlink(public_path("xls/cartera/" . $filename . ".xlsx"));
            }

            Excel::create($filename, function ($excel) use ($headers, $ano) {
                $excel->sheet('Hoja 1', function ($sheet) use ($headers, $ano) {
                    $sheet->appendRow($headers);

                    Coactivo::where('ano', $ano)->chunk(100, function ($items) use ($sheet) {
                        foreach ($items as $item) {
                            $this->line("AGREGANDO {$item->placa}...");
                            $tmp = [];
                            $tmp['placa'] = $item->placa;
                            $tmp['ano'] = $item->ano;
                            $tmp['nombre'] = $item->nombre;
                            $tmp['documento'] = $item->documento;
                            $tmp['direccion'] = $item->direccion;
                            $tmp['ciudad'] = $item->ciudad;
                            $tmp['departamento'] = $item->departamento;
                            $tmp['fijo'] = $item->fijo;
                            $tmp['celular'] = $item->celular;
                            $tmp['impuestos'] = $item->impuestos;
                            $tmp['intereses'] = $item->intereses;
                            $tmp['honorarios'] = $item->honorarios;
                            $tmp['sistematizacion'] = $item->sistematizacion;
                            $tmp['total'] = $item->total;

                            $sheet->appendRow($tmp);
                        }
                    });
                });
            })->save('xlsx', public_path("xls/cartera/"));
            $this->line("");
        }




    }
}
