<?php

namespace App\Console;

use App\Console\Commands\EnvioMsjPersuasivo;
use App\Console\Commands\EnvioMsjPersuasivoCampana;
use App\Console\Commands\EnvioMsjVencimiento;
use App\Console\Commands\ActualizaComparendoSimit;
use App\Console\Commands\ActualizarImpuestos;
use App\Console\Commands\ActualizarSolicitudes;
use App\Console\Commands\CargarComparendosSimit;
use App\Console\Commands\CargarResolucionesSimit;
use App\Console\Commands\CargarRecaudo;
use App\Console\Commands\CargarCursos;
use App\Console\Commands\CargarCursosReprocesar;
use App\Console\Commands\CargarVehiculos;
use App\Console\Commands\ExtraerCilindrajes;
use App\Console\Commands\ExtraerLineas;
use App\Console\Commands\ExtraerMarcas;
use App\Console\Commands\ImpuestoHistorico;
use App\Console\Commands\morosos;
use App\Console\Commands\morosos_crear_excel;
use App\Console\Commands\MoverComparendoSimit;
use App\Console\Commands\ProcesarArchivo;
use App\Console\Commands\ResolucionSancionPdf;
use App\Console\Commands\RuntCargarCiudadanos;
use App\Console\Commands\RuntExportarCiudadanos;
use App\Console\Commands\PersuadirComparendo;
use App\Console\Commands\Sancion;
use App\Console\Commands\procesarPqr;
use App\Console\Commands\procesarCiudadano;
use App\Console\Commands\procesarReconocer;
use App\Console\Commands\SancionMasiva;
use App\Console\Commands\SancionEspecial;
use App\Console\Commands\AvisoSancionEspecial;
use App\Console\Commands\AvisoMandamientoEspecial;
use App\Console\Commands\AcuerdoPago;
use App\Console\Commands\CrearExpedienteMasivo;
use App\Console\Commands\SimitTxtResoluciones;
use App\Console\Commands\SimitWsRecaudoExterno;
use App\Console\Commands\SimitWsCargaRegistroRecaudo;
use App\Console\Commands\SimitWsCargaResolucion;
use App\Console\Commands\SimitWsCargaComparendo;
use App\Console\Commands\SimitWsCursos;
use App\Console\Commands\SimitWsDatacredito;
use App\Console\Commands\ResolucionesSimitMandamiento;
use App\Console\Commands\ResolucionesSimitMandamientoPDF;
use App\Console\Commands\EmbargoMandamientoPDF;
use App\Console\Commands\DesembargoMandamientoPDF;
use App\Console\Commands\ResolucionesSimitSancion;
use App\Console\Commands\DepuracionResoluciones;
use App\Console\Commands\TransaccionesToRecaudosSimit;
use App\Console\Commands\RecaudosSimitComparendos;
use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;
use App\Console\Commands\RecaudosSimitCartera;
use App\Console\Commands\RecaudosSimitCartera2;
use App\Console\Commands\CarteraConsolidada;
use App\Console\Commands\ResolucionSancion;
use App\Console\Commands\AcuerdosPago;
use App\Console\Commands\Apropiaciones;
use App\Console\Commands\ResolucionMandamiento;
use App\Console\Commands\DesembargoPorAcuerdoPDF;
use App\Console\Commands\NotificacionPersonalSancionPdf;
use App\Console\Commands\NotificacionValidaciones;
use App\Console\Commands\TerminacionCobroPDF;
use App\Console\Commands\DepuracionDesembargos;
use App\Console\Commands\AvisoMandamientoEspecial1;
use App\Console\Commands\ASanciona;

class Kernel extends ConsoleKernel
{
    /**
     * The Artisan commands provided by your application.
     *
     * @var array
     */
    protected $commands = [
        ExtraerLineas::class,
        ExtraerCilindrajes::class,
        ExtraerMarcas::class,
        ActualizarImpuestos::class,
        ImpuestoHistorico::class,
        morosos::class,
        morosos_crear_excel::class,
        CargarComparendosSimit::class,
        CargarResolucionesSimit::class,
        EnvioMsjPersuasivo::class,
        EnvioMsjPersuasivoCampana::class,
        EnvioMsjVencimiento::class,
        ActualizaComparendoSimit::class,
        ProcesarArchivo::class,
        MoverComparendoSimit::class,
        CargarRecaudo::class,
        CargarCursos::class,
        CargarCursosReprocesar::class,
        ResolucionSancionPdf::class,
        RuntCargarCiudadanos::class,
        RuntExportarCiudadanos::class,
        PersuadirComparendo::class,
        CargarVehiculos::class,
        Sancion::class,
        procesarPqr::class,
        procesarCiudadano::class,
        procesarReconocer::class,
        SancionMasiva::class,
        SancionEspecial::class,
        AvisoSancionEspecial::class,
        AvisoMandamientoEspecial::class,
        AcuerdoPago::class,
        CrearExpedienteMasivo::class,
        SimitTxtResoluciones::class,
        SimitWsRecaudoExterno::class,
        SimitWsCargaRegistroRecaudo::class,
        SimitWsCargaResolucion::class,
        SimitWsCargaComparendo::class,
        SimitWsCursos::class,
        SimitWsDatacredito::class,
        ResolucionesSimitMandamiento::class,
        ResolucionesSimitMandamientoPDF::class,
        ResolucionesSimitSancion::class,
        DepuracionResoluciones::class,
        EmbargoMandamientoPDF::class,
        TransaccionesToRecaudosSimit::class,
        RecaudosSimitComparendos::class,
	RecaudosSimitCartera::class,
	RecaudosSimitCartera2::class,
        CarteraConsolidada::class,
        ResolucionSancion::class,
        AcuerdosPago::class,
        Apropiaciones::class,
        ResolucionMandamiento::class,
        DesembargoPorAcuerdoPDF::class,
        DesembargoMandamientoPDF::class,
        NotificacionPersonalSancionPdf::class,
        NotificacionValidaciones::class,
        TerminacionCobroPDF::class,
        DepuracionDesembargos::class,
        AvisoMandamientoEspecial1::class,
        ASanciona::class,
        'App\Console\Commands\EspecialSanciones\ResolucionSancionPdfOfelia',
        'App\Console\Commands\EspecialSanciones\ResolucionMandamientoPdfOfelia',
        'App\Console\Commands\EspecialSanciones\AudienciasPdfJairsino',
        'App\Console\Commands\EspecialSanciones\AuxiliarFix',
        'App\Console\Commands\EspecialSanciones\FormatoAudienciasJairsino',
        'App\Console\Commands\EspecialSanciones\ResolucionAudienciasJairsino',
        'App\Console\Commands\Avisos\AvisoEspecial',
        'App\Console\Commands\EspecialSanciones\AvisoResReconstruccion',
        'App\Console\Commands\EspecialSanciones\CantDocumentos',
        'App\Console\Commands\EspecialSanciones\EstadosAudienciasJairsino',
    ];

    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {
        //$schedule->command(ProcesarArchivo::class)->everyMinute();
        //$schedule->command('sancion_masiva:start c old false 4')->dailyAt('17:20');
    }

    /**
     * Register the Closure based commands for the application.
     *
     * @return void
     */
    protected function commands()
    {
        require base_path('routes/console.php');
    }
}
