<?php

namespace App\Exports;

use App\RegistrosCatastro;

use Illuminate\Support\Facades\DB;
    
use Maatwebsite\Excel\Concerns\FromQuery;

use Maatwebsite\Excel\Concerns\Exportable;

use Maatwebsite\Excel\Concerns\WithHeadings;

class PostsExport implements FromQuery, WithHeadings
{
    /**
    * @return \Illuminate\Support\Collection
    */
    
    use Exportable;

    protected $input;

    function __construct($input) {
        $this->input = $input;
    }

    public function query() {
        if($this->input == 1){
            $data = RegistrosCatastro::select('predios.numero_predio', 'predios.matricula_inmobiliaria', 'persona.nombre_completo','persona.numero_identificacion','predios.direccion_predio','registros_catastro.avaluo', 'tarifas.valor_tarifa')
            ->join('predios', 'registros_catastro.id_predio', '=', 'predios.id')
            ->join('destinos_economicos', 'predios.destino_economico', '=', 'destinos_economicos.id')
            ->join('usuarios', 'registros_catastro.id_usuario', '=', 'usuarios.id')
            ->join('persona', 'usuarios.id_persona', '=', 'persona.id')
            ->join('tarifas', 'registros_catastro.id_tarifa', '=', 'tarifas.id')
            ->whereNull('predios.matricula_inmobiliaria')
            ->where('registros_catastro.eliminado', '0')
            ->where('persona.eliminado', '0')
            ->orderBy('persona.nombre_completo', 'ASC');
        }else if($this->input == 2){
            $data = RegistrosCatastro::select('predios.numero_predio', 'predios.matricula_inmobiliaria', 'persona.nombre_completo','persona.numero_identificacion','predios.direccion_predio','registros_catastro.avaluo', 'tarifas.valor_tarifa')
            ->join('predios', 'registros_catastro.id_predio', '=', 'predios.id')
            ->join('destinos_economicos', 'predios.destino_economico', '=', 'destinos_economicos.id')
            ->join('usuarios', 'registros_catastro.id_usuario', '=', 'usuarios.id')
            ->join('persona', 'usuarios.id_persona', '=', 'persona.id')
            ->join('tarifas', 'registros_catastro.id_tarifa', '=', 'tarifas.id')
            ->where('persona.numero_identificacion', 'LIKE', '0%')
            ->where('registros_catastro.eliminado', '0')
            ->where('persona.eliminado', '0')
            ->orderBy('persona.nombre_completo', 'ASC');
        }else if($this->input == 3){
            $data = RegistrosCatastro::select('predios.numero_predio', 'predios.matricula_inmobiliaria', 'persona.nombre_completo','persona.numero_identificacion','predios.direccion_predio','registros_catastro.avaluo', 'tarifas.valor_tarifa')
            ->join('predios', 'registros_catastro.id_predio', '=', 'predios.id')
            ->join('destinos_economicos', 'predios.destino_economico', '=', 'destinos_economicos.id')
            ->join('usuarios', 'registros_catastro.id_usuario', '=', 'usuarios.id')
            ->join('persona', 'usuarios.id_persona', '=', 'persona.id')
            ->join('tarifas', 'registros_catastro.id_tarifa', '=', 'tarifas.id')
            ->where('registros_catastro.avaluo', '0')
            ->where('registros_catastro.eliminado', '0')
            ->where('persona.eliminado', '0')
            ->orderBy('persona.nombre_completo', 'ASC');
        }else if($this->input == 4){
            $data = RegistrosCatastro::select('predios.numero_predio', 'predios.matricula_inmobiliaria', 'persona.nombre_completo','persona.numero_identificacion','predios.direccion_predio','registros_catastro.avaluo', 'tarifas.valor_tarifa')
            ->join('predios', 'registros_catastro.id_predio', '=', 'predios.id')
            ->join('destinos_economicos', 'predios.destino_economico', '=', 'destinos_economicos.id')
            ->join('usuarios', 'registros_catastro.id_usuario', '=', 'usuarios.id')
            ->join('persona', 'usuarios.id_persona', '=', 'persona.id')
            ->join('tarifas', 'registros_catastro.id_tarifa', '=', 'tarifas.id')
            ->where('predios.direccion_predio', 'LIKE', '*%')
            ->where('registros_catastro.eliminado', '0')
            ->where('persona.eliminado', '0')
            ->orderBy('persona.nombre_completo', 'ASC');
        }else{
            $data = RegistrosCatastro::select('predios.numero_predio', 'predios.matricula_inmobiliaria', 'persona.nombre_completo','persona.numero_identificacion','predios.direccion_predio','registros_catastro.avaluo', 'tarifas.valor_tarifa')
            ->join('predios', 'registros_catastro.id_predio', '=', 'predios.id')
            ->join('usuarios', 'registros_catastro.id_usuario', '=', 'usuarios.id')
            ->join('persona', 'usuarios.id_persona', '=', 'persona.id')
            ->join('tarifas', 'registros_catastro.id_tarifa', '=', 'tarifas.id')
            ->whereNull('predios.matricula_inmobiliaria')
            ->orWhere('persona.numero_identificacion', 'LIKE', '0%')
            ->orWhere('predios.direccion_predio', 'LIKE', '*%')
            ->where('registros_catastro.eliminado', '0')
            ->where('persona.eliminado', '0')
            ->orderBy('persona.nombre_completo', 'ASC');
        }

        return $data;
    }
    
    public function headings(): array{
        return [
            'NUMERO_DEL_PREDIO',
            'MATRICULA_INMOBILIARIA',
            'NOMBRE',
            'NUMERO_DOCUMENTO',
            'DIRECCION',
            'AVALUO',
            'TARIFA'
        ];
    }
}
