<?php

namespace App\Exports;

use App\RegistrosCatastro;

use Illuminate\Support\Facades\DB;
    
use Maatwebsite\Excel\Concerns\FromQuery;

use Maatwebsite\Excel\Concerns\Exportable;

use Maatwebsite\Excel\Concerns\WithHeadings;

class PostsExportMatricula implements FromQuery, WithHeadings
{
    /**
    * @return \Illuminate\Support\Collection
    */
    
    use Exportable;

    protected $input;

    function __construct($input) {
        $this->input = $input;
    }

    public function query() {
        if($this->input != 0){
            $data = RegistrosCatastro::select('predios.numero_predio', 'predios.matricula_inmobiliaria', 'persona.nombre_completo','persona.numero_identificacion','predios.direccion_predio','registros_catastro.vigencia',DB::raw('FORMAT(registros_catastro.avaluo, 2) as avaluo'),'tarifas.valor_tarifa',DB::raw('FORMAT(((registros_catastro.avaluo*tarifas.valor_tarifa)/1000), 2) as vpagar'),DB::raw('(CASE WHEN registros_catastro.pagado = 1 THEN "PAGADO" ELSE "NO PAGADO" END)'))
            ->join('predios', 'registros_catastro.id_predio', '=', 'predios.id')
            ->join('usuarios', 'registros_catastro.id_usuario', '=', 'usuarios.id')
            ->join('persona', 'usuarios.id_persona', '=', 'persona.id')
            ->join('tarifas', 'registros_catastro.id_tarifa', '=', 'tarifas.id')
            ->where('predios.matricula_inmobiliaria', 'LIKE', '%' . $this->input . '%')
            ->where('registros_catastro.eliminado', '0')
            ->where('persona.eliminado', '0')
            ->orderBy('predios.matricula_inmobiliaria', 'ASC')
            ->orderBy('registros_catastro.vigencia', 'DESC');
        }else{
            $data = RegistrosCatastro::select('predios.numero_predio', 'predios.matricula_inmobiliaria', 'persona.nombre_completo','persona.numero_identificacion','predios.direccion_predio','registros_catastro.vigencia',DB::raw('FORMAT(registros_catastro.avaluo, 2) as avaluo'),'tarifas.valor_tarifa',DB::raw('FORMAT(((registros_catastro.avaluo*tarifas.valor_tarifa)/1000), 2) as vpagar'),DB::raw('(CASE WHEN registros_catastro.pagado = 1 THEN "PAGADO" ELSE "NO PAGADO" END)'))
            ->join('predios', 'registros_catastro.id_predio', '=', 'predios.id')
            ->join('usuarios', 'registros_catastro.id_usuario', '=', 'usuarios.id')
            ->join('persona', 'usuarios.id_persona', '=', 'persona.id')
            ->join('tarifas', 'registros_catastro.id_tarifa', '=', 'tarifas.id')
            ->whereNull('predios.matricula_inmobiliaria')
            ->where('registros_catastro.eliminado', '0')
            ->where('persona.eliminado', '0')
            ->orderBy('predios.matricula_inmobiliaria', 'ASC')
            ->orderBy('registros_catastro.vigencia', 'DESC');
        }
        
        return $data;
    }
    
    public function headings(): array{
        return [
            'NUMERO_DEL_PREDIO',
            'MATRICULA_INMOBILIARIA',
            'NOMBRE',
            'NUMERO_DOCUMENTO',
            'DIRECCION',
            'VIGENCIA',
            'AVALUO',
            'TARIFA',
            'VALOR A PAGAR',
            'ESTADO'
        ];
    }
}
