<?php

namespace App\Exports;

use App\ComparendoVivo;
use App\Organismo;
use App\User;
use Maatwebsite\Excel\Concerns\FromCollection;
use Illuminate\Support\Collection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Illuminate\Support\Facades\DB;

class RecaudoExport implements FromCollection,WithHeadings
{
    /**
    * @return \Illuminate\Support\Collection
    */
    public function headings(): array
    {
        return [
            'id',
            'Nº documento',
            'Nombre y Apellido',
        ];
    }
    public function collection()
    {

		/*$movimientos = ComparendoVivo::where('porcentajeprontopago','>',0)
		               ->where('msjtelefono',0)->where('infractor_tipo_documento',281)->orderBy('id')->get();*/   

        $movimientos = DB::table('comparendos_vivos')
                 ->select('id', 'infractor_documento', 'infractor_nombre', 'infractor_apellido', DB::raw('count(*) as total'))
                 ->where('porcentajeprontopago','>',0)
                 ->where('msjtelefono',0)->where('infractor_tipo_documento',281)
                 ->groupBy('id','infractor_documento', 'infractor_nombre', 'infractor_apellido')
                 ->get();

		$organismo = \App\Organismo::first();

        $array = [];
        $collection = null;
        $i=0;
        foreach ($movimientos as $movimiento) {
            $i=$i+1;
            array_push($array, (object)array(
                'id' => $i,
                'infractor_documento' => $movimiento->infractor_documento,
                'nombre' => $movimiento->infractor_nombre . " ". $movimiento->infractor_apellido
            ));
        }

        $collection = new Collection($array);

        return $collection;
    }
}
