<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;

use Maatwebsite\Excel\Facades\Excel;
use App\User;
use App\Exports\UsersExport;

use App\Archivo;
use App\Base_Gravable;
use League\Csv\Reader;
use League\Csv\Statement;

use App\Auditoria;
use App\Coactivo;
use App\Cuenta;
use App\Destino;
use App\Egreso;
use App\Tarifa;
use App\Tramite;
use App\MovimientoBancario;
use App\Transaccion;
use App\Organismo;
use App\RecaudoSimit;
use App\TransaccionPorAprobar;
use Carbon\Carbon;
use DB;
use Illuminate\Support\Collection;
use MongoDB\Driver\Query;


class ExcelController extends Controller
{


    function importarBase()
    {
        $pendientes = Archivo::where('estado', 'pendiente')->get();
        return view('importar.cargar', ['pendientes' => $pendientes]);
    }

function cargarPost(Request $request)
    {
        if ($request->hasFile('archivo')) {
            $archivo = $request->file('archivo');
            $filename = "base.csv";
            $archivo->move('uploads', $filename);


            $csv = Reader::createFromPath(public_path('uploads/' . $filename), 'r');
            $stmt = (new Statement());
            $records = $stmt->process($csv);

            $c = 1;
            foreach ($records as $record) {
                if (count($record) < 2) {
                    //echo("{$c}. PROCESANDO REGISTRO DE CONTROL...");
                } else {
                    //echo("{$c}. PROCESANDO " . $record[1] . "...");


                    $j=0;
                    //for($i=1994;$i<2006;$i++)
                    for($i=1994+12;$i<2006+13;$i++)
                    {
                        $base = new Base_Gravable();

                        $base->base_id = $record[0];
                        $base->base_tipo = $record[1];

                        //if (!empty($record[2])) {
                        //    $comparendo->infraccion_fecha = Carbon::createFromFormat('d/m/Y', $record[2])->format("Y-m-d");
                        //}

                        $base->base_clase = $record[2];
                        $base->base_marca = $record[3];
                        $base->base_linea = $record[4];

                        $base->base_cilindraje = $record[5];
                        //$comparendo->fecha_descarga = Carbon::now();

                        //$base->base_modelo = $record[8+$j];
                        $base->base_modelo = $record[8+11+$j];
                        $base->base_ano = $i;
                        $j=$j+1;

                        //$comparendo->fuente = "masivo";

                        $base->save();
                    }

                        //$this->info("CREADO!");
                    
                }

                $c++;
            }


        $pendientes = Archivo::where('estado', 'pendiente')->get();
        return view('importar.cargar', ['pendientes' => $pendientes]);

        }
    }


    public function exportUsers() 
    {

        \Excel::create('recaudo', function($excel) {
            $excel->sheet('Excel sheet', function($sheet) {
                //otra opción -> $products = Product::select('name')->get();
                //$products = User::all(); 

            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);




               // $sheet->fromArray($movimientos);
$i=1;

if($tipo=="derechos" || $tipo=="")
{

                     $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-impuesto')
                    ->orderBy('created_at')
                    ->get(); 

$sheet->row($i, [
    'Derechos de Transito'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Año', 'Placa', 'Valor', 'Intereses', 'Honorarios',
     'Sistematización', 'Descuento', 'Recaudo'     
]);
$i=$i+1;

$t1=0;$t2=0;$t3=0;$t4=0;$t5=0;$t6=0;
foreach($movimientos as $index => $movimiento) {

                            foreach($movimiento->pagos as $pago)
                            {


                    $t11=$pago->pago_aplicado_impuestos + $pago->descuento_aplicado;
                    $t12=$pago->pago_aplicado_intereses;
                    $t13=$pago->pago_aplicado_honorarios;
                    $t14=$pago->pago_aplicado_sistematizacion;
                    $t15=$pago->descuento_aplicado;
                    $t16=$pago->pago_aplicado_impuestos + $pago->pago_aplicado_honorarios + $pago->pago_aplicado_sistematizacion + $pago->pago_aplicado_intereses;

$t1=$t1+$t11;
$t2=$t2+$t12;
$t3=$t3+$t13;
$t4=$t4+$t14;
$t5=$t5+$t15;
$t6=$t6+$t16;

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $pago->ano, strtoupper($pago->vehiculo->placa),
          $pago->pago_aplicado_impuestos + $pago->descuento_aplicado, $pago->pago_aplicado_intereses,
          $pago->pago_aplicado_honorarios, 
         $pago->pago_aplicado_sistematizacion,$pago->descuento_aplicado,
         $pago->pago_aplicado_impuestos + $pago->pago_aplicado_honorarios
         + $pago->pago_aplicado_sistematizacion 
         + $pago->pago_aplicado_intereses
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', ' ', $t1, $t2, $t3,
     $t4, $t5, $t6     
]);
$i=$i+1;


$i=$i+2;
}


if($tipo=="comparendos" || $tipo=="")
{



                 $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-comparendo')
                    ->orderBy('created_at')
                    ->get(); 

               // $sheet->fromArray($movimientos);

$sheet->row($i, [
    'Comparendos'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Tipo', 'Comparendo', 'Placa', 'Valor Comp.', 'Intereses', 'Honorarios',
     'Sistematización', 'Descuento', 'Recaudo'
]);
$i=$i+1;

$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;
foreach($movimientos as $index => $movimiento) {


                            foreach($movimiento->obtenerComparendosObj() as $comparendo)
                            {
                            $factura = json_decode($movimiento->factura, true);
            $valcompa =($movimiento->valor-$factura['intereses']-$factura['honorarios']
            -$factura['sistematizacion']+$comparendo->calcularDescuento()+$factura['campana_calculados']);


                    $t11=$valcompa;
                    $t12=$factura['intereses'];
                    $t13=$factura['honorarios'];
                    $t14=$factura['sistematizacion'];
                    $t15=$comparendo->calcularDescuento();
                    $t16=$movimiento->valor;

                    $t_1=$t_1+$t11;
                    $t_2=$t_2+$t12;
                    $t_3=$t_3+$t13;
                    $t_4=$t_4+$t14;
                    $t_5=$t_5+$t15;
                    $t_6=$t_6+$t16;

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $movimiento->etiqueta, $comparendo->numero_corto,
         $comparendo->vehiculo_placa, $valcompa, $factura['intereses'], $factura['honorarios'], 
         $factura['sistematizacion'],$comparendo->calcularDescuento(),$movimiento->valor
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', ' ', ' ', $t_1, $t_2, $t_3,
     $t_4, $t_5, $t_6     
]);
$i=$i+1;
               // $sheet->fromArray($movimientos);

$i=$i+2;
}



if($tipo=="tramites" || $tipo=="")
{


                 $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-tramite')
                    ->orderBy('created_at')
                    ->get(); 



$sheet->row($i, [
    'Tramites'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Tipo', 'Placa', 'Tramite', 'Tarifa', 'Sistematizacion', 'Lamina',
     'Placas', 'Ministerio', 'Runt', 'Recaudo'
]);
$i=$i+1;

$t__1=0;$t__2=0;$t__3=0;$t__4=0;$t__5=0;$t__6=0;$t__7=0;
foreach($movimientos as $index => $movimiento) {

$factura = json_decode($movimiento->factura, true);

$nomtramites = Tramite::where('id',$factura['tramite'])->get();
foreach($nomtramites as $nomtramite)
{
$tra=$nomtramite->nombre;
}

$tarifas = Tarifa::where('id',$factura['tarifa'])->get();

                    $subtotal = 0;
                     $iva = 0;

                            foreach($tarifas as $tarifa)
                            {
                            $slp=($tarifa->SISTEMATIZACION*$tarifa->UVT+$tarifa->LAMINA*$tarifa->UVT+$tarifa->PLACAS*$tarifa->UVT)/1.19;
                    $iva=$slp*0.19;     
                    $subtotal=$slp+$tarifa->MINISTERIO+ $tarifa->RUNT+$tarifa->TARIFA*$tarifa->UVT; 




                    $t11=$tarifa->TARIFA*$tarifa->UVT;
                    $t12=$tarifa->LAMINA*$tarifa->UVT;
                    $t13=$tarifa->PLACAS*$tarifa->UVT;
                    $t14=$tarifa->SISTEMATIZACION*$tarifa->UVT;
                    $t15=$tarifa->MINISTERIO;
                    $t16=$tarifa->RUNT;
                    $t17=$subtotal;

$t__1=$t__1+$t11;
$t__2=$t__2+$t14;
$t__3=$t__3+$t12;
$t__4=$t__4+$t13;
$t__5=$t__5+$t15;
$t__6=$t__6+$t16;
$t__7=$t__7+$t17;

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $movimiento->etiqueta, strtoupper($factura['placa']),
         strtoupper($tra), $tarifa->TARIFA*$tarifa->UVT, $tarifa->SISTEMATIZACION*$tarifa->UVT,
         $tarifa->LAMINA*$tarifa->UVT, $tarifa->PLACAS*$tarifa->UVT, 
         $tarifa->MINISTERIO,$tarifa->RUNT,$movimiento->valor
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', ' ', ' ', $t__1, $t__2, $t__3,
     $t__4, $t__5, $t__6, $t__7      
]);

}



                $sheet->setOrientation('landscape');
            });
        })->export('xls');


        //return Excel::download(new UsersExport, 'users.xlsx');

   }





public function exportPolca() 
    {

        \Excel::create('polca', function($excel) {
            $excel->sheet('Excel sheet', function($sheet) {
                //otra opción -> $products = Product::select('name')->get();
                //$products = User::all(); 

            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);




               // $sheet->fromArray($movimientos);
$i=1;


                 $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-comparendo')
                    ->orderBy('created_at')
                    ->get(); 

               // $sheet->fromArray($movimientos);

$sheet->row($i, [
    'Comparendos'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Tipo', 'Comparendo', 'Placa', 'Valor Comp.', 'Simit', 'Ett', 'Municipio', 'Polca', 'Intereses', 'Honorarios',
     'Sistematización', 'Descuento', 'Recaudo'
]);
$i=$i+1;

$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;$t_a=0;$t_b=0;$t_c=0;$t_d=0;
foreach($movimientos as $index => $movimiento) {


                            foreach($movimiento->obtenerComparendosObj() as $comparendo)
                            {
                            $factura = json_decode($movimiento->factura, true);
            $valcompa =($movimiento->valor-$factura['intereses']-$factura['honorarios']
            -$factura['sistematizacion']+$comparendo->calcularDescuento()+$factura['campana_calculados']);


                    $t11=$valcompa;
                    $t12=$factura['intereses'];
                    $t13=$factura['honorarios'];
                    $t14=$factura['sistematizacion'];
                    $t15=$comparendo->calcularDescuento();
                    $t16=$movimiento->valor;

                    $t_1=$t_1+$t11;
                    $t_2=$t_2+$t12;
                    $t_3=$t_3+$t13;
                    $t_4=$t_4+$t14;
                    $t_5=$t_5+$t15;
                    $t_6=$t_6+$t16;


$a=($valcompa-$comparendo->calcularDescuento())*0.1;
//$b=(($valcompa-$comparendo->calcularDescuento())+$factura['intereses']-$factura['campana_calculados'])*0.4;
$b=(($valcompa-$comparendo->calcularDescuento())-$factura['campana_calculados'])*0.4;
$c=($valcompa-$comparendo->calcularDescuento())*0.25;
$d=($valcompa-$comparendo->calcularDescuento())*0.25;

$t_a=$t_a+$a;
$t_b=$t_b+$b;
$t_c=$t_c+$c;
$t_d=$t_d+$d;

               

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $movimiento->etiqueta, $comparendo->numero_corto,
         $comparendo->vehiculo_placa, $valcompa, $a,$b,$c,$d,$factura['intereses'], $factura['honorarios'], 
         $factura['sistematizacion'],$comparendo->calcularDescuento(),$movimiento->valor
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', ' ', ' ', $t_1, $t_a, $t_b, $t_c, $t_d, $t_2, $t_3,
     $t_4, $t_5, $t_6     
]);

                $sheet->setOrientation('landscape');
            });
        })->export('xls');


        //return Excel::download(new UsersExport, 'users.xlsx');

   }




public function exportFiducia() 
    {

        \Excel::create('polca', function($excel) {
            $excel->sheet('Excel sheet', function($sheet) {
                //otra opción -> $products = Product::select('name')->get();
                //$products = User::all(); 

            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);




               // $sheet->fromArray($movimientos);
$i=1;


                 $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-comparendo')
                    ->orderBy('created_at')
                    ->get(); 

               // $sheet->fromArray($movimientos);

$sheet->row($i, [
    'Comparendos'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Tipo', 'Comparendo', 'Factura', 'Placa', 'Valor Comp.', 'Simit', 'Ett', 'Municipio', 'Polca', 'Intereses', 'Honorarios',
     'Sistematización', 'Descuento', 'Recaudo'
]);
$i=$i+1;

$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;$t_a=0;$t_b=0;$t_c=0;$t_d=0;
foreach($movimientos as $index => $movimiento) {


                            foreach($movimiento->obtenerComparendosObj() as $comparendo)
                            {
                            $factura = json_decode($movimiento->factura, true);
            $valcompa =($movimiento->valor-$factura['intereses']-$factura['honorarios']
            -$factura['sistematizacion']+$comparendo->calcularDescuento()+$factura['campana_calculados']);


                    $t11=$valcompa;
                    $t12=$factura['intereses'];
                    $t13=$factura['honorarios'];
                    $t14=$factura['sistematizacion'];
                    $t15=$comparendo->calcularDescuento();
                    $t16=$movimiento->valor;

                    $t_1=$t_1+$t11;
                    $t_2=$t_2+$t12;
                    $t_3=$t_3+$t13;
                    $t_4=$t_4+$t14;
                    $t_5=$t_5+$t15;
                    $t_6=$t_6+$t16;

/*
$a=($valcompa-$comparendo->calcularDescuento())*0.1;
$b=(($valcompa-$comparendo->calcularDescuento())+$factura['intereses']-$factura['campana_calculados'])*0.4;
//$b=(($valcompa-$comparendo->calcularDescuento())-$factura['campana_calculados'])*0.4;
$c=($valcompa-$comparendo->calcularDescuento())*0.25;
$d=($valcompa-$comparendo->calcularDescuento())*0.25;
*/

$a=($valcompa-$comparendo->calcularDescuento())*0.1;
$b=(($valcompa-$comparendo->calcularDescuento())+$factura['intereses']-$factura['campana_calculados'])*0.45;
$c=($valcompa-$comparendo->calcularDescuento())*0.225;
$c=  $c + ( $factura['intereses'] - ($factura['intereses']*0.45)  );
$d=($valcompa-$comparendo->calcularDescuento())*0.225;

$t_a=$t_a+$a;
$t_b=$t_b+$b;
$t_c=$t_c+$c;
$t_d=$t_d+$d;

               

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $movimiento->etiqueta, $comparendo->numero_corto,
         $movimiento->cns_factura,
         $comparendo->vehiculo_placa, $valcompa, $a,$b,$c,$d,$factura['intereses'], $factura['honorarios'], 
         $factura['sistematizacion'],$comparendo->calcularDescuento(),$movimiento->valor
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', ' ', ' ', ' ', $t_1, $t_a, $t_b, $t_c, $t_d, $t_2, $t_3,
     $t_4, $t_5, $t_6     
]);

                $sheet->setOrientation('landscape');
            });
        })->export('xls');


        //return Excel::download(new UsersExport, 'users.xlsx');

   }



}
