<?php

namespace App\Http\Controllers;

use App\ParamHonorario;
use App\ParamImpuesto;
use App\ParamInteres;
use Illuminate\Http\Request;
use Input;

class ControladorParametros extends Controller
{
    function honorarios(){
        $honorario = null;

        if(\Input::has('ano')){
            $honorario = ParamHonorario::where('ano', \Input::get('ano'))->first();
        }else{
            $honorario = ParamHonorario::orderBy('ano', 'DESC')->first();
        }

        $honorarios = ParamHonorario::orderBy('ano', 'DESC')->get();


        return view('parametros.honorarios', ['honorario' => $honorario, 'honorarios' => $honorarios]);
    }

    function actualizarHonorarios(Request $request, ParamHonorario $honorario){
        $honorario->valor = $request->valor;
        $honorario->calcular_sobre = $request->calcular_sobre;
        $honorario->save();

        \Session::flash('alert_text', 'Parámetros actualizados correctamente.');

        return \Redirect::back();
    }

    function intereses()
    {

        $valores = null;
        $ano = ParamHonorario::orderBy('ano', 'DESC')->first()->ano;

        if (\Input::has('ano')) {
            $ano = Input::get('ano');
        }

        $valores = ParamInteres::where('ano', $ano)->orderBy('mes')->get();
        $intereses = ParamInteres::orderBy('ano', 'DESC')->distinct('ano')->pluck('ano');

        return view('parametros.intereses', ['valores' => $valores, 'intereses' => $intereses, 'ano' => $ano]);
    }

    function actualizarIntereses(Request $request, $ano)
    {
        for($i = 1; $i<=12; $i++){
            $interes = ParamInteres::where('ano', $ano)->where('mes', $i)->first();
            $interes->valor = $request->get('interes')[$i-1];
            $interes->save();
        }

        \Session::flash('alert_text', 'Parámetros actualizados correctamente.');

        return \Redirect::back();
    }

    function impuestos()
    {
        $impuesto = null;

        if (\Input::has('param')) {
            $impuesto = ParamImpuesto::find(\Input::get('param'));
        } else {
            $impuesto = ParamImpuesto::orderBy('ano', 'DESC')->first();
        }

        $impuestos = ParamImpuesto::orderBy('ano', 'DESC')->orderBy('id_tipo')->get();

        return view('parametros.impuestos', ['impuesto' => $impuesto, 'impuestos' => $impuestos]);
    }

    function actualizarImpuestos(Request $request, ParamImpuesto $impuesto)
    {
        $impuesto->valor = $request->valor;
        $impuesto->save();

        \Session::flash('alert_text', 'Parámetros actualizados correctamente.');

        return \Redirect::back();
    }
}
