<?php

namespace App\Http\Controllers;
use Illuminate\Http\Request;

use Maatwebsite\Excel\Facades\Excel;
use App\User;
use App\Exports\UsersExport;

use App\Archivo;
use App\Base_Gravable;
use League\Csv\Reader;
use League\Csv\Statement;

use App\Auditoria;
use App\Coactivo;
use App\Cuenta;
use App\Destino;
use App\Egreso;
use App\Tramite;
use App\MovimientoBancario;
use App\Transaccion;
use App\Organismo;
use App\RecaudoSimit;
use App\ResolucionSimit;
use App\Comparendo;
use App\TransaccionPorAprobar;
use App\ComparendoVivo;
use App\ArchivoDatacredito;

use App\Empresas;
use App\EmpresaPlaca;

use Illuminate\Support\Facades\Session;
use App\Formu;

use Carbon\Carbon;
use DB;
use Illuminate\Support\Collection;
use MongoDB\Driver\Query;

use App\Http\Controllers\CajaController;
use App\ParamHonorario;

use App\Exports\DatacreditoExport;
use App\Exports\FormatoExport;
use App\Exports\Formato02Export;
use App\Exports\Formato03Export;
use App\Exports\Formato04Export;
use App\Exports\Formato05Export;
use App\Exports\BitacoraExport;
use App\Exports\Bitacora2Export;
use App\Exports\Bitacora3Export;
use App\Exports\Bitacora4Export;
use App\Exports\RecaudoExternoExport;

class ExcelController extends Controller
{


    function importarBase()
    {
        $pendientes = Archivo::where('estado', 'pendiente')->get();
        return view('importar.cargar', ['pendientes' => $pendientes]);
    }

function cargarPost(Request $request)
    {
        if ($request->hasFile('archivo')) {
            $archivo = $request->file('archivo');
            $filename = "base.csv";
            $archivo->move('uploads', $filename);


            $csv = Reader::createFromPath(public_path('uploads/' . $filename), 'r');
            $stmt = (new Statement());
            $records = $stmt->process($csv);

            $c = 1;
            foreach ($records as $record) {
                if (count($record) < 2) {
                    //echo("{$c}. PROCESANDO REGISTRO DE CONTROL...");
                } else {
                    //echo("{$c}. PROCESANDO " . $record[1] . "...");


                    $j=0;
                    //for($i=1994;$i<2006;$i++)
                    for($i=1994+12;$i<2006+13;$i++)
                    {
                        $base = new Base_Gravable();

                        $base->base_id = $record[0];
                        $base->base_tipo = $record[1];

                        //if (!empty($record[2])) {
                        //    $comparendo->infraccion_fecha = Carbon::createFromFormat('d/m/Y', $record[2])->format("Y-m-d");
                        //}

                        $base->base_clase = $record[2];
                        $base->base_marca = $record[3];
                        $base->base_linea = $record[4];

                        $base->base_cilindraje = $record[5];
                        //$comparendo->fecha_descarga = Carbon::now();

                        //$base->base_modelo = $record[8+$j];
                        $base->base_modelo = $record[8+11+$j];
                        $base->base_ano = $i;
                        $j=$j+1;

                        //$comparendo->fuente = "masivo";

                        $base->save();
                    }

                        //$this->info("CREADO!");
                    
                }

                $c++;
            }


        $pendientes = Archivo::where('estado', 'pendiente')->get();
        return view('importar.cargar', ['pendientes' => $pendientes]);

        }
    }


    public function exportUsers() 
    {


 return Excel::download(new RecaudoExport, 'recaudo.xls');
/*
 $fechaHoy = Carbon::now();

                        $ciudadano = new ArchivoDatacredito();
                        $ciudadano->nombre = $fechaHoy;
                        $ciudadano->tipo_archivo = ".xls";
                        $ciudadano->transito = $organismo->codigo;
                        $ciudadano->estado = 0;
                        $ciudadano->save();*/



        \Excel::create('recaudo', function($excel) {
            $excel->sheet('Excel sheet', function($sheet) {
                //otra opción -> $products = Product::select('name')->get();
                //$products = User::all(); 

            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);




               // $sheet->fromArray($movimientos);
$i=1;

if($tipo=="derechos" || $tipo=="")
{

                     $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-impuesto')
                    ->orderBy('created_at')
                    ->get(); 

$sheet->row($i, [
    'Derechos de Transito'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Año', 'Placa', 'Valor', 'Intereses', 'Honorarios',
     'Sistematización', 'Descuento', 'Recaudo'     
]);
$i=$i+1;

$t1=0;$t2=0;$t3=0;$t4=0;$t5=0;$t6=0;
foreach($movimientos as $index => $movimiento) {

                            foreach($movimiento->pagos as $pago)
                            {


                    $t11=$pago->pago_aplicado_impuestos + $pago->descuento_aplicado;
                    $t12=$pago->pago_aplicado_intereses;
                    $t13=$pago->pago_aplicado_honorarios;
                    $t14=$pago->pago_aplicado_sistematizacion;
                    $t15=$pago->descuento_aplicado;
                    $t16=$pago->pago_aplicado_impuestos + $pago->pago_aplicado_honorarios + $pago->pago_aplicado_sistematizacion + $pago->pago_aplicado_intereses;

$t1=$t1+$t11;
$t2=$t2+$t12;
$t3=$t3+$t13;
$t4=$t4+$t14;
$t5=$t5+$t15;
$t6=$t6+$t16;

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $pago->ano, strtoupper($pago->vehiculo->placa),
          $pago->pago_aplicado_impuestos + $pago->descuento_aplicado, $pago->pago_aplicado_intereses,
          $pago->pago_aplicado_honorarios, 
         $pago->pago_aplicado_sistematizacion,$pago->descuento_aplicado,
         $pago->pago_aplicado_impuestos + $pago->pago_aplicado_honorarios
         + $pago->pago_aplicado_sistematizacion 
         + $pago->pago_aplicado_intereses
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', ' ', $t1, $t2, $t3,
     $t4, $t5, $t6     
]);
$i=$i+1;


$i=$i+2;
}


if($tipo=="comparendos" || $tipo=="")
{



                 $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-comparendo')
                    ->orderBy('created_at')
                    ->get(); 

               // $sheet->fromArray($movimientos);

$sheet->row($i, [
    'Comparendos'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Tipo', 'Comparendo', 'Placa', 'Valor Comp.', 'Intereses', 'Honorarios',
     'Sistematización', 'Descuento', 'Recaudo'
]);
$i=$i+1;

$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;
foreach($movimientos as $index => $movimiento) {


                            foreach($movimiento->obtenerComparendosObj() as $comparendo)
                            {
                            $factura = json_decode($movimiento->factura, true);
            $valcompa =($movimiento->valor-$factura['intereses']-$factura['honorarios']
            -$factura['sistematizacion']+$comparendo->calcularDescuento()+$factura['campana_calculados']);


                    $t11=$valcompa;
                    $t12=$factura['intereses'];
                    $t13=$factura['honorarios'];
                    $t14=$factura['sistematizacion'];
                    $t15=$comparendo->calcularDescuento();
                    $t16=$movimiento->valor;

                    $t_1=$t_1+$t11;
                    $t_2=$t_2+$t12;
                    $t_3=$t_3+$t13;
                    $t_4=$t_4+$t14;
                    $t_5=$t_5+$t15;
                    $t_6=$t_6+$t16;

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $movimiento->etiqueta, $comparendo->numero_corto,
         $comparendo->vehiculo_placa, $valcompa, $factura['intereses'], $factura['honorarios'], 
         $factura['sistematizacion'],$comparendo->calcularDescuento(),$movimiento->valor
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', ' ', ' ', $t_1, $t_2, $t_3,
     $t_4, $t_5, $t_6     
]);
$i=$i+1;
               // $sheet->fromArray($movimientos);

$i=$i+2;
}



if($tipo=="tramites" || $tipo=="")
{


                 $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-tramite')
                    ->orderBy('created_at')
                    ->get(); 



$sheet->row($i, [
    'Tramites'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Tipo', 'Placa', 'Tramite', 'Tarifa', 'Sistematizacion', 'Lamina',
     'Placas', 'Ministerio', 'Runt', 'Recaudo'
]);
$i=$i+1;

$t__1=0;$t__2=0;$t__3=0;$t__4=0;$t__5=0;$t__6=0;$t__7=0;
foreach($movimientos as $index => $movimiento) {

$factura = json_decode($movimiento->factura, true);

$nomtramites = Tramite::where('id',$factura['tramite'])->get();
foreach($nomtramites as $nomtramite)
{
$tra=$nomtramite->nombre;
}

$tarifas = Tarifa::where('id',$factura['tarifa'])->get();

                    $subtotal = 0;
                     $iva = 0;

                            foreach($tarifas as $tarifa)
                            {
                            $slp=($tarifa->SISTEMATIZACION*$tarifa->UVT+$tarifa->LAMINA*$tarifa->UVT+$tarifa->PLACAS*$tarifa->UVT)/1.19;
                    $iva=$slp*0.19;     
                    $subtotal=$slp+$tarifa->MINISTERIO+ $tarifa->RUNT+$tarifa->TARIFA*$tarifa->UVT; 




                    $t11=$tarifa->TARIFA*$tarifa->UVT;
                    $t12=$tarifa->LAMINA*$tarifa->UVT;
                    $t13=$tarifa->PLACAS*$tarifa->UVT;
                    $t14=$tarifa->SISTEMATIZACION*$tarifa->UVT;
                    $t15=$tarifa->MINISTERIO;
                    $t16=$tarifa->RUNT;
                    $t17=$subtotal;

$t__1=$t__1+$t11;
$t__2=$t__2+$t14;
$t__3=$t__3+$t12;
$t__4=$t__4+$t13;
$t__5=$t__5+$t15;
$t__6=$t__6+$t16;
$t__7=$t__7+$t17;

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $movimiento->etiqueta, strtoupper($factura['placa']),
         strtoupper($tra), $tarifa->TARIFA*$tarifa->UVT, $tarifa->SISTEMATIZACION*$tarifa->UVT,
         $tarifa->LAMINA*$tarifa->UVT, $tarifa->PLACAS*$tarifa->UVT, 
         $tarifa->MINISTERIO,$tarifa->RUNT,$movimiento->valor
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', ' ', ' ', $t__1, $t__2, $t__3,
     $t__4, $t__5, $t__6, $t__7      
]);

}



                $sheet->setOrientation('landscape');
            });
        })->export('xls');


        //return Excel::download(new UsersExport, 'users.xlsx');

   }


    public function exportExterno() 
    {

        \Excel::create('externo', function($excel) {
            $excel->sheet('Excel sheet', function($sheet) {
                //otra opción -> $products = Product::select('name')->get();
                //$products = User::all(); 

            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);




               // $sheet->fromArray($movimientos);
$i=1;



                $fe="CONCAT(substr(c2,7,4),'-',substr(c2,4,2),'-',substr(c2,1,2))";
                $movimientos =  RecaudoSimit::where(DB::raw($fe), '>=', $fecha_inicial)
                    ->where(DB::raw($fe), '<=', $fecha_final )
                    ->where('fuente', 'externo')
                    ->orderBy(DB::raw($fe))
                    ->get();

                 /*$movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-comparendo')
                    ->orderBy('created_at')
                    ->get(); */

               // $sheet->fromArray($movimientos);

$sheet->row($i, [
    'Externo'
]);
$i=$i+1;

   

$sheet->row($i, [
    'Fecha','Infra', 'Resolucion/Comparendo/cc', 'Valor Comp', 'Simit', 'Ett', 'Municipio', 'Polca',
     'Intereses', 'Supuesto', 'Honorarios', 'Sistematización', 'Descuento', '% desc', 'Recaudo', 'Diferencia'
]);
$i=$i+1;

$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;$t_a=0;$t_b=0;$t_c=0;$t_d=0;$t_diferencia=0;

$honorario=ParamHonorario::orderby('id', 'desc')->first();

foreach($movimientos as $index => $movimiento) {

            $hono=0;
            $inte=0;
            $inte_supuesto=0;
            $compa=0;
            $descu=0;
            $campana=0;
            $campa=0;
            $siste=0;
            $compare="";
            $no_compa="";
            $infra="";
            $cc="";

  $co=\App\Comparendo::where('numero', $movimiento->C16)->orwhere('numero', $movimiento->C10)->get();
    foreach($co as $comparendo){
                $compa = $comparendo->valor;
                if($comparendo->valor>$movimiento->C7)
                {
                $descu=$comparendo->valor - $movimiento->C7;
                }else
                {
                    $inte = $movimiento->C7-$comparendo->valor;
                }
                $no_compa = $comparendo->numero;
                $infra = $comparendo->infraccion_fecha;
                $cc = $comparendo->infractor_documento;
            }
           $fecha_pago="";

            $c=\App\ResolucionSimit::where('COL2', $movimiento->C10)->get();
            foreach($c as $resol){
                if($no_compa=="")
                {
                $no_compa = $resol->COL7;
                }
            }

        $intereses_calculados2=0;
        $intereses_calculados=0;
        $campana_calculados =0;
        $valor_honorario=0;
        $valor_sistematizacion=0;  
        $tp ="";  
        $fecha_inicial="";
            
 $co=\App\Comparendo::where('numero', $no_compa)->get();     
  foreach($co as $comparendo)
  {  
            foreach($comparendo->obtenerResolucion() as $recaudo){      
                $compare = $recaudo->COL7;
                $cc = $recaudo->COL9;
                $c=\App\ResolucionSimit::where('COL7', $no_compa)->where('COL5', 1)->get();
                $fecha_inicial=$recaudo->COL4;
                $val_compa=$recaudo->COL23;
                foreach($c as $resol){
                    $fecha_inicial=$resol->COL4;
                    $val_compa=$resol->COL23;
                }


                 $fecha_pago=substr($movimiento->C4,6,4)."-".substr($movimiento->C4,3,2)."-".substr($movimiento->C4,0,2);


               if($recaudo->COL5=="1" || $recaudo->COL5=="270" 
                || $recaudo->COL5=="16"  || $recaudo->COL5=="17")
                {

                    $intereses_calculados = CajaController::calcularInteresesFecha($fecha_inicial,$val_compa,0,$fecha_pago);
        
                    $sw_f=0;
                         if(substr($comparendo->infracciones,0,1)=="F")
                          {
                              $sw_f=1;
                           }

                    if($fecha_pago>="2019-04-09" && $fecha_pago<="2019-10-31" && $sw_f==0){
                       $campana =($intereses_calculados * 70/100); 
                       $campa=70;
                      }

                        if($fecha_pago>="2018-10-31" && $fecha_pago<="2018-11-15")
                        {
                       $campana =($intereses_calculados * 25/100); 
                       $campa=25;
                        }




                    $descu=0;

                        //$comparendo->intereses=$intereses_calculados;       
                       $valor_honorario2 = $honorario->valor * ($intereses_calculados*1 + $val_compa*1)/100;
                       //$comparendo->campana=$campana;


                               
                               if( $recaudo->COL5=="16"  || $recaudo->COL5=="17")
                               {
                                   //$valor_sistematizacion=$sistematizacion->valor;
                                   //$comparendo->honorarios=$valor_honorario2;
                                   $valor_honorario=$valor_honorario2;
                               }


                               
                               //$comparendo->sistematizacion=$valor_sistematizacion;

                }

                     $tp =$recaudo->COL5;
                     $compa = $val_compa;
                     //$hono = $recaudo->COL17;
                     $inte_supuesto = $movimiento->C7-$val_compa;

                     $hono = $valor_honorario;
                     $inte = $intereses_calculados;

            }
  }

                    $t11=$compa;
                    $t12=$inte;
                    $t13=$hono;
                    $t14=$siste;
                    $t15=$descu+$campana;
                    $t16=$movimiento->C7;

$t_1=$t_1+$t11;
$t_2=$t_2+$t12;
$t_3=$t_3+$t13;
$t_4=$t_4+$t14;
$t_5=$t_5+$t15;
$t_6=$t_6+$t16;

$organismo = Organismo::first();

$a=($compa+$inte-$descu-$campana)*0.1;
$b=(($compa-$descu)+$inte-$campana)*$organismo->porcentajeett;
//$cb="((".$valcompa."-".$comparendo->calcularDescuento().")+".$factura['intereses']."-".$factura['campana_calculados'].")*0.45";
//$c=($compa-$descu)*0.2239;
//$c=  $c + ( $inte - ($inte*0.4522)  );
//$d=($compa-$descu)*0.2239;
$c=($compa-$descu+$inte- $campana -$a - $b)/2;
$d=($compa-$descu+$inte- $campana -$a - $b)/2;

$t_a=$t_a+$a;
$t_b=$t_b+$b;
$t_c=$t_c+$c;
$t_d=$t_d+$d;

$diferencia=$intereses_calculados - $inte_supuesto - $campana ;
$t_diferencia=$t_diferencia+$diferencia;



    $sheet->row($i, [
         $movimiento->C2,$infra, $no_compa. "/". $compare . "/". $cc  . "/RS=". $fecha_inicial, $compa , $a, $b, $c, $d, 
         $inte, $inte_supuesto, $hono,  $siste,
         $descu, $campana, $movimiento->C7, $diferencia
    ]); 
    $i=$i+1;

                              

}//end ifor 

 


$sheet->row($i, [
    'Total', ' ', ' ', $t_1, $t_a, $t_b, $t_c, $t_d, $t_2, ' ',$t_3, $t_4, $t_5, ' ', $t_6, $t_diferencia    
]);
$i=$i+1;
               



                $sheet->setOrientation('landscape');
            });
        })->export('xls');


        //return Excel::download(new UsersExport, 'users.xlsx');

   }


public function exportPolca() 
    {

        \Excel::create('polca', function($excel) {
            $excel->sheet('Excel sheet', function($sheet) {
                //otra opción -> $products = Product::select('name')->get();
                //$products = User::all(); 

            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);




               // $sheet->fromArray($movimientos);
$i=1;


                 $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-comparendo')
                    ->orderBy('created_at')
                    ->get(); 

               // $sheet->fromArray($movimientos);

$sheet->row($i, [
    'Comparendos'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Comparendo', 'Valor Comp', 'Pago Comp. Apli', 'Simit', 'Ett', 'Municipio', 'Polca', 
    'Intereses', 'Pago Int. Apli', 'Honorarios',
     'Sistematización', 'Descuento', 'Recaudo'
]);
$i=$i+1;

$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;$t_a=0;$t_b=0;$t_c=0;$t_d=0;$t_pca=0;$t_pia=0;
foreach($movimientos as $index => $movimiento) {


                            foreach($movimiento->obtenerComparendosObj() as $comparendo)
                            {
                            $factura = json_decode($movimiento->factura, true);
            $valcompa =($movimiento->valor-$factura['intereses']-$factura['honorarios']
            -$factura['sistematizacion']+$comparendo->calcularDescuento()
            +$factura['campana_calculados']+$factura['campana2_calculados']);


                    $t11=$valcompa;
                    $t12=$factura['intereses'];
                    $t13=$factura['honorarios'];
                    $t14=$factura['sistematizacion'];
                    $t15=$comparendo->calcularDescuento();
                    $t16=$movimiento->valor;

$t_1=$t_1+$t11;
$t_2=$t_2+$t12;
$t_3=$t_3+$t13;
$t_4=$t_4+$t14;
$t_5=$t_5+$t15;
$t_6=$t_6+$t16;

$organismo = Organismo::first();

$pca=$valcompa - $factura['campana2_calculados'] -$comparendo->calcularDescuento();
$pia=$factura['intereses'] - $factura['campana_calculados'];

$a=($pca)*0.1;
$b=($pca + $pia - $a)*$organismo->porcentajeett;

$d=(  $pca - $a - (($pca-$a)*$organismo->porcentajeett)  )/2;
$c=($pca + $pia -$a - $b -$d);


$t_a=$t_a+$a;
$t_b=$t_b+$b;
$t_c=$t_c+$c;
$t_d=$t_d+$d;
$t_pca=$t_pca+$pca;
$t_pia=$t_pia+$pia;

               

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $comparendo->numero_corto,
          round($valcompa),round($pca), round($a),round($b),round($c),round($d),
          round($factura['intereses']), round($pia), round($factura['honorarios']), 
         $factura['sistematizacion'],$comparendo->calcularDescuento(),$movimiento->valor
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', round($t_1), round($t_pca), round($t_a), round($t_b+($t_b*19/100)), round($t_c), 
        round($t_d), round($t_2), round($t_pia), round($t_3), round($t_4), round($t_5), round($t_6)     
]);

                $sheet->setOrientation('landscape');
            });
        })->export('xls');


        //return Excel::download(new UsersExport, 'users.xlsx');

   }




public function exportFiducia() 
    {

        \Excel::create('polca', function($excel) {
            $excel->sheet('Excel sheet', function($sheet) {
                //otra opción -> $products = Product::select('name')->get();
                //$products = User::all(); 

            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);




               // $sheet->fromArray($movimientos);
$i=1;


                 $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-comparendo')
                    ->orderBy('created_at')
                    ->get(); 

               // $sheet->fromArray($movimientos);

$sheet->row($i, [
    'Comparendos'
]);
$i=$i+1;
$sheet->row($i, [
    'Fecha', 'Tipo', 'Comparendo', 'Factura', 'Placa', 'Valor Comp.', 'Simit', 'Ett', 'Municipio', 'Polca', 'Intereses', 'Honorarios',
     'Sistematización', 'Descuento', 'Recaudo', 'Reportado'
]);
$i=$i+1;

$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;$t_a=0;$t_b=0;$t_c=0;$t_d=0;
foreach($movimientos as $index => $movimiento) {


                            foreach($movimiento->obtenerComparendosObj() as $comparendo)
                            {
                            $factura = json_decode($movimiento->factura, true);
            $valcompa =($movimiento->valor-$factura['intereses']-$factura['honorarios']
            -$factura['sistematizacion']+$comparendo->calcularDescuento()+$factura['campana_calculados']);


                    $t11=$valcompa;
                    $t12=$factura['intereses'];
                    $t13=$factura['honorarios'];
                    $t14=$factura['sistematizacion'];
                    $t15=$comparendo->calcularDescuento()+$factura['campana_calculados'];
                    $t16=$movimiento->valor;

                    $t_1=$t_1+$t11;
                    $t_2=$t_2+$t12;
                    $t_3=$t_3+$t13;
                    $t_4=$t_4+$t14;
                    $t_5=$t_5+$t15;
                    $t_6=$t_6+$t16;

/*
$a=($valcompa-$comparendo->calcularDescuento())*0.1;
$b=(($valcompa-$comparendo->calcularDescuento())+$factura['intereses']-$factura['campana_calculados'])*0.4;
//$b=(($valcompa-$comparendo->calcularDescuento())-$factura['campana_calculados'])*0.4;
$c=($valcompa-$comparendo->calcularDescuento())*0.25;
$d=($valcompa-$comparendo->calcularDescuento())*0.25;
*/

$a=($valcompa-$comparendo->calcularDescuento())*0.1;
$b=(($valcompa-$comparendo->calcularDescuento())+$factura['intereses']-$factura['campana_calculados'])*0.4522;
$c=($valcompa-$comparendo->calcularDescuento())*0.225;
$c=  $c + ( $factura['intereses'] - ($factura['intereses']*0.4522)  );
$d=($valcompa-$comparendo->calcularDescuento())*0.225;

$t_a=$t_a+$a;
$t_b=$t_b+$b;
$t_c=$t_c+$c;
$t_d=$t_d+$d;

$webs = \App\ReporteWebService::where('no_operacion', $movimiento->cns_factura)
                                    ->where('msj', ' carga exitosa ')->get();
            $reportado=0;
            foreach($webs as $web){
                $reportado = $web->valor;
            }               

    $sheet->row($i, [
         $movimiento->created_at->format('Y-m-d'), $movimiento->etiqueta, $comparendo->numero_corto,
         $movimiento->cns_factura,
         $comparendo->vehiculo_placa, $valcompa, $a,$b,$c,$d,$factura['intereses'], $factura['honorarios'], 
         $factura['sistematizacion'],($comparendo->calcularDescuento()+$factura['campana_calculados']),
         $movimiento->valor,$reportado
    ]); 
    $i=$i+1;

                              }

}//end ifor 

$sheet->row($i, [
    'Total', ' ', ' ', ' ', ' ', $t_1, $t_a, $t_b, $t_c, $t_d, $t_2, $t_3,
     $t_4, $t_5, $t_6     
]);

                $sheet->setOrientation('landscape');
            });
        })->export('xls');


        //return Excel::download(new UsersExport, 'users.xlsx');

   }


public function exportResoluciones() 
    {

        \Excel::create('resoluciones', function($excel) {
            $excel->sheet('Excel sheet', function($sheet) {
                //otra opción -> $products = Product::select('name')->get();
                //$products = User::all(); 

            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[0] = $fechaArray[0]->format('d/m/Y');
            $fechaArray[1] = new Carbon($fecha_final);
            $fechaArray[1] = $fechaArray[1]->format('d/m/Y');




               // $sheet->fromArray($movimientos);
$i=1;


        $movimientos = ResolucionSimit::where('COL5', $tipo)->
        whereRaw("STR_TO_DATE(COL4,'%d/%m/%Y') >= '".$fecha_inicial."'")->
        whereRaw("STR_TO_DATE(COL4,'%d/%m/%Y') <= '".$fecha_final."'")->get();   

                 /*$movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->where('etiqueta',  'pago-comparendo')
                    ->orderBy('created_at')
                    ->get(); */

               // $sheet->fromArray($movimientos);


$sheet->row($i, [
    'Resoluciones'
]);
$i=$i+1;
$sheet->row($i, [
     'Fecha', 'Hora', 'Cedula', 'Fecha Resol', 'Resolucion', 'Fecha Compa', 'Comparendo', 'Valor Compa',
     'Sancion', 'Fecha Sanc', 'Valor', 'Infraccion'
]);
$i=$i+1;

$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;$t_a=0;$t_b=0;$t_c=0;$t_d=0;
foreach($movimientos as $movimiento) {

                                    $i=$i+1;
                                    $compa = Comparendo::where('numero', $movimiento->COL7)->get();
                                    $infra="";
                                    $valorcompa="";
                                    $fechacompa="";
                                    $expedi="";
                                    foreach($compa as $comparendo)
                                        { 
                                            $infra=$comparendo->infracciones;
                                            $valorcompa=$comparendo->valor;
                                            $fechacompa=$comparendo->infraccion_fecha;
                                            $expedi=$comparendo->numero_expediente;
                                        }

                                    $sanci = ResolucionSimit::where('COL7', $movimiento->COL7)->
                                    where('COL5', 1)->get();
                                    $sancion="";
                                    $fechasancion="";
                                    foreach($sanci as $san)
                                        { 
                                            $sancion=$san->COL2;
                                            $fechasancion=$san->COL4;
                                        }

$link="#";
if($movimiento->COL5!="6" && $movimiento->COL5!="267")
{
 $link=config('myconfig.link_documentos').$expedi.'/'.$movimiento->COL2.'.pdf';
}                                       
        

    $sheet->row($i, [
        $movimiento->created_at->format('Y-m-d'), $movimiento->created_at->format('H:i'),
         $movimiento->COL9,
         $movimiento->COL4 , $movimiento->COL2, $fechacompa,$movimiento->COL7,$valorcompa,$sancion,$fechasancion,
          $movimiento->COL16 , $infra
    ]); 
   // $i=$i+1;


}//end ifor 


                $sheet->setOrientation('landscape');
            });
        })->export('xls');


        //return Excel::download(new UsersExport, 'users.xlsx');

   }


public function exportDatacredito() 
    {

$tipo = \Input::get('tipo');
 return Excel::download(new DatacreditoExport($tipo), 'datacredito.xls');

 $fechaHoy = Carbon::now();

                        $ciudadano = new ArchivoDatacredito();
                        $ciudadano->nombre = $fechaHoy;
                        $ciudadano->tipo_archivo = ".xls";
                        $ciudadano->transito = $organismo->codigo;
                        $ciudadano->estado = 0;
                        $ciudadano->save();


   }


public function exportFormato() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');

        $nombre="RNET_".$organismo->codigo."_TOP_".$fe;

        $fechaHoy = Carbon::now();

              /*          $ciudadano = new ArchivoDatacredito();
                        $ciudadano->nombre = $fechaHoy;
                        $ciudadano->tipo_archivo = ".xls";
                        $ciudadano->transito = $organismo->codigo;
                        $ciudadano->estado = 0;
                        $ciudadano->save();*/

/*
                $sheet->setOrientation('landscape');
            });
        })->export('txt');
*/

        return Excel::download(new FormatoExport, $nombre.'.csv');

   }



public function export02Formato() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');

        $nombre="RNET_".$organismo->codigo."_EMP_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new Formato02Export, $nombre.'.csv');

   }


public function export03Formato() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');

        $nombre="RNET_".$organismo->codigo."_DIR_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new Formato03Export, $nombre.'.csv');

   }


public function export04Formato() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');

        $nombre="RNET_".$organismo->codigo."_HAB_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new Formato04Export, $nombre.'.csv');

   }

public function export05Formato() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');

        $nombre="RNET_".$organismo->codigo."_CAG_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new Formato05Export, $nombre.'.csv');

   }


public function export06Formato() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');

        $nombre="RNET_".$organismo->codigo."_EMP_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new Formato06Export, $nombre.'.csv');

   }


public function export07Formato() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');

        $nombre="RNET_".$organismo->codigo."_EMP_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new Formato07Export, $nombre.'.csv');

   }


public function exportbitacora() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');

        $nombre="Bitacora_".$organismo->codigo."_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new BitacoraExport, $nombre.'.xlsx');

   }


public function exportbitacora2() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');
        $comp = \Input::get('comp');

        $nombre="Simit_".$organismo->codigo."_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new Bitacora2Export($comp), $nombre.'.xlsx');

   }   


public function exportbitacora4() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');
        $comp = \Input::get('comp');

        $nombre="Sevial_".$organismo->codigo."_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new Bitacora4Export($comp), $nombre.'.xlsx');

   }   

public function exportbitacora3() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');
        $comp = \Input::get('comp');

        $nombre="Bitacora_".$organismo->codigo."_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new Bitacora3Export($comp), $nombre.'.xlsx');

   }  


public function exportrecaudoexterno() 
    {

        $organismo = \App\Organismo::first();
        $fe=Carbon::now()->format('Ymd');
        $fi = \Input::get('fecha_inicial');
        $ff = \Input::get('fecha_final');
        $tipo = \Input::get('tipo');
        

        $nombre="RecaudoExterno_".$fe;

        $fechaHoy = Carbon::now();

        return Excel::download(new RecaudoExternoExport($fi,$ff,$tipo), $nombre.'.xlsx');

   }  



public function exportJson() 
    {

        \Excel::create('forms', function($excel) {
            $excel->sheet('Excel sheet', function($sheet) {

$i=1;


        $movimientos = Formu::where('id','>',6000)->where('id','<=',8000)->orderBy('id')->get();   




$sheet->row($i, [
    'Forms'
]);
$i=$i+1;
$sheet->row($i, [
     'id', 'user', 'email', 

     'id', 'address', 'neighborhood', 'phone', 'email','commune', 'total_homes',

'firstname1', 'lastname11', 'lastname21', 'nationality1', 'nationality_other1',
'is_lead1', 'gender1', 'birthdate1', 'age1', 'relationship1','document_type1',

'document_number1', 'marital_status1', 'sisben_survey1', 'sisben_score1', 'sisben_group1',
'affiliation_scheme1', 'eps1', 'ethnic_recognition1', 'conflict_victim1', 'disability1',

'can_read_and_write1', 'scolarship1', 'occupation1', 'religious_affiliation1', 
'religious_affiliation_prohibitions1', 'companion1', 'is_pregnant1', 'have_been_pregnant1', 

'number_of_pregnancies1', 'vaginal_births1', 'cesarean_births1', 'abortions1', 'children1', 
'medical_history1', 'total_records', 

'home_type', 'home_ownership', 'home_material_walls', 'home_material_floors', 'home_material_ceiling', 
'separate_kitchen', 'separate_adult_room', 'separate_children_room', 'separate_living_room', 'separate_bathroom',
'separate_laundry', 'separate_backyard', 'total_rooms', 'person_per_room',


'has_electricity', 'has_piped_gas', 'has_bottled_gas', 'has_acueduct', 'has_sewer', 'has_phone', 
'has_internet', 'has_cleaning', 'water_source', 'water_storage', 'water_treatment','disposal_system',
'sanitary_location', 'sanitary_shared'

]);
$i=$i+1;




$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;$t_a=0;$t_b=0;$t_c=0;$t_d=0;
foreach($movimientos as $movimiento) {

                                    $i=$i+1;      

if(strlen($movimiento->data)>300)
{

  $factura = json_decode($movimiento->data, true);  
  //$factura['id']=


   Session::put('error', 'Se Produjo un error .'.$movimiento->id);

//if($movimiento->id!=237 && $movimiento->id!=486)
//{

try
{   
  $factura2 = $factura['forms'][0]; 
  $factura3 = $factura['forms'][1];     
  $factura4 = $factura['forms'][2];  
  $factura5 = $factura['forms'][3]; 







    $sheet->row($i, [
        $movimiento->id, $movimiento->user, $movimiento->email, 

         "'".$factura['id'], $factura2['address'], $factura2['neighborhood'], $factura2['phone'],
         $factura2['email'], $factura2['commune'], $factura2['total_homes'], 

$factura3['firstname1'], $factura3['lastname11'], $factura3['lastname21'], $factura3['nationality1'], $factura3['nationality_other1'], 
$factura3['is_lead1'], $factura3['gender1'], $factura3['birthdate1'], $factura3['age1'], $factura3['relationship1'], $factura3['document_type1'],

$factura3['document_number1'], $factura3['marital_status1'], $factura3['sisben_survey1'], $factura3['sisben_score1'], $factura3['sisben_group1'], 
$factura3['affiliation_scheme1'], $factura3['eps1'], $factura3['ethnic_recognition1'], $factura3['conflict_victim1'], $factura3['disability1'], 

$factura3['can_read_and_write1'], $factura3['scolarship1'], $factura3['occupation1'], $factura3['religious_affiliation1'], 
$factura3['religious_affiliation_prohibitions1'], $factura3['companion1'], $factura3['is_pregnant1'], $factura3['have_been_pregnant1'], 

$factura3['number_of_pregnancies1'], $factura3['vaginal_births1'], $factura3['cesarean_births1'], $factura3['abortions1'], $factura3['children1'], 
$factura3['medical_history1'], $factura3['total_records'], 

$factura4['home_type'], $factura4['home_ownership'], $factura4['home_material_walls'], $factura4['home_material_floors'], $factura4['home_material_ceiling'], 
$factura4['separate_kitchen'], $factura4['separate_adult_room'], $factura4['separate_children_room'], $factura4['separate_living_room'], $factura4['separate_bathroom'], 
$factura4['separate_laundry'], $factura4['separate_backyard'], $factura4['total_rooms'], $factura4['person_per_room'], 


$factura5['has_electricity'], $factura5['has_piped_gas'], $factura5['has_bottled_gas'], $factura5['has_acueduct'], $factura5['has_sewer'],  $factura5['has_phone'],
$factura5['has_internet'], $factura5['has_cleaning'], $factura5['water_source'], $factura5['water_storage'], $factura5['water_treatment'], 
$factura5['disposal_system'], $factura5['sanitary_location'], $factura5['sanitary_shared']

    ]); 
}catch (\Exception $e) {
               // Session::put('error', 'Se Produjo un error .'.$e->getMessage());
               // return redirect()->route('pqr');
            }
//}

}

}//end ifor 


                $sheet->setOrientation('landscape');
            });
        })->export('xls');


        //return Excel::download(new UsersExport, 'users.xlsx');

   }

}