<?php

namespace App\Http\Controllers;

use App\FormatoEmail;
use App\Perfil;
use App\Menu;
use Illuminate\Http\Request;

class FormatoEmailController extends Controller
{
    function index(){
        $formato = FormatoEmail::all();
        return view('formatoemail.index', ['formato' => $formato]);
    }

    function crear(){
        $permisos = Menu::where('active', 1)->whereNull('padre')->orderBy('nombre')->get();
        return view('formatoemail.crear', ['permisos' => $permisos]);
    }

    function guardar(Request $request){
        $formato = new FormatoEmail();
        $formato->nombre = $request->nombre;
        $formato->descripcion = $request->body;
        $formato->save();

        return \Redirect::route('parametros.formatoemail');
    }

    function editar(FormatoEmail $formato)
    {
        $permisos = Menu::where('active', 1)->whereNull('padre')->orderBy('nombre')->get();
        return view('formatoemail.editar', ['formato' => $formato, 'permisos' => $permisos]);
    }

    function actualizar(Request $request, FormatoEmail $formato)
    {
        $formato->nombre = $request->nombre;
        $formato->descripcion = $request->body;
        $formato->save();

        \Session::flash('alert_text', 'Formato actualizado correctamente.');


        return \Redirect::route('parametros.formatoemail');
    }


}
