<?php

namespace App\Http\Controllers;

use App\FestivosTipo;
use App\Festivos;
use App\Ciudad;
use App\Divipos;
use App\Campana;
use Carbon\Carbon;
use App\Municipio;
use App\Tabla;
use App\DestinoEconomico;
use DB;
use Illuminate\Support\Collection;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Session;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Facades\Artisan;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;
use Illuminate\Support\Facades\Mail;

class MunicipioController extends Controller
{
    function index() {
        $municipio = Municipio::all();
        return view('municipio.index', ['municipio' => $municipio]);
    }

    function crear(){
        $divipos = Divipos::select('divipos_municipios.nombre as nombre_municipio','divipos_municipios.divipo','departamento.nombre as nombre_departamento')
        ->join('departamento', 'divipos_municipios.id_departamento', '=', 'departamento.id')
        ->where('divipos_municipios.active', '1')
        ->orderBy('divipos_municipios.divipo', 'ASC')
        ->get();

        $array = [];
        foreach ($divipos as $divip) {
            array_push($array, (object)array(
                'nombre_municipio' => $divip->nombre_municipio,
                'divipo' => $divip->divipo,
                'nombre_departamento' => $divip->nombre_departamento
            ));
        }

        $collection = new Collection($array);

        return view('municipio.create', ['divipos' => $collection]);
    }

    function guardar(Request $request){
        $municipio = new Municipio();
        $municipio->nombre_municipio = $request->nombre_municipio;
        $municipio->nit_municipio = $request->nit_municipio;
        $municipio->divipo = $request->divipo;
        $municipio->secretaria_hacienda = $request->secretaria_hacienda;
        $municipio->cta_bancaria = $request->cta_bancaria;
        $municipio->prefijo_predial = $request->prefijo_predial;
        $municipio->nombre_secretario = $request->nombre_secretario;
        $municipio->correo_secretario = $request->correo_secretario;
        $municipio->fecha_nombrado = $request->fecha_nombrado;
        $municipio->titulo_reporte = $request->titulo_reporte;
        $cadena = $request->nombre_municipio;
        $no_permitidas = array ("á","é","í","ó","ú","Á","É","Í","Ó","Ú","ñ","À","Ã","Ì","Ò","Ù","Ã™","Ã ","Ã¨","Ã¬","Ã²","Ã¹","ç","Ç","Ã¢","ê","Ã®","Ã´","Ã»","Ã‚","ÃŠ","ÃŽ","Ã”","Ã›","ü","Ã¶","Ã–","Ã¯","Ã¤","«","Ò","Ã","Ã„","Ã‹");
        $permitidas = array ("a","e","i","o","u","A","E","I","O","U","n","N","A","E","I","O","U","a","e","i","o","u","c","C","a","e","i","o","u","A","E","I","O","U","u","o","O","i","a","e","U","I","A","E");
        $texto_nombre_municipio = str_replace($no_permitidas, $permitidas, $cadena);
        $texto_nombre_municipio_low = str_replace(array(" "), array("_"), mb_strtolower($texto_nombre_municipio));
        $municipio->nombre_archivo_predios = "predios_".$texto_nombre_municipio_low.".xlsx";
        $municipio->save();

        $file = $request->file;

        $destinationPath = public_path('/docs/predios/');
        $fileData = "predios_".$texto_nombre_municipio_low.".xlsx";

        $file->move($destinationPath, $fileData);

        $file2 = $request->file_logo;

        if($file2 != null){
            $destinationPath2 = public_path('/assets/images/');
            $fileData2 = "logo_alcaldia_".$texto_nombre_municipio_low.".".substr($file2->getClientMimeType(), 6);
    
            $municipio->logo_municipio = 'http://45.33.67.95/catastro/public/assets/images/'.$fileData2;
            $municipio->nombre_logo_municipio = $fileData2;
            $municipio->save();
    
            $file2->move($destinationPath2, $fileData2);
        }

        $file3 = $request->firma;

        if($file3 != null){
            $destinationPath3 = public_path('/assets/images/firmas_municipio/');
            $fileData3 = "firma_secretario_".$texto_nombre_municipio_low.".".substr($file3->getClientMimeType(), 6);
    
            $municipio->firma = 'http://45.33.67.95/catastro/public/assets/images/firmas_municipio/'.$fileData3;
            $municipio->save();
    
            $file3->move($destinationPath3, $fileData3);
        }

        $createBD = DB::select('call creacionBDmunicipio (?)', array($texto_nombre_municipio_low));
        $createBD1 = DB::select('call creacionTabBitacoras (?)', array($texto_nombre_municipio_low));
        $createBD2 = DB::select('call creacionTabConfirmacionPagos (?)', array($texto_nombre_municipio_low));
        $createBD3 = DB::select('call creacionTabDepartamento (?)', array($texto_nombre_municipio_low));
        $createBD4 = DB::select('call creacionTabDestinosEconomicos (?)', array($texto_nombre_municipio_low));
        $createBD5 = DB::select('call creacionTabExclusiones (?)', array($texto_nombre_municipio_low));
        $createBD6 = DB::select('call creacionTabExenciones (?)', array($texto_nombre_municipio_low));
        $createBD7 = DB::select('call creacionTabHonorarios (?)', array($texto_nombre_municipio_low));
        $createBD8 = DB::select('call creacionTabIntereses (?)', array($texto_nombre_municipio_low));
        $createBD9 = DB::select('call creacionTabMetodosPago (?)', array($texto_nombre_municipio_low));
        $createBD10 = DB::select('call creacionTabMunicipio (?)', array($texto_nombre_municipio_low));
        $createBD11 = DB::select('call creacionTabPersona (?)', array($texto_nombre_municipio_low));
        $createBD12 = DB::select('call creacionTabPQR (?)', array($texto_nombre_municipio_low));
        $createBD13 = DB::select('call creacionTabPQRRespuestas (?)', array($texto_nombre_municipio_low));
        $createBD14 = DB::select('call creacionTabPredios (?)', array($texto_nombre_municipio_low));
        $createBD15 = DB::select('call creacionTabRegistros (?)', array($texto_nombre_municipio_low));
        $createBD16 = DB::select('call creacionTabTarifas (?)', array($texto_nombre_municipio_low));
        $createBD17 = DB::select('call creacionTabTipoExenciones (?)', array($texto_nombre_municipio_low));
        $createBD18 = DB::select('call creacionTabUsuarios (?)', array($texto_nombre_municipio_low));

        $insertsBD5 = DB::select('call insertsTabMunicipio (?,?,?,?,?,?,?,?,?,?,?,?,?)', array($texto_nombre_municipio_low,
        $request->nombre_municipio == '' ? 'NULL' : "'".$request->nombre_municipio."'",
        $request->nit_municipio == '' ? 'NULL' : "'".$request->nit_municipio."'",
        $request->divipo == '' ? 'NULL' : "'".$request->divipo."'",
        $request->secretaria_hacienda == '' ? 'NULL' : "'".$request->secretaria_hacienda."'",
        $request->cta_bancaria == '' ? 'NULL' : "'".$request->cta_bancaria."'",
        $request->prefijo_predial == '' ? 'NULL' : "'".$request->prefijo_predial."'",
        $request->nombre_secretario == '' ? 'NULL' : "'".$request->nombre_secretario."'",
        $request->fecha_nombrado == '' ? 'NULL' : "'".$request->fecha_nombrado."'",
        $request->firma == '' ? 'NULL' : "'".$request->firma."'",
        $request->titulo_reporte == '' ? 'NULL' : "'".$request->titulo_reporte."'",
        $request->logo_municipio == '' ? 'NULL' : "'http://45.33.67.95/catastro/public/assets/images/".$fileData2."'",
        $request->logo_municipio == '' ? 'NULL' : "'".$fileData2."'"));

        $reader = \PhpOffice\PhpSpreadsheet\IOFactory::createReader('Xlsx');
        $reader->setReadDataOnly(TRUE);
        $spreadsheet = $reader->load("docs/predios/predios_".$texto_nombre_municipio_low.".xlsx");

        $worksheet = $spreadsheet->getActiveSheet();
        $highestRow = $worksheet->getHighestRow();
        $highestRow_ = $highestRow - 1;
        $highestColumn = $worksheet->getHighestColumn();
        $highestColumnIndex = \PhpOffice\PhpSpreadsheet\Cell\Coordinate::columnIndexFromString($highestColumn);

        for ($row = 2; $row <= $highestRow; ++$row) {
            $id_predio = '';
            $id_persona = '';
            $id_usuario = '';
            $id_destino_economico = '';
            $id_tarifa = '';

            $select_persona = DB::select('call select_personas (?,?)', array($texto_nombre_municipio_low, "'".$worksheet->getCell('H'.$row)->getValue()."'"));
            if(empty($select_persona)){
                $insertsBD5 = DB::select('call insertsTabPersona (?,?,?,?,?)', array($texto_nombre_municipio_low,
                $worksheet->getCell('H'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('H'.$row)->getValue()."'",
                $worksheet->getCell('J'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('J'.$row)->getValue()."'",
                $worksheet->getCell('K'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('K'.$row)->getValue()."'",
                $worksheet->getCell('I'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('I'.$row)->getValue()."'"));

                foreach($insertsBD5 as $inspersona){
                    $id_persona = $inspersona->id;
                }
            }else{
                foreach($select_persona as $inspersona2){
                    $id_persona = $inspersona2->id;
                }
            }

            $id_destino_economico = DestinoEconomico::where('sigla', $worksheet->getCell('N'.$row)->getValue())->value('id');

            $select_predios = DB::select('call select_predios (?,?)', array($texto_nombre_municipio_low, "'".$worksheet->getCell('C'.$row)->getValue()."'"));
            if(empty($select_predios)){
                $insertsBD6 = DB::select('call insertsTabPredios (?,?,?,?,?)', array($texto_nombre_municipio_low,
                $worksheet->getCell('C'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('C'.$row)->getValue()."'",
                $worksheet->getCell('T'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('T'.$row)->getValue()."'",
                $worksheet->getCell('L'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('L'.$row)->getValue()."'",
                "'".$id_destino_economico."'"));

                foreach($insertsBD6 as $inspredios){
                    $id_predio = $inspredios->id;
                }
            }else{
                foreach($select_predios as $inspredios2){
                    $id_predio = $inspredios2->id;
                }
            }

            $destino_economico = $worksheet->getCell('N'.$row)->getValue();
            $avaluo = floatval(ltrim($worksheet->getCell('Q'.$row)->getValue(), "0"));
            $area_terreno = floatval(ltrim($worksheet->getCell('O'.$row)->getValue(), "0"));
            $numero_predio = substr($worksheet->getCell('C'.$row)->getValue(), 0, 2);

            if($numero_predio != '00'){
                if($destino_economico == 'A' || $destino_economico == 'D' || $destino_economico == 'E' || $destino_economico == 'L' || $destino_economico == 'M' || $destino_economico == 'N' || $destino_economico == 'O' || $destino_economico == 'P' || $destino_economico == 'T') {
                    if($avaluo >= 0 && $avaluo <= 20000000) {
                        $id_tarifa = 1;
                    } else if($avaluo >= 20000001 && $avaluo <= 40000000) {
                        $id_tarifa = 2;
                    } else if($avaluo >= 40000001 && $avaluo <= 60000000) {
                        $id_tarifa = 3;
                    } else if($avaluo >= 60000001 && $avaluo <= 80000000) {
                        $id_tarifa = 4;
                    } else if($avaluo >= 80000001 && $avaluo <= 100000000) {
                        $id_tarifa = 5;
                    } else if($avaluo >= 100000001) {
                        $id_tarifa = 6;
                    }
                } else if($destino_economico == 'B' || $destino_economico == 'C' || $destino_economico == 'F' || $destino_economico == 'G' || $destino_economico == 'H' || $destino_economico == 'I' || $destino_economico == 'J' || $destino_economico == 'K') {
                    $id_tarifa = 7;
                } else if($destino_economico == 'Q') {
                    $id_tarifa = 10;
                } else if($destino_economico == 'R') {
                    $id_tarifa = 11;
                } else if($destino_economico == 'S') {
                    $id_tarifa = 9;
                }
            }else{
                if($destino_economico == 'A') {
                    if($avaluo >= 0 && $avaluo <= 20000000) {
                        $id_tarifa = 1;
                    } else if($avaluo >= 20000001 && $avaluo <= 40000000) {
                        $id_tarifa = 2;
                    } else if($avaluo >= 40000001 && $avaluo <= 60000000) {
                        $id_tarifa = 3;
                    } else if($avaluo >= 60000001 && $avaluo <= 80000000) {
                        $id_tarifa = 4;
                    } else if($avaluo >= 80000001 && $avaluo <= 100000000) {
                        $id_tarifa = 5;
                    } else if($avaluo >= 100000001) {
                        $id_tarifa = 6;
                    }
                } else if($destino_economico == 'B' || $destino_economico == 'C' || $destino_economico == 'F' || $destino_economico == 'G' || $destino_economico == 'H' || $destino_economico == 'I' || $destino_economico == 'J' || $destino_economico == 'K') {
                    $id_tarifa = 7;
                } else if($destino_economico == 'D' || $destino_economico == 'E' || $destino_economico == 'L' || $destino_economico == 'M' || $destino_economico == 'N' || $destino_economico == 'O' || $destino_economico == 'P' || $destino_economico == 'Q' || $destino_economico == 'R' || $destino_economico == 'S' || $destino_economico == 'T') {
                    if($area_terreno >= 0 && $area_terreno <= 100000) {
                        $id_tarifa = 12;
                    } else if($area_terreno >= 100001 && $area_terreno < 300000) {
                        $id_tarifa = 13;
                    } else if($area_terreno >= 300000) {
                        $id_tarifa = 14;
                    }
                }
            }

            $random_users = '';
            $random_pass = '';
            $random_users = uniqid('userpredial_');
            $random_pass = uniqid('user_');

            $select_users = DB::select('call select_usuarios (?,?)', array($texto_nombre_municipio_low, "'".$id_persona."'"));
            if(empty($select_users)){
                $insertsBD8 = DB::select('call insertsTabUsuarios (?,?,?,?)', array($texto_nombre_municipio_low,
                "'".$id_persona."'",
                "'".$random_users."'",
                "'".$random_pass."'"));

                foreach($insertsBD8 as $insusers){
                    $id_usuario = $insusers->id;
                }
            }else{
                foreach($select_users as $insusers2){
                    $id_usuario = $insusers2->id;
                }
            }

            $insertsBD7 = DB::select('call insertsTabRegistros (?,?,?,?,?,?,?,?,?,?,?)', array($texto_nombre_municipio_low,
            "'".$id_usuario."'",
            "'".$id_predio."'",
            "'".$id_tarifa."'",
            $worksheet->getCell('E'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('E'.$row)->getValue()."'",
            $worksheet->getCell('F'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('F'.$row)->getValue()."'",
            $worksheet->getCell('G'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('G'.$row)->getValue()."'",
            $worksheet->getCell('O'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('O'.$row)->getValue()."'",
            $worksheet->getCell('P'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('P'.$row)->getValue()."'",
            $worksheet->getCell('Q'.$row)->getValue() == '' ? 'NULL' : "'".ltrim($worksheet->getCell('Q'.$row)->getValue(), "0")."'",
            $worksheet->getCell('S'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('S'.$row)->getValue()."'"));
        }

        \Session::flash('status', 'Municipio creado correctamente. Cantidad de registros: '.$highestRow_);

        return \Redirect::route('parametros.municipio');
    }

    function editar(Municipio $municipio){
        $divipos = Divipos::select('divipos_municipios.nombre_municipio','divipos_municipios.divipo','departamento.nombre')
        ->join('departamento', 'divipos_municipios.id_departamento', '=', 'departamento.id')
        ->where('divipos_municipios.active', '1')
        ->orderBy('divipos_municipios.divipo', 'ASC')
        ->get();

        $array = [];
        foreach ($divipos as $divip) {
            array_push($array, (object)array(
                'nombre_municipio' => $divip->nombre_municipio,
                'divipo' => $divip->divipo,
                'nombre_departamento' => $divip->nombre
            ));
        }

        $collection = new Collection($array);

        return view('municipio.editar', ['municipio' => $municipio, 'divipos' => $collection]);
    }

    function actualizar(Request $request, Municipio $municipio){
        $municipio->nombre_municipio = $request->nombre_municipio;
        $municipio->nit_municipio = $request->nit_municipio;
        $municipio->divipo = $request->divipo;
        $municipio->secretaria_hacienda = $request->secretaria_hacienda;
        $municipio->cta_bancaria = $request->cta_bancaria;
        $municipio->prefijo_predial = $request->prefijo_predial;
        $municipio->nombre_secretario = $request->nombre_secretario;
        $municipio->fecha_nombrado = $request->fecha_nombrado;
        $municipio->firma = $request->firma;
        $municipio->titulo_reporte = $request->titulo_reporte;
        $cadena = $request->nombre_municipio;
        $no_permitidas = array ("á","é","í","ó","ú","Á","É","Í","Ó","Ú","ñ","À","Ã","Ì","Ò","Ù","Ã™","Ã ","Ã¨","Ã¬","Ã²","Ã¹","ç","Ç","Ã¢","ê","Ã®","Ã´","Ã»","Ã‚","ÃŠ","ÃŽ","Ã”","Ã›","ü","Ã¶","Ã–","Ã¯","Ã¤","«","Ò","Ã","Ã„","Ã‹");
        $permitidas = array ("a","e","i","o","u","A","E","I","O","U","n","N","A","E","I","O","U","a","e","i","o","u","c","C","a","e","i","o","u","A","E","I","O","U","u","o","O","i","a","e","U","I","A","E");
        $texto_nombre_municipio = str_replace($no_permitidas, $permitidas ,$cadena);
        $texto_nombre_municipio_low = str_replace(array(" "), array("_"), mb_strtolower($texto_nombre_municipio));
        $municipio->save();
        $file = $request->file_logo;

        if($file != null){
            $destinationPath = public_path('/assets/images/');
            $fileData = "logo_alcaldia_".$texto_nombre_municipio_low.".".substr($file->getClientMimeType(), 6);

            $municipio->logo_municipio = 'http://45.33.67.95/catastro/public/assets/images/'.$fileData;
            $municipio->nombre_logo_municipio = $fileData;
            $municipio->save();

            $file->move($destinationPath, $fileData);
        }

        $file_archivo = $request->file;

        if($file_archivo != null){
            $destinationPath_archivo = public_path('/docs/predios/');
            $fileData_archivo = "predios_".$texto_nombre_municipio_low."_1.xlsx";

            $file_archivo->move($destinationPath_archivo, $fileData_archivo);

            $reader = \PhpOffice\PhpSpreadsheet\IOFactory::createReader('Xlsx');
            $reader->setReadDataOnly(TRUE);
            $spreadsheet = $reader->load("docs/predios/predios_".$texto_nombre_municipio_low."_1.xlsx");

            $worksheet = $spreadsheet->getActiveSheet();
            $highestRow = $worksheet->getHighestRow();
            $highestRow_ = $highestRow - 1;
            $highestColumn = $worksheet->getHighestColumn();
            $highestColumnIndex = \PhpOffice\PhpSpreadsheet\Cell\Coordinate::columnIndexFromString($highestColumn);

            for ($row = 2; $row <= $highestRow; ++$row) {
                $id_predio = '';
                $id_persona = '';
                $id_usuario = '';
                $id_destino_economico = '';
                $id_tarifa = '';

                $select_persona = DB::select('call select_personas (?,?)', array($texto_nombre_municipio_low, "'".$worksheet->getCell('H'.$row)->getValue()."'"));
                if(empty($select_persona)){
                    $insertsBD5 = DB::select('call insertsTabPersona (?,?,?,?,?)', array($texto_nombre_municipio_low,
                    $worksheet->getCell('H'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('H'.$row)->getValue()."'",
                    $worksheet->getCell('J'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('J'.$row)->getValue()."'",
                    $worksheet->getCell('K'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('K'.$row)->getValue()."'",
                    $worksheet->getCell('I'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('I'.$row)->getValue()."'"));

                    foreach($insertsBD5 as $inspersona){
                        $id_persona = $inspersona->id;
                    }
                }else{
                    foreach($select_persona as $inspersona2){
                        $id_persona = $inspersona2->id;
                    }
                }

                $id_destino_economico = DestinoEconomico::where('sigla', $worksheet->getCell('N'.$row)->getValue())->value('id');

                $select_predios = DB::select('call select_predios (?,?)', array($texto_nombre_municipio_low, "'".$worksheet->getCell('C'.$row)->getValue()."'"));
                if(empty($select_predios)){
                    $insertsBD6 = DB::select('call insertsTabPredios (?,?,?,?,?)', array($texto_nombre_municipio_low,
                    $worksheet->getCell('C'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('C'.$row)->getValue()."'",
                    $worksheet->getCell('T'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('T'.$row)->getValue()."'",
                    $worksheet->getCell('L'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('L'.$row)->getValue()."'",
                    "'".$id_destino_economico."'"));

                    foreach($insertsBD6 as $inspredios){
                        $id_predio = $inspredios->id;
                    }
                }else{
                    foreach($select_predios as $inspredios2){
                        $id_predio = $inspredios2->id;
                    }
                }

                $destino_economico = $worksheet->getCell('N'.$row)->getValue();
                $avaluo = floatval(ltrim($worksheet->getCell('Q'.$row)->getValue(), "0"));
                $area_terreno = floatval(ltrim($worksheet->getCell('O'.$row)->getValue(), "0"));
                $numero_predio = substr($worksheet->getCell('C'.$row)->getValue(), 0, 2);

                if($numero_predio != '00'){
                    if($destino_economico == 'A' || $destino_economico == 'D' || $destino_economico == 'E' || $destino_economico == 'L' || $destino_economico == 'M' || $destino_economico == 'N' || $destino_economico == 'O' || $destino_economico == 'P' || $destino_economico == 'T') {
                        if($avaluo >= 0 && $avaluo <= 20000000) {
                            $id_tarifa = 1;
                        } else if($avaluo >= 20000001 && $avaluo <= 40000000) {
                            $id_tarifa = 2;
                        } else if($avaluo >= 40000001 && $avaluo <= 60000000) {
                            $id_tarifa = 3;
                        } else if($avaluo >= 60000001 && $avaluo <= 80000000) {
                            $id_tarifa = 4;
                        } else if($avaluo >= 80000001 && $avaluo <= 100000000) {
                            $id_tarifa = 5;
                        } else if($avaluo >= 100000001) {
                            $id_tarifa = 6;
                        }
                    } else if($destino_economico == 'B' || $destino_economico == 'C' || $destino_economico == 'F' || $destino_economico == 'G' || $destino_economico == 'H' || $destino_economico == 'I' || $destino_economico == 'J' || $destino_economico == 'K') {
                        $id_tarifa = 7;
                    } else if($destino_economico == 'Q') {
                        $id_tarifa = 10;
                    } else if($destino_economico == 'R') {
                        $id_tarifa = 11;
                    } else if($destino_economico == 'S') {
                        $id_tarifa = 9;
                    }
                }else{
                    if($destino_economico == 'A') {
                        if($avaluo >= 0 && $avaluo <= 20000000) {
                            $id_tarifa = 1;
                        } else if($avaluo >= 20000001 && $avaluo <= 40000000) {
                            $id_tarifa = 2;
                        } else if($avaluo >= 40000001 && $avaluo <= 60000000) {
                            $id_tarifa = 3;
                        } else if($avaluo >= 60000001 && $avaluo <= 80000000) {
                            $id_tarifa = 4;
                        } else if($avaluo >= 80000001 && $avaluo <= 100000000) {
                            $id_tarifa = 5;
                        } else if($avaluo >= 100000001) {
                            $id_tarifa = 6;
                        }
                    } else if($destino_economico == 'B' || $destino_economico == 'C' || $destino_economico == 'F' || $destino_economico == 'G' || $destino_economico == 'H' || $destino_economico == 'I' || $destino_economico == 'J' || $destino_economico == 'K') {
                        $id_tarifa = 7;
                    } else if($destino_economico == 'D' || $destino_economico == 'E' || $destino_economico == 'L' || $destino_economico == 'M' || $destino_economico == 'N' || $destino_economico == 'O' || $destino_economico == 'P' || $destino_economico == 'Q' || $destino_economico == 'R' || $destino_economico == 'S' || $destino_economico == 'T') {
                        if($area_terreno >= 0 && $area_terreno <= 100000) {
                            $id_tarifa = 12;
                        } else if($area_terreno >= 100001 && $area_terreno < 300000) {
                            $id_tarifa = 13;
                        } else if($area_terreno >= 300000) {
                            $id_tarifa = 14;
                        }
                    }
                }

                $random_users = '';
                $random_pass = '';
                $random_users = uniqid('userpredial_');
                $random_pass = uniqid('user_');

                $select_users = DB::select('call select_usuarios (?,?)', array($texto_nombre_municipio_low, "'".$id_persona."'"));
                if(empty($select_users)){
                    $insertsBD8 = DB::select('call insertsTabUsuarios (?,?,?,?)', array($texto_nombre_municipio_low,
                    "'".$id_persona."'",
                    "'".$random_users."'",
                    "'".$random_pass."'"));

                    foreach($insertsBD8 as $insusers){
                        $id_usuario = $insusers->id;
                    }
                }else{
                    foreach($select_users as $insusers2){
                        $id_usuario = $insusers2->id;
                    }
                }

                $select_registros = DB::select('call select_registros (?,?,?,?,?,?,?,?,?,?,?)', array($texto_nombre_municipio_low,
                "'".$id_usuario."'",
                "'".$id_predio."'",
                "'".$id_tarifa."'",
                "'".$worksheet->getCell('E'.$row)->getValue()."'",
                "'".$worksheet->getCell('F'.$row)->getValue()."'",
                "'".$worksheet->getCell('G'.$row)->getValue()."'",
                "'".$worksheet->getCell('O'.$row)->getValue()."'",
                "'".$worksheet->getCell('P'.$row)->getValue()."'",
                "'".ltrim($worksheet->getCell('Q'.$row)->getValue(), "0")."'",
                "'".$worksheet->getCell('S'.$row)->getValue()."'"));
                if(empty($select_registros)){
                    $insertsBD7 = DB::select('call insertsTabRegistros (?,?,?,?,?,?,?,?,?,?,?)', array($texto_nombre_municipio_low,
                    "'".$id_usuario."'",
                    "'".$id_predio."'",
                    "'".$id_tarifa."'",
                    $worksheet->getCell('E'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('E'.$row)->getValue()."'",
                    $worksheet->getCell('F'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('F'.$row)->getValue()."'",
                    $worksheet->getCell('G'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('G'.$row)->getValue()."'",
                    $worksheet->getCell('O'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('O'.$row)->getValue()."'",
                    $worksheet->getCell('P'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('P'.$row)->getValue()."'",
                    $worksheet->getCell('Q'.$row)->getValue() == '' ? 'NULL' : "'".ltrim($worksheet->getCell('Q'.$row)->getValue(), "0")."'",
                    $worksheet->getCell('S'.$row)->getValue() == '' ? 'NULL' : "'".$worksheet->getCell('S'.$row)->getValue()."'"));
                }
            }
        }

        \Session::flash('status', 'Municipio actualizado correctamente.');

        return \Redirect::route('parametros.municipio');
    }

    function activar(Municipio $municipio){
        $municipio->active = true;
        $municipio->save();

        \Session::flash('alert_text', 'Municipio activado correctamente.');

        return \Redirect::back();
    }

    function desactivar(Municipio $municipio){
        $municipio->active = false;
        $municipio->save();

        \Session::flash('alert_text', 'Municipio desactivado correctamente.');

        return \Redirect::back();
    }

    function RegistrosUnoDos(){
        return view('municipio.registrosunodos');
    }

    function guardarR1(Request $request){
        $archivos = DB::table('r1')->get();

        $doc = fopen("docs/predios/R1.TXT", "w+");
        foreach ($archivos as $arch) {
            $length1 = 137;
            $length2 = 14;
            $length3 = 100;

            $parteAE = $arch->numero_del_predio.$arch->tipo_de_registro.$arch->numero_de_orden.$arch->total_registros.$arch->nombre;

            $parteGH = $arch->estado_civil.$arch->tipo_documento.$arch->numero_documento;

            $parteI = $arch->direccion;

            $parteKP = nl2br($arch->comuna.$arch->destino_economico.$arch->area_terreno.$arch->area_construida.$arch->avaluo.$arch->vigencia.$arch->numero_predial_anterior)."\n";

            fwrite($doc, $parteAE);

            $tell = $length1 - strlen($parteAE);
            fseek($doc, $tell, SEEK_CUR);
            fwrite($doc, $parteGH);

            $tell = $length2 - strlen($parteGH);
            fseek($doc, $tell, SEEK_CUR);
            fwrite($doc, $parteI);

            $tell = $length3 - strlen($parteI);
            fseek($doc, $tell, SEEK_CUR);
            fwrite($doc, $parteKP);
        }
        fclose($doc);

        header('Content-disposition: attachment; filename=R1.TXT');
        header('Content-type: application/txt');
        header('Content-Transfer-Encoding: binary');
        header('Content-Description: File Transfer');
        header('Content-Transfer-Encoding: binary');
        header('Cache-Control: must-revalidate');
        ob_clean();
        flush();
        readfile('docs/predios/R1.TXT');
    }

    function guardarR2(Request $request){
        $archivos = DB::table('r2')->get();

        $doc = fopen("docs/predios/R2.TXT", "w+");
        foreach ($archivos as $arch) {
            $length1 = 77;
            $length2 = 43;
            $length3 = 43;
            $length4 = 48;
            $length5 = 48;
            $length6 = 48;

            $parteAE = $arch->numero_del_predio.$arch->tipo_de_registro.$arch->numero_de_orden.$arch->total_registros.$arch->matricula_inmobiliaria;

            $parteGHI = $arch->zona_fisica_1.$arch->zona_economica_1.$arch->area_terreno_1;

            $parteKLM = $arch->zona_fisica_2.$arch->zona_economica_2.$arch->area_terreno_2;

            $parteOV = $arch->habitaciones_1.$arch->baños_1.$arch->locales_1.$arch->pisos_1.$arch->estrato_1.$arch->uso_1.$arch->puntaje_1.$arch->area_construida_1;

            $parteXAE = $arch->habitaciones_2.$arch->baños_2.$arch->locales_2.$arch->pisos_2.$arch->estrato_2.$arch->uso_2.$arch->puntaje_2.$arch->area_construida_2;

            $parteAGAN = $arch->habitaciones_3.$arch->baños_3.$arch->locales_3.$arch->pisos_3.$arch->estrato_3.$arch->uso_3.$arch->puntaje_3.$arch->area_construida_3;

            $parteAPAQ = nl2br($arch->vigencia.$arch->numero_predial_anterior)."\n";

            fwrite($doc, $parteAE);

            $tell = $length1 - strlen($parteAE);
            fseek($doc, $tell, SEEK_CUR);
            fwrite($doc, $parteGHI);

            $tell = $length2 - strlen($parteGHI);
            fseek($doc, $tell, SEEK_CUR);
            fwrite($doc, $parteKLM);

            $tell = $length3 - strlen($parteKLM);
            fseek($doc, $tell, SEEK_CUR);
            fwrite($doc, $parteOV);

            $tell = $length4 - strlen($parteOV);
            fseek($doc, $tell, SEEK_CUR);
            fwrite($doc, $parteXAE);

            $tell = $length5 - strlen($parteXAE);
            fseek($doc, $tell, SEEK_CUR);
            fwrite($doc, $parteAGAN);

            $tell = $length6 - strlen($parteAGAN);
            fseek($doc, $tell, SEEK_CUR);
            fwrite($doc, $parteAPAQ);
        }
        fclose($doc);

        header('Content-disposition: attachment; filename=R2.TXT');
        header('Content-type: application/txt');
        header('Content-Transfer-Encoding: binary');
        header('Content-Description: File Transfer');
        header('Content-Transfer-Encoding: binary');
        header('Cache-Control: must-revalidate');
        ob_clean();
        flush();
        readfile('docs/predios/R2.TXT');
    }
	
}
