<?php

namespace App\Http\Controllers;

use App\Tipo;
use App\Bitacora;
use App\BitacoraSeguimiento;
use App\Auditoria;
use App\Agente;
use App\Ciudadano;
use App\Coactivo;
use App\Cuenta;
use App\Destino;
use App\TpDocumento;
use App\Pqr;
use App\PqrRespuesta;
use App\TpEvento;
use App\Egreso;
use App\MovimientoBancario;
use App\Transaccion;
use App\RecaudoSimit;
use App\ComparendoSimit;
use App\Comparendo;
use App\ReporteWebService;
use App\Organismo;
use App\ResolucionSimitTipo;
use App\ResolucionSimit;
use App\TransaccionPorAprobar;
use Carbon\Carbon;
use DB;
use App\Festivos;
use Illuminate\Http\Request;
use Illuminate\Support\Collection;
use MongoDB\Driver\Query;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Session;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Facades\Artisan;

use App\ReporteRecaudoSimit;
use App\ArchivoDatacredito;
use App\ArchivoEmbargos;
use Maatwebsite\Excel\Facades\Excel;
use App\Imports\AlumnosImport;
use App\NumeracionOficio;

class ReportesController extends Controller
{

    public static function getTpDoc($doc)
    {
        $documento = TpDocumento::where('id', $doc)->first()->nombre;
        return $documento;
    }

    public static function getTpEvento($doc)
    {
        $documento = TpEvento::where('id', $doc)->first()->nombre;
        return $documento;
    }


    public function getDaysHabiles($fechaCarbon, $festivos, $numDias)
    {
        $contF = null;
        $contS = null;
        $contD = null;

        for ($i = 0; $i < $numDias; $i++) {
            $date = $fechaCarbon->addDays(1);

            foreach ($festivos as $festivo) {
                $diaF = $festivo->dia;
                $diaC = $date->day;
                $mesF = $festivo->mes;
                $mesC = $date->month;
                $anoF = $festivo->anio;
                $anoC = $date->year;

                if ($diaF == $diaC && $mesF == $mesC && $anoF == $anoC) {
                    $contF++;
                    break;
                } else if ($fechaCarbon->shortEnglishDayOfWeek == 'Sat') {
                    $contS++;
                    break;
                } else if ($fechaCarbon->shortEnglishDayOfWeek == 'Sun') {
                    $contD++;
                    break;
                }
            }

        }

        $countF = $contF + $contS + $contD;

        return $countF;
    }

    public function calcularFechaHabilLaboral($festivos, $fechaCarbon)
    {
        foreach ($festivos as $festivo) {
            if ($festivo->dia == $fechaCarbon->day && $festivo->mes == $fechaCarbon->month && $festivo->anio == $fechaCarbon->year) {
                $fechaCarbon = $fechaCarbon->addDays(1);
                $fechaCarbon = $this->calcularFechaHabilLaboral($festivos, $fechaCarbon);
                break;
            } else if ($fechaCarbon->shortEnglishDayOfWeek == 'Sat') {
                $fechaCarbon = $fechaCarbon->addDays(2);
                $fechaCarbon = $this->calcularFechaHabilLaboral($festivos, $fechaCarbon);
                break;
            } else if ($fechaCarbon->shortEnglishDayOfWeek == 'Sun') {
                $fechaCarbon = $fechaCarbon->addDays(1);
                $fechaCarbon = $this->calcularFechaHabilLaboral($festivos, $fechaCarbon);
                break;
            }
        }
        return $fechaCarbon;
    }

    public function getFiveDays($fechaCarbon, $fechaCarbon2, $numDias)
    {
        $festivos = Festivos::all();

        $dias = $this->getDaysHabiles($fechaCarbon, $festivos, $numDias);

        $dateFinal = $this->calcularFechaHabilLaboral($festivos, $fechaCarbon2->addDays($numDias + $dias));;

        $fechaFinal = explode(' ', $dateFinal . "")[0];
        return $fechaFinal;
    }

 public function webservice()
    {
        $tpc = TpDocumento::all()->sortBy('orden');
        $flag = false;


        $perPage = 20;
        $page = Input::get('page');
        $pageName = 'page';
        $page = Paginator::resolveCurrentPage($pageName);
        $offSet = ($page * $perPage) - $perPage;

            $fecha_busqueda = Input::get('fecha_busqueda');
            $fecha_busqueda2 = Input::get('fecha_busqueda2');
        

        //$documentos = Pqr::offset($offSet)->limit($perPage)->orderByDesc('id')->get();

                 if (Input::get('fecha_busqueda') == "") {
                    $documentos = ReporteWebService::offset($offSet)->limit($perPage)->orderBy('created_at')->get();
                    $total_registros = ReporteWebService::get()->count();
                 }else
                 {
                    //Session::put('success', '00!'.Input::get('fecha_busqueda'));
                     $documentos = ReporteWebService::where('created_at', '>=' ,$fecha_busqueda)
                     ->where('created_at', '<=',$fecha_busqueda2)->offset($offSet)->limit($perPage)->orderBy('created_at')->get();
                     $total_registros = ReporteWebService::where('fecha', '>=' ,$fecha_busqueda)
                     ->where('fecha', '<=',$fecha_busqueda2)->offset($offSet)->limit($perPage)->orderBy('created_at')->get()->count();                     
                 }


        $pendientes = Pqr::where('respondido', 'NO')->where('tp_doc', '<>' ,'8')->get()->count();

        $pendientes_envio = Pqr::where('respondido', 'SI')->where('enviado', 'NO')->get()->count();

        $array = [];
        $collection = null;
        foreach ($documentos as $doc) {

            array_push($array, (object)array(
                'id' => $doc->id,
                'ciudadano' => $doc->ciudadano,
                'id_organismo' => $doc->id_organismo,
                'cuota' => $doc->cuota,
                'valor' => $doc->valor,
                'intereses' => $doc->intereses,
                'honorarios' => $doc->honorarios,
                'descuentos' => $doc->descuentos,
                'fecha' => $doc->fecha,
                'no_operacion' => $doc->no_operacion,
                'tipo_pago' => $doc->tipo_pago,
                'xml' => $doc->xml,
                'msj' => $doc->msj
            ));
        }

        $collection = new Collection($array);



        //$documentos = Pqr::offset($offSet)->limit($perPage)->orderByDesc('id')->get();
        //$total_registros = Pqr::get()->count();


        $posts = new LengthAwarePaginator($collection, $total_registros, $perPage, $page, [
            'path' => Paginator::resolveCurrentPath(),
            'pageName' => $pageName,
        ]);


        if (Input::get('tp_doc')) {
            $flag = true;     
            return view('reportes.webservice', [
                'documentos' => $posts,
                'pendientes' => $pendientes,
                'pendientes_envio' => $pendientes_envio,
                'docs' => $tpc,
                'flag' => $flag,
                'tp_doc' => Input::get('tp_doc'),
                'fecha_busqueda' => Input::get('fecha_busqueda'),
                'fecha_busqueda2' => Input::get('fecha_busqueda2')
            ])->withPosts($posts);
        }

        return view('reportes.webservice', [
            'documentos' => $posts,
            'pendientes' => $pendientes,
            'pendientes_envio' => $pendientes_envio,
            'docs' => $tpc,
            'flag' => $flag,
            'tp_doc' => Input::get('tp_doc'),
            'fecha_busqueda' => Input::get('fecha_busqueda'),
            'fecha_busqueda2' => Input::get('fecha_busqueda2')
        ])->withPosts($posts);




    }
       

public function reporterecaudosimit()
    {
        $tpc = TpDocumento::all()->sortBy('orden');
        $flag = false;


        $perPage = 20;
        $page = Input::get('page');
        $pageName = 'page';
        $page = Paginator::resolveCurrentPage($pageName);
        $offSet = ($page * $perPage) - $perPage;

            $fecha_busqueda = Input::get('fecha_busqueda');
            $fecha_busqueda2 = Input::get('fecha_busqueda2');
        

        //$documentos = Pqr::offset($offSet)->limit($perPage)->orderByDesc('id')->get();

                 if (Input::get('fecha_busqueda') == "") {
                    $documentos = ReporteRecaudoSimit::where('id',0)->orderBy('fecharecaudo')->get();
                    $total_registros = ReporteRecaudoSimit::where('id',0)->get()->count();
                 }else
                 {
                    //Session::put('success', '00!'.Input::get('fecha_busqueda'));
            $documentos = ReporteRecaudoSimit::where('fecharecaudo', '>=' ,$fecha_busqueda)
                     ->where('fecharecaudo', '<=',$fecha_busqueda2)->orderBy('fecharecaudo')->get();
            $total_registros = ReporteRecaudoSimit::where('fecharecaudo', '>=' ,$fecha_busqueda)
                     ->where('fecharecaudo', '<=',$fecha_busqueda2)->get()->count();                     
                 }


        //$pendientes = Pqr::where('respondido', 'NO')->where('tp_doc', '<>' ,'8')->get()->count();

        //$pendientes_envio = Pqr::where('respondido', 'SI')->where('enviado', 'NO')->get()->count();

        $array = [];
        $collection = null;
        foreach ($documentos as $doc) {

            array_push($array, (object)array(
                'id' => $doc->id,
                'banco' => $doc->banco,
                'cuenta' => $doc->cuenta,
                'fecharecaudo' => $doc->fecharecaudo,
                'fechaaprobacion' => $doc->fechaaprobacion,
                'fechaautoridad' => $doc->fechaautoridad,
                'liquidacion' => $doc->liquidacion,
                'comparendo' => $doc->comparendo,
                'fechacompa' => $doc->fechacompa,
                'identificacion' => $doc->identificacion,
                'divipo' => $doc->divipo,
                'juridiccion' => $doc->juridiccion,
                'vrecaudo' => $doc->vrecaudo,
                'vadicional' => $doc->vadicional,
                'vbase' => $doc->vbase,
                'vsimitbase' => $doc->vsimitbase,
                'vtercero' => $doc->vtercero,
                'vautoridad' => $doc->vautoridad
            ));
        }

        $collection = new Collection($array);



        //$documentos = Pqr::offset($offSet)->limit($perPage)->orderByDesc('id')->get();
        //$total_registros = Pqr::get()->count();


        /*$posts = new LengthAwarePaginator($collection, $total_registros, $perPage, $page, [
            'path' => Paginator::resolveCurrentPath(),
            'pageName' => $pageName,
        ]);*/


        if (Input::get('tp_doc')) {
            $flag = true;     
            return view('reportes.recaudosimit', [
                'documentos' => $collection ,
                'docs' => $tpc,
                'flag' => $flag,
                'tp_doc' => Input::get('tp_doc'),
                'fecha_busqueda' => Input::get('fecha_busqueda'),
                'fecha_busqueda2' => Input::get('fecha_busqueda2')
            ])->withPosts($collection );
        }

        return view('reportes.recaudosimit', [
            'documentos' => $collection ,
            'docs' => $tpc,
            'flag' => $flag,
            'tp_doc' => Input::get('tp_doc'),
            'fecha_busqueda' => Input::get('fecha_busqueda'),
            'fecha_busqueda2' => Input::get('fecha_busqueda2')
        ])->withPosts($collection );




    }



    function bancos(){
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $totalMovimientos = null;
        $cuentas = Cuenta::where('estado', 'activo')->get();
        $id_cuenta = null;
        $totalAnterior = 0;

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            if(\Input::has('id_cuenta') && !empty(\Input::get('id_cuenta'))){
                $id_cuenta = \Input::get('id_cuenta');
            }

            $movimientos = MovimientoBancario::whereDate('created_at', '>=', $fechaArray[0])
                ->whereDate('created_at', '<=', $fechaArray[1]);

            if($id_cuenta){
                $movimientos = $movimientos->where('id_cuenta', $id_cuenta);
            }

            $movimientos = $movimientos->get();

            $totalMovimientos = MovimientoBancario::whereDate('created_at', '>=', $fechaArray[0])
                ->whereDate('created_at', '<=', $fechaArray[1]);

            if ($id_cuenta) {
                $totalMovimientos = $totalMovimientos->where('id_cuenta', $id_cuenta);
            }

            $totalMovimientos = $totalMovimientos->sum('valor');

            $totalAnterior = MovimientoBancario::whereDate('created_at', '<=', $fechaArray[1])->where('id_cuenta', $id_cuenta)->sum('valor');
        }

        if (isset($fechaArray[0])) {
            return view('reportes.bancos', ['totalAnterior' => $totalAnterior, 'id_cuenta' => $id_cuenta, 'cuentas' => $cuentas, 'fechaInicial' => $fechaArray[0], 'fechaFinal' => $fechaArray[1], 'movimientos' => $movimientos, 'totalMovimientos' => $totalMovimientos]);
        }

        return view('reportes.bancos', ['totalAnterior' => $totalAnterior, 'id_cuenta' => $id_cuenta, 'cuentas' => $cuentas, 'movimientos' => $movimientos, 'totalMovimientos' => $totalMovimientos]);
    }


    function movimientos(){
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $totalMovimientos = null;

        if(\Input::has('fecha_inicial') && \Input::has('fecha_final')){
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            $totalMovimientos = Transaccion::where('id_organismo', \Auth::user()->organismo->id)->where('etiqueta', '<>', 'apertura-caja')
                ->where('etiqueta', '<>', 'cierre-caja')
                ->whereDate('created_at', '>=', $fechaArray[0])
                ->whereDate('created_at', '<=', $fechaArray[1])
                ->sum('valor');

            $movimientos = Transaccion::where('id_organismo', \Auth::user()->organismo->id)->where('etiqueta', '<>', 'apertura-caja')
                //->where('etiqueta', '<>', 'cierre-caja')
                ->whereDate('created_at', '>=', $fechaArray[0])
                ->whereDate('created_at', '<=', $fechaArray[1])
                ->get();
        }

        if(isset($fechaArray[0])){
            return view('reportes.movimientos', ['fechaInicial' => $fechaArray[0], 'fechaFinal' => $fechaArray[1], 'movimientos' => $movimientos, 'totalMovimientos' => $totalMovimientos]);
        }

        return view('reportes.movimientos', ['movimientos' => $movimientos, 'totalMovimientos' => $totalMovimientos]);
    }

    function auditoria(){
        $fecha = null;
        $fechaArray = [];
        $items = new Collection();
        $totalMovimientos = null;
        $etiqueta = null;

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            if (\Input::has('etiqueta') && !empty(\Input::get('etiqueta'))) {
                $etiqueta = \Input::get('etiqueta');
            }

            $items = Auditoria::whereDate('created_at', '>=', $fechaArray[0])
                ->whereDate('created_at', '<=', $fechaArray[1]);

            if ($etiqueta) {
                $items = $items->where('etiqueta', $etiqueta);
            }

            $items = $items->get();
        }

        if (isset($fechaArray[0])) {
            return view('reportes.auditoria', ['etiqueta' => $etiqueta, 'fechaInicial' => $fechaArray[0], 'fechaFinal' => $fechaArray[1], 'items' => $items, 'totalMovimientos' => $totalMovimientos]);
        }

        return view('reportes.auditoria', ['etiqueta' => $etiqueta, 'items' => $items, 'totalMovimientos' => $totalMovimientos]);
    }

    function egresos(){
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $totalMovimientos = null;
        $cuentas = Cuenta::where('estado', 'activo')->get();
        $id_cuenta = null;

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            if (\Input::has('id_cuenta') && !empty(\Input::get('id_cuenta'))) {
                $id_cuenta = \Input::get('id_cuenta');
            }

            $movimientos = Egreso::whereDate('created_at', '>=', $fechaArray[0])
                ->whereDate('created_at', '<=', $fechaArray[1]);

            if ($id_cuenta) {
                $movimientos = $movimientos->where('id_cuenta', $id_cuenta);
            }

            $movimientos = $movimientos->get();

            $totalMovimientos = Egreso::whereDate('created_at', '>=', $fechaArray[0])
                ->whereDate('created_at', '<=', $fechaArray[1]);

            if ($id_cuenta) {
                $totalMovimientos = $totalMovimientos->where('id_cuenta', $id_cuenta);
            }

            $totalMovimientos = $totalMovimientos->sum('valor');
        }

        if (isset($fechaArray[0])) {
            return view('reportes.egresos', ['cuentas' => $cuentas, 'id_cuenta' => $id_cuenta, 'fechaInicial' => $fechaArray[0], 'fechaFinal' => $fechaArray[1], 'movimientos' => $movimientos, 'totalMovimientos' => $totalMovimientos]);
        }

        return view('reportes.egresos', ['cuentas' => $cuentas, 'id_cuenta' => $id_cuenta, 'movimientos' => $movimientos, 'totalMovimientos' => $totalMovimientos]);
    }



    function carteramorosa(){
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $totalMovimientos = null;
        $cuentas = Cuenta::where('estado', 'activo')->get();
        $id_cuenta = null;

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            if (\Input::has('id_cuenta') && !empty(\Input::get('id_cuenta'))) {
                $id_cuenta = \Input::get('id_cuenta');
            }

            $movimientos = Egreso::whereDate('created_at', '>=', $fechaArray[0])
                ->whereDate('created_at', '<=', $fechaArray[1]);

            if ($id_cuenta) {
                $movimientos = $movimientos->where('id_cuenta', $id_cuenta);
            }

            $movimientos = $movimientos->get();

            $totalMovimientos = Egreso::whereDate('created_at', '>=', $fechaArray[0])
                ->whereDate('created_at', '<=', $fechaArray[1]);

            if ($id_cuenta) {
                $totalMovimientos = $totalMovimientos->where('id_cuenta', $id_cuenta);
            }

            $totalMovimientos = $totalMovimientos->sum('valor');
        }

        if (isset($fechaArray[0])) {
            return view('reportes.carteramorosa', ['cuentas' => $cuentas, 'id_cuenta' => $id_cuenta, 'fechaInicial' => $fechaArray[0], 'fechaFinal' => $fechaArray[1], 'movimientos' => $movimientos, 'totalMovimientos' => $totalMovimientos]);
        }

        return view('reportes.carteramorosa', ['cuentas' => $cuentas, 'id_cuenta' => $id_cuenta, 'movimientos' => $movimientos, 'totalMovimientos' => $totalMovimientos]);
    }



    function recaudoImpuestos()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            if(!$tipo || empty($tipo)){
                $totalMovimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }elseif($tipo == "derechos"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-impuesto')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-impuesto')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();
            }elseif ($tipo == "comparendos"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-comparendo')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-comparendo')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }elseif ($tipo == "tramites"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-tramite')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-tramite')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }

            foreach($movimientos as $movimiento){
				
				$factura = json_decode($movimiento->factura, true);
                $totalIntereses += $factura['intereses'];
                $totalImpuestos += $movimiento->valor;
                $totalHonorarios += $factura['honorarios'];
                $totalSistematizacion += $factura['sistematizacion']/1.19;
				$totalIva += (($factura['sistematizacion']/1.19)*0.19);
				$totalDescuentos += $factura['campana_calculados'];
								
                $totalIva += $movimiento->pagos->sum('pago_aplicado_iva');
                $totalIntereses += $movimiento->pagos->sum('pago_aplicado_intereses');
                $totalImpuestos += $movimiento->pagos->sum('pago_aplicado_impuestos');
                $totalHonorarios += $movimiento->pagos->sum('pago_aplicado_honorarios');
                $totalSistematizacion += $movimiento->pagos->sum('pago_aplicado_sistematizacion');
                $totalDescuentos += $movimiento->pagos->sum('descuento_aplicado');

                if($movimiento->etiqueta == 'pago-comparendo'){
                    foreach($movimiento->obtenerComparendosObj() as $comparendo){
                        $totalDescuentos += $comparendo->calcularDescuento();
                    }
                }
            }

			$c=Cuenta::where('id_organismo', \Auth::user()->organismo->id)->get();
			
            foreach($c as $cuenta){
               /* $total = Destino::where('id_cuenta', $cuenta->id)
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('fecha_tx', '>=', $fechaArray[0])
                    ->whereDate('fecha_tx', '<=', $fechaArray[1])
                    ->sum('valor');*/
					
                $total = TransaccionPorAprobar::where('cuenta', $cuenta->id)
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');					
					
					
                $cuentas[$cuenta->id]['cuenta'] = $cuenta;
                $cuentas[$cuenta->id]['total'] = $total;
            }
        }

        return view('reportes.recaudoImpuestos', [
            'movimientos' => $movimientos,
            'totalMovimientos' => $totalMovimientos,
            'totalImpuestos' => $totalImpuestos,
            'totalSistematizacion' => $totalSistematizacion,
            'totalHonorarios' => $totalHonorarios,
            'totalIntereses' => $totalIntereses,
            'totalDescuentos' => $totalDescuentos,
            'totalIva' => $totalIva,
            'cuentas' => $cuentas,
            'tipo' => $tipo
        ]);
    }


    function imposicioncomparendos()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];
        $fdia=null;
        $infra=0;
        $valinfra=0;
        $infra=0;
        $infrapaga=0;
        $cantinfrapaga=0;
        $descuentos=0;

        $p1=0;
        $p2=0;
        $p3=0;


        $date = Carbon::now();
        $mes0="".$date->format('m'); 
        $ano=$date->format('Y');

        //$mes0="05"; 
        //$ano=2022;

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            //$tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            //$fechaArray[0] = new Carbon($fecha_inicial);
            //$fechaArray[1] = new Carbon($fecha_final);

            //$c=Cuenta::where('id_organismo', \Auth::user()->organismo->id)->get();
            //$fi3 = new Carbon($fecha_inicial);
            // $fdia = $fi3->subDay($fecha_final);   

           $ano=\Input::get('fecha_final') ;
            $mes0=\Input::get('fecha_inicial') ;
/*
            $infra = Comparendo::where('infraccion_fecha','>=',$fdia)
            ->where('infraccion_fecha','<=',$fecha_inicial)->count();  

            $infracciones = Comparendo::where('infraccion_fecha','>=',$fdia)
            ->where('infraccion_fecha','<=',$fecha_inicial)->get();       

            foreach($infracciones as $infraccion){              
                $valinfra += $infraccion->valor;
                if($infraccion->pagos>0)
                {
                   $infrapaga += $infraccion->pagos;
                   $cantinfrapaga += 1;
                }

                if ($infraccion->descuento) {
                    $descuentos += $infraccion->calcularDescuento();
                }
              
            }

            if($infrapaga>0)
            {
                $p1=round($infrapaga/$valinfra*100);
                $p2=round($cantinfrapaga/$infra*100); 
                $p3=round(($infrapaga+$descuentos)/$valinfra*100);              
            } 
*/

        }

        return view('reportes.imposicioncomparendos', [
            'movimientos' => $movimientos,
            'fdia' => $fdia,
            'infra' => $infra,
            'valinfra' => $valinfra,
            'infrapaga' => $infrapaga,
            'cantinfrapaga' => $cantinfrapaga,
            'p1' => $p1,
            'p2' => $p2,
            'p3' => $p3,
            'mes0' => $mes0,
            'ano' => $ano,            
            'descuentos' => $descuentos,
            'tipo' => $tipo
        ]);
    }



    function recuperacioncartera()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];
        $fdia=null;
        $infra=0;
        $valinfra=0;
        $infra=0;
        $infrapaga=0;
        $cantinfrapaga=0;
        $descuentos=0;

        $p1=0;
        $p2=0;
        $p3=0;

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            //$tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            //$fechaArray[0] = new Carbon($fecha_inicial);
            //$fechaArray[1] = new Carbon($fecha_final);

            //$c=Cuenta::where('id_organismo', \Auth::user()->organismo->id)->get();
            $fi3 = new Carbon($fecha_inicial);
           $fdia = $fi3->subDay($fecha_final);   

            $infra = Comparendo::where('infraccion_fecha','>=',$fdia)
            ->where('infraccion_fecha','<=',$fecha_inicial)->count();  

            $infracciones = Comparendo::where('infraccion_fecha','>=',$fdia)
            ->where('infraccion_fecha','<=',$fecha_inicial)->get();       

            foreach($infracciones as $infraccion){              
                $valinfra += $infraccion->valor;
                if($infraccion->pagos>0)
                {
                   $infrapaga += $infraccion->pagos;
                   $cantinfrapaga += 1;
                }

                if ($infraccion->descuento) {
                    $descuentos += $infraccion->calcularDescuento();
                }

            }

            if($infrapaga>0)
            {
                $p1=round($infrapaga/$valinfra*100,2);
                $p2=round($cantinfrapaga/$infra*100,2); 
                $p3=round(($infrapaga+$descuentos)/$valinfra*100,2);              
            } 


        }

        return view('reportes.recuperacioncartera', [
            'movimientos' => $movimientos,
            'fdia' => $fdia,
            'infra' => $infra,
            'valinfra' => $valinfra,
            'infrapaga' => $infrapaga,
            'cantinfrapaga' => $cantinfrapaga,
            'p1' => $p1,
            'p2' => $p2,
            'p3' => $p3,
            'descuentos' => $descuentos,
            'tipo' => $tipo
        ]);
    }

function recaudoExterno()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];
 $cade="Vacio";
        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            if(!$tipo || empty($tipo)){

              $cade="Fi:".$fecha_inicial.", Ff:".$fecha_final;
                $fe="CONCAT(substr(c2,7,4),'-',substr(c2,4,2),'-',substr(c2,1,2))";
                $movimientos =  RecaudoSimit::where(DB::raw($fe), '>=', $fecha_inicial)
                    ->where(DB::raw($fe), '<=', $fecha_final )
                    ->where('fuente', 'externo')
                    ->orderBy(DB::raw($fe))
                    ->get();
            }

            
        }

        return view('reportes.recaudoExterno', [
            'movimientos' => $movimientos,
            'cade' => $cade,
            'tipo' => $tipo,
            'export' => '0'
        ]);
    }


    

function recaudoSimit()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $recaudos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            if(!$tipo || empty($tipo)){
                $totalMovimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }elseif($tipo == "derechos"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-impuesto')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-impuesto')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();
            }elseif ($tipo == "comparendos"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-comparendo')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-comparendo')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }elseif ($tipo == "tramites"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-tramite')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-tramite')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }

            foreach($movimientos as $movimiento){
                
                $factura = json_decode($movimiento->factura, true);
                $totalIntereses += $factura['intereses'];
                $totalImpuestos += $movimiento->valor;
                $totalHonorarios += $factura['honorarios'];
                $totalSistematizacion += $factura['sistematizacion']/1.19;
                $totalIva += (($factura['sistematizacion']/1.19)*0.19);
                $totalDescuentos += $factura['campana_calculados'];
                                
                $totalIva += $movimiento->pagos->sum('pago_aplicado_iva');
                $totalIntereses += $movimiento->pagos->sum('pago_aplicado_intereses');
                $totalImpuestos += $movimiento->pagos->sum('pago_aplicado_impuestos');
                $totalHonorarios += $movimiento->pagos->sum('pago_aplicado_honorarios');
                $totalSistematizacion += $movimiento->pagos->sum('pago_aplicado_sistematizacion');
                $totalDescuentos += $movimiento->pagos->sum('descuento_aplicado');

                if($movimiento->etiqueta == 'pago-comparendo'){
                    foreach($movimiento->obtenerComparendosObj() as $comparendo){
                        $totalDescuentos += $comparendo->calcularDescuento();
                    }
                }
            }

            $c=Cuenta::where('id_organismo', \Auth::user()->organismo->id)->get();
            
            foreach($c as $cuenta){
               /* $total = Destino::where('id_cuenta', $cuenta->id)
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('fecha_tx', '>=', $fechaArray[0])
                    ->whereDate('fecha_tx', '<=', $fechaArray[1])
                    ->sum('valor');*/
                    
                $total = TransaccionPorAprobar::where('cuenta', $cuenta->id)
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');                 
                    
                    
                $cuentas[$cuenta->id]['cuenta'] = $cuenta;
                $cuentas[$cuenta->id]['total'] = $total;
            }

             /*   $recaudos = RecaudoSimit::where('fuente', 'externo')
                    ->where('SUBSTRING(C2,7,4)', '>=', substr($fecha_inicial, 0,4))
                    ->get();*/

$recaudos = RecaudoSimit::where('fuente','=', 'externo')
            ->select(
                DB::raw('C9 as `valor`'),
                DB::raw("substr(c2,1,2) as dia,substr(c2,4,2) as mes,substr(c2,7,4) as ano"),
                DB::raw("CONCAT_WS('-',substr(c2,4,2),substr(c2,7,4),substr(c2,1,2)) as fecha"))
            ->limit(10)->get();


        }

        return view('reportes.recaudoSimitPolca', [
            'movimientos' => $movimientos,
            'totalMovimientos' => $totalMovimientos,
            'totalImpuestos' => $totalImpuestos,
            'totalSistematizacion' => $totalSistematizacion,
            'totalHonorarios' => $totalHonorarios,
            'totalIntereses' => $totalIntereses,
            'totalDescuentos' => $totalDescuentos,
            'totalIva' => $totalIva,
            'cuentas' => $cuentas,
            'tipo' => $tipo,
            'recaudos' => $recaudos
        ]);
    }

function recaudoFiducia()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $recaudos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            if(!$tipo || empty($tipo)){
                $totalMovimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }elseif($tipo == "derechos"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-impuesto')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-impuesto')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();
            }elseif ($tipo == "comparendos"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-comparendo')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-comparendo')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }elseif ($tipo == "tramites"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-tramite')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-tramite')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }

            foreach($movimientos as $movimiento){
                
                $factura = json_decode($movimiento->factura, true);
                $totalIntereses += $factura['intereses'];
                $totalImpuestos += $movimiento->valor;
                $totalHonorarios += $factura['honorarios'];
                $totalSistematizacion += $factura['sistematizacion']/1.19;
                $totalIva += (($factura['sistematizacion']/1.19)*0.19);
                $totalDescuentos += $factura['campana_calculados'];
                                
                $totalIva += $movimiento->pagos->sum('pago_aplicado_iva');
                $totalIntereses += $movimiento->pagos->sum('pago_aplicado_intereses');
                $totalImpuestos += $movimiento->pagos->sum('pago_aplicado_impuestos');
                $totalHonorarios += $movimiento->pagos->sum('pago_aplicado_honorarios');
                $totalSistematizacion += $movimiento->pagos->sum('pago_aplicado_sistematizacion');
                $totalDescuentos += $movimiento->pagos->sum('descuento_aplicado');

                if($movimiento->etiqueta == 'pago-comparendo'){
                    foreach($movimiento->obtenerComparendosObj() as $comparendo){
                        $totalDescuentos += $comparendo->calcularDescuento();
                    }
                }
            }

            $c=Cuenta::where('id_organismo', \Auth::user()->organismo->id)->get();
            
            foreach($c as $cuenta){
               /* $total = Destino::where('id_cuenta', $cuenta->id)
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('fecha_tx', '>=', $fechaArray[0])
                    ->whereDate('fecha_tx', '<=', $fechaArray[1])
                    ->sum('valor');*/
                    
                $total = TransaccionPorAprobar::where('cuenta', $cuenta->id)
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');                 
                    
                    
                $cuentas[$cuenta->id]['cuenta'] = $cuenta;
                $cuentas[$cuenta->id]['total'] = $total;
            }



$recaudos = RecaudoSimit::where('fuente','=', 'externo')
            ->select(
                DB::raw('C9 as `valor`'),
                DB::raw("substr(c2,1,2) as dia,substr(c2,4,2) as mes,substr(c2,7,4) as ano"),
                DB::raw("CONCAT_WS('-',substr(c2,4,2),substr(c2,7,4),substr(c2,1,2)) as fecha"))
            ->limit(10)->get();


        }

        return view('reportes.recaudoFiducia', [
            'movimientos' => $movimientos,
            'totalMovimientos' => $totalMovimientos,
            'totalImpuestos' => $totalImpuestos,
            'totalSistematizacion' => $totalSistematizacion,
            'totalHonorarios' => $totalHonorarios,
            'totalIntereses' => $totalIntereses,
            'totalDescuentos' => $totalDescuentos,
            'totalIva' => $totalIva,
            'cuentas' => $cuentas,
            'tipo' => $tipo,
            'recaudos' => $recaudos
        ]);
    }



public function uploadComparendos(Request $request)
    {
        $file = $request->file;
        $fecha = Carbon::now();
      //  \DB::table('comparendos_simit')->truncate();

        if ($file->getClientOriginalExtension() == "txt") {
            $destinationPath = public_path() . '/docs/comparendos';
            $relative = '/docs/comparendos/';
            //$fileData = preg_replace('/\s+/', '', $request->cedula . trim($fecha) . $file->getclientoriginalname());
            $fileData = "comparendos_simit.txt";

            $sw=0;
           


            if($sw==0)
            {
            

       //     try {
                //$pqr->save();
                $file->move($destinationPath, $fileData);

    Artisan::call('simit:comparendos', [
      'id_usuario' => 4
    ]);

     Artisan::call('simit:mover-comparendo', [
      'id_usuario' => 4
    ]);
                //dd($request->no_radicacion. "-". $pqr->no_radicacion);
                //Session::put('success', 'El Archivo ha subido correctamente!');
                return redirect()->route('reporte.cargacomparendos');
      /*      } catch (\Exception $e) {
                Session::put('error', 'Se Produjo un error al subir archivo.');
                return redirect()->route('reporte.cargacomparendos');
            }*/
        }else
        {
            Session::put('error', 'Este numero de radicado ya esta registrado para este juzgado.');
            return redirect()->route('reporte.cargacomparendos');            
        }
        } else {
            Session::put('error', 'Archivo No Valido, Debe tener la extension .PDF');
            return redirect()->route('reporte.cargacomparendos');
        }
    }


public function uploadDatacredito(Request $request)
    {
        $file = $request->file;
        $fecha = Carbon::now();
      //  \DB::table('comparendos_simit')->truncate();

       //if ($file->getClientOriginalExtension() == "txt") {
            $destinationPath = public_path() . '/docs/datacredito';
            $relative = '/docs/datacredito/';
            //$fileData = preg_replace('/\s+/', '', $request->cedula . trim($fecha) . $file->getclientoriginalname());
            $fileData = "1.xlsx"; //$file->getclientoriginalname()

            $sw=0;
           


            if($sw==0)
            {

                $file->move($destinationPath, $fileData);
                Excel::import(new AlumnosImport(3), $destinationPath."/".$fileData);
                return redirect()->route('reporte.cargaDatacredito');

        }else
        {
            Session::put('error', 'Este numero de radicado ya esta registrado para este juzgado.');
            return redirect()->route('reporte.cargacomparendos');            
        }
        /*} else {
            Session::put('error', 'Archivo No Valido, Debe tener la extension .PDF');
            return redirect()->route('reporte.cargacomparendos');
        }*/
    }


function cargaComparendos()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $recaudos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $tipo = \Input::get('tipo');

            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            if (\Input::has('tipo_fecha')=="") {

                        $fechaArray[0] = new Carbon($fecha_inicial);
                        $fechaArray[1] = new Carbon($fecha_final);    

                            $movimientos = ComparendoSimit::whereDate('created_at', '>=', $fechaArray[0])
                                ->whereDate('created_at', '<=', $fechaArray[1])
                                ->orderBy('created_at','desc')
                                ->get();
            }else
            {

            /*$ano = substr($fecha_inicial, 6, 4);
            $mes = substr($fecha_inicial, 3, 2);
            $dia = substr($fecha_inicial, 0, 2);

            $ano2 = substr($fecha_final, 6, 4);
            $mes2 = substr($fecha_final, 3, 2);
            $dia2 = substr($fecha_final, 0, 2);


                $fecha_inicial=$ano."-".$mes."-".$dia;
                $fecha_final=$ano2."-".$mes2."-".$dia2;*/


                            $fechaArray[0] = new Carbon($fecha_inicial);
                            $fechaArray[1] = new Carbon($fecha_final);
                             $movimientos = ComparendoSimit::whereDate('COL3', '>=', $fechaArray[0])
                                ->whereDate('COL3', '<=', $fechaArray[1])
                                ->orderBy('created_at','desc')
                                ->get();               
            }


                $totalMovimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
                    ->where('estado', '<>', 'anulado')
                    ->sum('valor');            

        }

        return view('reportes.cargacomparendos', [
            'movimientos' => $movimientos
        ]);
    }



function reenviarComparendos(Request $request)
    {
        $numero = $request->id;

                   Artisan::call('simitws:registrocomparendo', [
                        'comparendo' => $numero
                       ]); 

        return \Redirect::route('home');

    }



function cargaBitacoras()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $recaudos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];

        if (\Input::has('fecha_inicial') ) {
            //$tipo = \Input::get('tipo');

            $fecha_inicial = \Input::get('fecha_inicial');
            //$fecha_final = \Input::get('fecha_final');

            if (\Input::has('tipo_fecha')=="") {

                        //$fechaArray[0] = new Carbon($fecha_inicial);
                        //$fechaArray[1] = new Carbon($fecha_final);    

                            $movimientos = Comparendo::where('infractor_documento', $fecha_inicial)
                                ->orwhere('numero', $fecha_inicial)
                                ->orderBy('created_at','desc')
                                ->get();
            }else
            {
       
            }

        

        }

        return view('reportes.cargabitacoras', [
            'movimientos' => $movimientos
        ]);
    }


public function uploadSeguimiento(Request $request)
    {
        $file = $request->file;
        $fecha = Carbon::now();

        if ($file->getClientOriginalExtension() == "pdf") {
            $destinationPath = public_path() . '/docs/seguimiento';
            $relative = '/docs/seguimiento/';
            $fileData = preg_replace('/\s+/', '', $request->cedula . trim($fecha) . $file->getclientoriginalname());
          //  try {
                $pqr = Bitacora::where('id', $request->id)->first();
                $pqr->respondido = "SI";
                $pqr->update();

                $respuestas = new BitacoraSeguimiento();
                $respuestas->respuesta_ruta = $relative . $fileData;
                $respuestas->respuesta_nombre = $fileData;
                $respuestas->fecha = $fecha;
                $respuestas->documento = $request->id;
                $respuestas->tipo_archivo='1';

                $respuestas->save();
                $pqr->envio = $respuestas->id;
                $pqr->update();
                $file->move($destinationPath, $fileData);
                Session::put('success', 'El Archivo ha subido correctamente!');
                return redirect()->route('reporte.bitacorasgeneradas');
         /*   } catch (\Exception $e) {
                Session::put('error', 'Se Produjo un error al subir archivo.');
                return redirect()->route('pqr.respuestas');
            }*/
        } else {
            Session::put('error', 'Archivo No Valido, Debe tener la extension .PDF');
            return redirect()->route('reporte.bitacorasgeneradas');
        }
    }

function bitacorasGeneradas()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $recaudos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];



                        //$fechaArray[0] = new Carbon($fecha_inicial);
                        //$fechaArray[1] = new Carbon($fecha_final);    

                            $movimientos = Bitacora::where('respondido','NO')
                                ->orderBy('created_at','desc')
                                ->get();


        return view('reportes.bitacorasgeneradas', [
            'movimientos' => $movimientos
        ]);
    }


function ingresarBitacoras()
    {


        $tpc = Tipo::where('tipo','tipobitacora')->get();
        $tpc2 = Tipo::where('tipo','documento')->get();


        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $recaudos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];


           $idn=0;


        if (\Input::has('idcomparendo') ) {
            //$tipo = \Input::get('tipo');

            $fecha_inicial = \Input::get('idcomparendo');
            //$fecha_final = \Input::get('fecha_final');

                            $movimientos = Comparendo::where('id', $fecha_inicial)
                                ->orderBy('created_at','desc')
                                ->get();
      

        }

        return view('reportes.ingresarbitacoras', ['id' => $idn,'movimientos' => $movimientos,
            'documentos' => $tpc,
            'documentos2' => $tpc2, 'usuario' => \Illuminate\Support\Facades\Auth::user()->name, 'fecha_sistema' => Carbon::now()->format('Y-m-d')]);
    }


public function guardarBitacoras(Request $request)
    {
        //$file = $request->file;
        $fecha = Carbon::now();

        $movimientos = Comparendo::where('id', $request->idcomparendo)
                                ->orderBy('created_at','desc')
                                ->first();

            $bita = new Bitacora();
            $bita->comparendo2= $request->numero;

        if($request->combo1=="numero" && $request->campo1!="")
        {
            $movimientos->numero = $request->campo1;
            $movimientos->numero_corto = $request->campo1;
            $bita->comparendo2= $request->campo1;
        }

        if($request->combo2=="numero" && $request->campo2!="")
        {
            $movimientos->numero = $request->campo2;
            $movimientos->numero_corto = $request->campo2;
             $bita->comparendo2= $request->campo2;
        }

        if($request->combo3=="numero" && $request->campo3!="")
        {
            $movimientos->numero = $request->campo3;
            $movimientos->numero_corto = $request->campo3;
             $bita->comparendo2= $request->campo3;
        }

        





$ciuda = Ciudadano::where('numero_documento', $movimientos->infractor_documento)->first();

        if($request->combo1=="identificacion" && $request->campo1!="")
        {
            $movimientos->infractor_documento = $request->campo1;

        $ciuda2 = Ciudadano::where('numero_documento', $request->campo1)->get();
            $sw=0;
            foreach($ciuda2 as $ci){
                 $sw=1;
            } 
            if($sw==0)
            {
                if ($ciuda ) {
                $ciuda->numero_documento = $request->campo1;
                $ciuda->save();
                }else
                {
                        $ciudadano = new Ciudadano();
                        $ciuda->numero_documento = $request->campo1;
                        $ciudadano->tipo_documento = "cc";
                        $ciudadano->save();                   
                }
            }           
            
        }

        if($request->combo2=="identificacion" && $request->campo2!="")
        {
            $movimientos->infractor_documento = $request->campo2;
        $ciuda2 = Ciudadano::where('numero_documento', $request->campo2)->get();
            $sw=0;
            foreach($ciuda2 as $ci){
                 $sw=1;
            } 
            if($sw==0)
            {
                if ($ciuda ) {
                $ciuda->numero_documento = $request->campo2;
                $ciuda->save();
                }else
                {
                        $ciudadano = new Ciudadano();
                        $ciuda->numero_documento = $request->campo2;
                        $ciudadano->tipo_documento = "cc";
                        $ciudadano->save();                   
                }
            } 

        }

        if($request->combo3=="identificacion" && $request->campo3!="")
        {
            $movimientos->infractor_documento = $request->campo3;
            $ciuda2 = Ciudadano::where('numero_documento', $request->campo3)->get();
            $sw=0;
            foreach($ciuda2 as $ci){
                 $sw=1;
            } 
            if($sw==0)
            {
                if ($ciuda ) {
                $ciuda->numero_documento = $request->campo3;
                $ciuda->save();
                }else
                {
                        $ciudadano = new Ciudadano();
                        $ciuda->numero_documento = $request->campo3;
                        $ciudadano->tipo_documento = "cc";
                        $ciudadano->save();                   
                }
            } 


        }



        $ciuda = Ciudadano::where('numero_documento', $movimientos->infractor_documento)->first();

        if($request->combo1=="nombre" && $request->campo1!="")
        {
            $movimientos->infractor_nombre = $request->campo1;
            $ciuda->nombre = $request->campo1;
        }

        if($request->combo2=="nombre" && $request->campo2!="")
        {
            $movimientos->infractor_nombre = $request->campo2;
            $ciuda->nombre = $request->campo2;
        }

        if($request->combo3=="nombre" && $request->campo3!="")
        {
            $movimientos->infractor_nombre = $request->campo3;
            $ciuda->nombre = $request->campo3;
        }


        if($request->combo1=="apellido" && $request->campo1!="")
        {
            $movimientos->infractor_apellido = $request->campo1;
            $ciuda->nombre = $ciuda->nombre." ".$request->campo1;
        }

        if($request->combo2=="apellido" && $request->campo2!="")
        {
            $movimientos->infractor_apellido = $request->campo2;
            $ciuda->nombre = $ciuda->nombre." ".$request->campo2;
        }

        if($request->combo3=="apellido" && $request->campo3!="")
        {
            $movimientos->infractor_apellido = $request->campo3;
            $ciuda->nombre = $ciuda->nombre." ".$request->campo3;
        }

        $ciuda->save();


        if($request->combo1=="placa" && $request->campo1!="")
        {
            $movimientos->vehiculo_placa = $request->campo1;
        }

        if($request->combo2=="placa" && $request->campo2!="")
        {
            $movimientos->vehiculo_placa = $request->campo2;
        }

        if($request->combo3=="placa" && $request->campo3!="")
        {
            $movimientos->vehiculo_placa = $request->campo3;
        }


        if($request->combo1=="infracciones" && $request->campo1!="")
        {
            $movimientos->infracciones = $request->campo1;
        }

        if($request->combo2=="infracciones" && $request->campo2!="")
        {
            $movimientos->infracciones = $request->campo2;
        }

        if($request->combo3=="infracciones" && $request->campo3!="")
        {
            $movimientos->infracciones = $request->campo3;
        }


        if($request->combo1=="fecha" && $request->campo1!="")
        {
            $movimientos->infraccion_fecha = $request->campo1;
        }

        if($request->combo2=="fecha" && $request->campo2!="")
        {
            $movimientos->infraccion_fecha = $request->campo2;
        }

        if($request->combo3=="fecha" && $request->campo3!="")
        {
            $movimientos->infraccion_fecha = $request->campo3;
        }

        if($request->combo4!="" )
        {
            $movimientos->infractor_tipo_documento = $request->combo4;
        }


            $movimientos->save();



            $bita->cedula = $request->cedula;
            $bita->nombre = $request->nombre;
            $bita->apellido = $request->apellido;
            $bita->descripcion= $request->descripcion;
            $bita->infraccion= $request->tipo_infraccion;
            $bita->fecha_infraccion= $request->fecha_infraccion;
            $bita->comparendo= $request->numero;
            $bita->tp_doc= $request->tpdoc;
            $bita->planilla= $request->placa;
            $bita->direccion= $request->dirigido;
            $bita->save();

            Artisan::call('bitacorapersonal:start', [
                  'id_comparendo' => $bita->id
              ]);

/*
            Artisan::call('bitacorasimit:start', [
                  'id_comparendo' => $bita->id
              ]);

            Artisan::call('bitacorasevial:start', [
                  'id_comparendo' => $bita->id
              ]);
*/


           /* $pqr->no_radicacion = $request->no_radicacion;
            $pqr->respondido = "NO";
            $pqr->archivo_ruta = $relative . $fileData;
            $pqr->archivo_nombre = $fileData;*/

            /*$tpd = TpDocumento::where('id', $request->tpdoc)->first()->id;

            $pqr->tp_doc = $tpd;*/

            try {
                //$pqr->save();
                //$file->move($destinationPath, $fileData);
                //dd($request->no_radicacion. "-". $pqr->no_radicacion);
                Session::put('success', 'Bitacora Cargada correctamente!');
                return redirect()->route('reporte.bitacorasgeneradas');
            } catch (\Exception $e) {
                Session::put('error', 'Se Produjo un error cargar la bitacora. '.$e->getMessage());
                return redirect()->route('reporte.cargabitacoras');
            }

    }



function descargar()
    {
        $input = Input::get('comp');
        $items = Comparendo::where('numero', $input)->get();

        $total = 0;
        $txt = "";
        $c = 1;
        foreach ($items as $item) {
            $total += $item->valor;
            $item->fecha_descarga = Carbon::now();
            $item->save();

            $tmp = [];
            $tmp['consecutivo'] = $c;
            $tmp['numero'] = $item->numero;
            $tmp['infraccion_fecha'] = Carbon::createFromFormat("Y-m-d", $item->infraccion_fecha)->format('d/m/Y');
            $tmp['infraccion_hora'] = Carbon::createFromFormat("H:i:s", $item->infraccion_hora)->format('Hi');
            $tmp['infraccion_direccion'] = $item->infraccion_direccion;
            $tmp['infraccion_ciudad'] = $item->infraccion_ciudad;
            $tmp['infraccion_localidad'] = $item->infraccion_localidad;
            $tmp['vehiculo_placa'] = $item->vehiculo_placa;
            $tmp['vehiculo_ciudad_matricula'] = $item->infraccion_ciudad;
            $tmp['vehiculo_tipo_vehiculo'] = $item->vehiculoTipo->codigo;
            $tmp['vehiculo_tipo_servicio'] = $item->vehiculoTipoServicio->codigo;
            $tmp['vehiculo_radio_accion'] = $item->vehiculo_radio_accion;;
            $tmp['vehiculo_modalidad'] =1; //$item->vehiculoModalidad->codigo;
            $tmp['vehiculo_tipo_transporte'] = 1; //$item->vehiculoTipoTransporte->codigo;
            $tmp['infractor_documento'] = $item->infractor_documento;
            $tmp['infractor_tipo_documento'] = $item->infractorTipoDocumento->codigo;
            $tmp['infractor_nombre'] = $item->infractor_nombre;
            $tmp['infractor_apellido'] = $item->infractor_apellido;
            $tmp['infractor_edad'] = $item->infractor_edad;
            $tmp['infractor_direccion'] = $item->infractor_direccion;
            $tmp['infractor_email'] = $item->infractor_email;
            $tmp['infractor_telefono'] = $item->infractor_telefono;
            $tmp['infractor_ciudad'] = $item->infractor_ciudad;
            $tmp['infractor_licencia'] = $item->infractor_licencia;
            $tmp['infractor_licencia_categoria'] = $item->infractor_licencia_categoria;
            $tmp['infractor_licencia_divipo'] =$item->infractor_licencia_divipo;

            $tmp['infractor_licencia_vence'] = "";
            if ($item->infractor_licencia_vence) {
                $tmp['infractor_licencia_vence'] = Carbon::createFromFormat("Y-m-d", $item->infractor_licencia_vence)->format('d/m/Y');
            }

            if ($item->infractorTipo) {
                $tmp['infractor_tipo'] = $item->infractorTipo->codigo;
            }

            $tmp['vehiculo_licencia'] = $item->vehiculo_licencia;
            $tmp['vehiculo_licencia_divipo'] = $item->vehiculo_licencia_divipo;
            $tmp['propietario_documento'] =  $item->propietario_documento; //$item->propietario->numero_documento;

            $tmp['propietario_tipo_documento'] = 1;
            if ($item->propietario_tipo_documento == "nit") {
                $tmp['propietario_tipo_documento'] = 4;
            }

            $tmp['propietario_nombre'] = $item->propietario_nombre;
            $tmp['empresa_nombre'] = $item->empresa_nombre;
            $tmp['empresa_nit'] = $item->empresa_nit;
            $tmp['empresa_tarjeta_operacion'] = $item->empresa_tarjeta_operacion;

            $tmp['observacion'] = $item->observacion;

        $age = Agente::where('id', $item->id_agente)->get();

        $agente1 = "001";
        foreach ($age as $it) {
                $agente1 =$it->codigo_simit;
        }
        $tmp['id_agente'] = $agente1;

            $tmp['es_fuga'] = "N";
            if ($item->es_fuga) {
                $tmp['es_fuga'] = "S";
            }

            $tmp['es_accidente'] = "N";
            if ($item->es_accidente) {
                $tmp['es_accidente'] = "S";
            }

            $tmp['es_inmovilizacion'] = "N";
            if ($item->es_inmovilizacion) {
                $tmp['es_inmovilizacion'] = "S";
            }

            $tmp['patio_nombre'] = "";
            $tmp['patio_direccion'] = "";

            if ($item->patio) {
                $tmp['patio_nombre'] = $item->patio->nombre;
                $tmp['patio_direccion'] = $item->patio->direccion;
            }

            $tmp['grua_numero'] = "";
            $tmp['grua_placa'] = "";
            if ($item->grua) {
                $tmp['grua_numero'] = $item->grua->numero;
                $tmp['grua_placa'] = $item->grua->placa;
            }

            $tmp['consecutivo_inmovilizacion'] = $item->consecutivo_inmovilizacion;
            $tmp['testigo_documento'] = $item->testigo_documento;
            $tmp['testigo_nombre'] = $item->testigo_nombre;
            $tmp['testigo_direccion'] = $item->testigo_direccion;
            $tmp['testigo_telefono'] = $item->testigo_telefono;

            $tmp['valor'] = $item->valor;
            $tmp['valor_adicional'] = $item->valor_adicional;
            $tmp['id_organismo'] = env('OT');//Auth::user()->organismo->codigo;
            $tmp['estado'] = $item->estado;

            $tmp['es_polca'] = "N";
            if ($item->es_polca) {
                $tmp['es_polca'] = "S";
            }

            $tmp['infracciones'] = $item->infracciones;
            $tmp['valor_infraccion'] = $item->valor;

            $tmp['es_fotomulta'] = "N";
            if ($item->es_fotomulta) {
                $tmp['es_fotomulta'] = "S";
            }

            $tmp['fecha_notificacion'] = "";
            if ($item->infraccion_fecha) {
                $tmp['fecha_notificacion'] = Carbon::createFromFormat("Y-m-d", $item->infraccion_fecha)->format('d/m/Y');
            }

            $tmp['grado_alcohol'] = $item->grado_alcohol;

            $txt .= implode(',', $tmp) . "\n";

            $c++;
        }

        $ascii = HomeController::string_to_ascii($txt);
        $digitoChequeo = $ascii % 10000;

        //Insertar oficio
        $oficio = new NumeracionOficio();
        $oficio->prefijo = 'OF';
        $oficio->numero = NumeracionOficio::obtenerSiguiente();
        $oficio->id_organismo = 1;//Auth::user()->organismo->id;
        $oficio->save();

        $control = array();
        $control['numreg'] = $c - 1;
        $control['sumreg'] = round($total);
        $control['oficio'] = "OF" . str_pad($oficio->numero, 8, "0", 0);
        $control['codchequeo'] = $digitoChequeo;

        $txt .= implode(',', $control);

        if (file_exists(public_path('/simit/' . env('OT') . "comp.txt"))) {
            unlink(public_path('/simit/' . env('OT') . "comp.txt"));
        }

        file_put_contents(public_path('/simit/' . env('OT') . "comp.txt"), $txt);
        return response()->download(public_path("/simit/" . env('OT') . "comp.txt"));
    }



function detalleBitacoras()
    {

        $movimientos = new Collection();
                            $movimientos = Bitacora::where('id', '>', 0)
                                ->orderBy('created_at','desc')
                                ->get();

        return view('reportes.detallebitacoras', [
            'movimientos' => $movimientos
        ]);
    }



function cargaDatacredito()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $recaudos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            //$tipo = \Input::get('tipo');

            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');
            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);  


                            $movimientos = ArchivoDatacredito::whereDate('created_at', '>=', $fechaArray[0])
                                ->whereDate('created_at', '<=', $fechaArray[1])
                                ->orderBy('created_at','desc')
                                ->get();          

        }

        return view('reportes.cargadatacredito', [
            'movimientos' => $movimientos
        ]);
    }


function cargaFormato()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $recaudos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            //$tipo = \Input::get('tipo');

            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');
            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);  


                            $movimientos = ArchivoDatacredito::whereDate('created_at', '>=', $fechaArray[0])
                                ->whereDate('created_at', '<=', $fechaArray[1])
                                ->orderBy('created_at','desc')
                                ->get();          

        }

        return view('reportes.cargaformato', [
            'movimientos' => $movimientos
        ]);
    }

function cargaEmbargos()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $recaudos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            //$tipo = \Input::get('tipo');

            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');
            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);  


                            $movimientos = ArchivoEmbargos::whereDate('created_at', '>=', $fechaArray[0])
                                ->whereDate('created_at', '<=', $fechaArray[1])
                                ->orderBy('created_at','desc')
                                ->get();          

        }

        return view('reportes.cargaembargos', [
            'movimientos' => $movimientos
        ]);
    }


function procesarEmbargos()
    {

    Artisan::call('mandamiento:embargo');

Session::put('success', 'Proceso Terminado!');

        $tipo = null;
        $fecha = Carbon::now()->format('Y-m-d');
        $fechaArray = [];
        $movimientos = new Collection();


            $fecha_inicial =  $fecha ;
            $fecha_final =  $fecha ;
            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);  


                            $movimientos = ArchivoEmbargos::whereDate('created_at', '>=', $fechaArray[0])
                                ->whereDate('created_at', '<=', $fechaArray[1])
                                ->orderBy('created_at','desc')
                                ->get();          


        return view('reportes.cargaembargos', [
            'movimientos' => $movimientos
        ]);
    }


    function recaudoConciliacion()
    {
        $tipo = null;
        $fecha = null;
        $fechaArray = [];
        $movimientos = new Collection();
        $totalMovimientos = null;
        $totalIva = 0;
        $totalIntereses = 0;
        $totalImpuestos = 0;
        $totalHonorarios = 0;
        $totalSistematizacion = 0;
        $totalDescuentos = 0;
        //Cuentas
        $cuentas = [];

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            $fechaArray[1] = new Carbon($fecha_final);

            if(!$tipo || empty($tipo)){
                $totalMovimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', '<>', 'apertura-caja')
                    ->where('etiqueta', '<>', 'cierre-caja')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }elseif($tipo == "derechos"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-impuesto')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-impuesto')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();
            }elseif ($tipo == "comparendos"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-comparendo')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-comparendo')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }elseif ($tipo == "tramites"){
                $totalMovimientos = Transaccion::where('etiqueta', 'pago-tramite')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');

                $movimientos = Transaccion::where('etiqueta', 'pago-tramite')
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->orderBy('created_at')
                    ->get();

            }

            foreach($movimientos as $movimiento){
				
				$factura = json_decode($movimiento->factura, true);
                $totalIntereses += $factura['intereses'];
                $totalImpuestos += $movimiento->valor;
                $totalHonorarios += $factura['honorarios'];
                $totalSistematizacion += $factura['sistematizacion']/1.19;
				$totalIva += (($factura['sistematizacion']/1.19)*0.19);
				$totalDescuentos += $factura['campana_calculados'];
								
                $totalIva += $movimiento->pagos->sum('pago_aplicado_iva');
                $totalIntereses += $movimiento->pagos->sum('pago_aplicado_intereses');
                $totalImpuestos += $movimiento->pagos->sum('pago_aplicado_impuestos');
                $totalHonorarios += $movimiento->pagos->sum('pago_aplicado_honorarios');
                $totalSistematizacion += $movimiento->pagos->sum('pago_aplicado_sistematizacion');
                $totalDescuentos += $movimiento->pagos->sum('descuento_aplicado');

                if($movimiento->etiqueta == 'pago-comparendo'){
                    foreach($movimiento->obtenerComparendosObj() as $comparendo){
                        $totalDescuentos += $comparendo->calcularDescuento();
                    }
                }
            }

			$c=Cuenta::where('id_organismo', \Auth::user()->organismo->id)->get();
			
            foreach($c as $cuenta){
               /* $total = Destino::where('id_cuenta', $cuenta->id)
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('fecha_tx', '>=', $fechaArray[0])
                    ->whereDate('fecha_tx', '<=', $fechaArray[1])
                    ->sum('valor');*/
					
                $total = TransaccionPorAprobar::where('cuenta', $cuenta->id)
                    ->where('id_organismo', \Auth::user()->organismo->id)
                    ->whereDate('created_at', '>=', $fechaArray[0])
                    ->whereDate('created_at', '<=', $fechaArray[1])
					->where('estado', '<>', 'anulado')
                    ->sum('valor');					
					
					
                $cuentas[$cuenta->id]['cuenta'] = $cuenta;
                $cuentas[$cuenta->id]['total'] = $total;
            }
        }

        return view('reportes.recaudoConciliacion', [
            'movimientos' => $movimientos,
            'totalMovimientos' => $totalMovimientos,
            'totalImpuestos' => $totalImpuestos,
            'totalSistematizacion' => $totalSistematizacion,
            'totalHonorarios' => $totalHonorarios,
            'totalIntereses' => $totalIntereses,
            'totalDescuentos' => $totalDescuentos,
            'totalIva' => $totalIva,
            'cuentas' => $cuentas,
            'tipo' => $tipo
        ]);
    }



    function cartera()
    {
        $items = null;
        $anoActual = date("Y");

        return view('reportes.coactivos', [
            'anoActual' => $anoActual,
            'items' => $items
        ]);
    }

    function carteramorosadetalle(Request $request)
    {
        $items = null;
        $anoActual = date("Y");

        return view('reportes.carteramorosadetalle', [
            'anoActual' => $anoActual,
            'items' => $items,
            'ano' => $request->get('ano')
        ]);
    }


    function resoluciones(Request $request)
    {
        $items = null;
        $anoActual = date("Y");
        $movimientos = new Collection();
        $totalMovimientos = null;

        $c=ResolucionSimitTipo::all();

        if (\Input::has('fecha_inicial') && \Input::has('fecha_final')) {
            $tipo = \Input::get('tipo');
            $fecha_inicial = \Input::get('fecha_inicial');
            $fecha_final = \Input::get('fecha_final');

            $fechaArray[0] = new Carbon($fecha_inicial);
            //$fechaArray[0] = $fechaArray[0]->format('Y-m-d');
            $fechaArray[1] = new Carbon($fecha_final);
            //$fechaArray[1] = $fechaArray[1]->format('Y-m-d');

         /*       $movimientos = ResolucionSimit::whereDate('COL4', '>=', $fechaArray[0])
                    ->whereDate('COL4', '<=', $fechaArray[1])->where('col5',$tipo)
                    ->orderBy('COL4')
                    ->get();

DB::raw(SELECT * FROM resoluciones_simit WHERE ( STR_TO_DATE(date, '%m/%d/%Y') BETWEEN '2014-08-05' AND '2014-08-05' ) ORDER BY id);*/

        $movimientos = ResolucionSimit::where('COL5', $tipo)->
        whereRaw("STR_TO_DATE(COL4,'%d/%m/%Y') >= '".$fecha_inicial."'")->
        whereRaw("STR_TO_DATE(COL4,'%d/%m/%Y') <= '".$fecha_final."'")->get();   

            }



        return view('reportes.resoluciones', [
            'tipos' => $c,
            'movimientos' => $movimientos,
            'totalMovimientos' => $totalMovimientos,
            'anoActual' => $anoActual,
            'items' => $items,
            'ano' => $request->get('ano'),
            'tipo' => $request->get('tipo')
        ]);
    }


    function descargaCartera(Request $request){
        $ano = $request->get('ano');

        if($ano == 0){
            return response()->download(public_path("xls/cartera/cartera-morosa.xlsx"));
        }else{
            return response()->download(public_path("xls/cartera/cartera-morosa-{$ano}.xlsx"));
        }
    }
}
