<?php namespace App\Http\Controllers;

use App\Http\Requests;
use App\Http\Requests\CreateofertasruralRequest;
use Illuminate\Http\Request;
use App\Libraries\Repositories\ofertasruralRepository;
use Mitul\Controller\AppBaseController;
use Response;
use Flash;

class ofertasruralController extends AppBaseController
{

	/** @var  ofertasruralRepository */
	private $ofertasruralRepository;

	function __construct(ofertasruralRepository $ofertasruralRepo)
	{
		$this->ofertasruralRepository = $ofertasruralRepo;
	}

	/**
	 * Display a listing of the ofertasrural.
	 *
	 * @param Request $request
	 *
	 * @return Response
	 */
	public function index(Request $request)
	{
	    $input = $request->all();

		$result = $this->ofertasruralRepository->search($input);

		$ofertasrurals = $result[0];

		$attributes = $result[1];

		return view('ofertasrurals.index')
		    ->with('ofertasrurals', $ofertasrurals)
		    ->with('attributes', $attributes);;
	}

	/**
	 * Show the form for creating a new ofertasrural.
	 *
	 * @return Response
	 */
	public function create()
	{
		return view('ofertasrurals.create');
	}

	/**
	 * Store a newly created ofertasrural in storage.
	 *
	 * @param CreateofertasruralRequest $request
	 *
	 * @return Response
	 */
	public function store(Request $request)
	{
        $input = $request->all();

		$ofertasrural = $this->ofertasruralRepository->store($input);

		Flash::message('ofertasrural saved successfully.');

		return redirect(route('ofertasrurals.index'));
	}

	/**
	 * Display the specified ofertasrural.
	 *
	 * @param  int $id
	 *
	 * @return Response
	 */
	public function show($id)
	{
		$ofertasrural = $this->ofertasruralRepository->findofertasruralById($id);

		if(empty($ofertasrural))
		{
			Flash::error('ofertasrural not found');
			return redirect(route('ofertasrurals.index'));
		}

		return view('ofertasrurals.show')->with('ofertasrural', $ofertasrural);
	}

	/**
	 * Show the form for editing the specified ofertasrural.
	 *
	 * @param  int  $id
	 * @return Response
	 */
	public function edit($id)
	{
		$ofertasrural = $this->ofertasruralRepository->findofertasruralById($id);

		if(empty($ofertasrural))
		{
			Flash::error('ofertasrural not found');
			return redirect(route('ofertasrurals.index'));
		}

		return view('ofertasrurals.edit')->with('ofertasrural', $ofertasrural);
	}

	/**
	 * Update the specified ofertasrural in storage.
	 *
	 * @param  int    $id
	 * @param CreateofertasruralRequest $request
	 *
	 * @return Response
	 */
	public function update($id, Request $request)
	{
		$ofertasrural = $this->ofertasruralRepository->findofertasruralById($id);

		if(empty($ofertasrural))
		{
			Flash::error('ofertasrural not found');
			return redirect(route('ofertasrurals.index'));
		}

		$ofertasrural = $this->ofertasruralRepository->update($ofertasrural, $request->all());

		Flash::message('ofertasrural updated successfully.');

		return redirect(route('ofertasrurals.index'));
	}

	/**
	 * Remove the specified ofertasrural from storage.
	 *
	 * @param  int $id
	 *
	 * @return Response
	 */
	public function destroy($id)
	{
		$ofertasrural = $this->ofertasruralRepository->findofertasruralById($id);

		if(empty($ofertasrural))
		{
			Flash::error('ofertasrural not found');
			return redirect(route('ofertasrurals.index'));
		}

		$ofertasrural->delete();

		Flash::message('ofertasrural deleted successfully.');

		return redirect(route('ofertasrurals.index'));
	}

}
