<?php

namespace App\Libraries\Repositories;


use App\Models\agentes;
use Illuminate\Support\Facades\Schema;

class agentesRepository
{

	/**
	 * Returns all agentes
	 *
	 * @return \Illuminate\Database\Eloquent\Collection|static[]
	 */
	public function all()
	{
		return agentes::all();
	}

	public function search($input)
    {
        $query = agentes::query();

        $columns = Schema::getColumnListing('agentes');
        $attributes = array();

        foreach($columns as $attribute){
            if(isset($input[$attribute]))
            {
                $query->where($attribute, $input[$attribute]);
                $attributes[$attribute] =  $input[$attribute];
            }else{
                $attributes[$attribute] =  null;
            }
        };

        return [$query->get(), $attributes];

    }

	/**
	 * Stores agentes into database
	 *
	 * @param array $input
	 *
	 * @return agentes
	 */
	public function store($input)
	{
		return agentes::create($input);
	}

	/**
	 * Find agentes by given id
	 *
	 * @param int $id
	 *
	 * @return \Illuminate\Support\Collection|null|static|agentes
	 */
	public function findagentesById($id)
	{
		return agentes::find($id);
	}

	/**
	 * Updates agentes into database
	 *
	 * @param agentes $agentes
	 * @param array $input
	 *
	 * @return agentes
	 */
	public function update($agentes, $input)
	{
		$agentes->fill($input);
		$agentes->save();

		return $agentes;
	}
}