<?php

namespace App\Libraries\Repositories;


use App\Models\ofertaph;
use Illuminate\Support\Facades\Schema;

class ofertaphRepository
{

	/**
	 * Returns all ofertaphs
	 *
	 * @return \Illuminate\Database\Eloquent\Collection|static[]
	 */
	public function all()
	{
		return ofertaph::all();
	}

	public function search($input)
    {
        $query = ofertaph::query();

        $columns = Schema::getColumnListing('ofertaphs');
        $attributes = array();

        foreach($columns as $attribute){
            if(isset($input[$attribute]))
            {
                $query->where($attribute, $input[$attribute]);
                $attributes[$attribute] =  $input[$attribute];
            }else{
                $attributes[$attribute] =  null;
            }
        };

        return [$query->get(), $attributes];

    }

	/**
	 * Stores ofertaph into database
	 *
	 * @param array $input
	 *
	 * @return ofertaph
	 */
	public function store($input)
	{
		return ofertaph::create($input);
	}

	/**
	 * Find ofertaph by given id
	 *
	 * @param int $id
	 *
	 * @return \Illuminate\Support\Collection|null|static|ofertaph
	 */
	public function findofertaphById($id)
	{
		return ofertaph::find($id);
	}

	/**
	 * Updates ofertaph into database
	 *
	 * @param ofertaph $ofertaph
	 * @param array $input
	 *
	 * @return ofertaph
	 */
	public function update($ofertaph, $input)
	{
		$ofertaph->fill($input);
		$ofertaph->save();

		return $ofertaph;
	}
}