<?php

namespace App\Libraries\Repositories;


use App\Models\ofertasnph;
use Illuminate\Support\Facades\Schema;

class ofertasnphRepository
{

	/**
	 * Returns all ofertasnphs
	 *
	 * @return \Illuminate\Database\Eloquent\Collection|static[]
	 */
	public function all()
	{
		return ofertasnph::all();
	}

	public function search($input)
    {
        $query = ofertasnph::query();

        $columns = Schema::getColumnListing('ofertasnphs');
        $attributes = array();

        foreach($columns as $attribute){
            if(isset($input[$attribute]))
            {
                $query->where($attribute, $input[$attribute]);
                $attributes[$attribute] =  $input[$attribute];
            }else{
                $attributes[$attribute] =  null;
            }
        };

        return [$query->get(), $attributes];

    }

	/**
	 * Stores ofertasnph into database
	 *
	 * @param array $input
	 *
	 * @return ofertasnph
	 */
	public function store($input)
	{
		return ofertasnph::create($input);
	}

	/**
	 * Find ofertasnph by given id
	 *
	 * @param int $id
	 *
	 * @return \Illuminate\Support\Collection|null|static|ofertasnph
	 */
	public function findofertasnphById($id)
	{
		return ofertasnph::find($id);
	}

	/**
	 * Updates ofertasnph into database
	 *
	 * @param ofertasnph $ofertasnph
	 * @param array $input
	 *
	 * @return ofertasnph
	 */
	public function update($ofertasnph, $input)
	{
		$ofertasnph->fill($input);
		$ofertasnph->save();

		return $ofertasnph;
	}
}