<?php

namespace App\Libraries\Repositories;


use App\Models\ofertasph;
use Illuminate\Support\Facades\Schema;

class ofertasphRepository
{

	/**
	 * Returns all ofertasphs
	 *
	 * @return \Illuminate\Database\Eloquent\Collection|static[]
	 */
	public function all()
	{
		return ofertasph::all();
	}

	public function search($input)
    {
        $query = ofertasph::query();
		
        $columns = Schema::getColumnListing('ofertasphs');
        $attributes = array();
		
        foreach($columns as $attribute){
			if(isset($input[$attribute]))
            {
				$query->where($attribute, $input[$attribute]);
                $attributes[$attribute] =  $input[$attribute];
            }else{
                $attributes[$attribute] =  null;
            }
        };

        return [$query->get(), $attributes];
    }

	/**
	 * Stores ofertasph into database
	 *
	 * @param array $input
	 *
	 * @return ofertasph
	 */
	public function store($input)
	{
		return ofertasph::create($input);
	}

	/**
	 * Find ofertasph by given id
	 *
	 * @param int $id
	 *
	 * @return \Illuminate\Support\Collection|null|static|ofertasph
	 */
	public function findofertasphById($id)
	{
		return ofertasph::find($id);
	}

	/**
	 * Updates ofertasph into database
	 *
	 * @param ofertasph $ofertasph
	 * @param array $input
	 *
	 * @return ofertasph
	 */
	public function update($ofertasph, $input)
	{
		$ofertasph->fill($input);
		$ofertasph->save();

		return $ofertasph;
	}
}