<?php

namespace App\Libraries\Repositories;


use App\Models\ofertasrural;
use Illuminate\Support\Facades\Schema;

class ofertasruralRepository
{

	/**
	 * Returns all ofertasrurals
	 *
	 * @return \Illuminate\Database\Eloquent\Collection|static[]
	 */
	public function all()
	{
		return ofertasrural::all();
	}

	public function search($input)
    {
        $query = ofertasrural::query();

        $columns = Schema::getColumnListing('ofertasrurals');
        $attributes = array();

        foreach($columns as $attribute){
            if(isset($input[$attribute]))
            {
                $query->where($attribute, $input[$attribute]);
                $attributes[$attribute] =  $input[$attribute];
            }else{
                $attributes[$attribute] =  null;
            }
        };

        return [$query->get(), $attributes];

    }

	/**
	 * Stores ofertasrural into database
	 *
	 * @param array $input
	 *
	 * @return ofertasrural
	 */
	public function store($input)
	{
		return ofertasrural::create($input);
	}

	/**
	 * Find ofertasrural by given id
	 *
	 * @param int $id
	 *
	 * @return \Illuminate\Support\Collection|null|static|ofertasrural
	 */
	public function findofertasruralById($id)
	{
		return ofertasrural::find($id);
	}

	/**
	 * Updates ofertasrural into database
	 *
	 * @param ofertasrural $ofertasrural
	 * @param array $input
	 *
	 * @return ofertasrural
	 */
	public function update($ofertasrural, $input)
	{
		$ofertasrural->fill($input);
		$ofertasrural->save();

		return $ofertasrural;
	}
}