<?php

namespace App;

use App\helpers\TipoUserManager;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;

class Menu extends Model
{
    protected $connection = 'mysql';
    protected $table = 'menu';

    function hijos(){
        return $this->hasMany('App\Menu', 'padre');
    }
/*
    function getHijos($padre){
        $hijos = Menu::where('padre', $padre)->get();
        return $hijos;
    }
*/

    function getHijos($padre){
        $hijos = Menu::where('padre', $padre)->where('active', '1')->get();
        foreach($hijos as $hijo){
            if($hijo->count_active == 1){
                if($hijo->count_table){
                    $hijo->counts_socket = $this->getCantidad($hijo);
                }
            }
        }
        return $hijos;
    }

    private function getCantidad($menu)
    {
        $condiciones = $this->getCondiciones($menu->id);
        if(!$condiciones->isEmpty()) {
            return DB::connection('mysql')->table($menu->count_table)->when($condiciones, function($query, $condiciones) {
                foreach($condiciones as $condicion) {
                    $value = preg_match('/auth/i', $condicion->value) ? Auth::id() : $condicion->value;
                    if(preg_match('/^\W$/', $condicion->operator)) {
                        $query->where($condicion->column, $condicion->operator, $value);
                    }elseif(preg_match('/^in$/i', $condicion->operator)){
                        $arr = explode(',', $value);
                        $query->whereIn($condicion->column, $arr);
                    }elseif(preg_match('/notIn/i',$condicion->operator)){
                        $arr = explode(',', $value);
                        $query->whereNotIn($condicion->column, $arr);
                    }else if(preg_match('/authByRolLectura/i',$condicion->operator)){
                        $rol = TipoUserManager::getRol();
                        if(!$rol->lectura){
                            $query->where($condicion->column, Auth::id());
                        }
                    }
                }
            })->count();
        }

        return 0;
    }

    private function getCondiciones($menuId)
    { 
        return DB::connection('mysql')->table('columns_menu')->where('menu', $menuId)->get();
    }


}
