<?php

namespace App;

use Illuminate\Support\Facades\DB;
use Illuminate\Database\Eloquent\Model;

class ResolucionSimit extends Model
{
    protected $connection = 'mysql2';
    protected $table = "resoluciones_simit";

    function calcularInteres(){

    }

    function comparendo()
    {
        return $this->hasOne('App\Comparendo', 'numero', $this->COL7);
    }

    function Tipo()
    {
        return $this->belongsTo('App\ResolucionSimitTipo', 'COL5');
    }

    public static function getComparendosConOpcionContinuidad()
    {
      $comparendos = Comparendo::select(
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '2' order by rs.COL4 limit 2) as countexfallo"),
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '6' order by rs.COL4 limit 2) as countap"),
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '8' order by rs.COL4 limit 2) as countapresumen"),
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '12' order by rs.COL4 limit 2) as countanulacion"),
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '16' order by rs.COL4 limit 2) as countmandamiento"),
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '1') as count_resolucion_sancion"),
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '17' order by rs.COL4 limit 2) as count17"),
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '18' order by rs.COL4 limit 2) as count18"),
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '3' order by rs.COL4 limit 2) as prescrito"),
          DB::raw("(select count(rs.COL4) from resoluciones_simit as rs where rs.COL7 = c.numero and rs.COL5 = '21' order by rs.COL4 limit 2) as revocatoriadirecta"),
          DB::raw("c.*")
      )
      ->from(DB::raw('comparendos c'))
      ->where('c.estado', '!=', DB::raw("2"))
      ->where('c.estado', '!=', DB::raw("11"))
      ->whereNull('fecha_pago');

      $consulta = $comparendos;
      $querySql = $consulta->toSql();

      $queryFinal = DB::table(DB::raw("($querySql) as tabla"));

      return $queryFinal;
    }

    /**
     * @autor: David Bastidas
     * ciudadanos con la direccion desactualizada
     */
    public static function resolucionesDireccionDesactualizada()
    {
        $comparendos = ResolucionSimit::select(
          DB::raw("rs.*")
        )
        ->from('resoluciones_simit as rs')
        ->leftJoin('ciudadanos as ci', 'ci.numero_documento', '=', 'COL9')
        ->leftJoin('ciudadanos_ubicacion as cu', 'cu.id_ciudadano', '=', 'ci.id')
        ->where(function ($query) {
            $query->where('cu.fecha_actualizacion', '<', DB::raw('DATE_ADD(curdate(), INTERVAL -3 MONTH)'))
                ->orWhereNull('cu.fecha_actualizacion');
        })
        ->where(function ($query) {
            $query->where('COL2', 'like', DB::raw("'RMP-%'"))
                ->orWhere('COL2', 'like', DB::raw("'RS-%'"));
        })
        ->where(DB::raw("(select es_recaudo_minimo from comparendos as c where c.numero = COL7 limit 1)"), '=', DB::raw('0'))
        ->where(function ($query) {
            $query->where('COL5', 'like', DB::raw("'1'"))
                ->orWhere('COL5', 'like', DB::raw("'16'"));
        })
        ->where('es_direccion_valida', '=', DB::raw('0'));

        $consulta = $comparendos;
        $querySql = $consulta->toSql();

        $queryFinal = DB::table(DB::raw("($querySql) as tabla"));

        return $queryFinal;
    }

    /**
     * @autor: David Bastidas
     * resoluciones para embargos
     */
    public static function getResolucionesByComparendo()
    {
        $resoluciones = ResolucionSimit::select(
            DB::raw("rs.*, STR_TO_DATE(COL4, '%d/%m/%Y') AS fecha_resol"),
            DB::raw("(select count(ex.id_tipo_evento) from comparendos_expediente as ex where ex.nombre_documento = rs.COL2 and ex.id_tipo_evento = 19 limit 2) as embargo")
        )
        ->from(DB::raw('resoluciones_simit as rs'))
        ->where('rs.confirmado_simit', '!=', DB::raw("-1"))
        ->where('rs.COL5', '=', DB::raw("16"));

        $consulta = $resoluciones;
        $querySql = $consulta->toSql();

        $queryFinal = DB::table(DB::raw("($querySql) as tabla"));

        return $queryFinal;
    }

    /**
     * @autor: David Bastidas
     * resoluciones para desembargos
     */
    public static function getResolucionesDesembargo()
    {
        $resoluciones = ResolucionSimit::select(
            DB::raw("rs.*, STR_TO_DATE(COL4, '%d/%m/%Y') AS fecha_resol"),
            DB::raw("(select count(1) from comparendos_expediente as ex where ex.nombre_documento = rs.COL2 and ex.id_tipo_evento = 19 limit 1) as embargo"),
            DB::raw("(select count(1) from comparendos as c where c.numero = rs.COL7 and c.es_recaudo_minimo = 1 limit 1) as pago")
        )
        ->from(DB::raw('resoluciones_simit as rs'))
        ->where('rs.COL5', '=', DB::raw("16"));

        $consulta = $resoluciones;
        $querySql = $consulta->toSql();

        $queryFinal = DB::table(DB::raw("($querySql) as tabla"));

        return $queryFinal;
    }
}
