<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Transaccion extends Model
{
    protected $connection = 'mysql2';
    protected $table = 'transacciones';

    function responsable(){
        return $this->belongsTo('App\User', 'id_usuario');
    }

    function numeracionFactura(){
        return $this->hasOne('App\NumeracionDetalle', 'id_transaccion');
    }

    function datos(){
        return json_decode($this->factura, true);
    }

    function pagos(){
        return $this->hasMany('App\Pago', 'id_transaccion');
    }

    function destinos(){
        return $this->hasMany('App\Destino','id_transaccion');
    }

    function recibo(){
        return $this->belongsTo('App\Recibo', 'id_recibo');
    }

    function obtenerComparendos(){
        $comparendos = $this->datos()['comparendos'];
        $comparendosTmp = Comparendo::whereIn('id', $comparendos)->get();


        $str = "";
        $coma = "";
        foreach($comparendosTmp as $comp){
            $str .= $coma . $comp->numero_corto;
            $coma = ", ";
        }

        return $str;
    }

    function obtenerPrimerComparendo()
    {
        $comparendos = $this->datos()['comparendos'];
        $comparendo = Comparendo::whereIn('id', $comparendos)->first();

        return $comparendo;
    }

    function obtenerComparendosObj()
    {
        $comparendosStr = $this->datos()['comparendos'];
        $comparendos = Comparendo::whereIn('id', $comparendosStr)->get();

        return $comparendos;
    }

    function esTransaccionAprobada()
    {
        $transaccion = TransaccionPorAprobar::where('id_transaccion', '=', $this->id)
                                            ->where('estado', '=', 'Aplicado')
                                            ->first();
        $esAplicado = false;
        if(isset($transaccion->id)){
          $esAplicado = true;
        }
        return $esAplicado;
    }
    function getFechaTransaccion()
    {
        $transaccion = TransaccionPorAprobar::where('id_transaccion', '=', $this->id)
                                            ->where('estado', '=', 'Aplicado')
                                            ->first();
        return $transaccion->fecha_descarga;
    }
}
