<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Support\Facades\Config;
use Illuminate\Support\Facades\DB;

class User extends Authenticatable
{
    use Notifiable;
    protected $connection = 'mysql';
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password', 'id'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    public function organismo()
    {
        return $this->belongsTo('App\Organismo', 'id_organismo');
    }

    public function name_user()
    {
        return $this->belongsTo('App\Users', 'id');
    }

    public function perfiles()
    {
        return $this->belongsToMany('App\Perfil', 'usuario_perfil', 'id_usuario', 'id_perfil')->withTimestamps();
        //return $this->belongsTo('App\Perfil', 'id_perfil');
    }

  

    public function listaPerfiles()
    {
        $perfiles = $this->perfiles->pluck('nombre')->toArray();
        return implode(', ', $perfiles);
    }

    public function listaPermisos()
    {
        $permisos = collect();
        foreach ($this->perfiles as $perfil) {
            foreach ($perfil->permisos as $permiso) {
                $permisos->push($permiso->ruta);
            }
        }

        return $permisos;
    }

    public function autorizarPerfil($permi)
    {
//, $showError = false
        if ($this->role == 'admin' || $this->tieneCualquierPermiso($permi,$this->id) ) {
            return true;
        }

        //if ($showError) {
            //abort(403, 'This action is unauthorized.');
       // }

        return false;
    }

    public function tieneCualquierPermiso($permi, $idu)
    {

       $per =UsuarioPerfil::where('id_usuario',$idu)->get();
       $sw = 0;
        foreach ($per as $pe) {
            $tmp = PerfilMenu::where('id_menu',$permi)->where('id_perfil',$pe->id_perfil)->get()->sortBy('orden');        
            foreach ($tmp as $tm) {
              $sw = 1;  
            }
        }

        if ($sw == 1) {
            return true;
        }

        return false;
    }

    public function tienePermiso($etiqueta)
    {
        $permisos = $this->listaPermisos();

        if ($permisos->contains($etiqueta)) {
            return true;
        }

        return false;
    }
}
