<?php

namespace App\helpers;

use Illuminate\Support\Facades\Auth;
use App\User;
use App\TipoUser;

class TipoUserManager {

    public static function getRol($id = null)
    {
        $id = $id ?? Auth::id();        
        $user = User::find($id);

        if($user){
            if($user->is_super == 1) return self::generateSuperUser($user);
            $tipoUser = TipoUser::find($user->id_tipo_usuario);

            if($tipoUser) {
                return (object)[
                    'id' => $tipoUser->id,
                    'nombre' => $tipoUser->nombre,
                    'tipo_pqr' => $tipoUser->tipo_pqr,
                    'active' => $tipoUser->active,
                    'created_at' => $tipoUser->created_at,
                    'updated_at' => $tipoUser->updated_at,
                    'superusuario' => false,
                    'lectura' => $tipoUser->lectura == 0 ? false : true
                ];
            }
        }

        return null;        
    }

    private static function generateSuperUser($user)
    {
        return (object)[
            'id' => $user->id,
            'nombre' => 'Superusuario',
            'tipo_pqr' => 1,
            'active' => $user->active,
            'created_at' => $user->created_at,
            'updated_at' => $user->updated_at,
            'superusuario' => true,
            'lectura' => true
        ];
    }

}