const labels = {
    "pqrs.fecha_recepcion": "F. Recepción",
    "pqrs.no_radicacion": "# Radicación",
    "pqrs.cedula": "Identificación",
    "pqrs.nombre": "Peticionario",
    "pqrs_tipo_documentos.nombre": "Tipo de Documento",
    "pqrs.direccion": "Dirección",
    "pqrs.email": "Email",
    "juzgados.nombre": "Juzgado",
    "divipos_municipios.nombre_municipio": "Ciudad peticonario",
    "users.name": "Signatario",
    fecha_sistema: "Fecha",
    "entidad.nombre": "Nombre entidad",
    "firma_electronica": "Firma electronica"
  };
  
  tinymce.init({
    selector: "textarea#body",
    language: "es",
    branding: false,
    relative_urls: false,
    setup: (editor) => {
      editor.on("input", (e) => {
        uploadPreview(e.content)
     });
      editor.on("SetContent", (e) => {
        uploadPreview(e.content)
      });
    },
  });
  
  function initLabels() {
    $.each(labels, (key, value) => {
      $("<button>", {
        class: "btn btn-xs btn-primary m-1",
        type: "button",
      })
        .text(value)
        .on("click", (e) => {
          const textarea = $(e.currentTarget).parent().parent().find("textarea");
          tinymce.get(textarea.attr("id")).selection.setContent(`[[${key}]]`);
        })
        .data("key", key)
        .appendTo(".Labels");
    });
  }
  
  function imgLabels() {
    //Header
    $("<button>", {
      class: "btn btn-xs btn-primary m-1",
      type: "button",
    })
      .text("IMG encabezado")
      .on("click", (e) => {
        const textarea = $(e.currentTarget).parent().parent().find("textarea");
        const img = `<img src="${$("#imgHeader").val()}">`;
        tinymce.get(textarea.attr("id")).selection.setContent(img);
      })
      .appendTo("#headerlabels");
    //footer
    $("<button>", {
      class: "btn btn-xs btn-primary m-1",
      type: "button",
    })
      .text("IMG pie de página")
      .on("click", (e) => {
        const textarea = $(e.currentTarget).parent().parent().find("textarea");
        const img = `<img src="${$("#footerimg").val()}">`;
        tinymce.get(textarea.attr("id")).selection.setContent(img);
      })
      .appendTo("#footerlabels");
  }
  
  $("#tipoforms_replace").on("change", function () {
    const content = $(this).find(":selected").attr("data-body");
    const editor = tinymce.get("body");
    if ($(this).val() != '0') {
      editor.setContent(content);
    } else {
      editor.setContent("");
    }
  });

  
  $("#formpreview").on("submit", function () {
    const content = tinymce.get("body").getContent();
    $("#contentpreview").val(content);
  });
  
  initLabels();
  
  function uploadPreview(content) {  

    const payload = new FormData();
    const xhr = new XMLHttpRequest();
  
    xhr.open("POST", $("#routeSetPreview").val());
    xhr.setRequestHeader(
      "X-CSRF-Token",
      $('meta[name="csrf-token"]').attr("content")
    );
  
    payload.append("content", content);
  
    xhr.send(payload);
  }
