const img_handler = (blobInfo, progress) =>
  new Promise((resolve, reject) => {
    const xhr = new XMLHttpRequest();
    xhr.withCredentials = false;
    xhr.open("POST", $("#imgRouteHandler").data("route"));
    token = $('input[name="_token"]').val();
    xhr.setRequestHeader("X-CSRF-Token", token);

    xhr.upload.onprogress = (e) => {
      progress((e.loaded / e.total) * 100);
    };

    xhr.onload = () => {
      if (xhr.status === 403) {
        reject({ message: "HTTP Error: " + xhr.status, remove: true });
        return;
      }

      if (xhr.status < 200 || xhr.status >= 300) {
        reject("HTTP Error: " + xhr.status);
        return;
      }

      const json = JSON.parse(xhr.responseText);

      if (!json || typeof json.location != "string") {
        reject("Invalid JSON: " + xhr.responseText);
        return;
      }

      resolve(json.location);
    };

    xhr.onerror = () => {
      reject(
        "Image upload failed due to a XHR Transport error. Code: " + xhr.status
      );
    };

    const formData = new FormData();
    formData.append("file", blobInfo.blob(), blobInfo.filename());

    xhr.send(formData);
});

function showUploadTabOnInit() {
  var observer = new MutationObserver(function () {
    var selector =
      ".tox-dialog .tox-dialog__body-nav .tox-tab.tox-dialog__body-nav-item:nth-child(2)";
    var tab = document.querySelector(selector);
    if (tab) tab.click();
  });

  var dialogContainer = document.querySelector("body > .tox.tox-tinymce-aux");
  observer.observe(dialogContainer, {
    childList: true,
  });
}

tinymce.init({
  selector: "textarea",
  language: "es",
  branding: false,
  plugins: "image autoresize",
  toolbar: "image",
  automatic_uploads: true,
  file_picker_types: "image",
  relative_urls: false,
  images_upload_handler: img_handler,
  image_uploadtab: true,
  init_instance_callback: showUploadTabOnInit
});
