<style>
    ol li a, ol li, .breadcrumb-item::before {
        color: white !important;
    }

    .fas{
        font-size: 15px !important;
    }
</style>

<?php 
    use Illuminate\Support\Facades\Auth;
    use Illuminate\Database\Query\Builder;
    use App\PqrsFavorito;
    use App\Noticia;
    use Illuminate\Support\Facades\DB;
    $favoritos = PqrsFavorito::where("id_user",Auth()->id())->where("is_favorite",'1')->count();

    $noticias = Noticia::from("noticia as n")
    ->join("noticia_area as na","n.id","=","na.id_noticia")
    ->join("users as u","u.id_area","=","na.id_area")
    ->where('n.estado',1)
    ->where('n.active',1)
    ->where('u.id',Auth()->id())
    ->whereNotIn('n.id',[DB::raw("select id from noticia_historial nh where nh.id_user=".Auth()->id())])
    ->groupBy('n.id')
    ->get();

    $cont_noticias = Noticia::from("noticia as n")
    ->join("noticia_area as na","n.id","=","na.id_noticia")
    ->join("users as u","u.id_area","=","na.id_area")
    ->where('n.estado',1)
    ->where('n.active',1)
    ->where('u.id',Auth()->id())
    ->whereNotIn('n.id',[DB::raw("select id from noticia_historial nh where nh.id_user=".Auth()->id())])
    ->count();
?>

<nav class="navbar default-layout col-lg-12 col-12 p-0 fixed-top d-flex flex-row" style="z-index: 950">
    <div class="text-center navbar-brand-wrapper d-flex align-items-top justify-content-center">
        <a id="logo_normal" href="{{route('home')}}">
            <img style="width:80% !important;margin-top:3%;" src="{{asset('images/xiltrion.png')}}" alt="logo"/></a>
    </div>
    <div class="navbar-menu-wrapper d-flex align-items-center">
        <span class="profile-text" style="color:white !important;font-size: 18px;">OFERTAS</span>
        @yield('breadcrumbs')
        <ul class="navbar-nav navbar-nav-right">
            <a title="Tickets" type="button" class="btn btn-transparent" href="{{route('soporte.ticket')}}" target="_blank" style="
            padding-right:0px;"><i class="text-light fa fa-question" aria-hidden="true"></i></a>
            <a title="Favoritos" type="button" href="{{route('pqrs.favoritos')}}" class="btn btn-transparent" style="
            padding-right:0px;"><i class="text-light fas fa-star"></i><span class="badge badge-success">{{$favoritos}}</span></a>
            @if($cont_noticias > 0)
                <li class="nav-item dropdown no-arrow">
                    <a title="Noticias e Información" aria-expanded="false" class="btn btn-transparent dropdown-toggle " id="Btn_menu_noticia" data-toggle="dropdown" style="padding-left: 0px">
                        <i class="text-light align-left text-left fas fa-bullhorn"></i>
                        <span class="badge badge-danger">{{ $cont_noticias }}</span>
                    </a>
                    <div class="dropdown-menu dropdown-menu-right navbar-dropdown" style="width: 250px;padding-bottom:0px;">
                        @foreach ($noticias as $noticias)
                            <h6 class="dropdown-header text-left text-truncate align-bottom bg-custom text-light" style="max-width: 280px;"><i class="align-left text-left fas fa-bullhorn"></i> &nbsp; {{ $noticias->titulo }}</h6>
                            <a class="dropdown-item text-truncate align-middle" style="max-width: 210px;" href="{{route('noticias.buzon')}}"> {{ strip_tags($noticias->cuerpo) }}</a>
                            <br>
                            <div class="dropdown-divider border border-secondary"></div>
                        @endforeach
                    </div>
                </li>
            @else
                <a href="{{route('noticias.buzon')}}" title="Noticias e Información" type="button" class="btn btn-transparent" data-target="noticias">
                    <i class="text-light align-left text-left fas fa-bullhorn"></i>
                    <span class="badge badge-success">{{ $cont_noticias }}</span>
                </a>
            @endif
            <li class="nav-item dropdown no-arrow">
                <a class="nav-link dropdown-toggle" id="UserDropdown" href="#" data-toggle="dropdown" aria-expanded="false" aria-haspopup="true"><span class="profile-text" style="color:white !important;">Bienvenido, {{\Illuminate\Support\Facades\Auth::user()->name}}</span><img class="img-xs rounded-circle" src="{{asset('assets/images/faces/face8.jpg')}}" alt="Profile image"></a>
                <!-- Dropdown - User Information -->
                <div class="dropdown-menu dropdown-menu-right navbar-dropdown" aria-labelledby="userDropdown">
                    <a class="dropdown-item p-0">
                        <div class="d-flex">
                            <div class="py-4 px-3 d-flex align-items-center justify-content-center">
                            </div>
                            <div class="py-1 px-1 d-flex align-items-center justify-content-center">
                                X
                            </div>
                            <div class="py-1 px-1 d-flex align-items-center justify-content-center">
                                I
                            </div>
                            <div class="py-1 px-1 d-flex align-items-center justify-content-center">
                                L
                            </div>
                            <div class="py-1 px-1 d-flex align-items-center justify-content-center">
                                T
                            </div>
                            <div class="py-1 px-1 d-flex align-items-center justify-content-center">
                                R
                            </div>
                            <div class="py-1 px-1 d-flex align-items-center justify-content-center">
                                I
                            </div>
                            <div class="py-1 px-1 d-flex align-items-center justify-content-center">
                                O
                            </div>
                            <div class="py-1 px-1 d-flex align-items-center justify-content-center">
                                N
                            </div>
                        </div>
                    </a>
                    <div class="dropdown-divider"></div>
                    <form action="{{route('inicio.ajustesperfiluser', '1')}}" method="GET" style="padding: 0">
                        {{csrf_field()}}
                        <button class="dropdown-item" style="cursor:pointer;">
                            <i class="fas fa-cogs fa-sm fa-fw mr-2 text-gray-400"></i>
                            Ajustes
                        </button>
                    </form>
                    <div class="dropdown-divider"></div>
                    <form action="{{route('logout')}}" method="POST" style="padding: 0">
                        {{csrf_field()}}
                        <button type="submit" class="dropdown-item" style="cursor:pointer;">
                            <i class="fas fa-sign-out-alt fa-sm fa-fw mr-2 text-gray-400"></i>
                            Salir
                        </button>
                    </form>
                </div>
            </li>
        </ul>
        <button class="navbar-toggler navbar-toggler-right d-lg-none align-self-center" type="button" data-toggle="offcanvas">
            <span class="icon-menu"></span>
        </button>
    </div>
</nav>
