@extends('layouts.app')
@section('content')
<div class="container mt-5">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Autenticación de doble factor') }}</div>
                <div class="card-body">
                    @if ($errors->any())
                    <div class="alert alert-danger mb/3">
                        <ul>
                            @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                    @endif
                    <form method="POST" action="{{ route('login.2fa', $user) }}">
                        @csrf
                        <div class="row">
                            <div class="col-12">
                                <p>
                                    Ingrese la clave generada en su aplicación de <b>Google Authenticator</b>.
                                </p>
                            </div>
                        </div>
                        <div class="form-group row">
                            <div class="col-12">
                                <div class="form-group">
                                    <label for="code_verification" class="col-form-label">
                                        {{ __('CÓDIGO DE VERIFICACIÓN') }}
                                    </label>
                                    <input id="code_verification" type="text"
                                        class="form-control{{ $errors->has('code_verification') ? ' is-invalid' : '' }}"
                                        name="code_verification" required autofocus>

                                </div>
                                <button type="submit" class="btn btn-primary">ENVIAR</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection