@extends('layouts.app')
@section('breadreportecrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Dias No Habiles']
        ],
        'show_add_button' => false,
        'add_button_route' => route('dias.crear')
    ])
@endsection
@section('content')
    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }
    </style>


<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="card">
            <div class="card-body">
                <div id="center">
                    @if($formato->isEmpty())
                        <div class="no-data">
                            <div class="no-data-icon">
                                <i class="fa fa-exclamation-triangle"></i>
                            </div>

                            <div class="no-data-message">
                                No se encontraron Formatos.
                            </div>
                            <div class="no-data-actions">
                                <a href="{{ route('formatoemail.crear') }}" class="ui button primary huge">Crear Formato</a>
                            </div>  
                        </div>
                    @else
                        <div class="row table-responsive">
                            <table class="table table-hover" >
                                <thead>
                                    <tr>
                                        <th scope="col">ID</th>
                                        <th scope="col">Nombre</th>
                                        <th scope="col">&nbsp;</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach($formato as $item)
                                        <tr>
                                            <td>{{ $item->id }}</td>
                                            <td>{{ $item->nombre }}</td>

                                            <td>
                                                <a href="{{ route('formatoemail.editar', $item->id) }}" class="ui button small">Editar</a>
                                            </td>                                            
                                        </tr>
                                    @endforeach
                                </tbody>
                            </table>
                            <br><br>
                            <div class="no-data-actions">
                                <a href="{{ route('formatoemail.crear') }}" class="ui button primary huge">Crear Formato</a>
                            </div> 
                        </div>
                    @endif
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
