<!DOCTYPE html>
<html lang="es">
@include('__partials.head')

<body>
    @if(isset(\Illuminate\Support\Facades\Auth::user()->id))
    <div class="container-scroller">
        @include('__partials.nav')
        <div class="page-body-wrapper">
            @include('__partials.settings-panel')
            @include('__partials.menu')
            <div class="main-panel">
                <div class="content-wrapper">
                    @yield('content')
                </div>
                @include('__partials.footer')
            </div>
        </div>
    </div>
    @else
    @if (\Request::is('/'))

    <body>
        <div class="container-scroller">
            @yield('content')
        </div>
    </body>
    @endif
    @if (\Request::is('login') || \Request::is('TwoFactor/*'))
    <body
        style="background-color:black;background-image:url('{{asset('assets/images/auth/register.jpg')}}');background-repeat:no-repeat;background-size:cover;">
        <div class="container-scroller">
            @yield('content')
        </div>
    </body>
    @endif
    
    @endif
    @include('__partials.scripts')

    @if(\Illuminate\Support\Facades\Session::has('success'))
    <script>
        swal("Proceso Completado", "{{\Illuminate\Support\Facades\Session::get('success')}}", "success");
    </script>
    <?php
    \Illuminate\Support\Facades\Session::remove('success');
    ?>
    @endif

    @if(\Illuminate\Support\Facades\Session::has('error'))
    <script>
        swal("Error", "{{\Illuminate\Support\Facades\Session::get('error')}}", "error");
    </script>
    <?php
    \Illuminate\Support\Facades\Session::remove('error');
    ?>
    @endif

</body>

</html>