@extends('layouts.app')

@section('content')

    <div class="container">

        @include('flash::message')

        <div class="row d-flex align-items-center">
            <h1 class="pull-left mr-3">Ofertas NPH</h1>
            <a class="btn btn-primary pull-right" href="{!! route('ofertasnphs.create') !!}">Nuevo</a>
            <form action="{{ route('export', ['tableType' => 'nph']) }}" method="post">
                @csrf
                <button class="btn btn-success pull-right ml-3" type="submit"><i style="font-size: 18px;" class="fa-solid fa-file-csv"></i></button>
            </form>
        </div>

        <div class="row">
            @if ($ofertasnphs->isEmpty())
                <div class="well text-center">No ofertasnphs found.</div>
            @else
                <div class="table-responsive">
                    <table class="table table-bordered table-hover">
                        <thead>
                            <th>Id Oferta Nph</th>
                            <th>Numero Predial Antiguo</th>
                            <th>Numero Predial Nuevo</th>
                            <th>Codigo Homologado</th>
                            <th>Matricula Inmobiliaria</th>
                            <th>Tipo Oferta</th>
                            <th>Departamento</th>
                            <th>Municipio</th>
                            <th>Nombre Barrio</th>
                            <th>Estrato</th>
                            <th>Direccion</th>
                            <th>Valor Arriendo</th>
                            <th>Valor De La Oferta</th>
                            <th>Porcentaje De Negociacion</th>
                            <th>Valor Oferta Negociado</th>
                            <th>Anio Construccion</th>
                            <th>Area Terreno</th>
                            <th>Area Construccion</th>
                            <th>Area Construccion</th>
                            <th>Vr M2 Const</th>
                            <th>Vr M2 Terreno</th>
                            <th>Observaciones</th>
                            <th>Latitud</th>
                            <th>Longitud</th>
                            <th>Conservacion</th>
                            <th>Fecha Captura Oferta</th>
                            <th>Tiempo Oferta Mercado</th>
                            <th>Numero Contacto Oferente</th>
                            <th>Nombre Oferente</th>
                            <th>Avaluo Catastral</th>
                            <th>Destinacion Economica</th>
                            <th>Derecho Tipo</th>
                            <th>Tipo Tipologia</th>
                            <th width="50px">Action</th>
                        </thead>
                        <tbody>

                            @foreach ($ofertasnphs as $ofertasnph)
                                <tr>
                                    <td>{!! $ofertasnph->ID_OFERTA_NPH !!}</td>
                                    <td>{!! $ofertasnph->NUMERO_PREDIAL_ANTIGUO !!}</td>
                                    <td>{!! $ofertasnph->NUMERO_PREDIAL_NUEVO !!}</td>
                                    <td>{!! $ofertasnph->CODIGO_HOMOLOGADO !!}</td>
                                    <td>{!! $ofertasnph->MATRICULA_INMOBILIARIA !!}</td>
                                    <td>{!! $ofertasnph->TIPO_OFERTA !!}</td>
                                    <td>{!! $ofertasnph->DEPARTAMENTO !!}</td>
                                    <td>{!! $ofertasnph->MUNICIPIO !!}</td>
                                    <td>{!! $ofertasnph->NOMBRE_BARRIO !!}</td>
                                    <td>{!! $ofertasnph->ESTRATO !!}</td>
                                    <td>{!! $ofertasnph->DIRECCION !!}</td>
                                    <td>{!! $ofertasnph->VALOR_ARRIENDO !!}</td>
                                    <td>{!! $ofertasnph->VALOR_DE_LA_OFERTA !!}</td>
                                    <td>{!! $ofertasnph->PORCENTAJE_DE_NEGOCIACION !!}</td>
                                    <td>{!! $ofertasnph->VALOR_OFERTA_NEGOCIADO !!}</td>
                                    <td>{!! $ofertasnph->ANIO_CONSTRUCCION !!}</td>
                                    <td>{!! $ofertasnph->AREA_TERRENO !!}</td>
                                    <td>{!! $ofertasnph->AREA_CONSTRUCCION !!}</td>
                                    <td>{!! $ofertasnph->AREA_CONSTRUCCION !!}</td>
                                    <td>{!! $ofertasnph->VR_M2_CONST !!}</td>
                                    <td>{!! $ofertasnph->VR_M2_TERRENO !!}</td>
                                    <td>{!! $ofertasnph->OBSERVACIONES !!}</td>
                                    <td>{!! $ofertasnph->LATITUD !!}</td>
                                    <td>{!! $ofertasnph->LONGITUD !!}</td>
                                    <td>{!! $ofertasnph->CONSERVACION !!}</td>
                                    <td>{!! $ofertasnph->FECHA_CAPTURA_OFERTA !!}</td>
                                    <td>{!! $ofertasnph->TIEMPO_OFERTA_MERCADO !!}</td>
                                    <td>{!! $ofertasnph->NUMERO_CONTACTO_OFERENTE !!}</td>
                                    <td>{!! $ofertasnph->NOMBRE_OFERENTE !!}</td>
                                    <td>{!! $ofertasnph->AVALUO_CATASTRAL !!}</td>
                                    <td>{!! $ofertasnph->DESTINACION_ECONOMICA !!}</td>
                                    <td>{!! $ofertasnph->DERECHO_TIPO !!}</td>
                                    <td>{!! $ofertasnph->TIPO_TIPOLOGIA !!}</td>
                                    <td>
                                        <a class="mr-3 btn btn-primary btn-sm" href="{!! route('ofertasnphs.edit', [$ofertasnph->id]) !!}"><i class="fa-solid fa-edit"></i></a>
                                        <a class="btn btn-danger btn-sm" href="{!! route('ofertasnphs.delete', [$ofertasnph->id]) !!}"
                                            onclick="return confirm('Estás seguro de que quieres eliminar esta ofertasnph??')"><i
                                                class="fa-solid fa-trash"></i></a>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            @endif
        </div>
    </div>
    <style>
        .table-responsive {
            width: 100%;
            overflow-x: auto;
            border: 1px solid rgb(218, 218, 218);
            background: white;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            min-height: auto;
            max-height: 70vh;
        }
    </style>
@endsection
