@extends('layouts.app')

@section('content')

    {{-- <div id="spinner-container">
        <div id="spinner-background"></div>
        <div class="spinner"></div>
    </div> --}}
    <div class="container">

        @include('flash::message')
        <div class="row d-flex align-items-center">
            <h1 class="pull-left mr-3">Ofertas PH</h1>
            <a class="btn btn-primary pull-right" href="{!! route('ofertasphs.create') !!}">Nuevo</a>
            <form id="exportForm" action="{{ route('export', ['tableType' => 'ph']) }}" method="post">
                @csrf
                <button class="btn btn-success pull-right ml-3" type="submit"><i style="font-size: 18px;" class="fa-solid fa-file-csv"></i></button>
            </form>
        </div>
        <div class="row">
            @if ($ofertasphs->isEmpty())
                <div class="well text-center">No ofertasphs found.</div>
            @else
                <div class="table-responsive">
                    <table class="table table-bordered table-hover">
                        <thead>
                            <th>Id Oferta Ph</th>
                            <th>Numero Predial Antiguo</th>
                            <th>Numero Predial Nuevo</th>
                            <th>Codigo Homologado</th>
                            <th>Matricula Inmobiliaria</th>
                            <th>Tipo Oferta</th>
                            <th>Departamento</th>
                            <th>Municipio</th>
                            <th>Nombre Barrio</th>
                            <th>Estrato</th>
                            <th>Direccion</th>
                            <th>Valor Arriendo</th>
                            <th>Valor Administracion</th>
                            <th>Valor Oferta Venta</th>
                            <th>Porcentaje De Negociacion</th>
                            <th>Valor Oferta Negociado</th>
                            <th>Anio Construccion</th>
                            <th>Altura Dificio</th>
                            <th>No Piso</th>
                            <th>Area Construida M2</th>
                            <th>Area Privada M2</th>
                            <th>No Garajes</th>
                            <th>No Depositos</th>
                            <th>Vr Total Terraza Balcon Patio</th>
                            <th>Valor Garajes</th>
                            <th>Valor Depositos</th>
                            <th>Observaciones</th>
                            <th>Latitud</th>
                            <th>Longitud</th>
                            <th>Conservacion</th>
                            <th>Fecha Captura Oferta</th>
                            <th>Tiempo Oferta Mercado</th>
                            <th>Numero Contacto Oferente</th>
                            <th>Nombre Oferente</th>
                            <th>Coeficiente</th>
                            <th>Avaluo Catastral</th>
                            <th>Destinacion Economica</th>
                            <th>Derecho Tipo</th>
                            <th>Tipo Tipologia</th>
                            <th width="50px">Action</th>
                        </thead>
                        <tbody>
    
                            @foreach ($ofertasphs as $ofertasph)
                                <tr>
                                    <td>{!! $ofertasph->ID_OFERTA_PH !!}</td>
                                    <td>{!! $ofertasph->NUMERO_PREDIAL_ANTIGUO !!}</td>
                                    <td>{!! $ofertasph->NUMERO_PREDIAL_NUEVO !!}</td>
                                    <td>{!! $ofertasph->CODIGO_HOMOLOGADO !!}</td>
                                    <td>{!! $ofertasph->MATRICULA_INMOBILIARIA !!}</td>
                                    <td>{!! $ofertasph->TIPO_OFERTA !!}</td>
                                    <td>{!! $ofertasph->DEPARTAMENTO !!}</td>
                                    <td>{!! $ofertasph->MUNICIPIO !!}</td>
                                    <td>{!! $ofertasph->NOMBRE_BARRIO !!}</td>
                                    <td>{!! $ofertasph->ESTRATO !!}</td>
                                    <td>{!! $ofertasph->DIRECCION !!}</td>
                                    <td>{!! $ofertasph->VALOR_ARRIENDO !!}</td>
                                    <td>{!! $ofertasph->VALOR_ADMINISTRACION !!}</td>
                                    <td>{!! $ofertasph->VALOR_OFERTA_VENTA !!}</td>
                                    <td>{!! $ofertasph->PORCENTAJE_DE_NEGOCIACION !!}</td>
                                    <td>{!! $ofertasph->VALOR_OFERTA_NEGOCIADO !!}</td>
                                    <td>{!! $ofertasph->ANIO_CONSTRUCCION !!}</td>
                                    <td>{!! $ofertasph->ALTURA_DIFICIO !!}</td>
                                    <td>{!! $ofertasph->No_PISO !!}</td>
                                    <td>{!! $ofertasph->AREA_CONSTRUIDA_M2 !!}</td>
                                    <td>{!! $ofertasph->AREA_PRIVADA_M2 !!}</td>
                                    <td>{!! $ofertasph->No_GARAJES !!}</td>
                                    <td>{!! $ofertasph->No_DEPOSITOS !!}</td>
                                    <td>{!! $ofertasph->VR_TOTAL_TERRAZA_BALCON_PATIO !!}</td>
                                    <td>{!! $ofertasph->VALOR_GARAJES !!}</td>
                                    <td>{!! $ofertasph->VALOR_DEPOSITOS !!}</td>
                                    <td>{!! $ofertasph->OBSERVACIONES !!}</td>
                                    <td>{!! $ofertasph->LATITUD !!}</td>
                                    <td>{!! $ofertasph->LONGITUD !!}</td>
                                    <td>{!! $ofertasph->CONSERVACION !!}</td>
                                    <td>{!! $ofertasph->FECHA_CAPTURA_OFERTA !!}</td>
                                    <td>{!! $ofertasph->TIEMPO_OFERTA_MERCADO !!}</td>
                                    <td>{!! $ofertasph->NUMERO_CONTACTO_OFERENTE !!}</td>
                                    <td>{!! $ofertasph->NOMBRE_OFERENTE !!}</td>
                                    <td>{!! $ofertasph->COEFICIENTE !!}</td>
                                    <td>{!! $ofertasph->AVALUO_CATASTRAL !!}</td>
                                    <td>{!! $ofertasph->DESTINACION_ECONOMICA !!}</td>
                                    <td>{!! $ofertasph->DERECHO_TIPO !!}</td>
                                    <td>{!! $ofertasph->TIPO_TIPOLOGIA !!}</td>
                                    <td>
                                        <a class="mr-3 btn btn-primary btn-sm" href="{!! route('ofertasphs.edit', [$ofertasph->id]) !!}"><i class="fa-solid fa-pen-to-square"></i></a>
                                        <a class="btn btn-danger btn-sm" href="{!! route('ofertasphs.delete', [$ofertasph->id]) !!}"
                                            onclick="return confirm('Estás seguro de que quieres eliminar esta ofertasph??')"><i class="fa-solid fa-trash"></i></a>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            @endif
        </div>
    </div>
    <style>
        .table-responsive{
            width: 100%;
            overflow-x: auto;
            border: 1px solid rgb(218, 218, 218);
            background: white;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            max-height: 70vh;
            overflow-y: auto;
        }
/* 
        #spinner-container {
            display: none;
            position: fixed;
            background: #3498db;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            z-index: 1000;
        }

        #spinner-background {
            width: 500vh;
            height: 100vh;
            position: fixed;
            top: 0;
            left: 0;
            transform: translate(-50%, -50%);
            background: rgba(0, 0, 0, 0.3);
            z-index: 1000;
            display: none;
        }

        .spinner {
            width: 60px;
            height: 60px;
            border: 6px solid rgba(255, 255, 255, 0.3);
            border-top: 6px solid #3498db;
            border-radius: 50%;
            animation: spin 1s linear infinite;
            position: fixed;
            top: 50%;
            left: 50%;
            margin-top: -22px;
            margin-left: -22px;
            z-index: 1000;
        }

        @keyframes spin {
            0% { transform: rotate(0deg); }
            100% { transform: rotate(360deg); }
        } */
    </style>
    {{-- <script>
        document.getElementById('exportForm').addEventListener('submit', function() {
            document.getElementById('spinner-background').style.display = 'block';
            document.getElementById('spinner-container').style.display = 'block';

            setTimeout(function() {
                document.getElementById('spinner-background').style.display = 'none';
                document.getElementById('spinner-container').style.display = 'none';
            }, 3800);
        });
    </script> --}}
@endsection
