@extends('layouts.app')

@section('content')

    <div class="container">

        @include('flash::message')

        <div class="row d-flex align-items-center">
            <h1 class="pull-left mr-3">Ofertas Rurals</h1>
            <a class="btn btn-primary pull-right" href="{!! route('ofertasrurals.create') !!}">Nuevo</a>
            <form action="{{ route('export', ['tableType' => 'rural']) }}" method="post">
                @csrf
                <button class="btn btn-success pull-right ml-3" type="submit"><i style="font-size: 18px;" class="fa-solid fa-file-csv"></i></button>
            </form>
        </div>

        <div class="row">
            @if ($ofertasrurals->isEmpty())
                <div class="well text-center">No ofertasrurals found.</div>
            @else
                <div class="table-responsive">
                    <table class="table table-bordered table-hover">
                        <thead>
                            <th>Id Oferta Rural</th>
                            <th>Numero Predial Antiguo</th>
                            <th>Numero Predial Nuevo</th>
                            <th>Codigo Homologado</th>
                            <th>Matricula Inmobiliaria</th>
                            <th>Tipo Oferta</th>
                            <th>Departamento</th>
                            <th>Municipio</th>
                            <th>Nombre Vereda</th>
                            <th>Tipo Inmuebles</th>
                            <th>Estrato</th>
                            <th>Direccion</th>
                            <th>Valor Arriendo</th>
                            <th>Valor De La Oferta</th>
                            <th>Porcentaje De Negociacion</th>
                            <th>Valor Oferta Negociado</th>
                            <th>Anio Construccion</th>
                            <th>Area Terreno</th>
                            <th>Area Construccion</th>
                            <th>Vr M2 Const</th>
                            <th>Vr Ha Terreno</th>
                            <th>Observaciones</th>
                            <th>Latitud</th>
                            <th>Longitud</th>
                            <th>Conservacion</th>
                            <th>Fecha Captura Oferta</th>
                            <th>Tiempo Oferta Mercado</th>
                            <th>Numero Contacto Oferente</th>
                            <th>Nombre Oferente</th>
                            <th>Avaluo Catastral</th>
                            <th>Destinacion Economica</th>
                            <th>Derecho Tipo</th>
                            <th>Tipo Tipologia</th>
                            <th>Tipo Cultivos</th>
                            <th>Construcciones Anexas</th>
                            <th width="50px">Action</th>
                        </thead>
                        <tbody>

                            @foreach ($ofertasrurals as $ofertasrural)
                                <tr>
                                    <td>{!! $ofertasrural->ID_OFERTA_RURAL !!}</td>
                                    <td>{!! $ofertasrural->NUMERO_PREDIAL_ANTIGUO !!}</td>
                                    <td>{!! $ofertasrural->NUMERO_PREDIAL_NUEVO !!}</td>
                                    <td>{!! $ofertasrural->CODIGO_HOMOLOGADO !!}</td>
                                    <td>{!! $ofertasrural->MATRICULA_INMOBILIARIA !!}</td>
                                    <td>{!! $ofertasrural->TIPO_OFERTA !!}</td>
                                    <td>{!! $ofertasrural->DEPARTAMENTO !!}</td>
                                    <td>{!! $ofertasrural->MUNICIPIO !!}</td>
                                    <td>{!! $ofertasrural->NOMBRE_VEREDA !!}</td>
                                    <td>{!! $ofertasrural->TIPO_INMUEBLES !!}</td>
                                    <td>{!! $ofertasrural->ESTRATO !!}</td>
                                    <td>{!! $ofertasrural->DIRECCION !!}</td>
                                    <td>{!! $ofertasrural->VALOR_ARRIENDO !!}</td>
                                    <td>{!! $ofertasrural->VALOR_DE_LA_OFERTA !!}</td>
                                    <td>{!! $ofertasrural->PORCENTAJE_DE_NEGOCIACION !!}</td>
                                    <td>{!! $ofertasrural->VALOR_OFERTA_NEGOCIADO !!}</td>
                                    <td>{!! $ofertasrural->ANIO_CONSTRUCCION !!}</td>
                                    <td>{!! $ofertasrural->AREA_TERRENO !!}</td>
                                    <td>{!! $ofertasrural->AREA_CONSTRUCCION !!}</td>
                                    <td>{!! $ofertasrural->VR_M2_CONST !!}</td>
                                    <td>{!! $ofertasrural->VR_Ha_TERRENO !!}</td>
                                    <td>{!! $ofertasrural->OBSERVACIONES !!}</td>
                                    <td>{!! $ofertasrural->LATITUD !!}</td>
                                    <td>{!! $ofertasrural->LONGITUD !!}</td>
                                    <td>{!! $ofertasrural->CONSERVACION !!}</td>
                                    <td>{!! $ofertasrural->FECHA_CAPTURA_OFERTA !!}</td>
                                    <td>{!! $ofertasrural->TIEMPO_OFERTA_MERCADO !!}</td>
                                    <td>{!! $ofertasrural->NUMERO_CONTACTO_OFERENTE !!}</td>
                                    <td>{!! $ofertasrural->NOMBRE_OFERENTE !!}</td>
                                    <td>{!! $ofertasrural->AVALUO_CATASTRAL !!}</td>
                                    <td>{!! $ofertasrural->DESTINACION_ECONOMICA !!}</td>
                                    <td>{!! $ofertasrural->DERECHO_TIPO !!}</td>
                                    <td>{!! $ofertasrural->TIPO_TIPOLOGIA !!}</td>
                                    <td>{!! $ofertasrural->TIPO_CULTIVOS !!}</td>
                                    <td>{!! $ofertasrural->CONSTRUCCIONES_ANEXAS !!}</td>
                                    <td>
                                        <a class="mr-3 btn btn-primary btn-sm" href="{!! route('ofertasrurals.edit', [$ofertasrural->id]) !!}"><i class="fa-solid fa-edit"></i></a>
                                        <a class="btn btn-danger btn-sm" href="{!! route('ofertasrurals.delete', [$ofertasrural->id]) !!}"
                                            onclick="return confirm('Estás seguro de que quieres eliminar esta ofertarutals??')"><i
                                                class="fa-solid fa-trash"></i></a>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            @endif
        </div>
    </div>

    <style>
        .table-responsive {
            width: 100%;
            overflow-x: auto;
            border: 1px solid rgb(218, 218, 218);
            background: white;
            box-shadow: 0 4px 8px rgba(0, 0, 0, 0.1);
            min-height: auto;
            max-height: 70vh;
        }
    </style>
@endsection
