@extends('layouts.app')
@section('breadreportecrumbs')
@include('__partials.breadcrumbs', [
'data' => [
['route' => 'home', 'name' => 'Home'],
['route' => '', 'name' => 'Dias No Habiles']
],
'show_add_button' => false,
'add_button_route' => route('dias.crear')
])
@endsection
@section('content')
@if (session('status'))
<div class="alert alert-success">
    {{ session('status') }}
</div>
@endif
<style>
    input[type=text] {
        width: 100%;
        padding: 12px 10px !important;
        margin: 8px 0;
        display: inline-block;
        border: 1px solid #ccc;
        border-radius: 4px;
        box-sizing: border-box;
        margin-bottom: 10px;
    }

    .field {
        margin-bottom: 2%;
    }

    #body {
        height: 250px;
        position: fixed;
        right: 0;
        z-index: 200;
        width: 30vh !important;
    }
</style>
<div id="center">
    <div class="container-small" id="crear-formato" style="width:100%;">
        <div class="col-sm-12">
            <h4>Parametrización Formatos de Respuesta - {{$nombretipodoc}} <a href="{{ route('parametros.tipodocumento') }}" class="btn btn-primary"><i class="fas fa-chevron-circle-left"></i> Volver</a></h4>
        </div>
        <div class="row mt-4 mb-2 mr-2">
            <form method="GET" href="{{route('parametros.editartipoDocFormatos', $id_tipodoc)}}" class="col-10 form-group">
                {{csrf_field()}}
                <label for="tipoforms"><b>Tipos de formato</b></label>
                <div class="d-flex">
                    <select class="form-control mr-2" name="tipoforms" id="tipoforms">
                        <option value="0" selected>Seleccione un tipo de formato</option>
                        @foreach($formatos as $tipoforms)
                        <option value="{{$tipoforms->id}}">{{$tipoforms->nombre}}</option>
                        @endforeach
                    </select>
                    <button class="btn btn-primary"><i class="fa fa-search" aria-hidden="true"></i></button>&nbsp;
                    @if($flag)
                    <button class="btn btn-info">Volver</i></button>
                    @endif
                </div>
            </form>
        </div>
        <div class="row mt-4 mb-2 mr-2">
            <form class="form-group col-10" method="GET">
                <label><b>Replicar formato de:</b></label>
                <div class="d-flex">
                    <select class="form-control mr-2" name="tipoforms" id="tipoforms_replace">
                        <option class="optionpreview" value="0" selected>Seleccione un tipo de formato</option>
                        @foreach($formatos as $tipoforms)
                        <option class="optionpreview" value="{{$tipoforms->id}}" data-body="{{ $tipoforms->body }}">{{$tipoforms->nombre}}</option>
                        @endforeach
                    </select>
                </div>
            </form>
        </div>

        <a target="_blank" href="{{ route('parametros.previewTipoFormatos') }}" class="mb-2 btn btn-info" id="#preview" class="btn btn-info">Preview</a>
        <form enctype="multipart/form-data" method="POST" action="{{ route('parametros.guardartipoDocFormatos') }}">
            {{ csrf_field() }}

            <div class="field col-10 form-group p-0">
                <label><b>Nombre Formato de Respuesta</b></label>
                <input type="text" name="nombre_formato" class="form-control" id="nombre_formato" value="{{$nombre_formato}}" required>
            </div>

                <div class="row field">
                    <div class="col-10">
                        <label>Cuerpo</label>
                        <textarea style="height: 100vh;" name="body" id="body">{!! $body !!}</textarea>
                    </div>
                    <div class="col-2 d-flex flex-column Labels" id="bodyLabels">
                        <label>Labels</label>
                    </div>
                </div>

                <div class="row mb-4">
                    <div class="col-10">
                        <label>Leyenda final:</label>
                        <textarea name="leyenda" id="leyenda" style="width: 100%;" rows="5"></textarea>
                    </div>
                </div>

            <div class="spacer"></div>
            <div class="spacer"></div>

            <input type="hidden" name="id_tipodoc" value="{{$id_tipodoc}}">
            <input type="hidden" name="id_tipoforms" value="{{$id_tipoforms}}">
            <div class="buttons">
                <a href="{{ route('parametros.tipodocumento') }}" class="ui button">Cancelar</a>
                <button class="ui button primary">Guardar</button>
            </div>
        </form>

    </div>
</div>
<input type="hidden" id="imgHeader" value="{{ $imgHeader }}">
<input type="hidden" id="footerimg" value="{{ $imgFooter }}">
<input type="hidden" id="nameEntidad" value="{{ $nombrEntidad }}">
<input type="hidden" name="routeSetPreview" id="routeSetPreview" value="{{ route('parametros.setPreviewTipoFormato') }}">
<script src="{{asset('assets/js/parametros/editartipodocumento.js')}}"></script>
@endsection