@extends('layouts.app')
@section('breadcrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Parametros'],
            ['route' => '', 'name' => 'Lista de tipo documentos']
        ],
        'show_add_button' => false
    ])
@endsection
@section('content')
    <div class="row">
        <div class="col-md-12 grid-margin">
            <div class="grouped fields">
                <label>Parametrización Usuarios y Tipo Documentos</label>
                <form id="form" action="{{route('userstipodocs.actualizar')}}" method="POST">
                    {{csrf_field()}}
                    <div class="form-group">
                        <div class="checkbox">
                            <input type="checkbox" name="tipos_chk_todos" id="tipos_chk_todos">
                            <label for="exampleInputEmail1" style="margin-top: 10px;">TODOS</label>
                        </div>
                        @foreach($tiposdocs as $tpd)
                            <div class="checkbox">
                                <input class="tiposdocs" type="checkbox" name="tiposdocs[]" value="{{ $tpd->id }}" @if(in_array($tpd->id, $tpdoc)) checked @endif>
                                <label for="exampleInputEmail1" style="margin-top: 10px;">{{ mb_strtoupper($tpd->nombre) }}</label>
                            </div>
                        @endforeach
                    </div>

                    <div class="spacer"></div>
                    <div class="spacer"></div>
                    <input type="hidden" name="id_user" value="{{$id_user}}">
                    <div class="buttons">
                        <a href="{{ route('parametros.userstipodocs') }}" class="ui button">Cancelar</a>
                        <button class="ui button primary">Actualizar</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    <script src="{{asset('assets/js/parametros/edituserstipodocs.js')}}"></script>
@endsection