@extends('layouts.app')
@section('breadreportecrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Dias No Habiles']
        ],
        'show_add_button' => false
    ])
@endsection
@section('content')
<style>
    table tbody tr td, table thead tr th {
        font-size: 11px !important;
        padding-right: 0px !important;
    }

    form {
        padding: 0 !important;
    }

    .table th, .table td {
        padding: 10 !important;
    }

</style>
@if (session('status'))
    <div class="alert alert-success">
        {{ session('status') }}
    </div>
@endif
<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="card">
            <div class="card-body">
                <div id="center">
                    <div class="row table-responsive">
                        <table class="table table-hover">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>NOMBRE</th>
                                    <th>URL DE LA ENTIDAD</th>
                                    <th>IMAGEN lOGO</th>
                                    <th>IMAGEN ENCABEZADO</th>
                                    <th>IMAGEN PIE DE PAGINA</th>
                                    <th>&nbsp;</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($entidad as $ent)
                                    <tr>
                                        <td>{{ $ent->id }}</td>
                                        <td>{{ mb_strtoupper($ent->nombre) }}</td>
                                        <td>{{ $ent->url_entidad }}</td>
                                        <td>
                                            @if($ent->imagen_logo == null)
                                                SIN ASIGNAR
                                            @else
                                                <a target="_blank" href="{{ route('entidad.descargarimagenentidad', $ent->imagen_logo) }}" style="cursor:pointer;color:blue;">{{ $ent->imagen_logo }}</a>
                                            @endif
                                        </td>
                                        <td>
                                            @if($ent->nombre_header == null)
                                                SIN ASIGNAR
                                            @else
                                                <a target="_blank" href="{{ route('entidad.descargarimagenentidad', $ent->nombre_header) }}" style="cursor:pointer;color:blue;">{{ $ent->nombre_header }}</a>
                                            @endif
                                        </td>
                                        <td>
                                            @if($ent->nombre_footer == null)
                                                SIN ASIGNAR
                                            @else
                                                <a target="_blank" href="{{ route('entidad.descargarimagenentidad', $ent->nombre_footer) }}" style="cursor:pointer;color:blue;">{{ $ent->nombre_footer }}</a>
                                            @endif
                                        </td>
                                        <td>
                                            <a target="_blank" href="{{ route('entidad.screenmembrete') }}" class="btn btn-primary" title="Ver membrete"
                                                @if($ent->nombre_header == null || $ent->nombre_footer == null) 
                                                disabled 
                                                @endif
                                            ><i class="fas fa-eye"></i></a>&nbsp;
                                            <a href="{{ route('entidad.editar', $ent->id) }}" class="ui button small">Editar</a>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection