@extends('layouts.app')
@section('breadcrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Reporte Recaudo Fiducia']
        ],
        'show_add_button' => false,
        'add_button_route' => route('reporte.recaudofiducia')
    ])
@endsection
@section('content')

    <div id="center">
        <form action="?" method="get" class="ui form" style="max-width: 200px;" id="form-cambiar-ano">
            {{ csrf_field() }}

            <div class="field">
                <label>Año</label>

                <select name="ano" class="ui dropdown">
                    @foreach($honorarios as $h)
                        <option @if($h->ano == Input::get('ano')) selected
                                @endif value="{{ $h->ano }}">{{ $h->ano }}</option>
                    @endforeach
                </select>
            </div>
        </form>

        <div class="spacer"></div>

        @if($honorario)
        <form action="{{ route('parametros.dias', $honorario->id) }}" class="ui form" method="post" style="max-width: 200px;">
            {{ csrf_field() }}

            <div class="field">
                <label>Valor Honorarios (%)</label>
                <input type="text" name="valor" value="{{ $honorario->valor }}">
            </div>

            <div class="field">
                <label>Calcular Sobre</label>
                <select name="calcular_sobre" class="ui dropdown">
                    <option value="impuesto">Solo Impuesto</option>
                    <option value="impuesto_intereses">Impuesto + Intereses</option>
                </select>
            </div>

            <div class="field">
                <button class="ui button">Actualizar</button>
            </div>
        </form>
        @endif
    </div>

    <script>
        $('select[name="ano"]').change(function(){
            $('#form-cambiar-ano').submit();
        });
    </script>
@endsection
