@extends('layouts.app')

@section('breadcrumbs')
    @include('_includes.breadcrumbs', [
        'data' => [
            ['route' => route('home'), 'name' => 'Inicio'],
            ['route' => '', 'name' => 'Parámetros'],
            ['route' => '', 'name' => 'Derechos']
        ],
        'show_add_button' => false
    ])
@endsection

@section('content')

    <div id="center">
        <form action="?" method="get" class="ui form" style="max-width: 200px;" id="form-cambiar-ano">
            {{ csrf_field() }}

            <div class="field">
                <label>Año</label>

                <select name="param" class="ui dropdown">
                    @foreach($impuestos as $h)
                        <option @if($h->id == Input::get('param')) selected
                                @endif value="{{ $h->id }}">{{ $h->ano }} - {{ $h->tipo->nombre }}</option>
                    @endforeach
                </select>
            </div>
        </form>

        <div class="spacer"></div>

        @if($impuesto)
        <form action="{{ route('parametros.impuestos.post', $impuesto->id) }}" class="ui form" method="post" style="max-width: 200px;">
            {{ csrf_field() }}

            <div class="field">
                <label>Valor Derecho</label>
                <input type="text" name="valor" value="{{ $impuesto->valor }}">
            </div>

            <div class="field">
                <button class="ui button">Actualizar</button>
            </div>
        </form>
        @endif
    </div>

    <script>
        $('select[name="param"]').change(function(){
            $('#form-cambiar-ano').submit();
        });
    </script>
@endsection
