@extends('layouts.app')

@section('breadcrumbs')
    @include('_includes.breadcrumbs', [
        'data' => [
            ['route' => route('home'), 'name' => 'Inicio'],
            ['route' => '', 'name' => 'Parámetros'],
            ['route' => '', 'name' => 'Tasas de Interés']
        ],
        'show_add_button' => false
    ])
@endsection

@section('content')

    <div id="center">
        <form action="?" method="get" class="ui form" style="max-width: 200px;" id="form-cambiar-ano">
            {{ csrf_field() }}

            <div class="field">
                <label>Año</label>

                <select name="ano" class="ui dropdown">
                    @foreach($intereses as $i)
                        <option @if($i == Input::get('ano')) selected
                                @endif value="{{ $i }}">{{ $i }}</option>
                    @endforeach
                </select>
            </div>
        </form>

        <div class="spacer"></div>

        @if($valores)
        <form action="{{ route('parametros.intereses.post', $ano) }}" class="ui form" method="post" style="max-width: 200px;">
            {{ csrf_field() }}

            <div class="field">
                <label>Enero (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[0]->valor }}">
            </div>

            <div class="field">
                <label>Febrero (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[1]->valor }}">
            </div>

            <div class="field">
                <label>Marzo (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[2]->valor }}">
            </div>

            <div class="field">
                <label>Abril (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[3]->valor }}">
            </div>

            <div class="field">
                <label>Mayo (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[4]->valor }}">
            </div>

            <div class="field">
                <label>Junio (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[5]->valor }}">
            </div>

            <div class="field">
                <label>Julio (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[6]->valor }}">
            </div>

            <div class="field">
                <label>Agosto (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[7]->valor }}">
            </div>

            <div class="field">
                <label>Septiembre (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[8]->valor }}">
            </div>

            <div class="field">
                <label>Octubre (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[9]->valor }}">
            </div>

            <div class="field">
                <label>Noviembre (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[10]->valor }}">
            </div>

            <div class="field">
                <label>Diciembre (%)</label>
                <input type="text" name="interes[]" value="{{ $valores[11]->valor }}">
            </div>

            <div class="field">
                <button class="ui button">Actualizar</button>
            </div>
        </form>
        @endif
    </div>

    <script>
        $('select[name="ano"]').change(function(){
            $('#form-cambiar-ano').submit();
        });
    </script>
@endsection
