@extends('layouts.app')
@section('breadcrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Parametros'],
            ['route' => '', 'name' => 'Lista de tipo documentos']
        ],
        'show_add_button' => false,
        'add_button_route' => route('pqrs.respuestas')
    ])
@endsection
@section('content')
<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="card">
            <div class="card-body">
                <center><h5>TIPOS DE DOCUMENTOS</h5></center>
                <br>
                <form action="{{route('parametros.tipodocumento')}}" method="get">
                    <div class="row">
                        <div class="col-md-12">
                            <label><b>Nombres</b></label>
                            <div class="input-group mb-3">
                                <input type="text" name="search" class="form-control border border-primary" placeholder="Nombre a buscar" aria-label="Nombre" aria-describedby="Nombre">
                                <div class="input-group-append">
                                    <button class="btn btn-outline-success" id="BtnBuscar"><i class="fa fa-search" aria-hidden="true"></i> Buscar</button>
                                    @if($flag)
                                        <button onclick="window.location.reload(true);" class="btn btn-outline-warning" id="BtnVolver">Volver</button>
                                    @endif
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
                <br>
                <div class="table-responsive">
                    <div class="col-md-12">
                        <table class="table table-hover table-striped">
                            <thead class="thead-light">
                                <tr>
                                    <th scope="col" class="text-center">#</th>
                                    <th scope="col" class="text-center">Nombre <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#modal-crear-documento">Crear tipo de documento <i class="fa fa-plus-circle" aria-hidden="true"></i> </button></th>
                                    <th scope="col" class="text-center">Días hábiles</th>
                                    <th scope="col" class="text-center">Formato Email</th>
                                    <th scope="col" class="text-center">Estado</th>
                                    <th scope="col" class="text-center">Respuesta</th>
                                </tr>
                            </thead>
                            <tbody>
                                @if(count($documento) > 0)
                                    <?php $fila = 1; ?>
                                    @foreach($documento as $doc)
                                        <form id="form" action="{{route('parametros.actualizarTipoDocumento')}}" method="POST">
                                            {{csrf_field()}}
                                            <tr>
                                                <td class="text-center"><a href="{{ route('parametros.editartipoDocFormatos', $doc->id) }}" style="cursor:pointer;" title="Editar formatos"><i class="fa-solid fa-pen-to-square" style="color:#0C83E2"></i></a> <?php echo $fila; ?></td>
                                                <td class="text-center"><input type="text" id="nombre" name="nombre" class="nombre form-control" value="{{ $doc->nombre }}" required/></td>
                                                <td class="text-center"><input type="number" id="dias_respuesta" name="dias_respuesta" class="nombre form-control" value="{{ $doc->dias_respuesta }}" required/></td>

                                                 <td class="text-center">
                                                                <select name="formatoemail" required class="form-control"> 
                                                                    <option value="" >Seleccione formato Email</option>
                                                                    <?php 
                                                                    $formatoe = App\FormatoEmail::all();
                                                                    ?>        
                                                                    @foreach($formatoe as $forma)
                                                                    <option value="{{ $forma->id }}" <?php if($doc->formatoemail ==$forma->id) { ?>  selected <?php } ?>>{{ $forma->nombre }}</option>
                                                                    @endforeach 
                                                                </select>
                                                 </td>
                                                
                                                <td class="text-center">
                                                    <div class="input-group">
                                                        <select class="active custom-select" name="active" id="active" aria-label="Seleccionar documento">
                                                            <option value="0" @if($doc->active == 0) selected @endif>Inactivo</option>
                                                            <option value="1" @if($doc->active == 1) selected @endif>Activo</option>
                                                        </select>
                                                    </div>
                                                </td>
                                                <td class="text-center">
                                                    <div class="input-group">
                                                        <select class="active custom-select" name="sin_respuesta" id="sin_respuesta" aria-label="Seleccionar documento">
                                                            <option value="0" @if($doc->sin_respuesta == 0) selected @endif>Si</option>
                                                            <option value="1" @if($doc->sin_respuesta == 1) selected @endif>No</option>
                                                        </select>
                                                        <div class="input-group-append">
                                                            <button class="btn btn-primary">Actualizar</button>
                                                        </div>
                                                        <input type="hidden" value="{{$doc->id}}" name="id">
                                                    </div>
                                                </td>
                                            </tr>
                                        </form>
                                        <?php $fila++; ?>
                                    @endforeach
                                @else
                                    <div class="alert alert-danger" role="alert">No hay tipo de documentos registrados</div>
                                @endif
                           </tbody>
                        </table>
                        @if(!$flag){{ $documento->appends(Input::except('page'))->links() }}@endif
                    </div>
                </div>
            </div> 
        </div>
    </div>
    <!-- Modal -->
    <div class="modal fade" id="modal-crear-documento" tabindex="-1" role="dialog" aria-labelledby="modal-crear-documento" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header bg-primary text-light">
                    <h5 class="modal-title" id="titulo">Nuevo tipo documento <i class="fa fa-plus-circle" aria-hidden="true"></i> </h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form id="form" action="{{route('parametros.guardarTipoDocumento')}}" method="POST">
                        <div class="form-group">
                            {{csrf_field()}}
                            <label for="exampleInputEmail1">Nombre</label>
                            <input type="text" class="form-control" id="nombre" name="nombre" aria-describedby="nombre" placeholder="Insertar nombre" required>
                            <small id="nombreHelp" class="form-text text-muted">Nombre que llevará el nuevo tipo de documento</small>
                            <br>
                            <label for="exampleInputEmail1">Días habiles</label>
                            <input type="number" class="form-control" id="dias_respuesta" name="dias_respuesta" aria-describedby="Dias habiles de respuesta" placeholder="Dias habiles de respuesta" required>
                            <small id="nombreHelp" class="form-text text-muted">Días habiles de respuesta del documento</small>
                        </div>
                        <div class="form-group">
                            <div class="checkbox">
                                <input type="checkbox" onclick="setValueSinResp(this)" name="sin_respuesta" id="sin_respuesta">
                                <label for="exampleInputEmail1" style="margin-top: 10px;">No Requiere respuesta</label>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar <i class="fa fa-times-circle" aria-hidden="true"></i></button>
                            <button type="submit" class="btn btn-primary">Guardar <i class="fa fa-plus-circle" aria-hidden="true"></i></button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

<script src="{{asset('assets/js/parametros/tipodocumento.js')}}"></script>
@endsection