@extends('layouts.app')
@section('breadcrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Parametros'],
            ['route' => '', 'name' => 'Lista de parametros']
        ],
        'show_add_button' => false
    ])
@endsection
@section('content')
    <div class="row">
        <div class="col-md-12 grid-margin">
            <div class="card">
                <div class="card-body">
                    <center><h5>Tipos de Trámite</h5></center>
                    <br>
                    <form action="{{route('parametros.tipostramite')}}" method="get">
                        <div class="row">
                            <div class="col-md-12">
                                <label><b>Nombre</b></label>
                                <div class="input-group mb-3">
                                    <input type="text" name="search" class="form-control border border-primary" placeholder="Nombre a buscar" aria-label="Nombre" aria-describedby="Nombre">
                                    <div class="input-group-append">
                                    <button class="btn btn-outline-success" id="BtnBuscar"><i class="fa fa-search" aria-hidden="true"></i> Buscar</button>
                                    @if($flag)
                                        <button href="#" onclick="window.location.reload(true);" class="btn btn-outline-warning" id="BtnVolver">Volver</button>
                                    @endif
                                    </div>
                                </div>
                            </div>
                        </div>
                    </form>
                    <br>
                    <!--TABLA-->
                    <div class="table-responsive">
                        <div class="col-md-12">
                            <table class="table table-hover table-striped">
                                <thead class="thead-light">
                                    <tr>
                                        <th scope="col" class="text-center align-middle">#</th>
                                        <th scope="col" class="text-center align-middle">Nombre <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#modal-crear-parametro">Crear tipo trámite <i class="fa fa-plus-circle" aria-hidden="true"></i> </button></th>
                                        <th scope="col" class="text-center align-middle">Estado</th>
                                        <th scope="col" class="text-center align-middle">Acciones</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @if(count($documento) > 0)
                                        @foreach($documento as $parametros)
                                            <form id="form" action="{{route('parametros.actualizartipotramite')}}" method="POST">
                                                {{csrf_field()}}
                                                <tr>
                                                    <td class="text-center align-middle">{{ $parametros->id }}</td>
                                                    <td class="text-center align-middle"><input type="text" id="nombre" name="nombre" class="nombre form-control" value="{{ $parametros->nombre }}" required/></td>
                                                    <td class="text-center align-middle">
                                                        <div class="input-group">
                                                            <select class="active custom-select" name="active" id="active" aria-label="Seleccionar estado">
                                                                <option value="0" @if($parametros->active == 0) selected @endif>Inactivo</option>
                                                                <option value="1" @if($parametros->active == 1) selected @endif>Activo</option>
                                                            </select>
                                                            <div class="input-group-append">
                                                                <button class="btn btn-primary">Actualizar</button>
                                                            </div>
                                                            <input type="hidden" value="{{$parametros->id}}" name="id">
                                                        </div>
                                                    </td>
                                                    <td class="text-center align-middle"><a href="{{route('parametros.listarvalortptramite',$parametros->id)}}" class="btn bg-success text-light" data-toggle="tooltip" title="Ver / agregar valores" data-placement="top" type="button"><i class="fas fa-plus-circle"></i></a></td>
                                                </tr>
                                            </form>
                                        @endforeach
                                    @else
                                        <div class="alert alert-danger" role="alert">No hay tipos de trámites registrados</div>
                                    @endif
                                </tbody>
                            </table>
                            {{ $documento->links() }}
                        </div>
                    </div>
                    <!--fin tabla -->
                    <!-- Modal -->
                    <div class="modal fade" id="modal-crear-parametro" tabindex="-1" role="dialog" aria-labelledby="modal-crear-parametro" aria-hidden="true">
                        <div class="modal-dialog modal-dialog-centered" role="document">
                            <div class="modal-content">
                                <div class="modal-header bg-primary text-light">
                                    <h5 class="modal-title" id="titulo">Nuevo tipo de trámite <i class="fa fa-plus-circle" aria-hidden="true"></i> </h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <div class="modal-body">
                                    <form id="form" action="{{route('ipat.guardarParametro')}}" method="POST">
                                        <div class="form-group">
                                            {{csrf_field()}}
                                            <label for="exampleInputEmail1">Nombre</label>
                                            <input type="text" class="form-control" id="nombre" name="nombre" aria-describedby="nombre" placeholder="Insertar nombre" required>
                                            <small id="nombreHelp" class="form-text text-muted">Nombre que llevará el nuevo tipo de trámite</small>
                                        </div>
                                        <div class="modal-footer">
                                            <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar <i class="fa fa-times-circle" aria-hidden="true"></i></button>
                                            <button type="submit" class="btn btn-primary">Guardar <i class="fa fa-plus-circle" aria-hidden="true"></i></button>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!--fin modal -->
                </div>
            </div>
        </div>
    </div>
@endsection