@extends('layouts.app')
@section('breadcrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Parametros'],
            ['route' => '', 'name' => 'Lista de tipo documentos']
        ],
        'show_add_button' => false
    ])
@endsection
@section('content')
<style>
    table tbody tr td, table thead tr th {
        font-size: 11px !important;
        padding-right: 0px !important;
    }

    form {
        padding: 0 !important;
    }

    .table th, .table td {
        padding: 10px !important;
    }

</style>
@if (session('status'))
    <div class="alert alert-success">
        {{ session('status') }}
    </div>
@endif
<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="card">
            <div class="card-body">
                <div id="center">
                    @if(count($items))
                        <div class="row table-responsive">
                            <table class="table table-hover">
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>NOMBRE</th>
                                        <th>EMAIL</th>
                                        <th>ÁREA PQR</th>
                                        <th>ROL PQR</th>
                                        <th>TIPO DOC</th>
                                        <th>&nbsp;</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <?php $fila = 1; ?>
                                    @foreach($items as $usuario)
                                        <tr>
                                            <td><?php echo $fila; ?></td>
                                            <td>{{ mb_strtoupper($usuario->name) }}</td>
                                            <td>{{ $usuario->email }}</td>
                                            <td>{{ mb_strtoupper($usuario->area_nombre) }}</td>
                                            <td>{{ mb_strtoupper($usuario->tipo_usuario_nombre) }}</td>
                                            <td>
                                                @if($usuario->role == 'user')
                                                    <button type="button" class="btn btn-primary" data-placement="top" title="Ver tipos documentos del usuario" data-toggle="modal" data-target="#modal_vertiposdocs{{$usuario->id}}"><i class="fas fa-eye"></i></button>
                                                    <div style="height:100%" class="modal fade bd-example-modal-lg" id="modal_vertiposdocs{{$usuario->id}}" tabindex="-1" role="dialog" aria-labelledby="myLargeModalLabel" aria-hidden="true">
                                                        <div class="modal-dialog modal-lg">
                                                            <div class="modal-content" style="bottom:82px;">
                                                                <div class="card">
                                                                    <div class="card-header text-left text-light bg-primary bg-gradient-primary">
                                                                        <div class="col-md-12 btn-md align-left">
                                                                            <h5>Tipos de Documentos asignados a {{mb_strtoupper($usuario->name)}}</h5>
                                                                        </div>
                                                                    </div>
                                                                    <div class="card-body container">
                                                                        <div class="row text-truncate" style="margin-left:-132px !important;">
                                                                            <?php $cont = 1; ?>
                                                                            @if(count($usuario->tpdoc) > 0)
                                                                                @foreach($usuario->tpdoc as $tpd)
                                                                                    <div class="col-sm-4">
                                                                                        <label for="exampleInputEmail1"><?php echo $cont; ?>. {{ mb_strtoupper($tpd->nombre) }}</label>
                                                                                    </div>
                                                                                    <?php $cont++; ?>
                                                                                @endforeach
                                                                            @else
                                                                                <h5>El usuario no tiene tipo de documento asignados.</h5>
                                                                            @endif
                                                                        </div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                @endif
                                            </td>
                                            <td>
                                                @if($usuario->role == 'user')
                                                    <a href="{{ route('parametros.editarUserstipoDoc', $usuario->id) }}" style="cursor:pointer;" class="ui button small">Editar</a>
                                                @endif
                                            </td>
                                        </tr>
                                        <?php $fila++; ?>
                                    @endforeach
                                </tbody>
                            </table>
                        </div> 
                    @else
                        <div class="no-data">
                            <div class="no-data-message">
                                No se encontraron registros.
                            </div>
                        </div>
                    @endif
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
