@extends('layouts.app')
@section('breadcrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Parametros'],
            ['route' => '', 'name' => 'Lista de parametros']
        ],
        'show_add_button' => false
    ])
@endsection
@section('content')
<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="card">
            <div class="card-body">
                <div class="col">
                    <a href="{{route('parametros.tipostramite')}}" class="form-group btn-md btn btn-primary btn-md align-left"><i class="fas fa-chevron-circle-left"></i> Volver</a>
                    <center><h5>Lista de valores de parametros para : <b>{{ $nombre_parametro->nombre }}</b></h5></center>
                </div>
                <br>
                <form action="{{route('ipat.listValorParametro',$id)}}" method="GET">
                    <div class="row">
                        <div class="col-md-12">
                            <label><b>Nombres</b></label>
                            <div class="input-group mb-3">
                                <input type="text" name="search"  class="form-control border border-primary" placeholder="Nombre a buscar" aria-label="Nombre" aria-describedby="Nombre">
                                <div class="input-group-append">
                                    <button class="btn btn-outline-success" id="BtnBuscar"><i class="fa fa-search" aria-hidden="true"></i> Buscar</button>
                                    @if($flag)
                                        <button href="#" onclick="window.location.reload(true);" class="btn btn-outline-warning" id="BtnVolver">Volver</button>
                                    @endif
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
                <br>
                <!--TABLA-->
                <div class="table-responsive">
                    <div class="col-md-12">
                        <table class="table table-hover table-striped">
                            <thead class="thead-light">
                                <tr>
                                    <th scope="col" class="text-center align-middle">#</th>
                                    <th scope="col">Nombre <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#modal-crear-parametro">Crear valor de parámetro <i class="fa fa-plus-circle" aria-hidden="true"></i> </button></th>
                                    <th scope="col" class="text-center align-middle">Estado</th>
                                    <th scope="col" class="text-center align-middle">Reasignar</th>
                                </tr>
                            </thead>
                            <tbody>
                                @if(count($documento) > 0)
                                    @foreach($documento as $parametros)
                                        <tr>
                                            <form id="form" action="{{route('ipat.actualizarValorParametro')}}" method="POST">
                                                {{csrf_field()}}
                                                <td class="text-center align-middle">{{ $parametros->id }}</td>
                                                <td class="text-center align-middle"><input type="text" id="nombre" name="nombre" class="nombre form-control" value="{{ $parametros->nombre }}" required/></td>
                                                <td class="text-center align-middle">
                                                    <div class="input-group">
                                                        <select class="active custom-select" name="active" id="active" aria-label="Seleccionar estado">
                                                            <option value="0" @if($parametros->active == 0) selected @endif>Inactivo</option>
                                                            <option value="1" @if($parametros->active == 1) selected @endif>Activo</option>
                                                        </select>
                                                        <div class="input-group-append">
                                                            <button class="btn btn-primary">Actualizar</button>
                                                        </div>
                                                        <input type="hidden" value="{{$parametros->id}}" name="id">
                                                        <input type="hidden" value="{{$parametros->id_parametro}}" name="id_parametro">
                                                    </div>
                                                </td>
                                            </form>
                                            <form id="form" action="{{route('ipat.reasignarValorParametro')}}" method="POST">
                                                <td class="text-center align-middle">
                                                    {{csrf_field()}}
                                                    <div class="input-group">
                                                        <select class="active custom-select" name="id_parametro" id="id_parametro" aria-label="Reasignar parametro" required>
                                                            <option value="">Escoja una opción</option>
                                                            @foreach($parametro as $param)
                                                                <option value="{{$param->id}}">{{$param->nombre}}</option>
                                                            @endforeach
                                                        </select>
                                                        <div class="input-group-append">
                                                            <button class="btn btn-warning">Reasignar</button>
                                                        </div>
                                                        <input type="hidden" value="{{$parametros->id}}" name="id">
                                                    </div>
                                                </td>
                                            </form>
                                        </tr>
                                    @endforeach
                                @else
                                    <div class="alert alert-danger" role="alert">No hay valores para el parámetro registrado</div>
                                @endif
                           </tbody>
                        </table>
                        {{ $documento->links() }}
                    </div>
                </div>
                <!--fin tabla -->
                <!-- Modal -->
                <div class="modal fade" id="modal-crear-parametro" tabindex="-1" role="dialog" aria-labelledby="modal-crear-parametro" aria-hidden="true">
                    <div class="modal-dialog modal-dialog-centered" role="document">
                        <div class="modal-content">
                            <div class="modal-header bg-primary text-light">
                                <h5 class="modal-title" id="titulo" >NuevO valor <i class="fa fa-plus-circle" aria-hidden="true"></i> </h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <form id="form" action="{{route('ipat.guardarValorParametro')}}" method="POST">
                                    <div class="form-group">
                                        {{csrf_field()}}
                                        <label for="exampleInputEmail1">Nombre</label>
                                        <input type="text" class="form-control" id="nombre" name="nombre" aria-describedby="nombre" placeholder="Insertar nombre" required>
                                        <input type="hidden" class="form-control" id="id_parametro" name="id_parametro" value="{{ $id }}">
                                        <small id="nombreHelp" class="form-text text-muted">Nombre que llevará el nuevo valor para el parámetro</small>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar <i class="fa fa-times-circle" aria-hidden="true"></i></button>
                                        <button type="submit" class="btn btn-primary">Guardar <i class="fa fa-plus-circle" aria-hidden="true"></i></button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
                <!--fin modal -->
            </div>
        </div>
    </div>
</div>
@endsection