@extends('layouts.app')
@section('breadreportecrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Dias No Habiles']
        ],
        'show_add_button' => false,
        'add_button_route' => route('dias.crear')
    ])
@endsection
@section('content')
    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }

    </style>
    <div id="center" class="card p-4">
        <center>
            <h4>CREAR PERFIL</h4>
        </center>
        <div class="container-small card-body" id="crear-perfil">
            <form class="ui form" method="POST" action="{{ route('perfiles.guardar') }}">
                {{ csrf_field() }}

                <div class="row mb-4">
                    <div class="field col-md-6">
                        <label>Nombre Perfil <span class="required">*</span></label>
                        <input class="form-control" name="nombre">
                    </div>
    
                    <div class="field col-md-6">
                        <label>Descripción <span class="required">*</span></label>
                        <input class="form-control" name="descripcion">
                    </div>
                </div>

                <div class="container">
                    <div class="row">
                        @foreach($permisos as $permiso)
                            <div class="col-md-4">
                                <div class="mb-5 d-flex align-items-center">
                                    <input type="checkbox" class="form-check-input padre" name="permisos[]" value="{{ $permiso->id }}">
                                    <label class="form-check-label">{{ $permiso->nombre }}</label>
                                </div>
                
                                @if(!$permiso->hijos->isEmpty())
                                    <div class="hijos" style="margin-top: 1em;">
                                        @foreach($permiso->hijos as $hijo)
                                            <div style="margin-bottom: 1em;">
                                                <input type="checkbox" class="form-check-input hijo" name="permisos[]" value="{{ $hijo->id }}">
                                                <label class="form-check-label">{{ $hijo->nombre }}</label>
                                                <div style="font-size: 0.9em; color: #a4a4a4;">{{ $hijo->descripcion }}</div>
                                            </div>
                                        @endforeach
                                    </div>
                                @endif
                            </div>
                        @endforeach
                    </div>
                </div>

                <div class="buttons d-flex justify-content-end">
                    <a href="{{ route('parametros.perfiles') }}" class="ui button mr-2 btn btn-warning">Cancelar</a>
                    <button class="ui button primary btn btn-primary">Guardar</button>
                </div>
            </form>
        </div>
    </div>
    <script src="{{asset('assets/js/perfiles/crear.js')}}"></script>
    <style>
        .form-control{
            background: rgb(249, 248, 248);
            border: 1px solid rgb(227, 225, 225)
        }
    </style>
@endsection