@extends('layouts.app')
@section('breadreportecrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Dias No Habiles']
        ],
        'show_add_button' => false,
        'add_button_route' => route('dias.crear')
    ])
@endsection
@section('content')
    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }

    </style>
    <div id="center" class="p-4 card">
        <center>
            <h4>EDITAR PERFIL</h4>
        </center>
        <div class="container-small" id="crear-perfil">
            <form class="ui form" method="POST" action="{{ route('perfiles.actualizar', $perfil->id) }}">
                {{ csrf_field() }}

                <div class="row mb-4">
                    <div class="field col-md-6">
                        <label>Nombre Perfil <span class="required">*</span></label>
                        <input class="form-control" name="nombre" value="{{ $perfil->nombre }}">
                    </div>

                    <div class="field col-md-6">
                        <label>Descripción <span class="required">*</span></label>
                        <input class="form-control" name="descripcion" value="{{ $perfil->descripcion }}">
                    </div>
                </div>


                <div class="container">
                    <div class="row">
                        @foreach($permisos as $permiso)
                            <div class="col-md-4">
                                <div class="ui checkbox mb-5 d-flex align-items-center">
                                    <input type="checkbox" class="form-check-input padre" name="permisos[]"
                                        value="{{ $permiso->id }}">
                                    <label class="form-check-label">{{ $permiso->nombre }}</label>
                                </div>
                            </div>

                            @if(!$permiso->hijos->isEmpty())
                                <div class="hijos" style="margin-bottom: 2em; margin-top: 1em;">
                                    @foreach($permiso->hijos as $hijo)
                                        <div class="field" style="margin-left: 2em; margin-bottom: 1em;">
                                            <div class="ui checkbox">
                                                <input type="checkbox" class="hijo" name="permisos[]"
                                                    @if($perfil->permisos()->where('menu.id', $hijo->id)->exists()) checked @endif
                                                    value="{{ $hijo->id }}">
                                                <label>{{ $hijo->nombre }}</label>
                                            </div>
                                        </div>
                                    @endforeach
                                </div>
                            @endif
                        @endforeach
                    </div>
                </div>

                <div class="buttons d-flex justify-content-end">
                    <a href="{{ route('parametros.perfiles') }}" class="ui button mr-2 btn btn-warning">Cancelar</a>
                    <button class="ui button primary btn btn-primary">Actualizar</button>
                </div>
            </form>
        </div>
    </div>
    <script src="{{asset('assets/js/perfiles/editar.js')}}?version=1.0"></script>
    <style>
        .form-control{
            background: rgb(249, 248, 248);
            border: 1px solid rgb(227, 225, 225)
        }
    </style>
@endsection