@extends('layouts.app')
@section('breadreportecrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Dias No Habiles']
        ],
        'show_add_button' => false,
        'add_button_route' => route('dias.crear')
    ])
@endsection
@section('content')
    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }
    </style>


<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="card">
            <div class="card-body">
                <div id="center">
                    @if($perfiles->isEmpty())
                        <div class="no-data">
                            <div class="no-data-icon">
                                <i class="fa fa-exclamation-triangle"></i>
                            </div>

                            <div class="no-data-message">
                                No se encontraron perfiles.
                            </div>
                            <div class="no-data-actions">
                                <a href="{{ route('perfiles.crear') }}" class="ui button primary huge">Crear perfil</a>
                            </div>  
                        </div>
                    @else
                        <div class="row table-responsive">
                            <table class="table table-hover" >
                                <thead>
                                    <tr>
                                        <th scope="col">ID</th>
                                        <th scope="col">Nombre</th>
                                        <th scope="col">Descripción</th>
                                        <th scope="col">Estado</th>
                                        <th scope="col">&nbsp;</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach($perfiles as $item)
                                        <tr>
                                            <td>{{ $item->id }}</td>
                                            <td>{{ $item->nombre }}</td>
                                            <td>{{ $item->descripcion }}</td>
                                            <td>
                                                @if($item->active)
                                                    <button type="button" class="btn btn-success btn-sm" style="font-size: 10px"><i class="fa fa-check"></i> Activo</button>
                                                @else
                                                    <button type="button" class="btn btn-secondary btn-sm" style="font-size: 10px"><i class="fa fa-xmark"></i> Inactivo</button>
                                                @endif
                                            </td>
                                            <td>
                                                <a href="{{ route('perfiles.editar', $item->id) }}" class="ui button small btn btn-primary btn-sm" style="font-size: 10px">Editar</a>
                                                @if($item->active)
                                                    <a href="{{ route('perfiles.desactivar', $item->id) }}" class="ui button small btn btn-danger btn-sm" style="font-size: 10px">Desactivar</a>
                                                @else
                                                    <a href="{{ route('perfiles.activar', $item->id) }}"
                                                    class="ui button small btn btn-success btn-sm" style="font-size: 10px">Activar</a>
                                                @endif
                                            </td>
                                        </tr>
                                    @endforeach
                                </tbody>
                            </table>
                            <br><br>
                            <div class="no-data-actions">
                                <a href="{{ route('perfiles.crear') }}" class="ui button primary huge btn btn-primary">Crear perfil</a>
                            </div> 
                        </div>
                    @endif
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
