@extends('layouts.app')
@section('breadcrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Carga Comparendos']
        ],
        'show_add_button' => false,
        'add_button_route' => route('reporte.cargacomparendos')
    ])
@endsection
@section('content')

    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }

    </style>

    <div class="row">
        <div class="col-md-12 grid-margin">
<?php
    $fi=Carbon\Carbon::now()->format('Y-m-d') ;
    if(Input::has('fecha_inicial'))
     {
       $fi=Input::get('fecha_inicial') ;
       //$fi=substr($fi,9,2)."-".substr($fi,6,2)."-".substr($fi,1,4);
     } 
    $ff=Carbon\Carbon::now()->format('Y-m-d') ;
    if(Input::has('fecha_final'))
     {
       $ff=Input::get('fecha_final') ;
       //$fi=substr($fi,9,2)."-".substr($fi,6,2)."-".substr($fi,1,4);
     } 
?>



    <div class="card">
        <div class="card-body">
                <form class="ui form" method="POST" enctype="multipart/form-data"  action="{{ route('reporte.uploadComparendos') }}">
                    {{csrf_field()}}
                <div class="row">

                    <div class="col-md-3">
                        <label>
                            Seleccione el Archivo
                        </label>

                               <input type="file" class="form-control" 
                                name="file"
                                id="file" >
                    </div>
                    <div class="col-md-2">
                        <button class="btn btn-outline-success">Cargar archivo</button>
                    </div>
                 </div>   
                </form>
            </div>
        </div>

<br>

    <div class="card">
        <div class="card-body">
                <form class="ui form" method="GET" action="{{ route('reporte.cargacomparendos') }}">
                    {{csrf_field()}}
                <div class="row">

                    <div class="col-md-3">
                        <label>
                            FECHA INICIAL
                        </label>

                               <input type="date" class="form-control" 
                                name="fecha_inicial"
                                id="fecha_inicial" value="{{ $fi }}">
                    </div>

                    <div class="col-md-3">
                        <label>
                            FECHA FINAL
                        </label>
                        <input class="form-control" type="date"
                                name="fecha_final"
                                id="fecha_final" value="{{ $ff }}" >
                    </div>

                    <div class="col-md-3">
                        <label>
                            FECHA COMPARENDO
                        </label>
                        <input class="form-control" type="checkbox"
                                name="tipo_fecha"
                                id="tipo_fecha" value="1" >
                    </div>

                    <div class="col-md-2">
                        <button class="btn btn-outline-success">CONSULTAR</button>
                    </div>
                 </div>   
                </form>
            </div>


        </div>

        @if(!$movimientos->isEmpty())

<div class="row">
 <div class="col-md-12 grid-margin">
 <div class="card">
 <div class="card-body text-right">


</div></div></div></div>


<div class="row">
 <div class="col-md-12 grid-margin">
 <div class="card">
 <div class="card-body">

<div class="row">


            <div class="spacer"></div>
            <div class="spacer"></div>

<div class="row table-responsive">
            

            <div class="flex flex-alineado-centro flex-justificado-espaciado-entre">
                <div class="resumen caja-reporte">
                    <h3>Comparendos Procesados</h3>
                </div>
            </div>

            <div class="spacer"></div>
            <div class="spacer"></div>

            <table class="table table-hover">
                <thead>
                    <tr>
                        <th style="width: auto; max-width: none; text-align: left;">Fecha</th>
                        <th>Comparendo</th>
                        <th style="text-align: right;">Fecha</th>

                        <th style="text-align: right;">Hora</th>                     
                        
                        <th style="text-align: right;">CC</th>
                        <th style="text-align: right;">Nombre</th>
                        <th style="text-align: right;">Estadp</th>

                    </tr>
                </thead>
                <tbody>

<?php
$t_1=0;$t_2=0;$t_3=0;$t_4=0;$t_5=0;$t_6=0;$t_a=0;$t_b=0;$t_c=0;$t_d=0;
?>

                    @foreach($movimientos as $movimiento)
  

                            <tr>
                                <td style="text-align: left;">
                                    <div>
                                        {{ $movimiento->created_at->format('Y-m-d') }}
                                    </div>
                                    <div style="font-size: 0.9em;">
                                        {{ $movimiento->created_at->format('H:i') }}
                                    </div>
                                </td>

                                <td>{{ $movimiento->COL2 }}

                                </td>
<td  style="text-align: right;">{{ $movimiento->COL3 }}</td>

<td  style="text-align: right;">{{ $movimiento->COL4 }}</td>

<td  style="text-align: right;">{{ $movimiento->COL15 }}</td>

                                <td style="text-align: right;">{{ $movimiento->COL17 }}</td>
                                <td style="text-align: right;">{{ $movimiento->COL18 }}</td>
                                <td style="text-align: right;">{{ $movimiento->estado }}</td>

                            </tr>

                         
                    @endforeach
                
                

                </tbody>
            </table>


            
     </div></div>

      </div> </div> </div> </div>



        @else
            @if(Input::has('fecha_inicial'))
            <div class="no-data">
                <div class="no-data-icon">
                    <i class="fa fa-exclamation-triangle"></i>
                </div>

                <div class="no-data-message">
                    No se encontraron registros para este rango de fechas.
                </div>
            </div>
            @endif
        @endif

    </div>


</div>
    

@endsection
