@extends('layouts.app')
@section('breadcrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Reporte Resoluciones']
        ],
        'show_add_button' => false,
        'add_button_route' => route('reportes.resoluciones')
    ])
@endsection
@section('content')

    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }

    </style>

    <div class="row">
        <div class="col-md-12 grid-margin">

<?php
    $fi=Carbon\Carbon::now()->format('Y-m-d') ;
    if(Input::has('fecha_inicial'))
     {
       $fi=Input::get('fecha_inicial') ;
       //$fi=substr($fi,9,2)."-".substr($fi,6,2)."-".substr($fi,1,4);
     } 
    $ff=Carbon\Carbon::now()->format('Y-m-d') ;
    if(Input::has('fecha_final'))
     {
       $ff=Input::get('fecha_final') ;
       //$fi=substr($fi,9,2)."-".substr($fi,6,2)."-".substr($fi,1,4);
     } 
?>

    <div class="card">
        <div class="card-body">
                <form class="ui form" method="GET" action="{{ route('reportes.resoluciones') }}">
                    {{csrf_field()}}
                <div class="row">
                    <div class="col-md-3">
                        <label>Tipo</label>
                        <select name="tipo" class="form-control" required>
                    @foreach($tipos as $t)
                         <option value="{{ $t->id }}" @if($tipo==$t->id) selected @endif>{{ $t->nombre }}</option>
                    @endforeach
                        </select>
                    </div>

                    <div class="col-md-3">
                        <label>
                            FECHA INICIAL
                        </label>
                        <input type="date" class="form-control" 
                                name="fecha_inicial"
                                id="fecha_inicial" value="{{ $fi }}" required>
                    </div>

                    <div class="col-md-3">
                        <label>
                            FECHA FINAL
                        </label>
                        <input class="form-control" type="date"
                                name="fecha_final"
                                id="fecha_final" value="{{ $ff }}" required>
                    </div>

                    <div class="col-md-2">
                        <button class="btn btn-outline-success">CONSULTAR</button>
                    </div>
                 </div>   
                </form>
            </div>


        </div>


<div class="row">
 <div class="col-md-12 grid-margin">
 <div class="card">
 <div class="card-body text-right">

<form class="ui form" action="{{ URL::route('reporte.exportresoluciones', 1) }}" 
                            method="get" >                    
                                     {{ csrf_field() }}         
    <button class="btn btn-outline-success">Exportar</button>
      <input type="hidden" name="tipo_pago" value="Contado">
                         <input type="hidden" class="form-control" 
                                name="fecha_inicial"
                                id="fecha_inicial" value="{{ $fi }}">

                          <input class="form-control" type="hidden"
                                name="fecha_final"
                                id="fecha_final" value="{{ $ff }}" >

 <input type="hidden"
                                name="tipo"

 value="{{ Input::get('tipo') }}"
                        >

</form></div></div></div></div>


<div class="row">
 <div class="col-md-12 grid-margin">
 <div class="card">
 <div class="card-body">

<div class="row">


            <div class="flex flex-alineado-centro flex-justificado-espaciado-entre">
                <div class="resumen caja-reporte">
                    <h3>Reporte Resoluciones</h3>
                </div>
            </div>

            <div class="spacer"></div>
            <div class="spacer"></div>

<div class="row table-responsive">
            
       

            <table class="table table-hover">
                <thead>
                    <tr>
                        <th style="width: auto; max-width: none; text-align: left;">Item</th>
                        <th style="width: auto; max-width: none; text-align: left;">Fecha</th>
                        <th style="text-align: center;">Cedula</th>
                        <th style="text-align: center;">Fecha Resol</th>
                        <th style="text-align: center;">Resolucion</th>
                        <th style="text-align: center;">Fecha Compa</th>
                        <th style="text-align: center;">Comparendo</th>
                        <th style="text-align: center;">Valor Compa</th>
                        <th style="text-align: center;">Sancion</th>
                        <th style="text-align: center;">Fecha Sanc</th>
                        <th style="text-align: center;">Valor</th>
                        <th style="text-align: center;">Infraccion</th>
                    </tr>
                </thead>

                <tbody>
<?php
$i=0;
?>
                 
                    @foreach($movimientos as $movimiento)

                               <?php
                                    $i=$i+1;
                                    $compa = App\Comparendo::where('numero', $movimiento->COL7)->get();
                                    $infra="";
                                    $valorcompa="";
                                    $fechacompa="";
                                    $expedi="";
                                    foreach($compa as $comparendo)
                                        { 
                                            $infra=$comparendo->infracciones;
                                            $valorcompa=$comparendo->valor;
                                            $fechacompa=$comparendo->infraccion_fecha;
                                            $expedi=$comparendo->numero_expediente;
                                        }

                                    $sanci = App\ResolucionSimit::where('COL7', $movimiento->COL7)->
                                    where('COL5', 1)->get();
                                    $sancion="";
                                    $fechasancion="";
                                    foreach($sanci as $san)
                                        { 
                                            $sancion=$san->COL2;
                                            $fechasancion=$san->COL4;
                                        }

$link="#";
if($movimiento->COL5!="6" && $movimiento->COL5!="267")
{
 $link=config('myconfig.link_documentos').$expedi.'/'.$movimiento->COL2.'.pdf';
}                                       

                                ?>                      

                                <tr>
                                    <td >
                                        <div>
                                            {{ $i }}
                                        </div>
                                    </td>
                                    <td style="text-align: left;">
                                        <div>
                                            {{ $movimiento->created_at->format('Y-m-d') }}
                                        </div>
                                        <div style="font-size: 0.9em;">
                                            {{ $movimiento->created_at->format('H:i') }}
                                        </div>
                                    </td>
                                     <td style="text-align: right; ">
                                        {{ $movimiento->COL9 }}
                                    </td>   

                                    <td style="text-align: right; ">
                                        {{ $movimiento->COL4 }}
                                    </td>                                
                                    <td  style="text-align: center;">
                                        {{ $movimiento->COL2 }}
                      <a href="{{ $link }}" class="file-icon-wrapper" target="_blank">
                        <div class="btn btn-outline-danger file-icon">
                          <i class="mdi mdi-file-pdf"></i>
                        </div>
                      </a>
                                    </td>


                                    <td style="text-align: right; ">
                                        {{ $fechacompa }}
                                    </td>
                                    <td style="text-align: right; ">
                                        {{ $movimiento->COL7 }}
                                    </td>
                                    <td style="text-align: right; ">
                                        {{ $valorcompa }}
                                    </td>
                                    <td style="text-align: right; ">
                                        {{ $sancion }}
                                    </td>
                                    <td style="text-align: right; ">
                                        {{ $fechasancion }}
                                    </td>

                                     <td style="text-align: right; ">
                                        {{ $movimiento->COL16 }}
                                    </td>  

                                    <td style="text-align: right; ">
                                        {{ $infra }}
                                    </td>
                                  



                                </tr>

                        
                                               
                        
                    @endforeach
                

                </tbody>
            </table>
     </div>

 </div>

      </div> </div> </div> </div>




    </div>


</div>
    

@endsection
