@extends('layouts.app')
@section('breadcrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'PQR'],
            ['route' => '', 'name' => 'Reporte WebService']
        ],
        'show_add_button' => false,
        'add_button_route' => route('reporte.webservice')
    ])
@endsection
@section('content')
    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }
    </style>
    <div class="row">
        <div class="col-md-12 grid-margin">
            <div class="card">
                <div class="card-body">
                    <center><h4>Reporte WebService</h4></center>
                    <form action="{{route('reporte.webservice')}}" method="get">
                        <div class="row">
                            <div class="col-md-2">
                                <label>Tipo Documento</label>
                                <select class="form-control" name="tp_doc">
                                    <option value="0">Todos</option>
                                    @foreach($docs as $doc)
                                        <option
                                            value="{{$doc->id}}" @if($flag)
                                        @if($tp_doc == $doc->id)
                                        selected
                                            @endif
                                            @endif>{{$doc->nombre}}</option>
                                    @endforeach
                                </select>
                            </div>

                             <div class="col-md-2">
                                <label>Fecha Inicial</label>
                                <input type="date" class="form-control" name="fecha_busqueda" placeholder="YYYY-MM-DD" value="{{ $fecha_busqueda }}">
                            </div>

                             <div class="col-md-2">
                                <label>Fecha Final</label>
                                <input type="date" class="form-control" name="fecha_busqueda2" placeholder="YYYY-MM-DD" value="{{ $fecha_busqueda2 }}">
                            </div>

                            <div class="col-md-2">
                                <br>
                                <button style="margin-top: 10px !important;" class="btn btn-outline-success">Buscar
                                </button>
                            </div>



                            <div class="col-md-1"></div>
                        </div>
                    </form>
                    <br><br>
                    <div class="row table-responsive">
                        @if($documentos != "[]")
                            <table class="table table-hover">
                                <thead>
                                <tr>
                                    <th scope="col">Fecha</th>
                                    <th scope="col">Ciudadano</th>
                                    <th scope="col">Organismo</th>
                                    <th scope="col">Referencia</th>
                                    <th title="4: Acuerdo, 6 coactivo, 1 otros" scope="col">Tipo pago</th>
                                    <th scope="col">Intereses</th>
                                    <th scope="col">Honorarios</th>
                                    <th style="text-align: center !important;" scope="col">Descuentos</th>
                                    <th style="text-align: center !important;" scope="col">Cuota</th>
                                    <th style="text-align: center !important;" scope="col">Valor</th>
                                    <th style="text-align: center !important;" scope="col">Msj</th>
                                    <th style="text-align: center !important;" scope="col">Xml</th>
                                </tr>
                                </thead>
                                <tbody>
                                <!-- Large modal -->

                                @foreach($documentos as $doc)
                                    <tr>
                                        <td><b>{{$doc->fecha}}</b></td>
                                        <td>{{$doc->ciudadano}}</td>
                                        <td>{{$doc->id_organismo}}</td>
                                        <td>{{$doc->no_operacion}}</td>
                                        <td>{{$doc->tipo_pago}}</td>
                                        <td>{{$doc->intereses}}</td>
                                        <td>{{$doc->honorarios}}</td>
                                        <td>{{$doc->descuentos}}</td>
                                        <td>{{$doc->cuota}}</td>
                                        <td>{{$doc->valor}}</td>
                                        <td>{{$doc->msj}}</td>
                                        <td>{{$doc->xml}}</td>



                                        </td>

                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                            {{ $documentos->appends(Input::except('page'))->links() }}
                        @else
                            <div class="col-md-4"></div>
                            <center><b></b></center>
                        @endif
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection
