@extends('layouts.app')
@section('breadreportecrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Usuarios']
        ],
        'show_add_button' => false,
        'add_button_route' => route('usuarios.crear')
    ])
@endsection
@section('content')
    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }

    </style>

    <div id="center" class="card p-4">
        <center>
            <h4>CREAR USUARIO</h4>
        </center>
        <div class="container-small card-body" id="crear-usuario-organismo">
            <form class="ui form" method="POST" action="{{ route('usuarios.guardar') }}">
                {{ csrf_field() }}

                <div class="row mb-4">
                    <div class="field col-md-4">
                        <label>Email <span class="required">*</span></label>
                        <input class="form-control" name="email" autocomplete="off">
                    </div>
    
                    <div class="field col-md-4">
                        <label>Nombre <span class="required">*</span></label>
                        <input class="form-control" name="nombre" autocomplete="off">
                    </div>
    
                    <div class="field col-md-4">
                        <label>Contraseña <span class="required">*</span></label>
                        <input type="password" class="form-control" name="password" autocomplete="off">
                    </div>
                </div>

                <div class="container">

                        @if(Auth::user()->role == 'super')
                            <input type="hidden" name="role" value="admin">
                        @else
                            <input type="hidden" name="role" value="user">
        
                            <label class="mb-3">Perfiles</label>
    
                            <div class="row">
                                @foreach($perfiles as $perfil)
                                    <div class="col-md-3">
                                        <div class="ui checkbox ml-3 mb-4 d-flex align-items-center">
                                            <input type="checkbox" class="form-check-input" name="perfiles[]" value="{{ $perfil->id }}">
                                            <label class="form-check-label">{{ $perfil->nombre }}</label>
                                        </div>
                                    </div>
                                @endforeach
                            </div>
                        @endif
                </div>


                <div class="buttons d-flex justify-content-end">
                    <a href="{{ URL::previous() }}" class="ui button mr-2 btn btn-warning">Cancelar</a>
                    <button class="ui button primary btn btn-primary">Guardar</button>
                </div>
            </form>
        </div>
    </div>
    <style>
        .form-control{
            background: rgb(249, 248, 248);
            border: 1px solid rgb(227, 225, 225)
        }
    </style>

@endsection