@extends('layouts.app')
@section('breadreportecrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Dias No Habiles']
        ],
        'show_add_button' => false,
        'add_button_route' => route('dias.crear')
    ])
@endsection
@section('content')
    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }

        .field{
            margin-bottom: 3%;
        }

    </style>
    <div id="center" class="card p-4">
        <center>
            <h4>EDITAR USUARIO</h4>
        </center>
        <div class="container-small" id="editar-usuario-organismo">
            <form class="ui form" method="POST" action="{{ route('usuarios.actualizar', $usuario->id) }}">
                {{ csrf_field() }}

                <div class="row mb-4">
                    <div class="field col-md-6">
                        <label>Email</label>
                        <input style="width:100%;" class="form-control" name="email" value="{{ $usuario->email }}" readonly autocomplete="off">
                    </div>
    
                    <div class="field col-md-6">
                        <label>Nombre</label>
                        <input style="width:100%;" class="form-control" name="nombre" autocomplete="off" value="{{ $usuario->name }}">
                    </div>
                </div>

                <div class="row mb-4">
                    <div class="field col-md-6">
                        <label>Área PQR</label>
                        <select class="custom-select" name="area" style="width:100%;" required>
                            <option value="0">Seleccione..</option>
                            @foreach($areas as $arr)
                            <option value="{{$arr->id}}" @if ($usuario->id_area == $arr->id) selected @endif>{{$arr->nombre}}</option>
                            @endforeach
                        </select>
                    </div>
                    
                    <div class="field col-md-6">
                        <label>Rol PQR</label>
                        <select class="custom-select" name="rol_pqr" style="width:100%;" required>
                            <option value="0">Seleccione..</option>
                            @foreach($roles as $rol)
                            <option value="{{$rol->id}}" @if ($usuario->id_tipo_usuario == $rol->id) selected @endif>{{$rol->nombre}}</option>
                            @endforeach
                        </select>
                        @if($valido == 1)
                        <span style="color:red;">No puede asignar un instrumentador sin antes haber seleccionado a un usuario como coordinador.</span>
                        @endif
                    </div>
                </div>
                
                <div class="field">
                    <label>Cambiar Contraseña</label>
                    <input class="form-control" style="width:100%;" type="password" name="password" autocomplete="off">
                </div>

                <div class="container">
                    @if($usuario->role == 'super')
                    <input type="hidden" name="role" value="admin">
                    @else
                    <input type="hidden" name="role" value="user">
    
                        <div class="grouped fields">
                            <label class="mb-3">Perfiles</label>
    
                            <div class="row">
                                @foreach($perfiles as $perfil)
                                    <div class="field col-md-3">
                                        <div class="ui checkbox ml-3 mb-4 d-flex align-items-center">
                                            <input type="checkbox" class="form-check-input" name="perfiles[]" value="{{ $perfil->id }}" @if(in_array($perfil->id, $perfiles_user)) checked @endif>
                                            <label class="form-check-label">{{ $perfil->nombre }}</label>
                                        </div>
                                    </div>
                                @endforeach
                            </div>
                        </div>
                    @endif
                </div>

                <div class="buttons d-flex justify-content-end">
                    <a href="{{ route('parametros.users') }}" class="ui button mr-2 btn btn-warning">Cancelar</a>
                    <button class="ui button primary btn btn-primary">Actualizar</button>
                </div>
            </form>
        </div>
    </div>
    <style>
        .form-control{
            background: rgb(249, 248, 248);
            border: 1px solid rgb(227, 225, 225)
        }
    </style>
@endsection