@extends('layouts.app')
@section('breadreportecrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Dias No Habiles']
        ],
        'show_add_button' => false,
        'add_button_route' => route('usuarios.crear')
    ])
@endsection
@section('content')
    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }

    </style>

    <div class="row">
        <div class="col-md-12 grid-margin">
            <div class="card">
                <div class="card-body">

    <div id="center">
        @if(count($items))
        <div class="row table-responsive">
            <table class="table table-hover">
                <thead>
                <tr>
                    <th>ID</th>
                    <th>NOMBRE</th>
                    <th>EMAIL</th>
                    <th>ROL</th>
                    <th>ESTADO</th>
                    <th>&nbsp;</th>
                </tr>
                </thead>

                <tbody>
                @foreach($items as $usuario)
                    <tr>
                        <td>{{ $usuario->id }}</td>
                        <td>{{ $usuario->name }}</td>
                        <td>{{ $usuario->email }}</td>
                        <td>
                            @if($usuario->role == 'super') Super Administrador @elseif($usuario->role == 'admin') Administrador @else Usuario @endif
                        </td>
                        <td>
                            @if($usuario->active)
                                <button type="button" class="btn btn-success btn-sm" style="font-size: 10px"><i class="fa fa-check"></i> Activo</button>
                            @else
                                <button type="button" class="btn btn-secondary btn-sm" style="font-size: 10px"><i class="fa fa-xmark"></i> Inactivo</button>
                            @endif
                        </td>
                        <td>
                            @if($usuario->role == 'user')
                                <a href="{{ route('usuarios.editar', $usuario->id) }}"
                                   class="ui button small btn btn-primary btn-sm" style="font-size: 10px">Editar</a>

                                @if($usuario->active)
                                    <a href="{{ route('usuarios.desactivar', $usuario->id) }}" class="ui button small btn btn-danger btn-sm" style="font-size: 10px">Desactivar</a>
                                @else
                                    <a href="{{ route('usuarios.activar', $usuario->id) }}"
                                       class="ui button small small btn btn-success btn-sm" style="font-size: 10px">Activar</a>
                                @endif
                            @endif
                        </td>
                    </tr>
                @endforeach
                </tbody>
            </table>
                <br><br>
                 <div class="no-data-actions">
                    <a href="{{ route('usuarios.crear') }}" class="ui button primary huge btn btn-primary">Crear usuario</a>
                </div>           
            </div> 
        @else
            <div class="no-data">
                <div class="no-data-icon">
                    <i class="fa fa-exclamation-triangle"></i>
                </div>

                <div class="no-data-message">
                    No se encontraron registros.
                </div>

                <div class="no-data-actions">
                    <a href="{{ route('usuarios.crear') }}" class="ui button primary huge btn btn-primary">Crear usuario</a>
                </div>
            </div>
        @endif
    </div>
                </div>
            </div>
        </div>
    </div>
@endsection