@extends('layouts.app')
@section('breadreportecrumbs')
    @include('__partials.breadcrumbs', [
        'data' => [
            ['route' => 'home', 'name' => 'Home'],
            ['route' => '', 'name' => 'Dias No Habiles']
        ],
        'show_add_button' => false,
        'add_button_route' => route('dias.crear')
    ])
@endsection
@section('content')
    <style>
        table tbody tr td, table thead tr th {
            font-size: 11px !important;
            padding-right: 0px !important;
        }

        form {
            padding: 0 !important;
        }

        .table th, .table td {
            padding: 10 !important;
        }

    </style>
    <div id="center">
        <div class="multi">
            <div style="min-width: 250px; margin-right: 2em;">
                <div class="container-small" id="editar-usuario-organismo">
                    <form class="ui form" method="POST" action="{{ route('usuarios.actualizar', $usuario->id) }}">
                        {{ csrf_field() }}

                        <div class="field">
                            <label>Email <span class="required">*</span></label>
                            <input name="email" value="{{ $usuario->email }}" readonly autocomplete="off">
                        </div>

                        <div class="field">
                            <label>Nombre <span class="required">*</span></label>
                            <input name="nombre" autocomplete="off" value="{{ $usuario->name }}">
                        </div>

                        <div class="field">
                            <label>Cambiar Contraseña <span class="required">*</span></label>
                            <input type="password" name="password" autocomplete="off">
                        </div>

                        <div class="spacer"></div>

                        <div class="buttons">
                            <button class="ui button primary">Actualizar</button>
                        </div>
                    </form>
                </div>
            </div>

            <div style="max-width: 300px;">
                <h4>Autorización por Token</h4>
                <p>Algunas funciones requieren la utilización de un token, por favor escanea el siguiente código
                con la aplicación Google Authenticator.</p>
                {!! QrCode::size(200)->margin(0)->generate("otpauth://totp/ETT:{$usuario->email}?secret={$usuario->secreto}&issuer=ETT") !!}
            </div>
        </div>
    </div>

@endsection