<?php

use \Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Auth::routes();
/*
Route::get('admin/juridica/upload-documents', [
    'as' => 'admin.upload.documents',
    'uses' => 'UploadDocsController@index'
]);
*/
Route::post('copi/upload-documents', [
    'as' => 'admin.rel.upload',
    'uses' => 'UploadDocsController@upload'
]);

Route::post('copi/upload-documentsmega', [
    'as' => 'admin.rel.uploadmega',
    'uses' => 'UploadDocsController@uploadmega'
]);

Route::post('copi/upload-documentsmemphis', [
    'as' => 'admin.rel.uploadmemphis',
    'uses' => 'UploadDocsController@uploadmemphis'
]);


Route::post('copi/upload-documentsgenfar', [
    'as' => 'admin.rel.uploadgenfar',
    'uses' => 'UploadDocsController@uploadgenfar'
]);



Route::post('copi/upload-documentstercero', [
    'as' => 'admin.rel.uploadtercero',
    'uses' => 'UploadDocsController@uploadtercero'
]);

Route::post('copi/upload-documentsterceromega', [
    'as' => 'admin.rel.uploadterceromega',
    'uses' => 'UploadDocsController@uploadterceromega'
]);

Route::post('copi/upload-documentsterceromemphis', [
    'as' => 'admin.rel.uploadterceromemphis',
    'uses' => 'UploadDocsController@uploadterceromemphis'
]);

Route::post('copi/upload-documentstercerogenfar', [
    'as' => 'admin.rel.uploadtercerogenfar',
    'uses' => 'UploadDocsController@uploadtercerogenfar'
]);







Route::post('copi/download-documents', [
    'as' => 'admin.rel.download',
    'uses' => 'UploadDocsController@download'
]);

Route::post('copi/download-documentsmega', [
    'as' => 'admin.rel.downloadmega',
    'uses' => 'UploadDocsController@downloadmega'
]);

Route::post('copi/download-documentsmemphis', [
    'as' => 'admin.rel.downloadmemphis',
    'uses' => 'UploadDocsController@downloadmemphis'
]);

Route::post('copi/download-documentsgenfar', [
    'as' => 'admin.rel.downloadgenfar',
    'uses' => 'UploadDocsController@downloadgenfar'
]);






Route::post('copi/downloadinv-documents', [
    'as' => 'admin.rel.downloadinv',
    'uses' => 'UploadDocsController@downloadinv'
]);


Route::post('copi/downloadinvmega-documents', [
    'as' => 'admin.rel.downloadinvmega',
    'uses' => 'UploadDocsController@downloadinvmega'
]);

Route::post('copi/downloadinvmemphis-documents', [
    'as' => 'admin.rel.downloadinvmemphis',
    'uses' => 'UploadDocsController@downloadinvmemphis'
]);

Route::post('copi/downloadinvgenfar-documents', [
    'as' => 'admin.rel.downloadinvgenfar',
    'uses' => 'UploadDocsController@downloadinvgenfar'
]);





Route::group(['middleware' => 'shareViews'], function () {
    Route::group(['middleware' => ['auth']], function () {

        Route::get('/', function () {
            if (isset(\Illuminate\Support\Facades\Auth::user()->id)) {
                return view('home');
            } else {
                return view('auth.login');
            }
        });


Route::post('export/{tableType}', 'ExportCSVController@export')->name('export');

Route::resource('ofertasphs', 'ofertasphController');

Route::get('ofertasphs/{id}/delete', [
    'as' => 'ofertasphs.delete',
    'uses' => 'ofertasphController@destroy',
]);


Route::resource('ofertasnphs', 'ofertasnphController');

Route::get('ofertasnphs/{id}/delete', [
    'as' => 'ofertasnphs.delete',
    'uses' => 'ofertasnphController@destroy',
]);


Route::resource('ofertasrurals', 'ofertasruralController');

Route::get('ofertasrurals/{id}/delete', [
    'as' => 'ofertasrurals.delete',
    'uses' => 'ofertasruralController@destroy',
]);



    Route::get('/home', 'HomeController@index')->name('home');
        
    Route::get('/PQR/index2back', 'PQRControllerBack@index')->name('pqr2back');
    Route::get('/PQR/indexback/{id}', [
        'as' => 'pqrback',
        'uses' => 'PQRControllerBack@index'
    ]);

    Route::post('/PQR/doc/uploadback', 'PQRControllerBack@uploadDocs')->name('pqr.doc.uploadback');
    Route::get('/PQR/respuestasback', 'PQRControllerBack@respuestas')->name('pqr.respuestasback');
    Route::get('/PQR/respuestassecretarioback', 'PQRControllerBack@respuestassecretario')->name('pqr.respuestassecretarioback');
    Route::get('/PQR/pendientesback', 'PQRControllerBack@pendientes')->name('pqr.pendientesback');

    Route::get('/PQR/webservice', 'ReportesController@webservice')->name('reporte.webservice');
    Route::get('/PQR/recaudosimit',
     'ReportesController@reporterecaudosimit')->name('reporte.recaudosimit');


//entidad
        Route::get('/parametros/entidad', 'ParametrizacionController@IndexEntidad')->name('parametros.entidad');

        Route::get('/entidad/{entidad}', [
            'as' => 'entidad.editar',
            'uses' => 'ParametrizacionController@editarEntidad'
        ]);

        Route::post('/entidad/{entidad}', [
            'as' => 'entidad.actualizar',
            'uses' => 'ParametrizacionController@actualizarEntidad'
        ]);

        Route::get('/parametros/entidad/descargarimagenentidad/{nombre_imagen}', 'ParametrizacionController@DescargarImagenEntidad')->name('entidad.descargarimagenentidad');

        Route::get('/parametros/entidad/screenmembrete', 'ParametrizacionController@ScreenMembrete')->name('entidad.screenmembrete');




//rutas audiencia

Route::get('/audiencia/pendientes', 'AudienciaController@pendientes')->name('audiencia.pendientes');
Route::get('/audiencia/respuestas_envio', 'AudienciaController@envios')->name('audiencia.respuestas_envio');
 Route::post('/audiencia/cita', 'AudienciaController@uploadRespuesta')->name('audiencia.cita');
        Route::post('/audiencia/upload2', 'AudienciaController@uploadRespuesta2')->name('audiencia.upload2');

Route::get('/audiencia/consultas', 'AudienciaController@consultas')->name('audiencia.consultas');

        Route::get('/gethorario/{fecha}', [
        'as' => 'gethorario',
        'uses' => 'AudienciaController@getHorarios'
    ]); 

Route::get('/avisos/pendientes', 'AvisosController@pendientes')->name('avisos.pendientes');




        Route::get('/transporte/empresatransporte', 'EmpresasController@empresa_transporte')->name('transporte.empresatransporte');
        Route::post('/transporte/empresa/guardar', 'EmpresasController@guardarEmpresa')->name('transporte.guardar.empresa');
        Route::get('/transporte/empresaasignar', 'EmpresasController@empresa_asignar')->name('transporte.empresaasignar');
        Route::post('/transporte/empresa/guardarasignar', 'EmpresasController@guardarAsignar')->name('transporte.guardar.empresaasignar');
        Route::get('/transporte/empresalistar', 'EmpresasController@empresaListar')->name('empresa.listar');
        Route::post('/transporte/tarjeta/imprimir', 'EmpresasController@imprimirTarjeta')->name('empresa.tarjeta.imprimir');


        Route::get('/PQR/respuestas_envioback', 'PQRControllerBack@envios')->name('pqr.respuestas_envioback');
        Route::get('/PQR/pendientes_envioback', 'PQRControllerBack@pendientesenvios')->name('pqr.pendientes_envioback'); 

        Route::post('/PQR/respuestas/uploadback', 'PQRControllerBack@uploadRespuesta')->name('pqr.respuestas.uploadback');
        Route::post('/PQR/respuestas/imprimirback', 'PQRControllerBack@imprimirSello')->name('pqr.respuestas.imprimirback');
        Route::post('/PQR/respuestas/uploadnotiofiback', 'PQRControllerBack@uploadNotiOfi')->name('pqr.respuestas.uploadnotiofiback');        
        Route::post('/PQR/respuestas/upload2back', 'PQRControllerBack@uploadRespuesta2')->name('pqr.respuestas.upload2back');
        Route::post('/PQR/respuestas/upload3back', 'PQRControllerBack@uploadRespuesta3')->name('pqr.respuestas.upload3back');
        Route::post('/PQR/respuestas/SinDireccionback', 'PQRControllerBack@uploadSinDireccion')->name('pqr.respuestas.SinDireccionback');

        Route::post('/PQR/respuestas/respuestasactualizarback', 'PQRControllerBack@respuestasActualizar')->name('pqr.respuestas.actualizar_direccionback');        

        Route::post('/PQR/tipoactualizarback', 'PQRControllerBack@tipoActualizar')->name('pqr.tipoactualizarback'); 
        Route::post('/PQR/eliminarpqrback', 'PQRControllerBack@eliminarPqr')->name('pqr.eliminarpqrback'); 

        Route::post('/PQR/respuestas/uploadrespuestaenvioback', 'PQRControllerBack@uploadRespuestaEnvio')->name('pqr.respuestas.uploadrespuestaenvioback');    

//ojo
        Route::get('/PQR/getDays/{p1}/{p2}', 'PQRControllerBack@getFiveDays')->name('pqr.getDays');

        Route::get('/PQR/consultasback', 'PQRControllerBack@consultas')->name('pqr.consultasback');
        Route::get('/PQR/notiofiback', 'PQRControllerBack@notiofi')->name('pqr.notiofiback');        
        Route::get('/PQR/rastreoback', 'PQRControllerBack@rastreo')->name('pqr.rastreoback');
        Route::get('/PQR/reclasificacionback', 'PQRControllerBack@reclasificacion')->name('pqr.reclasificacionback');

        Route::get('/reportesnack', 'PQRControllerBack@consultas')->name('reportesback');



        Route::get('/reportes/recaudo', 'ReportesController@recaudoImpuestos')->name('reporte.recaudo');

        Route::get('/reportes/recuperacioncartera', 'ReportesController@recuperacioncartera')->name('reporte.recuperacioncartera');

        Route::get('/reportes/imposicioncomparendos', 'ReportesController@imposicioncomparendos')->name('reporte.imposicioncomparendos');

        Route::get('/reportes/recaudoexterno', 'ReportesController@recaudoExterno')->name('reporte.recaudoexterno');
        Route::get('/reportes/recaudosimitpolca',
            'ReportesController@recaudoSimit')->name('reporte.recaudosimitpolca');

        Route::get('/reportes/carteramorosa', 'ReportesController@carteramorosa')->name('reporte.carteramorosa');
        Route::get('/reportes/carteramorosadetalle', 'ReportesController@carteramorosadetalle')->name('reportes.carteramorosadetalle');
        Route::get('/reportes/resoluciones', 'ReportesController@resoluciones')->name('reportes.resoluciones');

        Route::get('/reportes/recaudofiducia',
            'ReportesController@recaudoFiducia')->name('reporte.recaudofiducia');

         Route::get('/reportes/cargacomparendos',
            'ReportesController@cargaComparendos')->name('reporte.cargacomparendos');  

         Route::get('/reportes/reenviarcomparendos',
            'ReportesController@reenviarComparendos')->name('reporte.reenviarcomparendos'); 

         Route::get('/reportes/cargabitacoras',
            'ReportesController@cargaBitacoras')->name('reporte.cargabitacoras');  


         Route::get('/reportes/bitacorasgeneradas',
            'ReportesController@bitacorasGeneradas')->name('reporte.bitacorasgeneradas');  

         Route::get('/reportes/ingresarbitacoras',
            'ReportesController@ingresarBitacoras')->name('reporte.ingresarbitacoras');  

         Route::post('/reportes/guardarbitacora', 'ReportesController@guardarBitacoras')->name('reportes.guardarbitacora');

         Route::get('/reportes/detallebitacoras',
            'ReportesController@detalleBitacoras')->name('reporte.detallebitacoras'); 

         Route::get('/exportbitacora', 'ExcelController@exportbitacora')->name('reporte.exportbitacora');
         Route::get('/exportbitacora2', 'ExcelController@exportbitacora2')->name('reporte.exportbitacora2');
         Route::get('/exportbitacora3', 'ExcelController@exportbitacora3')->name('reporte.exportbitacora3');
         Route::get('/exportbitacora4', 'ExcelController@exportbitacora4')->name('reporte.exportbitacora4');
         Route::post('/reportes/seguimiento/upload', 'ReportesController@uploadSeguimiento')->name('reportes.seguimiento.upload');

Route::get('/exportrecaudoexterno', 'ExcelController@exportrecaudoexterno')->name('reporte.exportrecaudoexterno');

    Route::post('/comparendos/descargar/comp', [
        'as' => 'comparendos.descargarComp',
        'uses' => 'ReportesController@descargar'
    ]);

         Route::get('/reportes/cargadatacredito',
            'ReportesController@cargaDatacredito')->name('reporte.cargaDatacredito');  

         Route::get('/reportes/cargaformato',
            'ReportesController@cargaFormato')->name('reporte.cargaformato'); 

         Route::get('/reportes/cargaembargos',
            'ReportesController@cargaEmbargos')->name('reporte.cargaembargos'); 

         Route::get('/reportes/procesarembargos',
            'ReportesController@procesarEmbargos')->name('reporte.procesarembargos'); 

        Route::get('/exportdatacredito', 'ExcelController@exportDatacredito')->name('reporte.exportdatacredito');
        Route::post('/reportes/uploadDatacredito', 'ReportesController@uploadDatacredito')->name('reporte.uploadDatacredito');

        Route::get('/exportformato', 'ExcelController@exportFormato')->name('reporte.exportformato');

       Route::get('/export02formato', 'ExcelController@export02Formato')->name('reporte.export02formato');
       Route::get('/export03formato', 'ExcelController@export03Formato')->name('reporte.export03formato');
       Route::get('/export04formato', 'ExcelController@export04Formato')->name('reporte.export04formato');
       Route::get('/export05formato', 'ExcelController@export05Formato')->name('reporte.export05formato');


         Route::post('/reportes/uploadComparendos', 'ReportesController@uploadComparendos')->name('reporte.uploadComparendos');        

        Route::get('/exportusers', 'ExcelController@exportUsers')->name('reporte.users');
        Route::get('/exportexterno', 'ExcelController@exportExterno')->name('reporte.exportexterno');
        Route::get('/exportpolca', 'ExcelController@exportPolca')->name('reporte.polca');
        Route::get('/exportfiducia', 'ExcelController@exportFiducia')->name('reporte.fiducia');

        Route::get('/exportresoluciones', 'ExcelController@exportResoluciones')->name('reporte.exportresoluciones');

        Route::get('/exportjson', 'ExcelController@exportJson')->name('reporte.exportjson');

Route::post('/parametros/tipoformatosdocs/setpreview', 'ParametrizacionController@setPreviewTipoFormato')->name('parametros.setPreviewTipoFormato');
Route::get('/parametros/tipoformatodocs/preview', 'ParametrizacionController@previewTipoFormato')->name('parametros.previewTipoFormatos');

Route::get('/get_archivo_nueva_respuesta/{id}', 'PQRController@getDocumentArchivoRespuesta')->name('pqrs.getArchivoRespuesta');

Route::get('/pqrs/envRespuesta/getFileUpload/{id}', 'PQRController@getFileUpload')->name('pqrs.getFileUpload');

Route::post('/preview/sello', 'PQRController@previewSello')->name('pqrs.preview');

Route::get('/preview/{str}', 'PQRController@prevdocumento')->name('pqrs.prevdocumento');

/*RUTAS IPAT*/
Route::get('/ipat/lista-ipat', 'IpatController@listarIpat')->name('ipat.listarIpat');
Route::get('/ipat/parametros', 'ParametrosIpatController@listParametros')->name('ipat.parametros');
Route::post('/ipat/guardarparametro', 'ParametrosIpatController@guardarParametro')->name('ipat.guardarParametro');
Route::post('/ipat/actualizarparametro', 'ParametrosIpatController@actualizarParametro')->name('ipat.actualizarParametro');
Route::get('/ipat/listaparametros/{id}', ['as' => 'ipat.listValorParametro', 'uses' => 'ParametrosIpatController@listValorParametro']);
Route::post('/ipat/guardarvalorparametro', 'ParametrosIpatController@guardarValorParametro')->name('ipat.guardarValorParametro');
Route::post('/ipat/actualizarvalorparametro', 'ParametrosIpatController@actualizarValorParametro')->name('ipat.actualizarValorParametro');
Route::post('/ipat/reasignarvalorparametro', 'ParametrosIpatController@reasignarValorParametro')->name('ipat.reasignarValorParametro');
Route::get('/ipat/ingresar-ipat', 'IpatController@ipat')->name('ipat.ipat');  
Route::post('/ipat/registrar-ipat', 'IpatController@guardarIpat')->name('ipat.guardarIpat');
Route::get('/ipat/modaldetalleipat/{id}', ['as' => 'ipat.modalDetalleIpat', 'uses' => 'IpatController@modalDetalleIpat']);
/*FIN RUTA IPAT*/

 /* VISTAS NUEVAS DE PQRS*/
        Route::get('/PQRS/index', 'PQRController@index')->name('pqrs');
        Route::get('/PQRS/index/{id}', ['as' => 'pqr', 'uses' => 'PQRController@index']);
        Route::get('/PQRS/respuestas', 'PQRController@respuestas')->name('pqrs.respuestas');
        Route::get('/PQRS/respuestas_envio', 'PQRController@envios')->name('pqrs.respuestas_envio');
        Route::post('/PQRS/respuestas/upload', 'PQRController@uploadRespuesta')->name('pqrs.respuestas.upload');
        Route::get('/PQRS/tutela/{id}', ['as' => 'tutela', 'uses' => 'PQRController@tutela']);
        Route::get('/PQRS/consultas', 'PQRController@consultas')->name('pqrs.consultas');
        Route::post('/PQRS/respuestas/respuestasactualizar', 'PQRController@respuestasActualizar')->name('pqrs.respuestas.actualizar_direccion');
        Route::get('/PQRS/rastreo', 'PQRController@rastreo')->name('pqrs.rastreo');
        Route::get('/PQRS/reclasificacion', 'PQRController@reclasificacion')->name('pqrs.reclasificacion');
        Route::post('/PQRS/eliminarpqr', 'PQRController@eliminarPqr')->name('pqrs.eliminarpqr');
        Route::post('/PQRS/doc/upload', 'PQRController@uploadDocs')->name('pqrs.doc.upload');
        Route::post('/PQRS/respuestas/upload2', 'PQRController@uploadRespuesta2')->name('pqrs.respuestas.upload2');
        Route::post('/PQRS/tipoactualizar', 'PQRController@tipoActualizar')->name('pqrs.tipoactualizar');
        Route::post('/PQRS/actualizararea', 'PQRController@actualizararea')->name('pqrs.actualizararea');
        Route::get('/PQRS/asignarpqr', 'PQRController@asignarPqr')->name('pqrs.asignarpsqr');
        Route::post('/PQRS/actualizarestado', 'PQRController@actualizarEstado')->name('pqrs.actualizarestado');
        Route::get('/PQRS/estadisticas', 'PQRController@estadisticas')->name('pqrs.estadisticas');
        Route::post('/PQRS/usuarioasignado', 'PQRController@UsuarioAsignado')->name('pqrs.usuarioasignado');
        Route::get('/getTpDocByid/{id}', ['as' => 'getTpDocByid', 'uses' => 'PQRController@getTpDocByid']);
        Route::get('/PQRS/EnvioRespuesta/{id}', ['as' => 'envioRespuesta', 'uses' => 'PQRController@envRespuesta']);
        Route::post('/PQRS/respuestaenviada/{id}', ['as' => 'pqrs.respuestaenviada', 'uses' => 'PQRController@RespuestaEnviada']);
        Route::get('/PQRS/firmas', 'PQRController@firmasPendientes')->name('pqrs.firmas');
        Route::get('/PQRS/gestion', 'PQRController@gestion')->name('pqrs.gestion');
        Route::post('/PQRS/gestion/Aprobar/{id}', ['as' => 'pqrs.gestionarAprob', 'uses' => 'PQRController@gestionarAprob']);
        Route::post('/PQRS/gestion/Rechazar/{id}', ['as' => 'pqrs.gestionarRechaz', 'uses' => 'PQRController@gestionarRechaz']);
        Route::post('/PQRS/firmas/guardar/{id}', 'PQRController@GenerarFirma')->name('pqrs.firmas.guardar');
        Route::get('/PQRS/gestion/respuesta/{id}', 'PQRController@getUrlRespuestaPQR')->name('pqrs.gestion.getRespuesta');
        Route::post('/PQRS/reenviarcorreo/{id}', 'PQRController@ReenviarCorreo')->name('pqrs.reenviarcorreo');
        Route::get('/PQRS/exportardatosgenerales', 'ReportePqrsController@exportEstadisticasGeneralesPqrs')->name('pqrs.exportEstadisticasGeneralesPqrs');
        Route::get('/PQRS/exportardatoshome', 'ReportePqrsController@exportEstadisticasGeneralesHome')->name('pqrs.exportEstadisticasGeneralesHome');
        Route::get('/PQRS/exportardatosarea', 'ReportePqrsController@exportEstadisticasArea')->name('pqrs.exportEstadisticasArea');
        Route::get('/PQRS/exportardatosusuario', 'ReportePqrsController@exportEstadisticasUsuario')->name('pqrs.exportEstadisticasUsuario');
        Route::get('/PQRS/exportardatospdf', 'ReportePqrsController@exportPdfGeneral')->name('pqrs.exportPdfGeneral');
        Route::get('/PQRS/notifpendientes', 'PQRController@IndexNotificacionesPendientes')->name('pqrs.notifpendientes');
        Route::get('/PQRS/consultardatosreporte', 'PQRController@ConsultarDatosReporte')->name('pqrs.consultardatosreporte');
        Route::get('/PQRS/favoritos', 'PQRController@favoritos')->name('pqrs.favoritos');
        Route::get('/PQRS/guardarfavorito', 'PQRController@guardarFavorito')->name('pqrs.guardarFavorito');
        Route::get('/PQRS/gestionreclasificacion', 'PQRController@GestionReclasificacion')->name('pqrs.gestionreclasificacion');
        Route::post('/PQRS/gestionreclasificacion/Aprobar/{id}', ['as' => 'pqrs.gestionareclasificacionAprob', 'uses' => 'PQRController@gestionarReclasificacionAprob']);
        Route::post('/PQRS/gestionreclasificacion/Rechazar/{id}', ['as' => 'pqrs.gestionareclasificacionRechaz', 'uses' => 'PQRController@gestionarReclasificacionRechaz']);
        Route::post('/PQRS/cargarenviosoporte/{id}', 'PQRController@CargarEnvioSoporte')->name('pqrs.cargarenviosoporte');
        Route::get('/PQRS/descargarenviosoporte/{id}', 'PQRController@DescargarEnvioSoporte')->name('pqrs.descargarenviosoporte');
        Route::post('/PQRS/cargarenviorecibosoporte/{id}', 'PQRController@CargarReciboSoporte')->name('pqrs.cargarenviorecibosoporte');
        Route::get('/PQRS/descargarenviorecibosoporte/{id}', 'PQRController@DescargarEnvioReciboSoporte')->name('pqrs.descargarenviorecibosoporte');
        Route::post('/PQRS/solicitarapoyo', 'PQRController@SolicitarApoyo')->name('pqrs.solicitarapoyo');
        Route::post('/PQRS/anularapoyo', 'PQRController@AnularApoyo')->name('pqrs.anularapoyo');
        Route::post('/PQRS/guardarnuevafechalimite', 'PQRController@GuardarNuevaFechaLimite')->name('pqrs.guardarnuevafechalimite');
        Route::get('/PQRS/solicitudesapoyo', 'PQRController@SolicitudesApoyo')->name('pqrs.solicitudesapoyo');
        Route::get('/PQRS/envApoyoRespuesta/{id}', ['as' => 'pqrs.envApoyoRespuesta', 'uses' => 'PQRController@envApoyoRespuesta']);
        Route::post('/PQRS/apoyorespuesta', 'PQRController@ApoyoRespuesta')->name('pqrs.apoyorespuesta');
        Route::get('/PQRS/screencorreo/{id}', 'PQRController@ScreenCorreo')->name('pqrs.screencorreo');
        Route::post('/PQRS/guardarperiodicidad', 'PQRController@GuardarPeriodicidad')->name('pqrs.guardarperiodicidad');
        Route::post('/PQRS/envApoyoRespuesta/uploadFilesapoyo/{id}', 'PQRController@guardarArchivosRespuestaApoyo')->name('pqrs.uploadFilesRespuestaApoyo');
        Route::post('/PQRS/envApoyoRespuesta/deleteFilesapoyo', 'PQRController@deleteFilesRespuestaApoyo')->name('pqrs.deleteFilesUploadApoyo');
        Route::get('/PQRS/descargararchivorespuestapoyo/{id}', 'PQRController@DescargarArchivoRespuestApoyo')->name('pqrs.descargararchivorespuestapoyo');
        Route::get('/PQRS/screensello/{id}', 'PQRController@ScreenSello')->name('pqrs.screensello');
        Route::get('/PQRS/ajustes', 'PQRController@PQRAjustes')->name('pqrs.ajustes');
        Route::get('/PQRS/EnvioNuevaRespuesta/{id}', ['as' => 'envioNuevaRespuesta', 'uses' => 'PQRController@envNuevaRespuesta']);
        Route::post('/PQRS/nuevarespuestaenviada/{id}', ['as' => 'pqrs.nuevarespuestaenviada', 'uses' => 'PQRController@NuevaRespuestaEnviada']);
        Route::get('/PQRS/Respuestas/{id}', 'PQRController@getRespuestasPQR')->name('pqrs.consulta.nuevaRepuesta');
        Route::get('/PQRS/Nuevas_Respuestas/{id}', 'PQRController@getNuevaRepuesta')->name('pqrs.getnuevaRespuesta');
        /* FIN VISTA PQRS*/


 /* VISTAS NUEVAS DE PARAMETRIZACION PQRS*/
        Route::get('/parametros/TipoDocumento', 'ParametrizacionController@listTipoDocumento')->name('parametros.tipodocumento');
        Route::post('/parametros/guardarTipoDocumento', 'ParametrizacionController@guardarTipoDocumento')->name('parametros.guardarTipoDocumento');
        Route::post('/parametros/actualizarTipoDocumento', 'ParametrizacionController@actualizarTipoDocumento')->name('parametros.actualizarTipoDocumento');
        Route::get('/parametros/editartipoDocFormatos/{tipodocs}', [
            'as' => 'parametros.editartipoDocFormatos',
            'uses' => 'ParametrizacionController@EditartipoDocFormatos'
        ]);
        Route::post('/parametros/guardartipoDocFormatos', [
            'as' => 'parametros.guardartipoDocFormatos',
            'uses' => 'ParametrizacionController@GuardartipoDocFormatos'
        ]);
        Route::post('/parametros/actualizartipoDocFormatos/{tipodocs}', [
            'as' => 'parametros.actualizartipoDocFormatos',
            'uses' => 'ParametrizacionController@ActualizartipoDocFormatos'
        ]);
        Route::get('/parametros/area', 'ParametrizacionController@listarArea')->name('parametros.area');
        Route::post('/parametros/GuardarArea', 'ParametrizacionController@guardarArea')->name('parametros.guardarArea');
        Route::post('/parametros/actualizarArea', 'ParametrizacionController@actualizarArea')->name('parametros.actualizarArea');
        Route::post('/parametros/editarNivelesArea', 'ParametrizacionController@editarNivelesArea')->name('parametros.editarNivelesArea');
        Route::get('/parametros/juzgados', 'ParametrizacionController@listarJuzgados')->name('parametros.juzgados');
        Route::post('/parametros/guardarjuzgados', 'ParametrizacionController@guardarJuzgados')->name('parametros.guardarJuzgados');
        Route::get('/parametros/modaleditarjuzgados/{id}', ['as' => 'parametros.modaleditarjuzgados', 'uses' => 'ParametrizacionController@modaleditarjuzgados']);
        Route::post('/parametros/actualizarjuzgados', 'ParametrizacionController@actualizarJuzgados')->name('parametros.actualizarJuzgados');
        Route::post('/parametros/eliminarjuzgados', 'ParametrizacionController@eliminarJuzgados')->name('parametros.eliminarJuzgados');

 /* fim VISTAS NUEVAS DE PARAMETRIZACION PQRS*/


        Route::get('/inicio/ajustesperfiluser', [
            'as' => 'inicio.ajustesperfiluser',
            'uses' => 'ParametrizacionController@AjustesPerfilUser'
        ]);

        Route::post('/', [
            'as' => 'inicio.actualizarDatos',
            'uses' => 'ParametrizacionController@ActualizarPerfilUser'
        ]);


        Route::post('/ciudadano/guardarciudadano', 'CiudadanoController@guardarCiudadano')->name('ciudadano.guardarCiudadano');
        Route::get('/noticias/ingresar', 'NoticiasController@index')->name('noticias');
        Route::post('/noticias/guardarnoticia', 'NoticiasController@guardarNoticia')->name('noticias.guardarNoticia');
        Route::get('/noticias/buzonadmin', 'NoticiasController@buzonAdmin')->name('noticias.buzonadmin');
        Route::post('/noticias/actualizarnoticia', 'NoticiasController@actualizarEstadoNoticia')->name('noticias.actualizarEstadoNoticia');
        Route::post('/noticias/actualizar', 'NoticiasController@actualizarNoticia')->name('noticias.actualizarNoticia');
        Route::get('/noticias/buzon', 'NoticiasController@buzon')->name('noticias.buzon');
        Route::post('/noticias/guardarhistorialnoticia', 'NoticiasController@guardarHistorialNoticia')->name('noticias.guardarHistorialNoticia');



        Route::get('/parametros/userstipodocs', 'ParametrizacionController@UsersTipoDocs')->name('parametros.userstipodocs');

        Route::get('/parametros/userstipodocs/{usuario}', [
            'as' => 'parametros.editarUserstipoDoc',
            'uses' => 'ParametrizacionController@EditUsersTipoDocs'
        ]);

        Route::post('/parametros/userstipodocs/actualizar', [
            'as' => 'userstipodocs.actualizar',
            'uses' => 'ParametrizacionController@ActualizarUserTipoDoc'
        ]);



         Route::get('/ticket', [
            'as' => 'soporte.ticket',
            'uses' => 'SoporteController@solicitud'
        ]);

        Route::post('/ticket/generar', [
            'as' => 'soporte.generar',
            'uses' => 'SoporteController@generarTicket'
        ]);

        Route::get('/tickets', [
            'as' => 'soporte.tickets',
            'uses' => 'SoporteController@tickets'
        ]);

        Route::get('/tickets/resueltos', [
            'as' => 'tickets.resueltos',
            'uses' => 'SoporteController@ticketResueltos'
        ]);
        
        Route::get('/tickets/pendientes', [
            'as' => 'tickets.pendientes',
            'uses' => 'SoporteController@ticketsPendientes'
        ]);


        Route::get('/tickets/{id}', [
            'as' => 'soporte.detalle',
            'uses' => 'SoporteController@detalle'
        ]);

        Route::post('tickets/respuesta/{id}', [
            'as' => 'soporte.respuesta',
            'uses' => 'SoporteController@respuesta'
        ]);

        Route::get('/MisTickets',[
            'as' => 'soporte.mistickets',
            'uses' => 'SoporteController@misTickets'
        ]);




        Route::post('/settings/TwoFa', 'ParametrizacionController@settingTowFa')->name('settings.towfa');

        Route::get('/pqrs/labels/{id}','PQRController@getLabels')->name('pqrs.labels');

        Route::post('/pqrs/envRespuesta/uploadFiles/{id}', 'PQRController@guardarArchivosRespuesta')->name('pqrs.uploadFilesRespuesta');

        Route::post('/pqrs/envRespuesta/deleteFiles', 'PQRController@deleteFilesRespuesta')->name('pqrs.deleteFilesUpload');

        Route::get('/PQRS/Bitacoras','PQRController@pqrBitacoras')->name('pqrs.bitacoras');

        Route::post('/PQRS/actualizarjuzgados', 'PQRController@actualizarJuzgados')->name('pqrs.actualizarJuzgados');

        Route::get('/enviocorrespondencia/enviar', 'EnvioCorrespondenciaController@index')->name('enviocorrespondencia.enviar');

        Route::get('/getUserArea/{id}', [
            'as' => 'getUserArea',
            'uses' => 'EnvioCorrespondenciaController@getUserArea'
        ]);

        Route::get('/getInfoUser/{id}', [
            'as' => 'getInfoUser',
            'uses' => 'EnvioCorrespondenciaController@getInfoUser'
        ]);








        Route::get('/parametros/dias',
            'DiasController@index')->name('parametros.dias');

        Route::get('/parametros/campana',
            'CampanaController@index')->name('parametros.campana');


    Route::get('/campana/crear', [
        'as' => 'campana.crear',
        'uses' => 'CampanaController@create'
    ]);

    Route::post('/campana/guardar', [
        'as' => 'campana.guardar',
        'uses' => 'CampanaController@save'
    ]);

    Route::get('/campana/{campa}', [
        'as' => 'campana.editar',
        'uses' => 'CampanaController@edit'
    ]);

    Route::post('/campanaact', [
        'as' => 'campana.actualizar',
        'uses' => 'CampanaController@update'
    ]);


Route::post('/prescribir/imprimir', 'HistoriaController@imprimirPDF')->name('prescribir.imprimir');

/* AGENTES */

/*
    Route::get('/parametros/agentes', [
        'as' => 'parametros.agentes',
        'uses' => 'ControladorAgentes@listar'
    ]);

    Route::get('/agentes/crear', [
        'as' => 'agentes.crear',
        'uses' => 'ControladorAgentes@crear'
    ]);

    Route::post('/agentes', [
        'as' => 'agentes.guardar',
        'uses' => 'ControladorAgentes@guardar'
    ]);

    Route::get('/agentes/{agente}', [
        'as' => 'agentes.editar',
        'uses' => 'ControladorAgentes@editar'
    ]);

    Route::post('/agentes/{agente}', [
        'as' => 'agentes.actualizar',
        'uses' => 'ControladorAgentes@actualizar'
    ]);
*/

Route::resource('agentes', 'agentesController');

Route::get('agentes/{id}/delete', [
    'as' => 'agentes.delete',
    'uses' => 'agentesController@destroy',
]);



    Route::get('/PQR/tutela/{id}', [
        'as' => 'tutela',
        'uses' => 'PQRControllerBack@tutela'
    ]);

    Route::get('/PQR/comparendo/{id}', [
        'as' => 'comparendo',
        'uses' => 'PQRControllerBack@comparendo'
    ]);

    Route::get('/PQR/oficio/{id}', [
        'as' => 'oficio',
        'uses' => 'PQRControllerBack@oficio'
    ]);

     Route::post('/PQR/oficio/{id}', [
        'as' => 'oficio.buscar',
        'uses' => 'PQRControllerBack@oficio'
    ]);   


    
    Route::get('/parametros/users',
            'UsuariosController@index')->name('parametros.users');       

    Route::get('/usuarios/crear', [
        'as' => 'usuarios.crear',
        'uses' => 'UsuariosController@create'
    ]);

    Route::post('/usuarios', [
        'as' => 'usuarios.guardar',
        'uses' => 'UsuariosController@save'
    ]);

    Route::get('/usuarios/{usuario}', [
        'as' => 'usuarios.editar',
        'uses' => 'UsuariosController@editar'
    ]);

    Route::post('/usuarios/{usuario}', [
        'as' => 'usuarios.actualizar',
        'uses' => 'UsuariosController@actualizar'
    ]);

    Route::get('/usuarios/{usuario}/activar', [
        'as' => 'usuarios.activar',
        'uses' => 'UsuariosController@activate'
    ]);

    Route::get('/usuarios/{usuario}/desactivar', [
        'as' => 'usuarios.desactivar',
        'uses' => 'UsuariosController@deactivate'
    ]);

    Route::get('/parametros/perfil', [
        'as' => 'parametros.perfil',
        'uses' => 'UsuariosController@perfil'
    ]);


        /*PERFILES*/
        Route::get('/parametros/perfiles', [
            'as' => 'parametros.perfiles',
            'uses' => 'PerfilesController@index'
        ]);

        Route::get('/perfiles/crear', [
            'as' => 'perfiles.crear',
            'uses' => 'PerfilesController@crear'
        ]);

        Route::post('/perfiles/guardar', [
            'as' => 'perfiles.guardar',
            'uses' => 'PerfilesController@guardar'
        ]);

        Route::get('/perfiles/{perfil}', [
            'as' => 'perfiles.editar',
            'uses' => 'PerfilesController@editar'
        ]);

        Route::post('/perfiles/{perfil}', [
            'as' => 'perfiles.actualizar',
            'uses' => 'PerfilesController@actualizar'
        ]);

        Route::get('/perfiles/{perfil}/activar', [
            'as' => 'perfiles.activar',
            'uses' => 'PerfilesController@activar'
        ]);

        Route::get('/perfiles/{perfil}/desactivar', [
            'as' => 'perfiles.desactivar',
            'uses' => 'PerfilesController@desactivar'
        ]);



        /*FORMATOEMAIL*/
        Route::get('/parametros/formatoemail', [
            'as' => 'parametros.formatoemail',
            'uses' => 'FormatoEmailController@index'
        ]);

        Route::get('/formatoemail/crear', [
            'as' => 'formatoemail.crear',
            'uses' => 'FormatoEmailController@crear'
        ]);

        Route::post('/formatoemail/guardar', [
            'as' => 'formatoemail.guardar',
            'uses' => 'FormatoEmailController@guardar'
        ]);

        Route::get('/formatoemail/{formato}', [
            'as' => 'formatoemail.editar',
            'uses' => 'FormatoEmailController@editar'
        ]);

         Route::post('/formatoemail/{formato}', [
            'as' => 'formatoemail.actualizar',
            'uses' => 'FormatoEmailController@actualizar'
        ]);

        Route::get('/parametros/buscarjuzgados/{input}', function ($input) {
            $juzgados = DB::connection('mysql')->table('juzgados')->where('nombre', $input)->where('active', 1)->get();

            $nombres = 0;
            foreach ($juzgados as $juzgado) {
                $nombres += $juzgado->nombre;
            }
        
            return $nombres;
        });




    Route::get('/dias/crear', [
        'as' => 'dias.crear',
        'uses' => 'DiasController@create'
    ]);
    Route::get('/dias/{id}', [
        'as' => 'dias.editar',
        'uses' => 'DiasController@edit'
    ]);

   Route::get('/importar/base', 'ExcelController@importarBase')->name('importar.base');
    Route::post('/importar/cargarPost', [
        'as' => 'importar.cargarPost',
        'uses' => 'ExcelController@cargarPost'
    ]);

        /*impresiones sancion*/
        Route::get('/impresion/rs',
            'ImpresionesController@indexSanciones')->name('impresion.rs');

        Route::get('/impresion/rs/descargaredirect/{id}', [
          'as' => 'impresion.rs.descargaredirect',
          'uses' => 'ImpresionesController@redireccionarPaqueteSancion'
        ]);

        Route::get('/impresion/rs/descarga/{id}', [
          'as' => 'impresion.rs.descarga',
          'uses' => 'ImpresionesController@descargarPaqueteSancion'
        ]);

        /*impresiones mandamientos*/
        Route::get('/impresion/rmp',
            'ImpresionesController@indexMandamiento')->name('impresion.rmp');

        Route::get('/impresion/rmp/descargaredirect/{id}', [
          'as' => 'impresion.rmp.descargaredirect',
          'uses' => 'ImpresionesController@redireccionarPaqueteMandamiento'
        ]);

        Route::get('/impresion/rmp/descarga/{id}', [
          'as' => 'impresion.rmp.descarga',
          'uses' => 'ImpresionesController@descargarPaqueteMandamiento'
        ]);

        /*impresiones embargos*/
        Route::get('/impresion/emb',
            'ImpresionesController@indexEmbargo')->name('impresion.emb');

        Route::get('/impresion/emb/descargaredirect/{id}', [
          'as' => 'impresion.emb.descargaredirect',
          'uses' => 'ImpresionesController@redireccionarPaqueteEmbargo'
        ]);

        Route::get('/impresion/emb/descarga/{id}', [
          'as' => 'impresion.emb.descarga',
          'uses' => 'ImpresionesController@descargarPaqueteEmbargo'
        ]);


    Route::get('/getciudadano/{id}', [
        'as' => 'getciudadano',
        'uses' => 'PQRControllerBack@getCiudadano'
    ]);    

        Route::get('/getciudad/{id}', [
        'as' => 'getciudad',
        'uses' => 'PQRControllerBack@getCiudades'
    ]);  

        Route::get('/getbuscar/{id}', [
        'as' => 'getbuscar',
        'uses' => 'PQRController@getBuscar'
    ]);  
  



        /*impresiones citaciones de mandamientos de pago*/
        Route::get('/impresion/citmp',
            'ImpresionesController@indexCitmp')->name('impresion.citacion');

        Route::get('/impresion/citmp/descargaredirect/{id}', [
          'as' => 'impresion.citmp.descargaredirect',
          'uses' => 'ImpresionesController@redireccionarPaqueteCitmp'
        ]);

        Route::get('/impresion/citmp/descarga/{id}', [
          'as' => 'impresion.citmp.descarga',
          'uses' => 'ImpresionesController@descargarPaqueteCitmp'
        ]);
        

        /*impresiones notificaciones personal de mandamientos de pago*/
        Route::get('/impresion/notificacion',
            'ImpresionesController@indexNotificacion')->name('impresion.notificacion');

        Route::get('/impresion/notificacion/descargaredirect/{id}', [
          'as' => 'impresion.notificacion.descargaredirect',
          'uses' => 'ImpresionesController@redireccionarPaqueteNotificacion'
        ]);

        Route::get('/impresion/notificacion/descarga/{id}', [
          'as' => 'impresion.notificacion.descarga',
          'uses' => 'ImpresionesController@descargarPaqueteNotificacion'
        ]);

        /*avisos*/
        Route::get('/impresion/avisos',
            'ImpresionesController@indexAvisos')->name('impresion.avisos');

        Route::get('/impresion/avisos/descargaredirect/{id}', [
          'as' => 'impresion.avisos.descargaredirect',
          'uses' => 'ImpresionesController@redireccionarPaqueteAvisos'
        ]);

        Route::get('/impresion/avisos/descarga/{id}', [
          'as' => 'impresion.avisos.descarga',
          'uses' => 'ImpresionesController@descargarPaqueteAvisos'
        ]);


        /*carga archivos*/
        Route::get('/historialcarga',
            'HistoriaController@carga')->name('historialcarga');

        Route::get('/historialcarga/detalle/{id}',
            'HistoriaController@detallecarga')->name('historial.detallecarga');

        Route::post('/historialcarga/upload', 'HistoriaController@SubirArchivo')->name('historialcarga.subirarchivo');


        /*historial conductor*/
        Route::get('/historial',
            'HistoriaController@index')->name('historial');

        Route::get('/historial/detalle/{id}',
            'HistoriaController@detalle')->name('historial.detalle');

        Route::get('/historial/descargaresol/{id}',
            'HistoriaController@descargarResolucion')->name('historial.descargaresol');

        Route::get('/historial/consulta/documentos/{id}/{tipo}/{emb}',
            'HistoriaController@consultaDocumentos')->name('historial.consulta.documentos');

        Route::get('/historial/cambiaraudiencia/{id}',
            'HistoriaController@viewCambiarAudiencia')->name('historial.cambiaraudiencia');

        Route::post('/historial/cambiaraudiencia',
            'HistoriaController@cambiarAudiencia')->name('historial.cambiaraudiencia.post');

        Route::get('/historial/crearsentencia/{id}',
            'HistoriaController@crearSentencia')->name('historial.crearsentencia');

        Route::get('/historial/crearcitacionmandamiento/{id}',
            'HistoriaController@crearCitacionMandamiento')->name('historial.crearcitacionmandamiento');

        /*titulos*/
        Route::get('/titulos/devolucion',
            'TitulosController@index')->name('titulos.devolucion');

        Route::get('/titulos/apropiar/{cedula}',
            'TitulosController@apropiar')->name('titulos.apropiar');

        Route::post('/titulos/devolver',
            'TitulosController@devolver')->name('titulos.devolver');

        Route::get('/titulos/revertirapropiacion/{id}/{cedula}',
            'TitulosController@revertirApropiacion')->name('titulos.revertirapropiacion');

        Route::get('/titulos/eliminarapropiacion/{id}/{cedula}',
            'TitulosController@eliminarApropiacion')->name('titulos.eliminarapropiacion');

        Route::get('/titulos/consulta',
            'TitulosController@consulta')->name('titulos.consulta');

        Route::get('/titulos/nuevo',
            'TitulosController@new')->name('titulos.nuevo');

        Route::get('/titulos/editar/{id}',
            'TitulosController@edit')->name('titulos.editar');

        Route::post('/titulos/guardar',
            'TitulosController@save')->name('titulos.guardar');

        Route::get('/titulos/cedula/titulos/{cedula}',
            'TitulosController@consultaCedulaTitulo')->name('titulos.cedula.titulos');

        /*incumplimiento*/
        Route::get('/incumplimiento/index',
            'IncumplimientoController@index')->name('incumplimiento.index');

        Route::post('/incumplimiento/guardar',
            'IncumplimientoController@guardar')->name('incumplimiento.guardar');



    });
});
